
/*
  Natjecanje studenata informaticara hrvatskih sveucilista 2005
  Zadatak LUD

  Opis algoritma:
  Zadatak rjesavamo rekurzivno, razmatrajuci dva slucaja: 1. trazena znamenka
  L(n) je "nasljedjena" iz L(n-1), 2. trazena znamenka je jedna od znamenki
  broja n, tj. dodana je u zadnjem koraku.
  Da bi znali o kojem se slucaju radi potrebno je odrediti broj znamenaka broja
  n te provjeriti da li je trazena pozicija k djeljiva s tim brojem.
*/

#include <iostream>
#include <vector>

using namespace std;

int znamenka (int n, int k)
{
        vector<int> z;
        int nn=n;
        while (nn>0)
        {
                z.push_back(nn%10);
                nn/=10;
        }
        int b=z.size();
        if (k==1 || n==1) return 1;
        if ((k-1)%(b+1)==0) return znamenka(n-1, (k-1)/(b+1)+1);
        return z[b-(k-1)%(b+1)];
}

int main (void)
{
        int n, k;
        cin >> n >> k;
        cout << znamenka(n, k) << endl;
        return 0;
}
