#include<cstdlib>
#include<cstdio>
#include<algorithm>

using namespace std;

int perm[1024*1024];
int *perm2;
int perm10[9][1024*1024];
int done1[10];
int inv1[10];
//int perm2[1024*1024];
int perm3[1024*1024];
char done[1024*1024];
int n, n2;
char str[21024];

inline void inv() {
    for (int i = 0; i < n2; ++i) {
	perm3[i] = perm2[i];
    }
    for (int i = 0; i < n2; ++i) {
	perm2[perm3[i]] = i;
    }
}

inline void compose() {
    for (int i = 0; i < n2; ++i) {
	perm3[i] = perm[perm2[i]];
    }
    for (int i = 0; i < n2; ++i) {
	perm[i] = perm3[i];
    }
}

inline int nwd(int a, int b) {
    if (a > b) {
	return nwd(b, a);
    }
    else if (a == 0) return b;
    else return nwd(a, b%a);
}

inline int nww(int a, int b) {
    return a*(b/nwd(a,b));
}

int okres() {
    int result = 1;
    for (int i = 0; i < n2; ++i) done[i] = 0;
    for (int i = 0; i < n2; ++i) if (!done[i]) {
	done[i] = 1;
	int k = 1;
	int j = perm[i];
	while (j != i) {
	    done[j] = 1;
	    j = perm[j];
	    ++k;
	}
	result = nww(result, k);
    }
    return result;
}

void checkPerm() {
    return;
    for (int i = 0; i < n2; ++i) done[i] = 0;
    for (int i = 0; i < n2; ++i) {
	if (done[perm2[i]]) {
	    printf("WRONG!\n");
	}
	done[perm2[i]] = 1;
    }
}

int main(){
    while(scanf("\n%d\n", &n), n) {
	for (int i = 0; i < 8; ++i) done1[i] = inv1[i] = 0;
	n2 = n*n;
	for (int i = 0; i < n2; ++i) perm[i] = i;
	gets(str);
	char *p = str;
	while (*p) {
	    /*printf ("read znak: %c\n", *p);*/
	    switch(*p) {
		case ' ': ++p; continue;
		case 'i':
		    if (!done1[0]) {
			for (int i = 0; i < n2; ++i) perm10[0][i] = i;
			done1[0] = 1;
		    }
			perm2 = perm10[0];
			p+=2;
		    break;
		case 'r':
		    if (!done1[1]) {
		    
		    for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
			    perm10[1][i*n+j] = (n-1-j)*n+i;
			}
		    }
		    
		    	done1[1] = 1;
		    }
		    perm2 = perm10[1];
		    p+=3;
		    break;
		case 's':
		    if (!done1[2]) {

		    for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
			    perm10[2][i*n+j] = (n-1-i)*n+j;
			}
		    }
		    
		    			done1[2] = 1;
		    }
		    p+=3;
		    		    perm2 = perm10[2];
		    break;
		case 'b':

		
		    if (p[1] == 'h') {
		    
		    		    if (!done1[3]) {
			for (int i = 0; i < n; ++i) {
		    	    for (int j = 0; j < n/2; ++j) {
				perm10[3][i*n+j] = (i)*n+j;
			    }
			}
		        for (int i = 0; i < n; ++i) {
		    	    for (int j = n/2; j < n; ++j) {
				perm10[3][i*n+j] = (n-1-i)*n+j;
			    }
			}
			
			done1[3] = 1;
		    }
		    	    perm2 = perm10[3];
		    }
		    else {
		    
		    		    if (!done1[4]) {
			for (int i = 0; i < n; ++i) {
		    	    for (int j = 0; j < n/2; ++j) {
				perm10[4][i*n+j] = (i)*n+j;
			    }
			}
			for (int i = 0; i < n; ++i) {
		    	    for (int j = n/2; j < n; ++j) {
				perm10[4][i*n+j] = (i)*n+n+n/2-1-j;
			    }
			}
			done1[4] = 1;
		    }
		    	perm2 = perm10[4];
		    }
		    p+=5;
		    break;
		case 'd':
				    if (!done1[5]) {
		    for (int i = 0; i < n; ++i) {
		    	for (int j = 0; j < n/2; ++j) {
			    perm10[5][i*n+j] = (i)*n+j*2;
			}
		    }
		    for (int i = 0; i < n; ++i) {
		    	for (int j = n/2; j < n; ++j) {
			    perm10[5][i*n+j] = (i)*n+(j-n/2)*2+1;
			}
		    }

		    inv();
		    		    done1[5] = 1;
		    }
		        perm2 = perm10[5];
					    p+=3;
		    break;
		case 'm':
		
				    if (!done1[7]) {
		    for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; j+=2) {
			    perm10[7][i*n+j] = (i/2)*n+j+i%2;
			}
		    }
		    for (int i = 0; i < n; ++i) {
			for (int j = 1; j < n; j+=2) {
			    perm10[7][i*n+j] = (n/2+i/2)*n+j+i%2-1;
			}
		    }
		    done1[7] = 1;
		    }
		        perm2 = perm10[7];
		    p+=3;
		    break;
	    }
	    //checkPerm();
	    bool o = false;
	    if (*p == '-') {
		++p; o = true;
	    }
	    if (inv1[] != o) { inv(); }
	    
		/*printf ("read znak: %c\n", *p);*
		compose();
	}
	printf("%d\n", okres());
    }
    return 0;
}