#define MAGIC 2200
#include<cstdlib>
#include<cstdio>
#include<algorithm>

using namespace std;

struct rek{
  int x, y;
  int nu;
};

bool operator<(const rek &u, const rek &v){
  if (u.x != v.x) return (u.x < v.x); else
  return (u.y < v.y);
}

int ks, kl, i, j, n, m, kk, q;
int wy[1500][16];
int wyx[1500], wyy[1500];
rek wys[3000];
int ilewy, ii;
int x1, y1;
double pole, xc, yc, ile;

int zazakresie(double u, double v){
  if (u > n || v > m || u < 0 || v < 0) return 1;
  else return 0;
}

int sprawdz(double x, double y, int num){
  if (num==0) return 1; else
  if (num==1 && x*x+y*y <= 0.58*0.58) return 1; else
  if (num==2 && x*x+(1-y)*(1-y) <= 0.58*0.58) return 1; else
  if (num==3 && x*x+(1+y)*(1+y) <= 0.58*0.58) return 1; else
  if (num==4 && (1-x)*(1-x)+y*y <= 0.58*0.58) return 1; else
  if (num==5 && (1+x)*(1+x)+y*y <= 0.58*0.58) return 1; else
  if (num==10 && x*x+(1-y)*(1-y) <= 1.31*1.31) return 1; else
  if (num==11 && x*x+(1+y)*(1+y) <= 1.31*1.31) return 1; else
  if (num==12 && (1-x)*(1-x)+y*y <= 1.31*1.31) return 1; else
  if (num==13 && (1+x)*(1+x)+y*y <= 1.31*1.31) return 1; else
  if (num==6 && (1-x)*(1-x)+(1-y)*(1-y) <= 1.31*1.31) return 1; else
  if (num==7 && (1-x)*(1-x)+(1+y)*(1+y) <= 1.31*1.31) return 1; else
  if (num==8 && (1+x)*(1+x)+(1-y)*(1-y) <= 1.31*1.31) return 1; else
  if (num==9 && (1+x)*(1+x)+(1+y)*(1+y) <= 1.31*1.31) return 1; else
  return 0;
}

int main(){
  while(1){
    ilewy=0;
    scanf("%d%d%d%d", &n, &m, &ks, &kl);
    if(n==0) break;
    for(i=1; i<=ks; i++){
      scanf("%d%d", &x1, &y1);
      wys[ilewy].x = x1; wys[ilewy].y = y1; wys[ilewy].nu = 1; ilewy++;
      wys[ilewy].x = x1+1; wys[ilewy].y = y1; wys[ilewy].nu = 4; ilewy++;
      wys[ilewy].x = x1-1; wys[ilewy].y = y1; wys[ilewy].nu = 5; ilewy++;
      wys[ilewy].x = x1; wys[ilewy].y = y1-1; wys[ilewy].nu = 3; ilewy++;
      wys[ilewy].x = x1; wys[ilewy].y = y1+1; wys[ilewy].nu = 2; ilewy++;
    }
    for(i=1; i<=kl; i++){
      scanf("%d%d", &x1, &y1);
      wys[ilewy].x = x1; wys[ilewy].y = y1; wys[ilewy].nu = 0; ilewy++;
      wys[ilewy].x = x1+1; wys[ilewy].y = y1; wys[ilewy].nu = 12; ilewy++;
      wys[ilewy].x = x1-1; wys[ilewy].y = y1; wys[ilewy].nu = 13; ilewy++;
      wys[ilewy].x = x1; wys[ilewy].y = y1-1; wys[ilewy].nu = 11; ilewy++;
      wys[ilewy].x = x1; wys[ilewy].y = y1+1; wys[ilewy].nu = 10; ilewy++;
      wys[ilewy].x = x1+1; wys[ilewy].y = y1+1; wys[ilewy].nu = 6; ilewy++;
      wys[ilewy].x = x1-1; wys[ilewy].y = y1+1; wys[ilewy].nu = 8; ilewy++;
      wys[ilewy].x = x1+1; wys[ilewy].y = y1-1; wys[ilewy].nu = 7; ilewy++;
      wys[ilewy].x = x1-1; wys[ilewy].y = y1-1; wys[ilewy].nu = 9; ilewy++;
    }
    sort(wys, wys+ilewy);
    ii=-1;
    ii++; wyx[ii] = wys[0].x;  wyy[ii] = wys[0].y; for(j=0; j<14; j++) wy[ii][j]=0;
    wy[ii][wys[0].nu]=1;
    for(i=1; i<ilewy; i++){
      if (wys[i].x == wys[i-1].x && wys[i].y == wys[i-1].y) {
        wy[ii][wys[i].nu]=1;
      } else {
        ii++; wyx[ii] = wys[i].x;  wyy[ii] = wys[i].y; for(j=0; j<14; j++) wy[ii][j]=0;
        wy[ii][wys[i].nu]=1;  
      }
    }
    ii++;
    //debug 
/*    for (j=0; j<ii; j++){
      printf("%d %d: ", wyx[j], wyy[j]); for(kk=0; kk<14; kk++) printf("%d", wy[j][kk]); printf("\n");
    }
    printf("=---\n"); */
    //end debug
    pole = n*m; 
    for(i=0; i<ii; i++){
      ile = 0;
      for (q = 1; q <= MAGIC; q++){
        xc = drand48()-0.5; yc = drand48()-0.5;
//	printf("%.3lf %.3lf\n", xc, yc);
	if (zazakresie(xc+wyx[i], yc+wyy[i])) {ile ++; continue;}
        for(j=0; j<=13; j++){
	  if(wy[i][j])
	    if (!sprawdz(xc, yc, j))
	      {ile++; break;}
	}
      }
      //odejmij pole
      pole -= 1.;
      pole += double(MAGIC-ile)/MAGIC;
//      printf("po %d %d: %.4lf\n", wyx[i], wyy[i],  pole);
    }
    printf("%.2lf\n", pole+0.005);
  }
  return 0;
}