#include <stdio.h>
#include <stdlib.h>

#define MAX 1100

int sous[MAX+2][MAX+2];
int deg[MAX+2];
int mohou[MAX+2];
int videl[MAX+2];

int k[MAX+2];
int k_len;

int min[MAX+2],cis[MAX+2];

int n,m;
int pocet;

int barvy[MAX+2];
int odkud;

int obarvi(int v,int barva) {
  barvy[k[v]]=barva;
  for (int i=odkud;i<k_len; i++) if (sous[k[v]][k[i]]) {
    if (barvy[k[i]]==0) {
      int ret=obarvi(i, -1*barva);
      if (!ret) return 0;
    } else if (barvy[k[i]]==barva) return 0;
  }
  return 1;
}

void search(int v) {
  for (int i=odkud;i<k_len; i++) barvy[k[i]]=0;
  int ret=obarvi(v,1);
  if (!ret) for (int i=odkud;i<k_len; i++) mohou[k[i]]=1;
}

void dvasouv(int v) {
  min[v]=cis[v]=pocet++;

  for (int j=0;j<n;j++) if (sous[v][j]) {
    if (cis[j]) {
      if (cis[j] < min[v]) min[v]=cis[j];
    } else {
      int from=k_len;
      dvasouv(j);
      if (min[j] >= cis[v]) /*mame "komponentu" */ {
	k[k_len++]=v;

	odkud=from;
	search(from);	
	k_len=from;
      } else if (min[j] < min[v]) min[v]=min[j];
    }
  } 
  k[k_len++]=v;
}

int main(void)
{
  int i,j,pom,pom2;
  while(1)
  {
    scanf("%d %d",&n,&m);
    if(n==0) break;
    
    for(i=0;i<n;i++) 
      { deg[i]=n-1; for(j=0;j<n;j++) if(i!=j) sous[i][j]=1; }

    for(i=0;i<m;i++)
    {
      scanf("%d %d",&pom,&pom2); pom--; pom2--;
      if(sous[pom][pom2])
      {
        deg[pom]--; deg[pom2]--;
        sous[pom][pom2]=sous[pom2][pom]=0;
      }  
    }

    k_len=0;
    for (i=0; i<n; i++) mohou[i]=videl[i]=cis[i]=0;

    pocet=1;
    for (i=0; i<n; i++) if (!cis[i]) {
      dvasouv(i);
    }

    int sum=0;
    for (i=0;i<n;i++) sum+=mohou[i];

    printf("%d\n", n-sum);
  }
  return 0;
}

/*qzac=qkon=0;
    for(i=0;i<n;i++)
    {
      if(deg[i]<2) { ex[i]=0; q[qkon++]=i;}
    }
    while(qkon>qzac)
    {
      pom=q[qzac++];
      for(i=0;i<n;i++) if(sous[i][pom])
      {
        sous[i][pom]=sous[pom][i]=0;
        deg[i]--;
        if(deg[i]<2) { ex[i]=0; q[qkon++]=i; }
      }
    }

    pom=0;
    for(i=0;i<n;i++) if(ex[i])
    {
      map[i]=pom++;
    }
    pom=0;
    for(i=0;i<n;i++) if(ex[i]) pom++;
    n=pom;
    for(i=0;i<n;i++) 
    {
      i*/

