#include <stdio.h>

int y,b;

int yh[505][505];
int bh[505][505];

int vysl[505][505];

int h(int yp, int bp) {
  if (yp < 0 || bp < 0) return 0;
  if (vysl[yp][bp]!=-1) return vysl[yp][bp];

  int first=yh[yp][bp] + h(yp-1,bp);
  int second=bh[yp][bp] + h(yp, bp-1);

  vysl[yp][bp]=first;
  if (second > vysl[yp][bp]) vysl[yp][bp]=second;

  return vysl[yp][bp];
}

int main(void) {
  while (scanf("%d %d", &y, &b), y) {
    for (int i=0;i<y;i++)
      for (int j=0;j<b;j++)
	vysl[i][j]=-1;

    for (int i=0;i<y;i++) {
      scanf("%d", &yh[i][0]);
      for (int j=1;j<b;j++) {
	int tmp;
	scanf("%d", &tmp);
	yh[i][j]=yh[i][j-1]+tmp;
      }
    }

    for (int j=0;j<b;j++) scanf("%d", &bh[0][j]);
    for (int i=1;i<y;i++) {
      for (int j=0;j<b;j++) {
	scanf("%d", &bh[i][j]);
	bh[i][j]+=bh[i-1][j];
      
      }
    }

    printf("%d\n", h(y-1,b-1));

  }
  

  return 0;
}
