#include <cstdio>
#include <algorithm>
#include <iterator>
#include <string>
#include <vector>
#include <utility>
#include <map>
#include <set>

using namespace std;

typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;

#define MP make_pair
#define FOR(i,a,b) for(int i=a; i<=b; ++i)
#define FORD(i,a,b) for(int i=a; i>=b; --i)
#define REP(i,n) for(int i=0;i<n; ++i)
#define VAR(v,i) __typeof(i) v=(i)
#define FOREACH(i,c) for(VAR(i,(c).begin()); i!=(c).end(); ++i)
#define PB push_back
#define ST first
#define ND second
#define ALL(c) c.begin(),c.end()
#define SIZE(x) (int)x.size()

const int N=110000;
typedef pair<int,PII> typ;
typ t[N];
int n,m;
LL pole;
set<PII> zbior;

bool kryt(typ a,typ b){
  if (a.ST!=b.ST) return a.ST>b.ST;
  return a.ND<b.ND;
}

void dodaj(PII p){
 // printf("dodaje %d %d, pole=%lld\n",p.ST,p.ND,pole);
  if (zbior.empty()){
    zbior.insert(p);
    pole+=(LL)p.ST*(LL)p.ND;
    return;
  }
  set<PII>::iterator it=zbior.upper_bound(p),pom;
  if (it!=zbior.end() && it->ND>=p.ND) return;
  int wys=it==zbior.end()?0:it->ND;
  --it;
  bool koniec=0;
  while (!koniec){
    if (it!=zbior.begin()) pom=it--;
    else pom=it,koniec=1;
    pole+=(LL)(p.ST-pom->ST)*(LL)(min(p.ND,pom->ND)-wys);
    wys=pom->ND;
    if (wys>p.ND) break;
    zbior.erase(pom);
  }
  zbior.insert(p);
 // printf("%lld\n",pole);
}

int main(){  
  while (1){
    zbior.clear();
    scanf("%d %d",&n,&m);
    if (n+m==0) return 0;
    REP(i,n) scanf("%d %d %d",&t[i].ST,&t[i].ND.ST,&t[i].ND.ND);
    t[n++]=MP(m+1,MP(0,m+1));
    sort(t,t+n,kryt);
    pole=0;
    LL res=0;
    int wys=t[0].ST;
    int pos=0;
    while (pos<n){
      int gdzie=pos;
      res+=(LL)pole*(LL)(wys-t[gdzie].ST);
      while (gdzie<n && t[gdzie].ST==t[pos].ST) dodaj(t[gdzie++].ND);
      wys=t[pos].ST;
      pos=gdzie; 
    }
    res+=(LL)pole*t[n-1].ST;
    printf("%lld\n",(LL)m*(LL)m*(LL)m-res);
  }
  return 0;
}
