#include <cstdio>
#include <algorithm>
#include <iterator>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;

#define MP make_pair
#define FOR(i,a,b) for(int i=(a); i<=(b); ++i)
#define FORD(i,a,b) for(int i=(a); i>=(b); --i)
#define REP(i,n) for(int i=0;i<(n); ++i)
#define VAR(v,i) __typeof(i) v=(i)
#define FOREACH(i,c) for(VAR(i,(c).begin()); i!=(c).end(); ++i)
#define PB push_back
#define ST frirst
#define ND second
#define ALL(c) c.begin(),c.end()
#define SIZE(x) (int)x.size()

int mapa[1024][1024][2];
bool vis[1024][1024];
int v1,v2;

#define Pox(x,y) ((x<<10) + y)
#define Posx(p) (p>>10)
#define Posy(p) (p&1023)

int NWD(int a, int b) {return (b==0) ? a : NWD(b, a%b);}

int Calc(int x, int y) {
    int res=0;
    while(!vis[x][y]) {
	vis[x][y] = 1;
	res++;
	int x1=Posx(mapa[x][y][v1]);
	int y1=Posy(mapa[x][y][v1]);
	x=x1;
	y=y1;
    }
    return res;
}

int main(){
    int n;
    char op[100];
    scanf("%s", op);
    while(1) {
	v1=0;
	v2=1;
	sscanf(op, "%d", &n);
	if (n ==0) break;
	REP(x,n) REP(y,n) vis[x][y]=0;
	REP(x,n) REP(y,n) mapa[x][y][v1] = Pox(x,y);
	while(1) {
	    scanf("%s", op);
//	    printf("%s\n",op);
	    if (op[0] >= '0' && op[0] <= '9') break;
	    if (strcmp(op, "rot") == 0) {
		REP(x,n) REP(y,n) mapa[x][y][v2] = mapa[y][n-1-x][v1];
	    } else
	    if (strcmp(op, "rot-") == 0) {
		REP(x,n) REP(y,n) mapa[y][n-1-x][v2] =  mapa[x][y][v1];
//		REP(x,n) REP(y,n) mapa[x][y][v2] = mapa[n-1-y][x][v1];
	    } else
	    
	    if (strcmp(op, "sym") == 0 || strcmp(op, "sym-")==0) {
		REP(x,n) REP(y,n) mapa[x][y][v2] = mapa[n-1-x][y][v1];
	    } else
	    if (strcmp(op, "bhsym") == 0 || strcmp(op, "bhsym-") == 0) {
	        REP(x,n) REP(y,n>>1) mapa[x][y][v2] = mapa[x][y][v1];
		REP(x,n) FOR(y,n>>1,n-1) mapa[x][y][v2] = mapa[n-x-1][y][v1];
	    } else
	    if (strcmp(op, "bvsym") == 0 || strcmp(op, "bvsym-") == 0) {
	        REP(x,n) REP(y,n>>1) mapa[x][y][v2] = mapa[x][y][v1];
		REP(x,n) FOR(y,n>>1,n-1) mapa[x][y][v2] = mapa[x][(n>>1)+(n-y-1)][v1];
	    } else
	    if (strcmp(op, "div-") == 0) {
		REP(i,n) {
		    int wiersz = (i&1) ? (n>>1)+(i>>1) : (i>>1);
		    REP(j,n) mapa[j][wiersz][v2] = mapa[j][i][v1];
		}
	    } else 
	    if (strcmp(op, "div") == 0) {
		REP(i,n) {
		    int wiersz = (i&1) ? (n>>1)+(i>>1) : (i>>1);
//		    REP(j,n) mapa[j][wiersz][v2] = mapa[j][i][v1];
		    REP(j,n) mapa[j][i][v2] = mapa[j][wiersz][v1];
		}
	    }else
	    if (strcmp(op, "mix") == 0) {
		REP(i,n) {
		    if (i&1) {
		        REP(j,n) mapa[(n>>1) + (j>>1)][(i-1) + (j&1)][v2] = mapa[j][i][v1];
//			REP(j,n) mapa[j][i][v2] = mapa[n/2+j/2][i-1+(j&1)][v1];
		    } else {
		        REP(j,n) mapa[j>>1][i+(j&1)][v2] = mapa[j][i][v1];
//			REP(j,n) mapa[j][i][v2] = mapa[j/2][i+(j&1)][v1];
		    }
		}
	    }else
	    if (strcmp(op, "mix-") == 0) {
		for (int i=0; i<n; i+=2) {
		    REP(j,n) mapa[j][i][v2] = mapa[j>>1][i + (j&1)][v1];
		    REP(j,n) mapa[j][i+1][v2] = mapa[(n>>1) + (j>>1)][i+(j&1)][v1];
/*		    if (i&1) {
			REP(j,n) mapa[n/2+j/2][i-1+(j&1)][v2] = mapa[j][i][v1];
		    } else {
			REP(j,n) mapa[j/2][i+(j&1)][v2] = mapa[j][i][v1];
		    }*/
		}
	    }
	    else{
	      REP(i,n) REP(j,n) mapa[j][i][v2] = mapa[j][i][v1];
	    }
	    swap(v1,v2);
	}
	LL res = 1;
	REP(x,n) REP(y,n) if (!vis[x][y]) {
	    LL len = Calc(x,y);
//	    printf("%lld\n", len);
	    res *= LL(len)/NWD(len,res);
	}
	printf("%d\n", int(res));
    }
    return 0;
}
