#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cctype>
#include<cmath>
#include<iostream>
#include<sstream>
#include<string>
#include<utility>
#include<vector>
#include<queue>
#include<map>
using namespace std;

#define VAR(a,b) typeof(b) a=(b)
#define REP(i,n) for (int _n=n, i=0; i<_n; ++i)
#define FOR(i,a,b) for (int i=(a),_b=(b); i<=_b; ++i)
#define FORD(i,a,b) for (int i=(a),_b=(b); i>=_b; --i)

typedef long long LL;
const int INF = 1000000000;

struct pozycja { 
	int pocz;
	vector<int> tab;
	bool operator<(const pozycja & ww)  const {
		if (tab.size() < ww.tab.size()) return false;
		if (tab.size() > ww.tab.size()) return true;
		REP(i,tab.size()) {
			if (tab[i] < ww.tab[i]) return true;
			if (tab[i] > ww.tab[i]) return false;
		}
		if (pocz > ww.pocz) return false;
		if (pocz < ww.pocz) return true;
		return false;
//		return (tab < ww.tab);
	}
};

int n;
priority_queue<pair<int,pozycja> > Q;

int ruch[4][2] = { {0,1},{0,-1},{1,0},{-1,0}};

void dod_kolej(map<pozycja,int> &mapa, pozycja & pp, int ile) {
	if ((mapa.find(pp)==mapa.end())||(mapa[pp]>ile)) {
		mapa[pp] = ile;
		Q.push(make_pair(-ile,pp));
	}
}

bool ok(int pozx, int pozy, pozycja &pp) {
	if (pozx < 0) return false;
	if (pozy < 0) return false;

	if (pozx >= n) return false;
	if (pozy >= n) return false;

	int aa = pp.tab[pozy];
	int wyn = aa >> ((n-pozx-1)*3);
	wyn &= 7;
	if (wyn !=0) 	return true;
	return false;
}
int  get_wart(int pozx, int pozy, pozycja &pp) {
	if (pozx < 0) return -1;
	if (pozy < 0) return -1;

	if (pozx >= n) return -1;
	if (pozy >= n) return -1;


	int aa = pp.tab[pozy];
	int wyn = aa >> ((n-pozx-1)*3);
	wyn &= 7;
	return wyn;
}

void  set_wart(int pozx, int pozy, pozycja &pp, int co) {
	int aa = pp.tab[pozy];
	int bb = get_wart(pozx,pozy,pp);
	bb = (bb << ((n-pozx-1)*3));
	co = (co << ((n-pozx-1)*3));
	pp.tab[pozy] = aa-bb+co;

}



bool topple(int rx, int ry, pozycja & pp, pozycja & nowa) {
	int pox = (pp.pocz)>>4;
	int poy = (pp.pocz)%16;
	int aaa =  get_wart(pox,poy,pp);

	if (aaa > 1) {
		FOR(i,1,aaa) {
			if (get_wart(pox+rx*i,poy+ry*i,pp)!=0) return false;
		}
	} else return false;
	vector<int> tabik (pp.tab.size());
	REP(i,pp.tab.size()) tabik[i] = pp.tab[i];
	nowa.tab =tabik;
	nowa.pocz = ((pox+rx)<<4) + (poy +ry);
	set_wart(pox,poy,nowa,0);
	FOR(i,1,aaa) {
		set_wart(pox+rx*i,poy+ry*i,nowa,1);
	}
	return true;

	
}

int main() {

	while (1) {

	int pozx,pozy;

	map<pozycja,int> mapka;
	scanf("%d%d%d\n",&n,&pozy,&pozx);
	if ((n==0)&&(pozx==0)&&(pozy==0)) return 0;
	pozx--; pozy--;
	vector<int> tabik;
	char ch;
	int konx,kony;
	char bufor[100];
	REP(y,n) {
		int aa = 0;
		gets(bufor);
		REP(x,n) {
			aa = aa<<3;
			ch = bufor[x];
			if (ch=='E') { aa++; konx = x; kony = y; }
			if (ch=='.') { }
			if (ch=='1') { aa++; }
			if (ch=='2') { aa+=2; }
			if (ch=='3') { aa+=3; }
			if (ch=='4') { aa+=4; }
		}
		
		tabik.push_back(aa);
	}
	while (Q.empty()==false) Q.pop();
	int wynik = -1;

	int koncowka = ((konx)<<4)+ kony;
	pozycja  ppp;
	ppp.tab=tabik;
	ppp.pocz = ((pozx)<<4) + (pozy);
	dod_kolej(mapka,ppp,0);
	bool koniec = false;

	while ((koniec == false) &&(!Q.empty())) {
		pair<int,pozycja> ww = Q.top();
		Q.pop();
		ww.first = abs(ww.first);
		pozx = (ww.second.pocz)>>4;
		pozy = (ww.second.pocz)%16;
		int aaa = ww.second.pocz;
		pozycja nowa;
		if (ww.second.pocz==koncowka) {
			wynik = ww.first;
			koniec = true;
		} else {
		
		
		REP(r,4) {
			int aktx = pozx + ruch[r][0];
			int akty = pozy + ruch[r][1];
			if (ok(aktx,akty,ww.second)) {
				ww.second.pocz = (aktx<<4)+akty;
				dod_kolej(mapka,ww.second,ww.first+1);
				ww.second.pocz = aaa;
			} else {
				if (topple(ruch[r][0],ruch[r][1],ww.second,nowa)) {
					dod_kolej(mapka,nowa,ww.first+1);
				}
			}
		}

		}
	}
	if (wynik == -1) {
		printf("Impossible.\n");
	} else {
		printf("%d\n",wynik);
	}

	}
	


	return 0;
}
