#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAX_N 1100
#define MAX_M 1100000
bool hates[MAX_N][MAX_N],safe[MAX_N];
int visited[MAX_N];
vector<int> s[MAX_N],e,s2[MAX_N],current_e;
int k[MAX_M][2],id,low[MAX_N],nr[MAX_N];

bool color(int x,int c) {
  visited[x]=c;
  for (int i=0; i<s2[x].size(); i++)
    if (!visited[s2[x][i]]) { if (!color(s2[x][i],3-c)) return false; }
    else if (visited[s2[x][i]]==c) return false;
  return true;
}

void solve() {
  int i,j;
  
/*  printf("---------\n");
  for (i=0; i<current_e.size(); i++)
    printf("%d %d\n",k[current_e[i]][0],k[current_e[i]][1]);*/
  if (current_e.size()<2) return;
  for (i=0; i<current_e.size(); i++) for (j=0; j<=1; j++) {
    s2[k[current_e[i]][j]].clear();
    visited[k[current_e[i]][j]]=0;
  }
  for (i=0; i<current_e.size(); i++) {
    s2[k[current_e[i]][0]].push_back(k[current_e[i]][1]);
    s2[k[current_e[i]][1]].push_back(k[current_e[i]][0]);
  }
  if (color(k[current_e[0]][0],1)) return;
  for (i=0; i<current_e.size(); i++) for (j=0; j<=1; j++)
    safe[k[current_e[i]][j]]=true;
}

void dfs(int x,int from=-1) {
  int i,j;
  nr[x]=low[x]=++id;
  for (i=0; i<s[x].size(); i++) if (s[x][i]!=from) {
    j=k[s[x][i]][0]^k[s[x][i]][1]^x;
    if (!nr[j]) {
      e.push_back(s[x][i]);
      dfs(j,s[x][i]);
      if (low[j]>=nr[x]) {
      //tu bedzie fajnie
      	current_e.clear();
        while (e.back()!=s[x][i]) {
	  current_e.push_back(e.back());
	  e.pop_back();
	}
	current_e.push_back(e.back());
	solve();
	e.pop_back();
      }
      low[x]<?=low[j];
    }
    else {
      if (nr[j]<nr[x]) e.push_back(s[x][i]);
      low[x]<?=nr[j];
    }
  }
}

int main() {
  int n,m,i,j,z;
  
  while (scanf("%d %d",&n,&m),n) {
    memset(hates,0,sizeof(hates));
    while (m--) {
      scanf("%d %d",&i,&j);
      hates[i][j]=hates[j][i]=true;
    }
    for (i=1; i<=n; i++) { s[i].clear(); nr[i]=0; safe[i]=false; }
    z=0;
    for (i=1; i<=n; i++) for (j=1; j<i; j++) if (!hates[i][j]) {
      k[z][0]=i;
      k[z][1]=j;
      s[i].push_back(z);
      s[j].push_back(z);
      z++;
    }
    for (i=1; i<=n; i++) if (!nr[i]) dfs(i);
    j=0;
    for (i=1; i<=n; i++) j+=!safe[i];
    printf("%d\n",j);
  }
  return 0;
}
