#include <cstdio>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int,int> p2;
typedef pair<int,p2> p3;
typedef long long int64;

#define MAX 110000
p3 tab[MAX];
set<p2> s;
int64 ans;

void update(p2 &p) {
  set<p2>::iterator iter,iter2;

//  printf("%lld ",ans);
  iter=s.lower_bound(p2(p.first,MAX));
  if (iter->second>=p.second) return;
  iter2=iter; iter2--;
  ans-=(int64)(p.first-iter2->first)*(p.second-iter->second);
  while (iter2->second<=p.second) {
    iter=iter2; iter--;
    ans-=(int64)(iter2->first-iter->first)*(p.second-iter2->second);
    s.erase(iter2);
    iter2=iter;
  }
  if (iter2->first<p.first) s.insert(p);
//  for (iter=s.begin(); iter!=s.end(); iter++) {
//    printf("%d:%d ",iter->first,iter->second);
//  }
//  printf("%lld\n",ans);
}

int main() {
  int n,m,i,j;
  int64 sum;

  while(scanf("%d %d",&n,&m),n) {
    for (i=0; i<n; i++)
      scanf("%d %d %d",&tab[i].first,&tab[i].second.first,&tab[i].second.second);
    sort(tab,tab+n);
    s.clear();
    sum=0;
    ans=m*m;
    s.insert(p2(0,m+1));
    s.insert(p2(m+1,0));
    j=n-1;
    for (i=m; i>=1; i--) {
      while (j>=0 && tab[j].first>=i) {
        update(tab[j].second);
	j--;
      }
      sum+=ans;
    }
    printf("%lld\n",sum);
  }

  return 0;
}
