#include <stdio.h>

#define NMAX 66
#define INF 666666

int min[NMAX][NMAX], last[NMAX][NMAX];
int rows[NMAX], cols[NMAX];
int i, j, k, p, N, x, t1, t2;

int main()
{
	int te, T, Q;

	scanf("%d", &T);

	for (te = 1; te <= T; te++)
	{
		scanf("%d", &N);

		for (i = 1; i <= N; i++)
			scanf("%d %d", &rows[i], &cols[i]);

		printf("Matrix #%d\n", te);

		scanf("%d", &Q);

		while (Q--)
		{
			scanf("%d", &x);

			for (i = 1; i <= N; i++)
				for (j = 1; j <= N; j++)
					min[i][j] = last[i][j] = INF;

			for (i = 1; i <= N; i++)
				min[i][i] = last[i][i] = 0;

			for (k = 2; k <= N; k++)
				for (i = 1; i <= N - k + 1; i++)
				{
					j = i + k - 1;

					for (p = i; p < j; p++)
						if (min[i][p] < INF && min[p + 1][j] < INF)
						{
							t1 = min[i][p] + min[p + 1][j] + 1;
							t2 = rows[i] * cols[p] * cols[j];

							if (t2 <= x && (t1 < min[i][j] || (t1 == min[i][j] && t2 < last[i][j])))
								min[i][j] = t1,
								last[i][j] = t2;

							t1--;

							if (i == p)
								t1++;

							t2 = last[i][p] + rows[i] * cols[p] * cols[j];

							if (t2 <= x && (t1 < min[i][j] || (t1 == min[i][j] && t2 < last[i][j])))
								min[i][j] = t1,
								last[i][j] = t2;
						}
				}

			if (min[1][N] == INF)
				printf("Impossible.\n");
			else
				printf("%d\n", min[1][N]);
		}

		printf("\n");
	}

	return 0;
}