{$APPTYPE CONSOLE}

uses
  Math;

 procedure SortSwap(var a, b: Integer);
 var
   t: Integer;
 begin
   if a > b then begin
     t := a; a := b; b := t;
   end;
 end;

var
  dx, dy, x1, y1, x2, y2, x3, y3, x4, y4, x, y: Integer;
  ch: Char;
  f: TextFile;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Readln(f, x1, y1, x2, y2, x3, y3, x4, y4);
  dx := 0; dy := 0;
  while not Eof(f) do begin
     Read(f, ch);
     case ch of
       'n': Inc(dy);
       's': Dec(dy);
       'e': Inc(dx);
       'w': Dec(dx);
     end;
  end;
  CloseFile(f);

  SortSwap(x1, x2); SortSwap(y1, y2);
  SortSwap(x3, x4); SortSwap(y3, y4);

  AssignFile(f, 'output.txt'); Rewrite(f);
  for y := y4 downto y3 do begin
    for x := x3 to x4 do
      if InRange(x - dx, x1, x2) and InRange(y - dy, y1, y2) then
        Write(f, 'x')
      else
        Write(f, '.');
    Writeln(f);
  end;
  CloseFile(f);

end.
