/*---------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                     */
/* Northern Subregional Contest                                  */
/* St Petersburg, October 29, 2005                               */
/*---------------------------------------------------------------*/
/* Problem C. Cutting a Block                                    */
/*                                                               */
/* Original idea         Georgiy Korneev                         */
/* Problem statement     Georgiy Korneev                         */
/* Testset               Georgiy Korneev                         */
/*---------------------------------------------------------------*/
/* Solution                                                      */
/*                                                               */
/* Author:               Andrew Stankevich                       */
/*---------------------------------------------------------------*/

import java.util.Scanner;
import java.util.Locale;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class cutting_as {
    public static void main(String[] args) throws FileNotFoundException {
        Locale.setDefault(Locale.US);

        Scanner in = new Scanner(new File("cutting.in"));
        double x = in.nextInt();
        double y = in.nextInt();
        double z = in.nextInt();
        int n = in.nextInt();
        in.close();

        PrintWriter out = new PrintWriter(new File("cutting.out"));
        for (int i = 0; i < n; i++) {
            out.printf("%.8f %.8f %.8f %.8f %.8f %.8f\n", x * i / n, 0.0, 0.0, x * (i + 1) / n, y, z);
        }
        out.close();
    }
}
