#include <stdio.h>
#include <string.h>

#include <vector>

using namespace std;

#define QMAX 1010
#define NMAX 22222

int dl[4] = { -1, 0, +1, 0 };
int dc[4] = { 0, +1, 0, -1 }; 

int A[QMAX][QMAX], cnt[NMAX];
vector<int> l[2][NMAX], c[2][NMAX];
int i, j, k, t, M, N, nc, x, y, ine, jne, T, modif, cur, ant;

int main()
{
	//freopen("e.in", "r", stdin);
	
	scanf("%d %d %d %d", &M, &N, &nc, &T);

	memset(A, 0, sizeof(A));

	cur = 0;

	for (k = 1; k <= nc; k++)
	{
		scanf("%d %d", &i, &j);

		A[i][j] = k;

		l[cur][k].clear();
		l[cur][k].push_back(i);
		c[cur][k].clear();
		c[cur][k].push_back(j);
	}

	modif = 1;

	while ((T--) && modif)
	{
		modif = 0;

		ant = cur;
		cur = 1 - cur;

		for (k = 1; k <= nc; k++)
		{
			l[cur][k].clear();
			c[cur][k].clear();

			x = l[ant][k].size();
			for (t = 0; t < x; t++)
			{
				i = l[ant][k][t], j = c[ant][k][t];

				for (y = 0; y < 4; y++)
				{
					ine = i + dl[y], jne = j + dc[y];

					if (ine >= 1 && ine <= M && jne >= 1 && jne <= N && !A[ine][jne])
					{
						A[ine][jne] = k;
						modif = 1;

						l[cur][k].push_back(ine);
						c[cur][k].push_back(jne);
					}
				}
			}
		}
	}

	memset(cnt, 0, sizeof(cnt));

	for (i = 1; i <= M; i++)
		for (j = 1; j <= N; j++)
			cnt[A[i][j]]++;

	for (i = 1; i <= nc; i++)
		printf("%d\n", cnt[i]);

	return 0;
}