#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <algorithm>
#include <vector>
#include <map>

using namespace std;

#define NMAX 1010

int C[NMAX], viz[NMAX], f[NMAX][2], c[NMAX][2];
vector<int> card[NMAX], cc[NMAX], fard[NMAX], fc[NMAX];
map<int, int> mcard[NMAX], mc[NMAX];
int i, j, k, N;

int ok(int x, int o)
{
	int i, j, t0, t1;

	if (!mc[c[x][o]][f[x][o]])
		return 0;

	if (viz[x])
		return 1;

	viz[x] = 1;

	mc[c[x][1 - o]][f[x][1 - o]] = 0;

	for (i = 0; i < fc[f[x][o]].size(); i++)
		if (fc[f[x][o]][i] != c[x][o] && mc[fc[f[x][o]][i]][f[x][o]])
			mc[fc[f[x][o]][i]][f[x][o]] = 0;

	for (j = 0; j < cc[c[x][o]].size(); j++)
		if (cc[c[x][o]][j] != f[x][o] && mc[c[x][o]][cc[c[x][o]][j]])
			mc[c[x][o]][cc[c[x][o]][j]] = 0;

	for (i = 1; i <= N; i++)
		if (i != x && !C[i] && !viz[i])
		{
			t0 = mc[c[i][0]][f[i][0]];
			t1 = mc[c[i][1]][f[i][1]];

			if (!t0 && !t1)
				return 0;

			if (t0 && !t1)
			{
				if (!ok(i, 0))
					return 0;
			}
			else
			if (!t0 && t1)
			{
				if (!ok(i, 1))
					return 0;
			}
		}

	return 1;
}

int main()
{
	int t0, t1;

	//freopen("c.in", "r", stdin);
	
	scanf("%d", &N);

	for (i = 1; i <= N; i++)
	{
		card[i].clear();
		mcard[i].clear();
		fard[i].clear();
	}

	for (i = 1; i <= N; i++)
	{
		f[i][0] = i;

		scanf("%d %d %d", &c[i][0], &f[i][1], &c[i][1]);

		card[c[i][0]].push_back(f[i][0]);
		fard[f[i][0]].push_back(c[i][0]);
		mcard[c[i][0]][f[i][0]] = 1;

		card[c[i][1]].push_back(f[i][1]);
		fard[f[i][1]].push_back(c[i][1]);
		mcard[c[i][1]][f[i][1]] = 1;
	}

	memset(C, 0, sizeof(C));

	for (i = 1; i <= N; i++)
		if (!C[i])
		{
			for (j = 1; j <= N; j++)
			{
				mc[j] = mcard[j];
				cc[j] = card[j];
				fc[j] = fard[j];
			}

			memset(viz, 0, sizeof(viz));

			if (!ok(i, 0))
			{
				for (j = 1; j <= N; j++)
				{
					mc[j] = mcard[j];
					cc[j] = card[j];
					fc[j] = fard[j];
				}

				memset(viz, 0, sizeof(viz));

				if (!ok(i, 1))
					C[i] = -1;
				else
				{
					C[i] = 2;

					for (j = 1; j <= N; j++)
					{
						mcard[j] = mc[j];
						card[j] = cc[j];
						fard[j] = fc[j];
					}
				}
			}
			else
			{
				C[i] = 1;

				for (j = 1; j <= N; j++)
				{
					mcard[j] = mc[j];
					card[j] = cc[j];
					fard[j] = fc[j];
				}
			}
	
			for (j = 1; j <= N; j++)
				if (!C[j])
				{
					t0 = mcard[c[j][0]][f[j][0]];
					t1 = mcard[c[j][1]][f[j][1]];

					if (t0 && !t1)
					{
						C[j] = 1;
					}
					else
					if (!t0 && t1)
					{
						C[j] = 2;
					}
				}
		}

	for (i = 1; i <= N; i++)
		printf("%d ", C[i]);

	printf("\n");

	return 0;
}