#include <stdio.h>

#define DMAX 1024
#define NMAX 10000

#define CDIM (DMAX*DMAX)

double A[DMAX][DMAX];
int incoada[DMAX][DMAX];

int N, Vol, Bani, p1, p2;
int vol[NMAX], bani[NMAX];
double intens[NMAX];

int ci[CDIM], cj[CDIM];

int cmmdc(int a, int b)
{
 if (!b)
    return a;
 else
     return cmmdc(b, a % b);
}

int main()
{
 int i, j, di, dj, ic, jc, t, a, b, rap;
 double dc, best;
 double c;

 freopen("b.in", "r", stdin);
 
 scanf("%d%d%d\n", &N, &Vol, &Bani);
 rap = cmmdc(Vol, Bani);
 Vol /= rap;
 Bani /= rap;

 for (i = 0; i < N; i++)
 {
     scanf("%d %d %lf", &a, &b, &c);
     t = cmmdc(a, b);
     a /= t;
     b /= t;
     c /= t;
     if (c > A[a][b])
        A[a][b] = c;
 }
 
 N = 0;
 p1 = 0;
 p2 = 0;
 for (i = 0; i <= 100; i++)
     for (j = 0; j <= 100; j++)
         if (A[i][j] > 0)
         {
          vol[N] = i;
          bani[N] = j;
          intens[N] = A[i][j];
          
          ci[p2] = i;
          cj[p2] = j;
          
          p2++;
          incoada[i][j] = 1;
          N++;
         }


  while (p1 != p2)
  {
    ic = ci[p1];
    jc = cj[p1];

    for (i = 0; i < N; i++)
    {
        di = ic + vol[i];
        dj = jc + bani[i];

        t = cmmdc(di, dj);
        di /= t;
        dj /= t;

        if (di >= DMAX || dj >= DMAX)
           continue;

        dc = (A[ic][jc] + intens[i]) / t;
        if (A[di][dj] < dc)
        {
            A[di][dj] = dc;
            if (!incoada[di][dj])
            {
               ci[p2] = di;
               cj[p2] = dj;

               incoada[di][dj] = 1;
               
               p2 = (p2 + 1) % CDIM;
            }
            
        }
        
    }

    incoada[ic][jc] = 0;
    p1 = (p1 + 1) % CDIM;
  }

  best = 0;
  for (i = 1; i <= Vol; i++)
      for (j = 1; j <= Bani; j++)
          if (A[i][j] > best)
           best = A[i][j];

  printf("%.6lf\n", best * rap);
           
 return 0;
}

