#include <stdio.h>

#include <vector>
#include <algorithm>
#define NMAX 32000
#define INF 666666

using namespace std;

int nev[NMAX], sat[NMAX];
int N, K;
vector<int> f[NMAX];
vector<int> sol;

void df(int vf, int tata)
{
 int i;
 nev[vf] = 0;
 sat[vf] = K+1;
 
 for (i = 0; i < f[vf].size(); i++)
 {
     if (f[vf][i] == tata)
        continue;
     df(f[vf][i], vf);
     if (nev[f[vf][i]]+1 > nev[vf])
        nev[vf] = nev[f[vf][i]]+1;
        
     if (sat[f[vf][i]]+1 < sat[vf])
        sat[vf] = sat[f[vf][i]] + 1;
 }

 if (nev[vf] + sat[vf] <= K)
    nev[vf] = -INF;

 if (nev[vf] == K)
 {
     sol.push_back(vf);
     nev[vf] = -INF;
     sat[vf] = 0;
 }
}

int main()
{
 int i, l1, l2;
 
/* freopen("d.in", "r", stdin); */
 scanf("%d %d", &N, &K);

 for (i = 0; i < N-1; i++)
 {
  scanf("%d%d", &l1, &l2);
  f[l1].push_back(l2);
  f[l2].push_back(l1);
 }

 df(1, -1);
 if (nev[1] >= 0)
    sol.push_back(1);

 printf("%d\n", sol.size());
 sort(sol.begin(), sol.end());

 for (i = 0; i < sol.size(); i++)
     printf("%d ", sol[i]);
 printf("\n");

 return 0;
}

