#include <stdio.h>

#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 111111

vector<int> vM, vN;
int sM[NMAX], sN[NMAX];
int i, j, k, M, N, c, C;
int mi, ma;

int main()
{
    //freopen("3.in", "r", stdin);

    scanf("%d %d %d %d", &M, &N, &c, &C);

    for (i = 0; i < M; i++)
    {
        scanf("%d", &k);
        vM.push_back(k);
    }

    for (i = 0; i < N; i++)
    {
        scanf("%d", &k);
        vN.push_back(k);
    }

    sort(vM.begin(), vM.end());
    sort(vN.begin(), vN.end());

    mi = ma = 0;

    sM[0] = vM[0];
    for (i = 1; i < M; i++)
        sM[i] = sM[i - 1] + vM[i];

    sN[0] = vN[0];
    for (i = 1; i < N; i++)
        sN[i] = sN[i - 1] + vN[i];


    if (vM[M - 1] != vN[N - 1])
    {
        printf("Impossible\n");
        return 0;
    }

    i = 0;
    j = 0;
    while (i < M)
    {
        while (j < N && vN[j] <= vM[i])
              j++;

        if (j > 0)
           ma += sN[j - 1];

        ma += vM[i] * (N - j);
        i++;
    }

    i = M - 1;
    j = N - 1;
    while (i >= 0 && j >= 0)
    {
        if (vM[i] == vN[j])
        {
            mi += vM[i];
            i--;
            j--;
        }
        else
        if (vM[i] > vN[j])
        {
            mi += vM[i];
            i--;
        }
        else
        {
            mi += vN[j];
            j--;
        }
    }

    while (i >= 0)
          mi += vM[i--];

    while (j >= 0)
          mi += vN[j--];

    printf("Minimum: %d, maximum: %d\n", mi * c, ma * C);

    return 0;
}
