{$R+,Q+}
type int = longint;
const MAXS = 2100;
var x, y: array [0..4, 1..MAXS] of int;
var vert, c: array [1..MAXS] of int;
var n: int;

var bug: boolean;

procedure color(u: int);
var i: int;
begin
  c[u]:=0;
  for i:=1 to 3 do
    begin
      if (y[i + 1][u] = y[i][u]) and (y[i - 1][u] > y[i][u]) then
        begin
          if c[u] <> 0 then
            begin
              bug:=true;
              exit;
            end;
          c[u]:=1;
          vert[u]:=i - 1;
        end;
      if (y[i + 1][u] = y[i][u]) and (y[i - 1][u] < y[i][u]) then
        begin
          if c[u] <> 0 then
            begin
              bug:=true;
              exit;
            end;
          c[u]:=3;
          vert[u]:=i - 1;
        end;
      if (x[i + 1][u] = x[i][u]) and (x[i - 1][u] > x[i][u]) then
        begin
          if c[u] <> 0 then
            begin
              bug:=true;
              exit;
            end;
          c[u]:=4;
          vert[u]:=i - 1;
        end;
      if (x[i + 1][u] = x[i][u]) and (x[i - 1][u] < x[i][u]) then
        begin
          if c[u] <> 0 then
            begin
              bug:=true;
              exit;
            end;
          c[u]:=2;
          vert[u]:=i - 1;
        end;
    end;
  if c[u] = 0 then
    begin
      bug:=true;
      exit;
    end;
  if vert[u] = 0 then vert[u]:=3;
  if vert[u] = 4 then vert[u]:=1;
end;

var a, b: int;

procedure count_a;
var u, i, a1, a2: int;
begin
  a1:=0;
  a2:=0;
  for i:=1 to n do
    if c[i] mod 2 = 1 then
      begin
        u:=vert[i];
        if c[i] = 1 then
          a1:=a1 + abs(x[u + 1][i] - x[u - 1][i]);
        if c[i] = 3 then
          a2:=a2 + abs(x[u + 1][i] - x[u - 1][i]);
      end;
  if a1 <> a2 then
    begin
      bug:=true;
      exit;
    end;
  a:=a1;
end;

procedure count_b;
var u, i, b1, b2, hh: int;
begin
  b1:=0;
  b2:=0;
  for i:=1 to n do
    if c[i] mod 2 = 0 then
      begin
        u:=vert[i];
        if c[i] = 2 then
          b1:=b1 + abs(y[u + 1][i] - y[u - 1][i]);
        if c[i] = 4 then
          b2:=b2 + abs(y[u + 1][i] - y[u - 1][i]);
      end;
  if b1 <> b2 then
    begin
      bug:=true;
      exit;
    end;
  b:=b1;
end;

var h1, h2, h3, h4: int;

procedure count_h;
var u, i, hh: int;
begin
  for i:=1 to n do
    begin
      u:=vert[i];
      if c[i] = 1 then
        begin
          hh:=abs(y[u][i] - y[u + 1][i]);
          if h1 = -1 then h1:=hh;
          if h1 <> hh then
            begin
              bug:=true;
              exit;
            end;
        end;
      if c[i] = 3 then
        begin
          hh:=abs(y[u][i] - y[u + 1][i]);
          if h3 = -1 then h3:=hh;
          if h3 <> hh then
            begin
              bug:=true;
              exit;
            end;
        end;
      if c[i] = 2 then
        begin
          hh:=abs(x[u][i] - x[u + 1][i]);
          if h2 = -1 then h2:=hh;
          if h2 <> hh then
            begin
              bug:=true;
              exit;
            end;
        end;
      if c[i] = 4 then
        begin
          hh:=abs(x[u][i] - x[u + 1][i]);
          if h4 = -1 then h4:=hh;
          if h4 <> hh then
            begin
              bug:=true;
              exit;
            end;
        end;
    end;
end;

var x0, y0: int;
var xx, yy: array [0..4, 1..MAXS] of int;

procedure find_new_coordinates;
var i, u, j: int;
var dx, dy: int;
begin
  for i:=1 to n do
    begin
      u:=vert[i];
      dx:=x0 - x[u][i];
      dy:=y0 - y[u][i];
      for j:=0 to 4 do
        begin
          xx[j][i]:=x[j][i] + dx;
          yy[j][i]:=y[j][i] + dy;
        end;
    end;
end;

var mark: array [0..11000] of boolean;
procedure check_new_coordinates;
var tmp, u, j1, j2, i, j: int;
var l1, l2, l3, l4: int;
begin
  l1:=0;
  l2:=0;
  l3:=0;
  l4:=0;
  for i:=1 to n do
    for j:=1 to 3 do
      begin
        if (xx[j][i] < 0) or (xx[j][i] > a) or
           (yy[j][i] < 0) or (yy[j][i] > b) then
             begin
               bug:=true;
               exit;
             end;
        if (xx[j][i] = 0) and (yy[j][i] = 0) then
          inc(l1);
        if (xx[j][i] = a) and (yy[j][i] = 0) then
          inc(l2);
        if (xx[j][i] = a) and (yy[j][i] = b) then
          inc(l3);
        if (xx[j][i] = 0) and (yy[j][i] = b) then
          inc(l4);
      end;
  if (l1 <> 2) or (l2 <> 2) or (l3 <> 2) or (l4 <> 2) then
    begin
      bug:=true;
      exit;
    end;
  for i:=0 to 10000 do
    mark[i]:=false;
  for i:=1 to n do
    if c[i] = 1 then
      begin
        u:=vert[i];
        j1:=xx[u - 1][i];
        j2:=xx[u + 1][i];
        if j1 > j2 then
          begin
            tmp:=j1;
            j1:=j2;
            j2:=tmp;
          end;
        for j:=j1 to j2 - 1 do
          begin
            if mark[j] then
              begin
                bug:=true;
                exit;
              end;
            mark[j]:=true;
          end;
      end;
  for i:=0 to 10000 do
    mark[i]:=false;
  for i:=1 to n do
    if c[i] = 3 then
      begin
        u:=vert[i];
        j1:=xx[u - 1][i];
        j2:=xx[u + 1][i];
        if j1 > j2 then
          begin
            tmp:=j1;
            j1:=j2;
            j2:=tmp;
          end;
        for j:=j1 to j2 - 1 do
          begin
            if mark[j] then
              begin
                bug:=true;
                exit;
              end;
            mark[j]:=true;
          end;
      end;
  for i:=0 to 10000 do
    mark[i]:=false;
  for i:=1 to n do
    if c[i] = 2 then
      begin
        u:=vert[i];
        j1:=yy[u - 1][i];
        j2:=yy[u + 1][i];
        if j1 > j2 then
          begin
            tmp:=j1;
            j1:=j2;
            j2:=tmp;
          end;
        for j:=j1 to j2 - 1 do
          begin
            if mark[j] then
              begin
                bug:=true;
                exit;
              end;
            mark[j]:=true;
          end;
      end;
  for i:=0 to 10000 do
    mark[i]:=false;
  for i:=1 to n do
    if c[i] = 4 then
      begin
        u:=vert[i];
        j1:=yy[u - 1][i];
        j2:=yy[u + 1][i];
        if j1 > j2 then
          begin
            tmp:=j1;
            j1:=j2;
            j2:=tmp;
          end;
        for j:=j1 to j2 - 1 do
          begin
            if mark[j] then
              begin
                bug:=true;
                exit;
              end;
            mark[j]:=true;
          end;
      end;
end;

var i: int;
begin
  assign(input, 'glass.in');
  assign(output, 'glass.out');
  reset(input);
  rewrite(output);
  read(n);
  for i:=1 to n do
    begin
      read(x[1][i], y[1][i], x[2][i], y[2][i], x[3][i], y[3][i]);
      x[0][i]:=x[3][i];
      y[0][i]:=y[3][i];
      x[4][i]:=x[1][i];
      y[4][i]:=y[1][i];
    end;
  bug:=false;
  for i:=1 to n do
    color(i);
  if bug then
    begin
      writeln('NO');
      close(input);
      close(output);
      exit;
    end;
  count_a;
  count_b;
  h1:=-1;
  h2:=-1;
  h3:=-1;
  h4:=-1;
  count_h;
  if (h1 + h3 <> b) or (h2 + h4 <> a) then
    bug:=true;
  if bug then
    begin
      writeln('NO');
      close(input);
      close(output);
      exit;
    end;
  x0:=h4;
  y0:=h1;
  find_new_coordinates;
  check_new_coordinates;
  if bug then
    begin
      writeln('NO');
      close(input);
      close(output);
      exit;
    end;
  for i:=1 to n do
    begin
      write(xx[1][i], ' ', yy[1][i], ' ');
      write(xx[2][i], ' ', yy[2][i], ' ');
      writeln(xx[3][i], ' ', yy[3][i]);
    end;
  close(input);
  close(output);
end.
