{.$define debug}

{$R-,Q-,S-,I-}

program template;
const
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 h = 1000;
 {$else}
 h = 101000;
 cinfile = 'fishes.in';
 coutfile = 'fishes.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 n,k :int;
 src :array [1..h] of byte;
 b :array [1..h] of int;
 m :int;
 d :array [1..h] of int;
 w :int;

procedure init;
begin
 fillchar (src,sizeof(src),0);
 fillchar (b,sizeof(b),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln(n,k);
 for i := 1 to n do
  read (src[i]);
 close (input);
end;

procedure solve;
var i,j :int;
    les :int;
    q :int;
    trance :array [1..h] of int;
    reach :int;
    maxgroup :int;
begin
 m := 1;
 b[1] := 1;
 for i := 2 to n do
  begin
   if src[i] = src[i-1] then
    inc (b[m])
   else
    begin
     inc(m);
     b[m] := 1;
    end;
  end;
 assign (output,coutfile);
 rewrite (output);
 while m > 2 do
  begin
   {$ifdef debug}
   fillchar (d,sizeof(d),0);
   fillchar (trance,sizeof(trance),0);
   {$endif}
   w := 0;
   q := 0;
   w := 1;
   d[1] := b[1];
   reach := b[1];
   maxgroup := 0;
   for i := 1 to k do
    begin
     if 3*i > m then
      break;
     d[w] := d[w] + b[3*i];
     inc(w);
     d[w] := b[3*i-1] + b[3*i+1];
     inc(q);
     trance[q] := reach + 1;
     reach := reach + b[3*i-1] + b[3*i] + b[3*i+1];
     maxgroup := 3*i+1;
    end;
   for i := maxgroup+1 to m do
    begin
     inc(w);
     d[w] := b[i];
    end;
   m := w;
   move (d,b,sizeof(d));
   write (q,' ');
   for i := 1 to q do
    write (trance[i],' ');
   writeln;
  end;
 writeln (0);
 close (output);
end;

begin
 init;
 readdata;
 solve;
end.