type
    TVector = record
               X,Y:LongInt;
              end;

    TTriangle = record
                 X,Y:LongInt;
                 S:array[1..3] of Byte;
                 V1,V2:TVector;
                end;

var
   i,j,k,N,UC:LongInt;
   T:array [1..2000] of TTriangle;
   U:array [1..2000] of Word;
   No:Boolean;

function Mul(V1,V2:TVector):LongInt;
 begin
  Mul:=V1.X*V2.Y-V1.Y*V2.X;
 end;

procedure SwapV(var V1,V2:TVector);
 var
    V:TVector;
 begin
  Move(V1,V,SizeOf(TVector));
  Move(V2,V1,SizeOf(TVector));
  Move(V,V2,SizeOf(TVector));
 end;

procedure ReadData;
 var
    P:array[1..3] of TVector;

 begin
  Assign(Input,'glass.in');
  Reset(Input);

  Readln(N);
  for i:=1 to N do
   begin
    Readln(P[1].X,P[1].Y,P[2].X,P[2].Y,P[3].X,P[3].Y);
    for j:=1 to 3 do
     begin
      k:=j+1;
      if k>3 then
       k:=1;
      if (P[j].X=P[k].X)or(P[j].Y=P[k].Y) then
       begin
        T[i].X:=P[6-j-k].X;
        T[i].Y:=P[6-j-k].Y;
        T[i].S[3]:=6-j-k;
        T[i].S[1]:=j;
        T[i].S[2]:=k;
        T[i].V1.X:=P[j].X-T[i].X;
        T[i].V1.Y:=P[j].Y-T[i].Y;
        T[i].V2.X:=P[k].X-T[i].X;
        T[i].V2.Y:=P[k].Y-T[i].Y;
        if Mul(T[i].V1,T[i].V2)>0 then
         begin
          SwapV(T[i].V1,T[i].V2);
          T[i].S[1]:=k;
          T[i].S[2]:=j;
         end;
       end;
     end;
   end;

  Close(Input);
  Assign(Input,'CON');
  Reset(Input);
 end;

procedure WriteData;
 begin
  Assign(Output,'glass.out');
  Rewrite(Output);

  if No then
   Write('NO')
  else
   for i:=1 to N do
    begin
     for j:=1 to 3 do
      for k:=1 to 3 do
       if T[i].S[k]=j then
        begin
         case k of
          1: Write(T[i].V1.X,' ',T[i].V1.Y,' ');
          2: Write(T[i].V2.X,' ',T[i].V2.Y,' ');
          3: Write(T[i].X,' ',T[i].Y,' ');
         end;
         Break;
        end;
     Writeln;
    end;

  Close(Output);
  Assign(Output,'CON');
  Rewrite(Output);
 end;

procedure Solve;
 var
    Xm,Ym,Im,Dx,Dy:LongInt;
    First:Boolean;
 begin
  k:=1;
  UC:=1;
  FillChar(u,SizeOf(U),0);
  U[1]:=1;
  repeat
   No:=true;
   for i:=1 to N do
    if (U[i]=0)and(T[k].V2.X=T[i].V1.X)and(T[k].V2.Y=T[i].V1.Y) then
     begin
      U[i]:=1;
      No:=false;
      Inc(UC);
      k:=i;
      Break;
     end;
   if No then
    Exit;
  until (T[k].V2.X=T[1].V1.X)and(T[k].V2.X=T[1].V1.X);
  if UC<N then
   begin
    No:=true;
    Exit;
   end;
  Xm:=1000000;
  Ym:=1000000;
  for i:=1 to N do
   begin
    T[i].V1.X:=T[i].V1.X+T[i].X;
    T[i].V1.Y:=T[i].V1.Y+T[i].Y;
    T[i].V2.X:=T[i].V2.X+T[i].X;
    T[i].V2.Y:=T[i].V2.Y+T[i].Y;
    if (T[i].V1.X=T[i].V2.X)and(T[i].X>T[i].V1.X)and(T[i].V1.X<Xm) then
     begin
      Im:=i;
      Xm:=T[i].V1.X;
      Ym:=T[i].V1.Y;
     end;
   end;
  Xm:=T[Im].X-Xm;
  Ym:=T[Im].Y-Ym;
  for i:=1 to N do
   begin
    Dx:=T[i].X-Xm;
    Dy:=T[i].Y-Ym;
    T[i].X:=T[i].X-Dx;
    T[i].V1.X:=T[i].V1.X-Dx;
    T[i].V2.X:=T[i].V2.X-Dx;
    T[i].Y:=T[i].Y-Dy;
    T[i].V1.Y:=T[i].V1.Y-Dy;
    T[i].V2.Y:=T[i].V2.Y-Dy;
   end;
 end;


begin
 ReadData;
 Solve;
 WriteData;
end.