{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
uses crt;

const
   max = 1000;
   input = 'chain.in';
   output = 'chain.out';

type
   TWord = string[10];
   TWords= array [0..max] of TWord;
   setchar = set of char;

var
   words: TWords;
   min, minc, N: integer;
   log: string;
   ws, minws: array [1..max] of integer;
   used: array [0..max] of boolean;
   st: string;
   ch: setchar;
   predch: char;
   back: boolean;

   fin, fout: Text;
   i, j: integer;
   b:boolean;

procedure GameOver;
begin
   WriteLn(fout, '?');
   Close(fout);
   Halt;
end;

function SetMin: boolean;
var
  l, k: integer;
begin
   SetMin:=false;
   if st<>'' then
   begin
      l:=1;
      for k:=1 to Length(st) do
         if st[k]=log[l] then
         begin
            Inc(l);
            if l>Length(log) then
            begin
               minws:=ws;
               min:=Length(st);
               minc:=i;

               SetMin:=true;
               Break;
           end;
         end;
   end;
end;

begin
   Assign(fin, input);
   Reset(fin);
   ReadLn(fin, log);
   ReadLn(fin, N);
   for i:=1 to N do
   begin
      ReadLn(fin, words[i]);
      for j:=1 to Length(words[i]) do
         ch:=ch+[words[i][j]];
   end;

   Assign(fout, output);
   Rewrite(fout);

   for i:=1 to length(log) do
      if not (log[i] in ch) then GameOver;

   i:=0;st:='';min:=0;minc:=0;
   predch:=' ';
   j:=1;back:=false;
      {backtrack}
   repeat
      b:=false;
      if not back then b:=SetMin;

      if not b then
      begin
         if not back then j:=1
            else j:=ws[i+1]+1;
         Back:=true;

      while j<=N do
         if not used[j] then
         begin
            if (Words[j][1]=predch) or
               (predch=' ') and
               ((min=0) or (min>length(st)+length(words[j]))) then
            begin
               Inc(i);
               ws[i]:=j;
               used[j]:=true;
               predch:=words[j][length(words[j])];
               if i>1 then st:=st+Copy(words[j], 2, length(words[j]))
                  else st:=words[j];
               back:=false;
               Break;
            end else Inc(j);
         end else Inc(j);

         if not back then Continue;

      end;

      if i=0 then Break;

      if i>1 then
      begin
         Delete(st, length(st)-length(words[ws[i]])+2, length(words[ws[i]])-1);
         predch:=words[ws[i]][1];
      end
        else begin st:='';predch:=' ';end;
      Used[ws[i]]:=false;
      Dec(i);
      Back:=true;
   until false;
   if min=0 then GameOver;

   for i:=1 to minc do
      WriteLn(fout, words[minws[i]]);

   Close(fout);
end.