{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}
program Chain_Word;

const
  maxl = 255; {255}

type
  TWord = string[10];

var
  slogan : string;
  n : integer;          {1..1000}
  l : integer;          {1..250}
  words : array [1..1000] of TWord;
  fword : array ['a'..'z'] of Integer;
  nword : array [1..1000] of Integer;
  a : array [0..maxl,'`'..'z'] of Longint;
  p : array [0..maxl,'`'..'z'] of Integer;
  c : array [0..maxl,'`'..'z'] of Char;
  w : array [0..maxl,'`'..'z'] of Integer;

procedure Load;
var
  i : integer;
begin
  assign(input,'chain.in'); reset(input);
  assign(output,'chain.out'); rewrite(output);
  readln(slogan);
  l := length(slogan);
  readln(n);
  fillchar(fword,sizeof(fword),0);
  fillchar(nword,sizeof(nword),0);
  for i:=1 to n do
  begin
    readln(words[i]);
    nword[i] := fword[words[i,1]];
    fword[words[i,1]] := i;
  end;
end;

procedure Solve;
var
  i,k : integer;
  t : longint;
  v : array ['`'..'z'] of boolean;
  cur,j : char;

procedure Relax1;
begin
  j := words[k,length(words[k])];
  t := a[i,cur] + length(words[k]) - 1;
  if (a[i,j]=-1) or (a[i,j]>t) then
  begin
    a[i,j] := t;
    p[i,j] := i;
    c[i,j] := cur;
    w[i,j] := k;
  end;
end;

procedure Relax2;
var
  tmp,temp,ttt : integer;
begin
  j := words[k,length(words[k])];
  t := a[i,cur] + length(words[k]) - 1;
  tmp := i;
  if cur='`' then
    ttt := 1
  else
    ttt := 2;
  for temp:=ttt to length(words[k]) do
  begin
    if (tmp<l) and (slogan[tmp+1]=words[k,temp]) then
      inc(tmp);
  end;
  for temp:=i+1 to tmp do
    if (a[temp,j]=-1) or (a[temp,j]>t) then
    begin
      a[temp,j] := t;
      p[temp,j] := i;
      c[temp,j] := cur;
      w[temp,j] := k;
    end;
end;

begin
  fillchar(a,sizeof(a),255);
  a[0,'`'] := 1;
  for i:=0 to l do
  begin
    fillchar(v,sizeof(v),0);
    repeat                                      {Djkstra}
      cur := #0;
      for j:='`' to 'z' do
        if (a[i,j]<>-1) and (not v[j]) and ((cur=#0) or (a[i,j]<a[i,cur])) then
          cur := j;
      if cur=#0 then
        break;
      v[cur] := true;
      if cur='`' then
        for k:=1 to n do
          Relax1
      else
      begin
        k := fword[cur];
        while k<>0 do
        begin
          Relax1;
          k := nword[k];
        end;
      end;
    until false;
    cur := '`';
    if a[i,cur]<>-1 then
      for k:=1 to n do
        Relax2;
    for cur:='a' to 'z' do
      if a[i,cur]<>-1 then
      begin
        k := fword[cur];
        while k<>0 do
        begin
          Relax2;
          k := nword[k];
        end;
      end;
  end;
end;

procedure Save;
var
  curi,oldi,i : integer;
  curc,oldc,j : char;
  wn : integer;
  way : array [1..10000] of integer;
begin
  curi := l;
  curc := #0;
  for j:='a' to 'z' do
    if (a[curi,j]<>-1) and ((curc=#0) or (a[curi,curc]>a[curi,j])) then
      curc := j;
  if curc=#0 then
    writeln('?')
  else
  begin
    wn := 0;
    repeat
      oldi := curi;
      oldc := curc;
      inc(wn);
      way[wn] := w[oldi,oldc];
      curi := p[oldi,oldc];
      curc := c[oldi,oldc];
    until curc='`';
    for i:=wn downto 1 do
      writeln(words[way[i]]);
  end;
  close(input); close(output);
end;

begin
  Load;
  Solve;
  Save;
end.