#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

char *Fishes;
int N;
int K;
int NOG = 1;

void Init()
{
	FILE *in = fopen("fishes.in", "r");

	fscanf(in, "%i %i", &N, &K);
	Fishes = new char[N];
	int f;
	for(int i = 0;i < N;i++)
	{
		fscanf(in, "%i", &f);
		Fishes[i] = (char)f;
		if((i > 0)&&(Fishes[i - 1] != Fishes[i]))
			NOG++;
	}
	fclose(in);
}
int XCHG(int FE)
{
	int FGS = FE;
	int SGS;
	int SGE;
	char FG = Fishes[FE];
	for(int i = FE;i < N;i++)
	{
		if((i != FE)&&(Fishes[i] != Fishes[i - 1]))
		{
			SGS = i;
			break;
		}
	}
	i++;
	for(;i < N;i++)
	{
		if((i != FE)&&(Fishes[i] != Fishes[i - 1]))
		{
			i++;
			break;
		}
	}
	SGE = i - 2;
	int SG;
	if(FG == 0)
		SG = 1;
	else SG = 0;

	memset(Fishes + FGS, SG, SGE - SGS + 1);
	memset(Fishes + SGE - SGS + FGS + 1, FG, SGS - FGS);
	return SGE + 1;
}
void Solve()
{
	int GID = 0;
	FILE *out = fopen("fishes.out", "w");
	int NOXCHGS = 0;
	long *XCHGS;
	XCHGS = new long [K];
	int SF = Fishes[0];
	int l;
	int DivT = Fishes[0] == Fishes[N - 1]?0:1;
	while(NOG > 2)
	{
		GID = 1;
		NOXCHGS = 0;
		l = 0;
		if((Fishes[0] == SF)||(NOG == 3))
		{
			l = XCHG(0);
			NOG--;
			XCHGS[NOXCHGS] = 1;
			NOXCHGS++;
			GID++;
		}
		for(int i = l;i < N;i++)
		{
			if(NOXCHGS == K)
				break;
			if((i > 0)&&(Fishes[i] != Fishes[i - 1]))
			{
				GID++;
				if((NOG == 2)&&(GID != NOG))
					break;
				if((GID % 2 == DivT)&&(GID != 0)&&(GID < NOG))
				{
					l = XCHG(i);
					NOG -= 2;
					XCHGS[NOXCHGS] = i + 1;
					i = l;
					GID++;
					NOXCHGS++;
				}

			}
		}
		fprintf(out, "%i", NOXCHGS);
		for(i = 0;i < NOXCHGS;i++)
		{
			fprintf(out, " %i", XCHGS[i]);
		}
		fprintf(out, "\n");
	}
	fprintf(out, "0");
	delete[] Fishes;
	delete[] XCHGS;
	fclose(out);
}
void Shutdown()
{

}

int main()
{
	Init();
	Solve();
	Shutdown();

	return 0;
}
