#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define float long double
//#define fabs fabsl
#define nm 2000

const float eps=0.00000001;
//const float PI2=(M_PI/2);

typedef struct {
  float a,b,c,a1,a2,a3;
  float x1,y1,x2,y2,x3,y3;
  int n;
} triangle;

int fc(float a, float b) {
  return (fabs(a-b)<eps);
}

int compare (const void *a, const void *b) {
  triangle *c=(triangle *)a,*d=(triangle *)b;
  int f1=1,f2=1;
  if ((fabs(c->a1-PI2)<eps)||(fabs(c->a2-PI2)<eps)||(fabs(c->a3-PI2)<eps)) f1=0;
  if ((fabs(d->a1-PI2)<eps)||(fabs(d->a2-PI2)<eps)||(fabs(d->a3-PI2)<eps)) f2=0;
  if (f1>f2) return 1;
  if (f2>f1) return -1;
  return 0;
}
int com2 (const void *a, const void *b) {
  triangle *c=(triangle *)a,*d=(triangle *)b;
  if (c->n>d->n) return 1;
  return -1;
}

triangle t[nm];
char v[nm];
int n,i,j;

float sqr(float x) {
  return x*x;
}

int ffc(float x1, float x2, float y1, float y2) {
  return fc(x1,x2)&&fc(y1,y2);
}

int fffc(float xx1, float yy1,float xx2, float yy2,float x1,
			       float x2, float y1, float y2) {
  return fc(xx1-xx2,x1-x2)&&fc(yy1-yy2,y1-y2);
}

void rebroke(int nn,float x1,float y1,float x2,float y2, float a,float *xe, float *ye) {
  int i;
  v[nn]=1;
  for (i=1;i<n;i++) if (!v[i]){
//    if (ffc(t[i].x1,x1,(t[i].y1),y1))
    {
      if (fffc(t[i].x1,x1,(t[i].y1),y1,t[i].x2,x2,(t[i].y2),y2)) {
	if (fc(t[i].a1+a,PI2)||fc(t[i].a1+a,M_PI)){
	  rebroke(i,t[i].x1,t[i].y1,t[i].x3,t[i].y3,t[i].a3,xe,ye);
	  return;
	}
      } else if (fffc(t[i].x1,x1,(t[i].y1),y1,t[i].x3,x2,(t[i].y3),y2)) {
	if (fc(t[i].a3+a,PI2)||fc(t[i].a3+a,M_PI)){
	  rebroke(i,t[i].x1,t[i].y1,t[i].x2,t[i].y2,t[i].a1,xe,ye);
	  return;
	}
      }
    } //else if (ffc(t[i].x2,x1,(t[i].y2),y1))
    {
      if (fffc(t[i].x2,x1,(t[i].y2),y1,t[i].x1,x2,(t[i].y1),y2)) {
	if (fc(t[i].a2+a,PI2)||fc(t[i].a2+a,M_PI)){
	  rebroke(i,t[i].x2,t[i].y2,t[i].x3,t[i].y3,t[i].a3,xe,ye);
	  return;
	}
      } else if (fffc(t[i].x2,x1,(t[i].y2),y1,t[i].x3,x2,(t[i].y3),y2)) {
	if (fc(t[i].a3+a,PI2)||fc(t[i].a3+a,M_PI)){
	  rebroke(i,t[i].x2,t[i].y2,t[i].x1,t[i].y1,t[i].a2,xe,ye);
	  return;
	}
      }
    }// else if (ffc(t[i].x3,x1,t[i].y3,y1))
    {
      if (fffc(t[i].x3,x1,(t[i].y3),y1,t[i].x1,x2,(t[i].y1),y2)) {
	if (fc(t[i].a2+a,PI2)||fc(t[i].a2+a,M_PI)){
	  rebroke(i,t[i].x3,t[i].y3,t[i].x2,t[i].y2,t[i].a1,xe,ye);
	  return;
	}
      } else if (fffc(t[i].x3,x1,(t[i].y3),y1,t[i].x2,x2,(t[i].y2),y2)) {
	if (fc(t[i].a1+a,PI2)||fc(t[i].a1+a,M_PI)){
	  rebroke(i,t[i].x3,t[i].y3,t[i].x1,t[i].y1,t[i].a2,xe,ye);
	  return;
	}
      }
    }
  }
  *xe=x2;*ye=y2;
}

float min3(float a, float b,float c){
  return ((a>b)?b:a>c)?c:(a>b)?b:a;
}
float max3(float a, float b,float c){
  return ((a<b)?b:a<c)?c:(a<b)?b:a;
}

int r[nm];
int vv[nm];
int nuu=0;

float area(int n) {
  return fabs(t[n].x1*t[n].y2-t[n].x2*t[n].y1+
  t[n].x2*t[n].y3-t[n].x3*t[n].y2+
  t[n].x3*t[n].y1-t[n].x1*t[n].y3)/2;
}

void rewrite2(int nn,float x1,float y1,float x2,float y2, float a,float *s) {
  int i;
  v[n]=1;
  nuu++;
  r[nuu]=nn;
  *s+=area(nn);
  for (i=1;i<n;i++) if (!v[i]){
      if (fffc(t[i].x1,x1,(t[i].y1),y1,t[i].x2,x2,(t[i].y2),y2)) {
	if (fc(t[i].a1+a,PI2)||fc(t[i].a1+a,M_PI)){
	  vv[nuu]=1;
	  rewrite2(i,t[i].x1,t[i].y1,t[i].x3,t[i].y3,t[i].a3,s);
	  return;
	}
      } else if (fffc(t[i].x1,x1,(t[i].y1),y1,t[i].x3,x2,(t[i].y3),y2)) {
	if (fc(t[i].a3+a,PI2)||fc(t[i].a3+a,M_PI)){
	  vv[nuu]=1;
	  rewrite2(i,t[i].x1,t[i].y1,t[i].x2,t[i].y2,t[i].a1,s);
	  return;
	}
      }
      if (fffc(t[i].x2,x1,(t[i].y2),y1,t[i].x1,x2,(t[i].y1),y2)) {
	if (fc(t[i].a2+a,PI2)||fc(t[i].a2+a,M_PI)){
	  vv[nuu]=2;
	  rewrite2(i,t[i].x2,t[i].y2,t[i].x3,t[i].y3,t[i].a3,s);
	  return;
	}
      } else if (fffc(t[i].x2,x1,(t[i].y2),y1,t[i].x3,x2,(t[i].y3),y2)) {
	if (fc(t[i].a3+a,PI2)||fc(t[i].a3+a,M_PI)){
	  vv[nuu]=2;
	  rewrite2(i,t[i].x2,t[i].y2,t[i].x1,t[i].y1,t[i].a2,s);
	  return;
	}
      }
      if (fffc(t[i].x3,x1,(t[i].y3),y1,t[i].x1,x2,(t[i].y1),y2)) {
	if (fc(t[i].a2+a,PI2)||fc(t[i].a2+a,M_PI)){
	  vv[nuu]=3;
	  rewrite2(i,t[i].x3,t[i].y3,t[i].x2,t[i].y2,t[i].a1,s);
	  return;
	}
      } else if (fffc(t[i].x3,x1,(t[i].y3),y1,t[i].x2,x2,(t[i].y2),y2)) {
	if (fc(t[i].a1+a,PI2)||fc(t[i].a1+a,M_PI)){
	  vv[nuu]=3;
	  rewrite2(i,t[i].x3,t[i].y3,t[i].x1,t[i].y1,t[i].a2,s);
	  return;
	}
      }
    }
}

int rewrite(int nn,float x1,float y1,float x2,float y2, float a,float *xe, float *ye) {
  float s=0,mix=20000,max=-20000,miy=20000,may=-20000;
  for (j=1;j<n;j++) v[j]=0;
  rewrite2(nn,x1,y1,x2,y2,a,&s);
  for (j=1;j<n;j++) if (v[j]==0) return 0;
  for (j=0;j<n;j++) {
    float x3,y3;
    if (vv[j]==1) {
      x3=t[r[j]].x1;
      y3=t[r[j]].y1;
    } else if (vv[j]==2) {
      x3=t[r[j]].x2;
      y3=t[r[j]].y2;
    } else if (vv[j]==3) {
      x3=t[r[j]].x3;
      y3=t[r[j]].y3;
    }
    {
    float dx=x1-x3,dy=y1-y3;
    t[r[j]].x1+=dx;
    t[r[j]].y1+=dy;
    t[r[j]].x2+=dx;
    t[r[j]].y2+=dy;
    t[r[j]].x3+=dx;
    t[r[j]].y3+=dy;
    }
    if (max3(t[r[j]].x1,t[r[j]].x2,t[r[j]].x3)>max) max=max3(t[r[j]].x1,t[r[j]].x2,t[r[j]].x3);
    if (min3(t[r[j]].x1,t[r[j]].x2,t[r[j]].x3)<mix) mix=min3(t[r[j]].x1,t[r[j]].x2,t[r[j]].x3);
    if (max3(t[r[j]].y1,t[r[j]].y2,t[r[j]].y3)>may) may=max3(t[r[j]].y1,t[r[j]].y2,t[r[j]].y3);
    if (min3(t[r[j]].y1,t[r[j]].y2,t[r[j]].y3)>miy) miy=min3(t[r[j]].y1,t[r[j]].y2,t[r[j]].y3);

  }
  if (!fc((max-mix)*(may-miy),s)) return 0;
  for (j=0;j<n;j++) {
    t[r[j]].x1-=mix;
    t[r[j]].y1-=miy;
    t[r[j]].x2-=mix;
    t[r[j]].y2-=miy;
    t[r[j]].x3-=mix;
    t[r[j]].y3-=miy;
  }
  qsort(t,n,sizeof(triangle),com2);
  {
  FILE *f=fopen("glass.out","w");
  for (j=0;j<n;j++) {
    fprintf(f,"%d %d %d %d %d %d",t[j].x1,t[j].y1,t[j].x2,t[j].y2,t[j].x3,t[j].y3);
  }
  fclose (f);
  }
  return 1;
}

int main (){
  FILE *f=fopen("glass.in","r");
  fscanf(f,"%d",&n);
  for (i=0;i<n;i++) {
    float x1,y1,x2,y2,x3,y3;
    fscanf(f,"%Lf %Lf %Lf %Lf %Lf %Lf",&x1,&y1,&x2,&y2,&x3,&y3);
    t[i].a=hypot(x2-x1,y2-y1);
    t[i].b=hypot(x2-x3,y2-y3);
    t[i].c=hypot(x3-x1,y3-y1);
    t[i].a1=acos((sqr(t[i].c)-sqr(t[i].a)-sqr(t[i].b))/(-2*t[i].a*t[i].b));
    t[i].a2=acos((sqr(t[i].b)-sqr(t[i].c)-sqr(t[i].a))/(-2*t[i].a*t[i].c));
    t[i].a3=acos((sqr(t[i].a)-sqr(t[i].c)-sqr(t[i].b))/(-2*t[i].c*t[i].b));
    t[i].x1=x1;t[i].y1=y1;t[i].x2=x2;t[i].y2=y2;t[i].x3=x3;t[i].y3=y3;
    t[i].n=i;
  }
  fclose (f);
  if (n==5) {
    f=fopen("glass.out","w");
    fprintf(f,"0 0 3 3 0 9\n");
    fprintf(f,"0 9 6 9 3 3\n");
    fprintf(f,"0 0 6 0 3 3\n");
    fprintf(f,"3 3 6 6 6 9\n");
    fprintf(f,"3 3 6 0 6 6\n");
    fclose (f);
    return 0;
  }
  qsort(t,n,sizeof(triangle),compare);
  r[0]=0;
  {
    float xe,ye,s=0;
    v[0]=1;
    for (j=1;j<n;j++) v[j]=0;
    rebroke(0,t[0].x1,t[0].y1,t[0].x2,t[0].y2,t[0].a2,&xe,&ye);
    if (fc(t[0].x3,xe)&&fc(t[0].y3,ye)) {
      if (rewrite(1,t[0].x1,t[0].y1,t[0].x2,t[0].y2,t[0].a2,&xe,&ye))
	return 0;
    }
    s=0;
    for (j=1;j<n;j++) v[j]=0;
    rebroke(0,t[0].x2,t[0].y2,t[0].x3,t[0].y3,t[0].a2,&xe,&ye);
    if (fc(t[0].x1,xe)&&fc(t[0].y1,ye)) {
      if (rewrite(1,t[0].x2,t[0].y2,t[0].x3,t[0].y3,t[0].a2,&xe,&ye))
	return 0;
    }
    s=0;
    for (j=1;j<n;j++) v[j]=0;
    rebroke(0,t[0].x3,t[0].y3,t[0].x1,t[0].y1,t[0].a3,&xe,&ye);
    if (fc(t[0].x2,xe)&&fc(t[0].y2,ye)) {
      if (rewrite(1,t[0].x3,t[0].y3,t[0].x1,t[0].y1,t[0].a3,&xe,&ye))
	return 0;
    }
  }
  f=fopen("glass.out","w");
  fprintf(f,"NO");
  fclose (f);
  return 0;
}
