#include <stdio.h>
#include <stdlib.h>

int check(int **c,int *q,int index,int m,int n) {
	int i,j,k;
	int gflag,lflag;
	gflag=1;
	for(i=0; i<m; i++) {
		// check Ith color
		for(j=0; j<q[i]; j++) {
			lflag=0;
			if(2*index-c[i][j]-1<0) {
				lflag=1;
				continue;
			}
			// for every encounter of ith color: j<index:
			// c[i] must contain (2index-c[i][j]-1)
			for(k=0; k<q[i]; k++) {
				if(k==j) continue;
				if(c[i][k]==2*index-c[i][j]-1) {
					lflag=1;
					break;
				}
			}
			if(lflag==0) {
				gflag=0;
				break;
			}
		}
	}
	return gflag;
}

int main() {
	FILE *in=fopen("cubes.in","r");
	FILE *out=fopen("cubes.out","w");
	int m,n;
	int i,j;
	int **c;
	int *q;

	fscanf(in,"%d %d", &n,&m);

	c=new int*[m];
	q=new int[m];
	if(c==NULL || q==NULL) {
		fprintf(out,"1\n");
		fcloseall();
		return 0;
	}

	int color;
	for(i=0; i<n; i++) {
		q[i]=0;
		c[i]=NULL;
	}

	for(i=0; i<n; i++) {
		fscanf(in,"%d", &color);
		q[color-1]++;
	}

	for(i=0; i<m; i++) {
		c[i]=new int[q[i]];
		if(c[i]==NULL) {
			fprintf(out,"1\n");
			fcloseall();
			return 0;
		}
	}

	fclose(in);
	in=fopen("cubes.in","r");
	fscanf(in,"%d %d\n",&n,&m);

	for(i=0; i<n; i++) q[i]=0;
	for(i=0; i<n; i++) {
		fscanf(in,"%d", &color);
		c[color-1][q[color-1]++]=i;
	}

	int flag=1;

	for(i=0; i<n; i++) {
		if(check(c,q,i,m,n))
			fprintf(out,"%d ", n-i);
	}

	fprintf(out,"\n");
	delete [] c;
	delete q;

	fcloseall();
	return 0;
}