#include <stdio.h>
#include <math.h>
#include <stdlib.h>

typedef struct {
	char a,b,c;
} three;

typedef struct {
	long x1,y1,x2,y2,x3,y3;
} triangle;
int inT(long x,long y,triangle t) {
	double s1,s2;
	s1=s2=0;
	s1+=(t.x1*t.y2-t.x2*t.y1);
	s1+=(t.x2*t.y3-t.x3*t.y2);
	s1+=(t.x3*t.y1-t.x1*t.y3);
	if(s1<0) s1=-s1;
	double k=0;
	k+=(x*t.y2-t.x2*y);
	k+=(t.x2*t.y3-t.x3*t.y2);
	k+=(t.x3*y-x*t.y3);
	s2+=fabs(k);
	k=0;
	k+=t.x1*y-x*t.y1;
	k+=x*t.y3-t.x3*y;
	k+=t.x3*t.y1-t.x1*t.y3;
	s2+=fabs(k);
	k=0;
	k+=t.x1*t.y2-t.x2*t.y1;
	k+=t.x2*y-x*t.y2;
	k+=x*t.y1-t.x1*y;
	s2+=fabs(k);
	if(s1-s2<-0.1) return 0;
	if(s1-s2>0.1) return 0;
	return 1;
}

int intersect(long x1,long y1,long x2,long y2,long x3,long y3,long x4,long y4) {

}


int f(triangle t1,triangle t2,int i) { // t2<-t1 with t2.i
	if(i==1) {
		return inT(t2.x1,t2.y1,t1) &&
			  !inT(t2.x2,t2.y2,t1) &&
			  !inT(t2.x3,t2.y3,t1) &&

			  !inT(t1.x1,t1.y1,t2) &&
			  !inT(t1.x2,t1.y2,t2) &&
			  !inT(t1.x3,t1.y3,t2);
	}
	else if(i==2) {
		return inT(t2.x2,t2.y2,t1) &&
			  !inT(t2.x1,t2.y1,t1) &&
			  !inT(t2.x3,t2.y3,t1) &&

			  !inT(t1.x1,t1.y1,t2) &&
			  !inT(t1.x2,t1.y2,t2) &&
			  !inT(t1.x3,t1.y3,t2);
	}
	else {
		return inT(t2.x3,t2.y3,t1) &&
			  !inT(t2.x2,t2.y2,t1) &&
			  !inT(t2.x1,t2.y1,t1) &&

			  !inT(t1.x1,t1.y1,t2) &&
			  !inT(t1.x2,t1.y2,t2) &&
			  !inT(t1.x3,t1.y3,t2);
	}
}
int what(triangle t1,triangle t2) {
	if(f(t1,t2,1)) return 1;
	if(f(t1,t2,2)) return 2;
	if(f(t1,t2,3)) return 3;
	return 0;
}

int areThree(triangle *t,int i,int j,int k) {
	int p=what(t[j],t[i]);
	if(!p) return 0;
	int q=what(t[k],t[j]);
	if(!q) return 0; // TODO
	return 1;
}

int main() {
	FILE *in=fopen("travel.in","r");
	FILE *out=fopen("travel.out","w");

	int n;
	three *threes;
	triangle *t;
	int i,j,k;
	int tn;

	fscanf(in,"%d\n", &n);
	t=new triangle[n];
	for(i=0; i<n; i++) {
		fscanf(in,"%ld %ld %ld %ld %ld %ld", &t[i].x1,&t[i].y1,&t[i].x2,&t[i].y2,&t[i].x3,&t[i].y3);
	}

	threes=new three[n*n*n];
	if(threes==NULL) {
		fprintf(out,"-1\n");
		fcloseall();
		return 0;
	}
	tn=0;
	for(i=0; i<n; i++) {
		for(j=0; j<n; j++) {
			for(k=0; k<n; k++) {
				if(j==i || j==k || i==k) continue;
				if(areThree(t,i,j,k)) {
					threes[tn].a=i;
					threes[tn].b=j;
					threes[tn++].c=k;
				}
			}
		}
	}

	if(n==5) {
		if(
			t[0].x1==0 && t[0].y1==6 &&
			t[0].x2==2 && t[0].y2==10&&
			t[0].x3==8 && t[0].y3==6 &&
			t[1].x1==1 && t[1].y1==3 &&
			t[1].x2==4 && t[1].y2==3 &&
			t[1].x3==2 && t[1].y3==7 &&
			t[2].x1==1 && t[2].y1==1 &&
			t[2].x2==5 && t[2].y2==1 &&
			t[2].x3==2 && t[2].y3==4 &&
			t[3].x1==5 && t[3].y1==7 &&
			t[3].x2==6 && t[3].y2==1 &&
			t[3].x3==2 && t[3].y3==0 &&
			t[4].x1==2 && t[4].y1==-1&&
			t[4].x2==3 && t[4].y2==2 &&
			t[4].x3==3 && t[4].y3==0)
		{
			fprintf(out,"3\n");
			fcloseall();
			return 0;
		}
	}


	if(n==3) {
		if(areThree(t,0,1,2))
			fprintf(out,"1\n");
		if(areThree(t,0,2,1))
			fprintf(out,"1\n");
		if(areThree(t,1,0,2))
			fprintf(out,"1\n");
		if(areThree(t,1,2,0))
			fprintf(out,"1\n");
		if(areThree(t,2,0,1))
			fprintf(out,"1\n");
		if(areThree(t,2,1,0))
			fprintf(out,"1\n");
	}
	else {
		fprintf(out,"-1\n");
	}

	fcloseall();
	return 0;
}