#include <stdio.h>
#include <stdlib.h>

int step(int a, int b) {
  int res = 1;
  int i;

  for (i = 0; i < b; i++) {
    res *= a;
  }

  return res;
}

int main() {
  FILE *in, *out;
  int *mass;
  int *hash, *hash2;
  int m, n;
  int cur;
  int i;
  int x = 5;
  int left, right;

  in = fopen("cubes.in", "r");
  out = fopen("cubes.out", "w");

  fscanf(in, "%d %d", &n, &m);

  mass = (int*) malloc (n * sizeof(int));
  hash = (int*) malloc ((n+1)/2 * sizeof(int));
  hash2 = (int*) malloc ((n+1)/2 * sizeof(int));

  for (i = 0; i < n; i++) {
    fscanf(in, "%d", &mass[i]);
    if (i < n/2) {
      hash[i] = 0;
      hash2[i] = 0;
    }
  }

  hash[0] = mass[0];
  for (i = 1; i < n/2; i++) {
    hash[i] = hash[i-1]*x + mass[i];
  }

  hash2[n/2-1] = 0;
  for (i = 0; i < n/2; i++) {
    hash2[n/2-1] += mass[n/2+i]*step(x, i);
  }
  for (i = n/2-2; i >= 0; i--) {
    hash2[i] = hash2[i+1]-mass[2*(i+2)-1]*step(x, i+1);
    hash2[i] -= mass[2*(i+2)-2]*step(x, i);
    hash2[i] *= x;
    hash2[i] += mass[i+1];
    cur+=2;
  }

  for (i = 0; i < n/2; i++) {
    if (hash[i] == hash2[i]) {
      left = i;
      right = i+1;
      while ((left > 0) && (mass[left] == mass[right])) {
	left--;
	right++;
      }
      if (mass[left] == mass[right]) {
	fprintf(out, "%d ", n-i-1);
      }
    }
  }

  fprintf(out, "%d\n", n);

  fclose(in);
  fclose(out);
  return 0;
}