/***
 * PROGRAMMER: Ryablkin Michael;
 ***/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>

typedef void VOID;
typedef int INT;
typedef unsigned int UINT;
typedef long LONG;
typedef unsigned long ULONG;
typedef double DBL;
typedef char CHAR;
typedef char BYTE;
typedef int BOOL;

FILE *In, *Out;

/* Array */
#define MAX_NUM 100004
LONG N, M;
LONG Cubs[MAX_NUM];

/* Check for good configuration */
BOOL Mir( LONG Pos )
{
  LONG i;

  for (i = Pos; i >= 0; i--)
    if (Pos + i + 1 > N ||
	Cubs[Pos - i] != Cubs[Pos + i + 1])
      return 0;
  return 1;
} /* End of 'Mir' function */

/* The main function */
INT main( VOID )
{
  LONG i, k, Max;

  In = fopen("cubes.in", "rt");
  if (In == NULL)
    return -1;
  Out = fopen("cubes.out", "wt");
  if (Out == NULL)
  {
    fclose(In);
    return -1;
  }
  fscanf(In, "%ld%ld", &N, &M);

  for (i = 0; i < N; i++)
    fscanf(In, "%ld", &Cubs[i]);

  k = 0;
  fprintf(Out, "%ld", N);
  Max = N / 2;
  for (i = 0; i <= Max; i++)
    if (Mir(i))
    {
      fprintf(Out, " %ld", N - i - 1);
    }

  fclose(In);
  fclose(Out);
  return 0;
} /* End of 'main' function */
