{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 56384,0,655360}
{$R+,S+,Q+} {Task C 㡮}
  Const
    MaxN = 10000;

  Type
    TA = Array [0..MaxN] Of Longint;

  Var
    N, K: Integer;
    aK: Longint;
    A: TA;
    Best,Res: Comp;
    bl1, bl2, bl3, br1, br2, br3, bd23, bd1: Integer;
    Invert: Boolean;

  Procedure Init;
    Var i: Integer;
  Begin
    Assign(input, 'e.in'); Reset(input);
     Read(N);
     For i := 1 To N Do Read(a[i]);
     Read(K);
    Close(input);
    Assign(output, 'e.out'); Rewrite(output);
  End;

  Procedure Swap(Var i,j: Longint);
    Var c: Longint;
  Begin
    c := i; i := j; j := c;
  End;

  Procedure QSort(b,l: Integer);
    Var x: Longint; i,j: Integer;
  Begin
    x := a[(b+l) shr 1]; i := b; j := l;
    Repeat
      While (x>a[i]) Do inc(i);
      While (x<a[j]) Do dec(j);
      If i <= j Then
       Begin
         Swap(a[i],a[j]); inc(i); dec(j);
       End;
    Until (i>j);
    If i < l Then QSort(i, l);
    If b < j Then QSort(b, j);
  End;

  Procedure Update(l1,r1,l2,r2,l3,r3,d1,d23: integer; inv: Boolean);
    Var t: Comp;
  Begin
    t := res+Abs(aK-a[r1]);
    If r2 <> 0 Then t := t+Abs(aK-a[l2]) Else t := t + Abs(aK-a[l3]);
    If (r2 <> 0) And (l3 <> 0) Then t := t+Abs(a[r2]-a[l3]);
    If (d1=1) Then
     Begin
       If l1 > 1 Then t := t - abs(a[l1]-a[l1-1]);
       If r1 < n-1 Then t := t - abs(a[r1]-a[r1+1]);
     End
    Else
     Begin
       If r1 > 1 Then t := t - Abs(a[r1]-a[r1-1]);
       If l1 < n-1 Then t := t - Abs(a[l1]-a[l1+1]);
     End;

    If t < Best Then
     Begin
       Best := t;
       bl1 := l1; br1 := r1;
       bl2 := l2; br2 := r2;
       bl3 := l3; br3 := r3;
       bd1 := d1; bd23 := d23;
       Invert := inv;
     End;
  End;

  Procedure Solve;
    Var i,j: Integer; t: Boolean;
  Begin
    Best := 10000000000.0;
    aK := a[k];
    For i := k To N-1 Do a[i] := a[i+1];
    If N > 2 Then QSort(1,N-1);
    a[0] := ak; a[n] := ak;
    res := 0; For i := 2 to n-1 Do res := res + abs(a[i]-a[i-1]);
    For t := false To true Do
     Begin
       For i := 1 to n-k+1 Do
        Begin
          Update(    i, i+k-2,   1,   i-1, i+k-1, n-1,  1,  1, t);
          Update(i+k-2,     i,   1,   i-1, i+k-1, n-1, -1,  1, t);
          Update(    i, i+k-2, n-1, i+k-1,   i-1,   1,  1, -1, t);
          Update(i+k-2,     i, n-1, i+k-1,   i-1,   1, -1, -1, t);
        End;
       k := n-k+1;
     End;
  End;

  Function IsGood(d,l,r: Integer): Boolean;
  Begin
    IsGood := ((d=1) And (l<=r)) Or ((d=-1) And (l>=r));
  End;

  Procedure Done;
    Var i,cnt: Integer; p: Array [1..MaxN] Of Longint;
  Begin
     cnt := 0;
     If IsGood(bd1,bl1,br1) Then
      Repeat
        inc(cnt); p[cnt] := a[bl1];
        inc(bl1, bd1);
      Until bl1 = br1+bd1;

     inc(cnt); p[cnt] := ak;

     If IsGood(bd23,bl2,br2) Then
      Repeat
        inc(cnt); p[cnt] := a[bl2];
        inc(bl2, bd23);
      Until bl2 = br2+bd23;

     If IsGood(bd23,bl3,br3) Then
      Begin
        While bl3 <> br3 do
         Begin
           inc(cnt); p[cnt] := a[bl3];
           inc(bl3, bd23);
         End;
        inc(cnt); p[cnt] := a[bl3];
      End;
     If Invert Then
      Begin
        For i := n Downto 2 Do Write(p[i],' '); Write(p[1]);
      End
     Else
      Begin
        For i := 1 To n-1 Do Write(p[i],' '); Write(p[n]);
      End;
    Close(output);
  End;

BEGIN
  Init; Solve; Done;
END.