{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  InputName = 'g.in';
  OutputName = 'g.out';
var
  hh, mm, ss, days : longint;
  h, m, s : longint;
procedure writenum(a : longint);
var
  s : string;
begin
  str(a, s);
  while length(s) < 2 do s := '0'+s;
  write(s);
end;

procedure readnum(var a : longint);
var
  c : char;
begin
  a := 0;
  repeat read(c) until c in ['0'..'9'];
  while (c in ['0'..'9']) do begin
    a := a * 10 + (ord(c) - ord('0'));
    if seekeoln or seekeof then break;
    read(c);
  end;
end;

begin
  assign(input, InputName);
  reset(input);
  readnum(hh);
  readnum(mm);
  readnum(ss);
  readnum(s);
  if not (seekeoln or seekeof) then begin
    m := s;
    readnum(s);
  end;
  if not (seekeoln or seekeof) then begin
    h := m;
    m := s;
    readnum(s);
  end;
  close(input);
  ss := ss + s;
  mm := mm + m;
  hh := hh + h;
  mm := mm + (ss div 60);
  ss := ss mod 60;
  hh := hh + (mm div 60);
  mm := mm mod 60;
  days := hh div 24;
  hh := hh mod 24;
  assign(output, OutputName);
  rewrite(output);
  writenum(hh);
  write(':');
  writenum(mm);
  write(':');
  writenum(ss);
  if days > 0 then write('+', days, ' days');
  writeln;
  close(output);
end.