program report;

const
    maxn = 1000;

var
    a, b, c, fa, fb, h: array [1..maxn] of longint;
    i, j, n, max: longint;

procedure outa(x, left: longint);
begin
    if left = 0 then exit;
    outa(fa[x], left - 1);
    write(x, ' ');
end;

procedure outb(x, left: longint);
begin
    if left = 0 then exit;
    write(x, ' ');
    outb(fb[x], left - 1);
end;

function min(x, y: longint): longint;
begin
    if x < y then
        min := x
    else
        min := y;
end;

begin
    assign(input, 'h.in');
    reset(input);
    assign(output, 'h.out');
    rewrite(output);

while not seekeof do begin    
    read(n);
    for i := 1 to n do
        read(h[i]);

    for i := 1 to n do
    begin
        a[i] := 1;
        for j := 1 to i - 1 do
        begin
            if (h[j] < h[i]) and (a[j] + 1 > a[i]) then
            begin
                a[i] := a[j] + 1;
                fa[i] := j;
            end;
        end;
    end;

    for i := n downto 1 do
    begin
        b[i] := 1;
        for j := i + 1 to n do
        begin
            if (h[j] < h[i]) and (b[j] + 1 > b[i]) then
            begin
                b[i] := b[j] + 1;
                fb[i] := j;
            end;
        end;
    end;

    for i := 1 to n do
        c[i] := min(a[i], b[i]);


    max := 1;
    for i := 1 to n do
        if c[i] > c[max] then
            max := i;

    writeln(c[max] - 1);

    outa(fa[max], c[max] - 1);
    write(max, ' ');
    outb(fb[max], c[max] - 1);
    writeln;
end;    

    close(input);
    close(output);
end.