Program AKindOfChessmasterPartyBeingHeldAtTheHighShoresOfTheAmurRiver;
Const
  TaskID='party';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxL=302;
  MaxR=MaxL;
Type
  Integer=LongInt;
Var
  NL,NR:Integer;
  NOutL:Array[1..MaxL]Of Integer;
  OutL:Array[1..MaxL,1..MaxR]Of Integer;
  ML:Array[1..MaxL]Of Integer;
  MR:Array[1..MaxR]Of Integer;
  Queue:Array[0..MaxL]Of Integer;
  QuHead,QuTail:Integer;
  Prev:Array[1..MaxL]Of Integer;
  Amount:Integer;
  NRes:Integer;
  Res:Array[1..MaxL]Of Integer;
Procedure Load;
Var
  I,Num,J,A:Integer;
Begin
  FillChar(NOutL,SizeOf(NOutL),0);
  Assign(Input,InFile);
  ReSet(Input);
  Read(NL,NR);
  For I:=1 To NL Do Begin
    Read(Num);
    For J:=1 To Num Do Begin
      Read(A);
      Inc(NOutL[I]);
      OutL[I,NOutL[I]]:=A;
    End;
  End;
  Close(Input);
End;
Procedure TryImproving(NumL:Integer);
Var
  Cur,I,A,B:Integer;
Label Lab;
Begin
  FillChar(Prev,SizeOf(Prev),0);
  If NumL=0 Then Begin
    QuHead:=0;
    QuTail:=0;
    For I:=1 To NL Do If ML[I]=0 Then Begin
      Queue[QuHead]:=I;
      Prev[I]:=I;
      Inc(QuHead);
    End;
  End Else Begin
    QuHead:=1;
    QuTail:=0;
    Queue[0]:=NumL;
    Prev[NumL]:=NumL;
  End;
  While QuTail<QuHead Do Begin
    Cur:=Queue[QuTail];
    Inc(QuTail);
    For I:=1 To NOutL[Cur] Do Begin
      A:=OutL[Cur,I];
      B:=MR[A];
      If B=0 Then Goto Lab;
      If Prev[B]=0 Then Begin
        Prev[B]:=Cur;
        Queue[QuHead]:=B;
        Inc(QuHead);
      End;
    End;
  End;
  Exit;
Lab:
  Repeat
    B:=ML[Cur];
    ML[Cur]:=A;
    MR[A]:=Cur;
    A:=B;
    Cur:=Prev[Cur];
  Until A=0;
  Inc(Amount);
End;
Procedure Solve;
Var
  I:Integer;
Begin
  NRes:=0;
  Amount:=0;
  FillChar(ML,SizeOf(ML),0);
  FillChar(MR,SizeOf(MR),0);
  For I:=1 To NL Do
    TryImproving(I);
  TryImproving(0);
  NRes:=QuHead;
  For I:=1 To NRes Do
    Res[I]:=Queue[I-1];
End;
Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(NRes);
  For I:=1 To NRes Do Begin
    If I>1 Then Write(' ');
    Write(Res[I]);
  End;
  WriteLn;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
