{$I-,Q-,R-,S-}
type
  TPoint=record
    x,y:longint;
  end;
  array1=array[1..100] of boolean;

const
  eps=1e-10;

var
  a1,a,ans:array[1..101] of byte;
  w,k,bk,k1:byte;
  s,bs:int64;
  z,i,j,n,m:byte;
  o,d:array[1..100] of TPoint;
  l:array[1..100,1..100] of record
    a,b,c:real;
  end;
  p:array[1..100] of real;
  u,bad:array1;
  q:array[1..101] of byte;
  t:array[1..100,1..100] of real;
  s1:array[1..100] of int64;
  v:array[1..100] of boolean;

procedure makeline(x1_,y1_,x2_,y2_:longint;var a,b,c:real);
var
  d:real;
begin
  a:=y1_-y2_;
  b:=x2_-x1_;
  d:=sqrt(sqr(a)+sqr(b));
  a:=a/d;
  b:=b/d;
  c:=-(a*x1_+b*y1_);
end;

procedure relax;
begin
  if s>bs then begin
    bs:=s;
    bk:=k;
    ans:=a;
  end;
end;

procedure qsort(l,r: byte);
var
  i,j,y:byte;
  x:real;
begin
  i:=l;
  j:=r;
  x:=p[q[(l+r) div 2]];
  repeat
    while p[q[i]]<x do
      inc(i);
    while x<p[q[j]] do
      dec(j);
    if not(i>j) then
      begin
        y:=q[i];
        q[i]:=q[j];
        q[j]:=y;
        inc(i);
        dec(j);
      end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;

function leftrotate(x1,y1,x2,y2,x3,y3:longint):boolean;
var
  a,b,c:real;
begin
  makeline(x1,y1,x2,y2,a,b,c);
  leftrotate:=a*x3+b*y3+c>eps;
end;

function leftrotate1(i1,i2,x3,y3:longint):boolean;
var
  a,b,c:real;
begin
  a:=l[i1,i2].a;
  b:=l[i1,i2].b;
  c:=l[i1,i2].c;
  leftrotate1:=a*x3+b*y3+c>eps;
end;

procedure counts;
var
  i:byte;
begin
  s:=0;
  if k1<3 then
    exit;
  s:=(o[a1[1]].x-o[a1[k1]].x)*(o[a1[1]].y+o[a1[k1]].y);
  for i:=2 to k1 do
    s:=s+(o[a1[i]].x-o[a1[i-1]].x)*(o[a1[i]].y+o[a1[i-1]].y);
end;

procedure counts1;
var
  i:byte;
begin
  fillchar(v,sizeof(v),false);
  s1[a1[1]]:=s;
  v[a1[1]]:=true;
  s1[a1[2]]:=s;
  v[a1[2]]:=true;
  for i:=3 to k1 do begin
    s:=s-(o[a1[i-1]].x-o[q[1]].x)*(o[a1[i-1]].y+o[q[1]].y);
    s:=s-(o[a1[i]].x-o[a1[i-1]].x)*(o[a1[i]].y+o[a1[i-1]].y);
    s:=s-(o[q[1]].x-o[a1[i]].x)*(o[q[1]].y+o[a1[i]].y);
    s1[a1[i]]:=s;
    v[a1[i]]:=true;
  end;
end;

procedure gofrom(i:byte);
var
  j:byte;
  bad1:array1;
  flag1:boolean;
  sr:int64;

begin
  bad1:=bad;
  sr:=s;
  flag1:=(k=1) or not leftrotate1(a[k-1],a[k],o[q[i]].x,o[q[i]].y);

  if flag1 then
    for j:=1 to m do begin
      bad[j]:=bad[j] and not leftrotate1(a[k],q[i],d[j].x,d[j].y);
      if bad[j] and not leftrotate1(q[i],q[1],d[j].x,d[j].y) then
        flag1:=false;
    end;

  if (t[q[i],a[k]]>s) then flag1:=false;

  if not flag1 then begin
    bad:=bad1;
    exit;
  end;
  t[q[i],a[k]]:=s;
  inc(k);
  a[k]:=q[i];

  s:=s-(o[q[1]].x-o[a[k-1]].x)*(o[q[1]].y+o[a[k-1]].y);
  s:=s+(o[a[k]].x-o[a[k-1]].x)*(o[a[k]].y+o[a[k-1]].y);
  s:=s+(o[q[1]].x-o[a[k]].x)*(o[q[1]].y+o[a[k]].y);
  relax;

  if (not v[a[k]]) or (s+s1[a[k]]>=bs) then
    for j:=i+1 to w do begin
      gofrom(j);
    end;

  dec(k);
  s:=sr;
  bad:=bad1;
end;

{
function countmaxs(i:byte):boolean;
var
  j:byte;

begin
  if i=w+1 then begin
    countmaxs:=true;
    exit;
  end;
  if (not (k1=1)) and leftrotate1(a1[k1-1],a1[k1],o[q[i]].x,o[q[i]].y) then begin
    exit;
  end;
  inc(k1);
  a1[k1]:=q[i];
  s:=s-(o[q[1]].x-o[a1[k1-1]].x)*(o[q[1]].y+o[a1[k1-1]].y);
  s:=s+(o[a1[k1]].x-o[a1[k1-1]].x)*(o[a1[k1]].y+o[a1[k1-1]].y);
  s:=s+(o[q[1]].x-o[a1[k1]].x)*(o[q[1]].y+o[a1[k1]].y);
  countmaxs:=false;
  for j:=i+1 to w+1 do begin
    if countmaxs(j) then begin
      countmaxs:=true;
      exit;
      break;
    end;
  end;
  dec(k1);
end;
}

procedure countmaxs;
var
  i,j:byte;

begin
  for i:=1 to w do begin
    while (not (k1=1)) and leftrotate1(a1[k1-1],a1[k1],o[q[i]].x,o[q[i]].y) do begin
      dec(k1);
    end;
    inc(k1);
    a1[k1]:=q[i];
  end;
  counts;
end;

begin
  assign(input,'birds.in');
  reset(input);
  assign(output,'birds.out');
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(o[i].x,o[i].y);
  read(m);
  for i:=1 to m do
    read(d[i].x,d[i].y);

  bk:=0;
  bs:=0;

  for i:=1 to n do
    for j:=1 to n do
      if i<>j then
        makeline(o[i].x,o[i].y,o[j].x,o[j].y,l[i,j].a,l[i,j].b,l[i,j].c);

  for z:=1 to n do begin
    for i:=1 to n do begin
      if (o[i].y<o[z].y) or ((o[i].y=o[z].y) and (o[i].x<=o[z].x)) then
        u[i]:=false
      else begin
        u[i]:=true;
        if o[i].y>o[z].y then
          p[i]:=(o[i].x-o[z].x)/(o[i].y-o[z].y)
        else
          p[i]:=(o[i].x-o[z].x)*1e50;
      end;
    end;
    u[z]:=true;
    p[z]:=-1e50;
    w:=0;
    for i:=1 to n do
      if u[i] then begin
        inc(w);
        q[w]:=i;
      end;
    qsort(1,w);

    q[w+1]:=q[1];
    k:=1;
    a[1]:=q[1];
    a1[1]:=q[1];
    for i:=2 to w do begin
      for j:=1 to m do begin
        bad[j]:=not leftrotate1(q[1],q[i],d[j].x,d[j].y);
      end;
      fillchar(t,sizeof(t),0);
      s:=0;
      k1:=1;
      countmaxs;
      if s>bs then begin
        counts1;
        s:=0;
        k:=1;
        gofrom(i);
      end;
    end;
  end;

  writeln(bk);
{  writeln(bs);}
  for i:=1 to bk do
    write(ans[i],' ');

  close(input);
  close(output);
end.
