{.$define debug}

{$R-,Q-,S-,I+}

program PureKingdom;
const
 nmax = 150;
 mmax = nmax*nmax;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'roads.in';
 coutfile = 'roads.out';
 {$endif}
type
 int = longint;
 tptr = ^tlist;
 tlist = record
  inf :int;
  w :int;
  next :tptr;
 end;
 tpair = record
  u,v :integer;
 end;
var
 i,j :int;
 n,m :int;
 gr :array [1..nmax] of tptr;
 cost :array [1..mmax] of integer;
 p :array [1..mmax] of tpair;
 u,v,z :int;

procedure add (var list :tptr; value :int; w :int);
var x :tptr;
begin
 new(x);
 x^.inf := value;
 x^.w := w;
 x^.next := list;
 list := x;
end;

function bfs (start,finish :int):int;
var q :array [1..nmax] of int;
    used :array [1..nmax] of boolean;
    prev :array [1..nmax] of int;
    w,t :int;
    cur :int; x :tptr; max :int;
    wp :array [1..nmax] of int;

procedure addv (v :int; from :int; w :int);
begin
 if used[v] then
  exit;
 used[v] := true;
 prev[v] := from;
 inc(t);
 q[t] := v;
 wp[v] := w;
end;

begin
 fillchar (used,sizeof(used),0);
 fillchar (prev,sizeof(prev),0);
 used[start] := true;
 q[1] := start;
 t := 1;
 w := 1;
 while w <= t do
  begin
   cur := q[w];
   inc(w);
   if cur = finish then
    break;
   x := gr[cur];
   while not (x = nil) do
    begin
     addv (x^.inf,cur,x^.w);
     x := x^.next;
    end;
  end;
 if not used[finish] then
  writeln ('jopa');
 cur := finish;
 max := 0;
 while not (prev[cur] = 0) do
  begin
   if wp[cur] > max then
    max := wp[cur];
   cur := prev[cur];
  end;
 bfs := max;
end;

var t :int;

begin
 fillchar (gr,sizeof(gr),0);
 fillchar (cost,sizeof(cost),0);
 fillchar (p,sizeof(p),0);
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to n-1 do
  begin
   read (u,v,z);
   add (gr[u],v,z);
   add (gr[v],u,z);
   p[i].u := u;
   p[i].v := v;
   cost[i] := z;
  end;
 for i := n to m do
  begin
   read (u,v,z);
   t := bfs(u,v);
   if t > z then
    cost[i] := t
   else
    cost[i] := z;
   p[i].u := u;
   p[i].v := v;
  end;
 close (input);
 assign (output,coutfile);
 rewrite (output);
 writeln (n,' ',m);
 for i := 1 to m do
  writeln (p[i].u,' ',p[i].v,' ',cost[i]);
 close (output);
end.