program zzz;

const
  maxn = 2000;
type
  rib = record
    v,w: longint;
  end;
  v = array[1..maxn] of rib;
  pv = ^v;

var
  ans,cur,i,j,k,n,p,m,r1,r2: longint;
  num: array[1..maxn] of longint;
  g: array[1..maxn] of pv;
  d: array[1..maxn,1..maxn] of longint;
  r: array[1..maxn] of record v1,v2,w: longint; end;
  vis: array[1..maxn] of boolean;
function max(a,b: longint): longint;
begin
  if a>b then max := a else max := b;
end;
function min(a,b: longint): longint;
begin
  if a>b then min := b else min := a;
end;
procedure dfs(v,w: longint);
var i: longint;
begin
  if vis[v] then exit;
  vis[v] := true;
  d[cur,v] := w;
  vis[v] := true;
  for i := 1 to num[v] do begin
    if not vis[g[v]^[i].v] then begin
      dfs(g[v]^[i].v,w+g[v]^[i].w);
    end;
  end;
end;
begin
  assign(input,'cows.in'); reset(input);
  assign(output,'cows.out'); rewrite(output);
  read(n);
  for i := 1 to n-1 do begin
    read(r[i].v1,r[i].v2,r[i].w);
    inc(num[r[i].v1]); inc(num[r[i].v2]);
  end;
  for i := 1 to n do begin
    getmem(g[i],sizeof(rib)*num[i]);
    num[i] := 0;
  end;
  ans := 1000000000;
  for i := 1 to n-1 do begin
    j := r[i].v1; k := r[i].v2;
    inc(num[j]); inc(num[k]);
    g[j]^[num[j]].v := k;
    g[j]^[num[j]].w := r[i].w;
    g[k]^[num[k]].v := j;
    g[k]^[num[k]].w := r[i].w;
  end;
  for i := 1 to n do begin
    fillchar(vis,sizeof(vis),false);
    cur := i;
    dfs(i,0);
  end;
  for i := 1 to n do begin
    for j := i+1 to n do begin
      p := 0;
      for k := 1 to n do begin
        p := max(p,min(d[j,k],d[i,k]));
        if p > ans then break;
      end;
      if p < ans then begin
        ans := p;
        r1 := j;
        r2 := i;
      end;
    end;
  end;
  writeln(r1,' ',r2);
  close(input);
  close(output);
end.
