{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 16384,0,655360}
Const INPUTFILE='palindr.in';
      OUTPUTFILE='palindr.out';
Const MaxL=100000;

Type TStringBase=Array[1..MaxL] of Char;
     TString=object
     public
     Len:Longint;
     Value:^TStringBase;
     Procedure InitIt;
     Procedure DestroyIt;
     Procedure ReadIt;
     end;

Procedure TString.InitIt;
begin
New(Self.Value);
Self.Len:=0;
FillChar(Self.Value^,SizeOf(Self.Value^),Chr(0));
end;

Procedure TString.DestroyIt;
begin
Dispose(Self.Value);
end;

Procedure TString.ReadIt;
begin
While EoLn=False Do
begin
  Inc(Self.Len);
  Read(Self.Value^[Self.Len]);
end;
Readln;
end;

var s:TString;
    N:Longint;
    i,j:Longint;

Procedure FRead;
begin
s.InitIt;
Assign(Input,INPUTFILE);
Reset(Input);
s.ReadIt;
Close(Input);
N:=s.Len;
end;

Procedure FWrite(Answer:int64);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Write(Answer);
Close(Output);
s.DestroyIt;
Halt;
end;

Procedure Solve;
var K:int64;
begin
K:=0;

for i:=2 to N-1 do
begin
  j:=1;
  While (i-j>=1) AND (i+j<=N) AND (s.Value^[i-j]=s.Value^[i+j]) Do
  begin
    Inc(K);
    Inc(j);
  end;
end;

for i:=1 to N-1 do
begin
  j:=0;
  While (i-j>=1) AND (i+j+1<=N) AND (s.Value^[i-j]=s.Value^[i+j+1]) Do
  begin
    Inc(K);
    Inc(j);
  end;
end;

FWrite(K);
end;

begin
FRead;
Solve;
end.
