{$D-,L-,Q-,R-,S-,I-}
Program pr_c;
const
  inpfile='in.in';
  outfile='in.out';
  nm=105;
type
  Transpos=array [0..nm] of LongInt;
var
  a,b,c,id : Transpos;
  u : array [0..nm] of Boolean;
  res : Boolean;
  n,sum : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do read(a[i]);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if res then begin
    writeln(n);
    for i:=1 to n do write(b[i],' ');
  end else writeln(0);
  close(output);
  halt;
end;
{}
Procedure Init;
var
  i : LongInt;
begin
  for i:=1 to nm do id[i]:=i;
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(u,sizeof(u),0);
  fillchar(c,sizeof(c),0);
end;
{}
Function Check(q : Transpos) : Boolean;
var
  i,s : LongInt;
  old : Boolean;
begin
  Check:=true; s:=0; old:=true;
  for i:=1 to n do begin
    s:=s+q[i];
    if q[i]>c[i] then old:=false;
    if (q[q[i]]<>i) or (q[i]<c[i]) and old then begin
      Check:=false;
      exit;
    end;
  end;
  if s<>sum then Check:=false;
end;
{}
Function Eq(q,w : Transpos) : Boolean;
var
  i : LongInt;
begin
  Eq:=true;
  for i:=1 to n do
    if q[i]<>w[i] then begin
      Eq:=false;
      exit;
    end;
end;
{}
var
  ok : Boolean;
{}
Procedure Rec(h : LongInt);
var
 j,k : LongInt;
 ok1 : Boolean;
begin
  ok1:=ok;

  if h=n+1 then begin
    if Check(b) and ok then Out;
    exit;
  end;

  if b[h]<>0 then Rec(h+1)
  else begin
    if ok then k:=1
          else k:=a[h];

    for j:=k to n do
      if not u[j] and (b[j]=0) then begin
        b[h]:=j; u[j]:=true;
        b[j]:=h; u[h]:=true;
        if (j>a[h]) or (h>a[j]) then ok:=true;

        Rec(h+1);

        ok:=ok1;
        b[h]:=0; u[j]:=false;
        b[j]:=0; u[h]:=false;
      end;
  end;
end;
{}
Procedure Swap(var q,w : LongInt);
var
  bak : LongInt;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Next(var a : Transpos);
var
  i,j,t : LongInt;
begin
  for i:=n-1 downto 0 do
    if a[i]<a[i+1] then break;
  if i=0 then begin res:=false; Out; end;
  for j:=n downto i+1 do
    if a[j]>a[i] then begin
      Swap(a[i],a[j]);
      break;
    end;
  for j:=i+1 to n-1 do
    for t:=j+1 to n do
      if a[j]>a[t] then Swap(a[j],a[t]);
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
begin
  sum:=0;
  for i:=1 to n do inc(sum,a[i]);

  c:=a; Next(c);

  res:=true;
  ok:=false; Rec(1);

  res:=false;

end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
