const MaxN=1000;

type Teg = array[1..3] of integer;
     Tvert = record
       el,en: integer;
     end;

var n,en,best: longint;
    a: array[1..MaxN,1..MaxN] of longint;
    es: array[1..MaxN*2] of Teg;
    vs: array[1..MaxN] of Tvert;
    sv,u,v: integer;


procedure DFS(v,p:integer;cl:longint);
var i: integer;
begin
  a[sv,v]:=cl;
  For i:=vs[v].el to vs[v].el+vs[v].en-1 do
    if es[i,2]<>p then
      DFS(es[i,2],v,cl+es[i,3]);
end;

function min(a,b: longint):longint;
begin
  if a<b then min:=a else min:=b;
end;

procedure Solve;
var i,j,k: integer;
    cur: longint;
begin
  For i:=1 to n do
    For j:=1 to n do
      a[i,j]:=-1;
  For sv:=1 to n do
    DFS(sv,0,0);
  best:=MaxLongint;
  For i:=1 to n-1 do
    For j:=i to n do begin
      cur:=0;
      For k:=1 to n do begin
        if cur<min(a[i,k],a[j,k]) then begin
          cur:=min(a[i,k],a[j,k]);
        end;
      end;
      if best>cur then begin
        best:=cur;
        u:=i;
        v:=j;
      end;
    end;
end;

procedure Save;
var f: text;
begin
  Assign(f,'cows.out');
  Rewrite(f);
  WriteLn(f,u,' ',v);
  Close(f);
end;

procedure sort(l,r: longint);
var
  i,j,x: longint;
  y: Teg;
begin
  i:=l;
  j:=r;
  x:=es[(l+r) div 2,1];
  repeat
    while es[i,1]<x do
     inc(i);
    while x<es[j,1] do
     dec(j);
    if not(i>j) then
    begin
      y:=es[i];
      es[i]:=es[j];
      es[j]:=y;
      inc(i);
      j:=j-1;
    end;
  until i>j;
  if l<j then
    sort(l,j);
  if i<r then
    sort(i,r);
end;

procedure Load;
var f: text;
    i,u,v,w: integer;
begin
  Assign(f,'cows.in');
  Reset(f);
  Read(f,n);
  For i:=1 to n-1 do begin
    Read(f,u,v,w);
    inc(en);
    es[en,1]:=u;
    es[en,2]:=v;
    es[en,3]:=w;
    inc(en);
    es[en,1]:=v;
    es[en,2]:=u;
    es[en,3]:=w;
  end;
  Close(f);
  Sort(1,en);
  For i:=1 to en do begin
    if vs[es[i,1]].el=0 then vs[es[i,1]].el:=i;
    inc(vs[es[i,1]].en);
  end;
end;


Begin
  Load;
  Solve;
  Save;
End.
