{$N+,I-,Q-,R-,L-,D-,S-}
Program pr_b;
const
  inpfile='road.in';
  outfile='road.out';
  nm=3005;
  mm=nm*nm;
type
  Coord=record
    x,y : Extended;
  end;
  Rebr=record
    x,y : Integer;
  end;
var
  a : array [1..nm] of Coord;
  b : array [0..2*mm] of Rebr;
  p,c : array [0..nm] of LongInt;
  rp,res : array [1..mm] of LongInt;
  u : array [1..mm] of Boolean;
  col,rn : LongInt;
  n,m : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
  for i:=1 to n do read(a[i].x,a[i].y);
  for i:=1 to m do begin
    read(b[i].x,b[i].y);
    b[i+m].x:=b[i].y;
    b[i+m].y:=b[i].x;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(rn);
  for i:=1 to rn do
    writeln(b[res[i]].x,' ',b[res[i]].y);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(p,sizeof(p),0);
  fillchar(c,sizeof(c),0);
  fillchar(rp,sizeof(rp),0);
end;
{}
Procedure CountP;
var
  i,j : LongInt;
begin
  for i:=1 to 2*m do begin
    p[b[i].x]:=i;
    if b[i].x<>b[i-1].x then
      for j:=b[i-1].x+1 to b[i].x-1 do p[j]:=i-1;
  end;
end;
{}
Procedure Swap(var q,w : Rebr);
var
  bak : Rebr;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l,r: LongInt);
var
  i,j,x : LongInt;
begin
  i:=l; j:=r; x:=b[(l+r) div 2].x;
  repeat
    while b[i].x<x do inc(i);
    while x<b[j].x do dec(j);
    if not(i>j) then begin
      Swap(b[i],b[j]);
      inc(i); j:=j-1;
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
Function Len(q,w : Coord) : Extended;
begin
  Len:=sqr(q.x-w.x)+sqr(q.y-w.y);
end;
{}
Function D(i : LongInt) : Extended;
begin
  d:=Len(a[b[i].x],a[b[i].y])
end;
{}
Procedure SwapR(var q,w : LongInt);
var
  bak : LongInt;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
var
  x : Extended;

Procedure SortD(l,r: LongInt);
var
  i,j : LongInt;
begin
  i:=l; j:=r; x:=d(rp[(l+r) div 2]);
  repeat
    while d(rp[i])<x do inc(i);
    while x<d(rp[j]) do dec(j);
    if not(i>j) then begin
      SwapR(rp[i],rp[j]);
      inc(i); j:=j-1;
    end;
  until i>j;
  if l<j then SortD(l,j);
  if i<r then SortD(i,r);
end;
{}
Procedure Dfs(x : LongInt);
var
  i : LongInt;
begin
  c[x]:=col;
  for i:=p[x-1]+1 to p[x] do
    if c[b[i].y]=0 then Dfs(b[i].y);
end;
{}
Procedure Solve;
var
  i,j,km,cl : LongInt;
begin
  Sort(1,2*m); CountP;
  col:=0;
  for i:=1 to n do
    if c[i]=0 then begin
      inc(col);
      Dfs(i);
    end;

  if col>1 then begin
    km:=0;
    for i:=1 to n-1 do
      for j:=i+1 to n do begin
        inc(km); b[km].x:=i; b[km].y:=j;
        rp[km]:=km;
      end;
    SortD(1,km);
    rn:=0; i:=0;
    while (col>1) do begin
      inc(i);
      if c[b[rp[i]].x]<>c[b[rp[i]].y] then begin
        inc(rn); res[rn]:=rp[i]; cl:=c[b[rp[i]].y];
        for j:=1 to n do
          if c[j]=cl then c[j]:=c[b[rp[i]].x];
        dec(col);
      end;
    end;
  end else rn:=0;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
