const
  inf = 'road.in'; ouf = 'road.out';
  max = 3000;
var
  c, t: array[1..max] of word;
  x, y: array[1..max] of longint;
  ds: array[1..(max * (max + 1)) shr 1] of longint;
  pa, pb: array[1..(max*(max + 1)) shr 1] of word;
  q, n, tm: longint;
  procedure swap(a, b: longint);
  var
    tm: longint;
  begin
    tm := ds[a]; ds[a] := ds[b]; ds[b] := tm;
    tm := pa[a]; pa[a] := pa[b]; pa[b] := tm;
    tm := pb[a]; pb[a] := pb[b]; pb[b] := tm;
  end;
  procedure qsort(l, r: longint);
  var
    i, j: longint;
  begin
     i := l; j := r; tm := ds[(l + r) shr 1];
     repeat
        while (ds[i] < tm) do inc(i);
        while (ds[j] > tm) do dec(j);
        if (i <= j) then
        begin
          swap(i, j); inc(i); dec(j);
        end;
     until i >= j;
     if (i < r) then qsort(i, r);
     if (l < j) then qsort(l, j);
  end;
  function dist(a, b: word): longint;
  begin
    dist := sqr(x[a] - x[b]) + sqr(y[a] - y[b]);
  end;
  function clr(a: word): longint;
  var
    cur, cr, boss: word;
  begin
    cur := c[a];
    while (t[cur] <> 0) do cur := t[cur];
    clr := cur; boss := cur; cur := c[a];
    while (t[cur] <> 0) do
    begin
      cr := cur; cur := t[cur]; t[cr] := boss;
    end;
  end;
  procedure unify(a, b: word);
  begin
    t[clr(a)] := clr(b); dec(q);
  end;
var
  ca, cb, mc, a, k, b, i,j, m: word;
  ed: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n, m);
  for i := 1 to n do readln(input, x[i], y[i]);
  fillchar(c, sizeof(c), 0);
  fillchar(t, sizeof(t), 0); mc := 0; q := 0;
  for i := 1 to m do
  begin
    readln(input, a, b); ca := clr(a); cb := clr(b);
    if (ca = 0) and (cb = 0) then
    begin
      inc(q); inc(mc); c[a] := mc; c[b] := mc;
    end else
     if (ca = 0) then c[a] := cb else
       if (cb = 0) then c[b] := ca else
       if (ca <> cb) then
          unify(a, b);
  end;
  for i := 1 to n do
    if (c[i] = 0) then
    begin
      inc(q); inc(mc); c[i] := mc;
    end;
  ed := 0;
  for i := 1 to n-1 do
    for j := i + 1 to n do
      if (clr(i) <> clr(j)) then
      begin
        inc(ed); ds[ed] := dist(i, j);
        pa[ed] := i; pb[ed] := j;
      end;
  qsort(1, ed);
  writeln(output, q - 1);
  for i := 1 to ed do
    if (clr(pa[i]) <> clr(pb[i])) then
    begin
      writeln(output, pa[i],' ',pb[i]); unify(pa[i], pb[i]);
    end;
  close(input); close(output);
end.
