program NiceMatrice;

type nice = array [1..1000, 1..1000] of byte;

var f: text;
    wid, hei, mat, i, j: word;
    a, b: array [1..2] of nice;
    t: cardinal;

procedure Transform (var a, b: nice);
var x, y: word;
begin
  for x := 1 to wid - 1 do
  begin
    for y := 1 to hei - 1 do
    begin
      if (a [x, y] = (y and 1)) then
      begin
        b [x, y] := 0;
      end
      else
      begin
        if (a [x + 1, y] = (y and 1)) and
           (a [x + 1, y + 1] = (y and 1)) and
           (a [x, y + 1] = (y and 1)) then
        begin
          a [x, y + 1] := 1 - a [x, y + 1];
          b [x, y] := 2;
          inc (t, 2);
        end
        else
        begin
          b [x, y] := 1;
          inc (t);
        end;
      end;
    end;
    if (a [x, hei] = (hei and 1)) then
      b [x, hei] := 0
    else
    begin
      b [x, hei] := 1;
      inc (t);
    end;
  end;
  for y := 1 to hei do
  begin
    if (a [wid, y] = (y and 1)) then
      b [wid, y] := 0
    else
    begin
      b [wid, y] := 1;
      inc (t);
    end;
  end;
end;

begin
  assign (f, 'nice.in');
  reset (f);
  read (f, hei);
  readln (f, wid);
  for mat := 1 to 2 do for j := 1 to hei do for i := 1 to wid do
  begin
    read (f, a [mat][i, j]);
  end;
  close (f);
  assign (f, 'nice.out');
  rewrite (f);
  t := 0;
  if (hei > 1) and (wid > 1) then
  begin
    Transform (a [1], b [1]);
    Transform (a [2], b [2]);
    writeln (f, t);
    for i := 1 to wid do for j := 1 to hei do
    begin
      if (b [1][i, j] = 1) then
      begin
          writeln (f, j, ' ', i);
      end
      else if (b [1][i, j] = 2) then
      begin
          writeln (f, j+1, ' ', i);
          writeln (f, j, ' ', i);
      end;
    end;
    for i := wid downto 1 do for j := hei downto 1 do
    begin
      if (b [2][i, j] = 1) then
      begin
          writeln (f, j, ' ', i);
      end
      else if (b [2][i, j] = 2) then
      begin
          writeln (f, j, ' ', i);
          writeln (f, j+1, ' ', i);
      end;
    end;
  end
  else
  begin
    for i := 1 to wid do for j := 1 to hei do
    begin
      if (a [1][i, j] <> a [2][i, j]) then inc (t);
    end;
    writeln (f, t);
    for i := 1 to wid do for j := 1 to hei do
    begin
      if (a [1][i, j] <> a [2][i, j]) then
      begin
        writeln (f, j, ' ', i);
      end;
    end;
  end;
  close (f);
end.
