{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'tree.in'; outfile = 'tree.out'; max = 1505;
var g: array [1..max*2,1..2] of longint;
    s: array [1..max,1..2] of longint;
    f: array [1..max] of longint;
    n,m,mx: longint;

procedure init;
var i,p,q: longint;
begin
     assign(input,infile);
     reset(input);
     read(n); m:=n-1;
     for i:=1 to m do begin
         read(g[i,1],g[i,2]); g[i+m,1]:=g[i,2]; g[i+m,2]:=g[i,1]; end;
     m:=2*m;
     close(input);
end;

function find(v: longint): longint;
var og: array [1..max] of longint;
    nnew: array [1..max] of longint;
    yk1,yk2,i: longint;
begin
     fillchar(og,sizeOf(og),0);
     fillchar(nnew,SizeOf(nnew),0);
     yk1:=1; yk2:=0; og[1]:=v; nnew[v]:=1;
     while yk1 > yk2 do begin
           inc(yk2);
           for i:=s[og[yk2],1] to s[og[yk2],2] do
               if (nnew[g[i,2]] = 0) then begin
                  nnew[g[i,2]]:=nnew[og[yk2]]+1;
                  inc(yk1); og[yk1]:=g[i,2];
               end;
     end;
     find:=nnew[og[yk1]];
end;

procedure swap(v1,v2: longint);
var c: longint;
begin
     c:=g[v1,1]; g[v1,1]:=g[v2,1]; g[v2,1]:=c;
     c:=g[v1,2]; g[v1,2]:=g[v2,2]; g[v2,2]:=c;
end;

procedure sort(l,t: longint);
var i,j,x: longint;
begin
     i:=l; j:=t; x:=g[(l+t) div 2,1];
     repeat
           while g[i,1] < x do inc(i);
           while g[j,1] > x do dec(j);
           if i <= j then begin
              swap(i,j); inc(i); dec(j);
           end;
     until i > j;
     if i < t then sort(i,t);
     if j > l then sort(l,j);
end;

procedure solve;
var i: longint;
begin
     sort(1,m); s[g[1,1],1]:=1;
     for i:=2 to m do
         if g[i,1] <> g[i-1,1] then begin
            s[g[i-1,1],2]:=i-1; s[g[i,1],1]:=i;
         end;
     s[g[m,1],2]:=m;
     for i:=1 to n do f[i]:=find(i);
     mx:=f[1];
     for i:=2 to n do
         if f[i] < mx then mx:=f[i];
end;

procedure done;
var ans,i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     ans:=0;
     for i:=1 to n do
         if f[i] = mx then inc(ans);
     writeln(ans);
     for i:=1 to n do
         if f[i] = mx then writeln(i);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
