#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 110000

FILE *fi, *fo;
int a,b;
int g[NN][3];
int w[NN+5];
int d[NN];
int r[NN];
bool used[NN];
int h,t;
int n;

int mod(double a, int n)
{
  double nn;
  int aa;
  double a1;
  nn=n;
  a1=a/n;
  aa=(int)a1;
  a-=(double)aa*n;
  aa=(int)a;
  return aa;
}

void bfs()
{
  int i;
  int c;
  while(h<t)
  {
    c=w[h];
    h++;
    for(i=0;i<3;i++)
    {
      if(!used[g[c][i]])
      {
        w[t]=g[c][i];
        r[w[t]]=r[c]+1;
        d[w[t]]=c;
        used[w[t]]=true;
        t++;
      }
    }
  }
}

void wr(int v)
{
  if(d[v]>=0)
    wr(d[v]);
  fprintf(fo,"%i ",v);
}

int main()
{
  int i,j;
  fi=fopen("game.in","rt");
  fo=fopen("game.out","wt");

  fscanf(fi,"%i%i%i",&n,&a,&b);
  for(i=0;i<n;i++)
  {
    g[i][0]=mod(i+1,n);
    g[i][1]=mod((double)i*i+1.0,n);
    g[i][2]=mod((double)mod((double)i*i,n)*i+1.0,n);
    used[i]=false;
  }
  h=0;
  t=1;
  w[0]=a;
  r[a]=0;
  d[a]=-1;
  used[a]=true;
  bfs();

  fprintf(fo,"%i\n",r[b]);
  wr(b);

  fclose(fi);
  fclose(fo);
  return 0;
}
