{$A+,B-,D-,E+,F-,G-,I+,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
type mas=array[0..10000] of boolean;
     mas2=array[0..1000] of record pred,cur:longint; end;
var
   bo:array[1..10] of ^mas;
   och:array[1..100] of ^mas2;
   ras:array[1..16000] of longint;
   n,a,b,max:longint;

procedure init;
var i:longint;
begin
   assign(input,'game.in');
   reset(input);
   assign(output,'game.out');
   rewrite(output);
   read(N,a,b);
   for i:=1 to (n div 10000)+1 do
   begin
        new(bo[i]);
        fillchar(bo[i]^,sizeof(bo[i]^),false);
   end;
   for i:=1 to (n div 1000)+1 do
   begin
        new(och[i]);
        fillchar(och[i]^,sizeof(och[i]^),0);
   end;
   if b>=N then
   begin
        writeln(-1);
        halt;
   end;
end;

function getochpred(const q:longint):longint;
begin
     getochpred:=och[(q div 1000)+1]^[q mod 1000].pred;
end;

Function getochcur(const q:longint):longint;
begin
     getochcur:=och[(q div 1000)+1]^[q mod 1000].cur;
end;

procedure raskrut(q:longint);
var i:longint;
begin
     i:=1;
     ras[i]:=b;
     q:=getochpred(q);
     while q<>1 do
     begin
          inc(i);
          ras[i]:=getochcur(q);
          q:=getochpred(q);
     end;
     max:=i;
end;

procedure putbo(const a:longint; bb:boolean);
begin
     bo[(a div 10000)+1]^[a mod 10000]:=bb;
end;

Function getbo(const i:longint):boolean;
begin
     getbo:=bo[(i div 10000)+1]^[i mod 10000];
end;

procedure putochcur(const i,a:longint);
begin
     och[(i div 1000)+1]^[i mod 1000].cur:=a;
end;

procedure putochpred(const i,a:longint);
begin
     och[(i div 1000)+1]^[i mod 1000].pred:=a;
end;

procedure solve;
var i,cnt:longint;
begin
    putochcur(1,a);
    putbo(a,true);
    putochcur(2,-1);
    i:=1;
    cnt:=1;
    while (getochcur(i)<>b)and(getochcur(i)<>-1) do
    begin
         if not getbo((getochcur(i)+1)mod N) then
         begin
              inc(cnt);
              putochcur(cnt,(getochcur(i)+1) mod N);
              putochcur(cnt+1,-1);
              putochpred(cnt,i);
              putbo(getochcur(cnt),true);
         end;
         if not getbo((getochcur(i)*getochcur(i)+1)mod N) then
         begin
              inc(cnt);
              putochcur(cnt,(getochcur(i)*getochcur(i)+1) mod N);
              putochcur(cnt+1,-1);
              putochpred(cnt,i);
              putbo(getochcur(cnt),true);
         end;
         if not getbo((getochcur(i)*getochcur(i)*getochcur(i)+1) mod N) then
         begin
              inc(cnt);
              putochcur(cnt,(getochcur(i)*getochcur(i)*getochcur(i)+1) mod N);
              putochcur(cnt+1,-1);
              putochpred(cnt,i);
              putbo(getochcur(cnt),true);
         end;
         inc(i);
    end;
    if getochcur(i)=-1 then
    begin
         writeln(-1);
         halt;
    end else raskrut(i);
end;

procedure print;
var i:longint;
begin
     writeln(max);
     ras[max+1]:=a;
     for i:=max+1 downto 1 do write(ras[i],' ');
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.
