const MaxN = 100000;
      Qlen = MaxN+100;

var n,a,b: longint;
    pr: array[0..MaxN] of longint;
    Q: array[0..Qlen-1] of longint;
    qb,qe: integer;
    path: array[1..MaxN] of longint;
    pl: longint;

procedure Solve;
var v: int64;
    t: longint;
begin
  if a=b then begin
    pl:=0;
    exit;
  end;

  For t:=0 to MaxN do
    pr[t]:=-1;
  pr[a]:=MaxLongint;
  qb:=0;
  Q[0]:=a;
  qe:=1;
  while qb<>qe do begin
    v:=q[qb]; qb:=(qb+1) mod Qlen;

    t:=(v+1) mod n;
    if pr[t]=-1 then begin
      pr[t]:=v;
      q[qe]:=t; qe:=(qe+1) mod Qlen;
      if t=b then break;
    end;

    t:=(v*v+1) mod n;
    if pr[t]=-1 then begin
      pr[t]:=v;
      q[qe]:=t; qe:=(qe+1) mod Qlen;
      if t=b then break;
    end;

    t:=(v*v*v+1) mod n;
    if pr[t]=-1 then begin
      pr[t]:=v;
      q[qe]:=t; qe:=(qe+1) mod Qlen;
      if t=b then break;
    end;
  end;
  if t=b then begin
    while t<MaxLongint do begin
      inc(pl);
      path[pl]:=t;
      t:=pr[t];
    end;
  end else pl:=-1;
end;

procedure Save;
var f: text;
    i: longint;
begin
  Assign(f,'game.out');
  Rewrite(f);
  if pl=0 then begin
    WriteLn(f,0);
    WriteLn(f,a,' ',b);
  end else begin
    WriteLn(f,pl-1);
    if pl>0 then begin
      For i:=pl downto 1 do
        Write(f,path[i],' ');
    end;
  end;
  Close(f);
end;

procedure Load;
var f: text;
begin
  Assign(f,'game.in');
  Reset(f);
  Read(f,n,a,b);
  Close(f);
end;


Begin
  Load;
  Solve;
  Save;
End.
