{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 1600;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'tree.in';
 coutfile= 'tree.out';
 {$endif}
type
 int = longint;
 real = extended;
 tptr = ^tlist;
 tlist = record
  inf :int;
  next :tptr;
 end;
 tdst = array [1..nmax] of int;
var
 n :int;
 gr :array [1..nmax] of tptr;
 result :array [1..2] of int;
 p :tdst;
 df,dn :tdst;
 ans :int;
 start,finish :int;

procedure init;
begin
 ans := 0;
 fillchar (gr,sizeof(gr),0);
 fillchar (result,sizeof(result),0);
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure add (var list :tptr; value :int);
var x :tptr;
begin
 new(x);
 x^.inf := value;
 x^.next := list;
 list := x;
end;

procedure readdata;
var i,j :int;
    u,v :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n-1 do
  begin
   read (u,v);
   add (gr[u],v);
   add (gr[v],u);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 for i := 1 to ans do
  write (result[i],' ');
 close (output);
end;

procedure bfs (start :int; var dist :tdst; var prev :tdst);
var q :array [1..nmax] of int;
    used :array [1..nmax] of boolean;
    w,t :int;
    cur :int;
    x :tptr;

procedure add (v :int; from :int);
begin
 if used[v] then
  exit;
 used[v] := true;
 inc(t);
 q[t] := v;
 dist[v] := dist[from] + 1;
 prev[v] := from;
end;

begin
 fillchar (q,sizeof(q),0);
 fillchar (used,sizeof(used),0);
 fillchar (dist,sizeof(dist),0);
 fillchar (prev,sizeof(prev),0);
 used[start] := true;
 q[1] := start;
 w := 1;
 t := 1;
 while w <= t do
  begin
   cur := q[w];
   inc(w);
   x := gr[cur];
   while not (x = nil) do
    begin
     add (x^.inf,cur);
     x := x^.next;
    end;
  end;
end;


procedure solve;
var i,j :int;
    res,cur,d :int;
begin
 if n = 1 then
  begin
   ans := 1;
   result[1] := 1;
   exit;
  end;
 bfs(1,df,p);
 res := 0;
 cur := 0;
 for i := 1 to n do
  if df[i] > res then
   begin
    res := df[i];
    cur := i;
   end;
 bfs (cur,dn,p);
 start := cur;
 res := 0;
 cur := 0;
 for i := 1 to n do
  if dn[i] > res then
   begin
    res := dn[i];
    cur := i;
   end;
 finish := cur;
 d := res;
 if res and 1 = 0 then
  ans := 1
 else
  ans := 2;
 while not (cur = 0) do
  begin
   if (res and 1 = 0) and (d = res shr 1) then
    result[1] := cur;
   if (res and 1 = 1) and (d = res shr 1) then
    result[1] := cur;
   if (res and 1 = 1) and (d = res shr 1 + 1) then
    result[2] := cur;
   cur := p[cur];
   dec (d);
  end;
 if (ans = 2) and (result[1] > result[2]) then
  swap (result[1],result[2]);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.