{$I-,Q-,R-,S-}
type
  real=double;
  point=record
    x,y:real;
  end;

const
  eps=1e-10;

var
  flag1:boolean;
  m1,m,j,i,n:word;
  a,b,c:array[1..2000] of real;
  p1,p2:array[1..2000] of point;
  p:point;
  x1_,y1_,x2_,y2_:longint;
  x1,y1,z,x,y:array[0..4001] of real;
  f:array[1..4000] of boolean;
  s:real;

procedure out(r:real);
begin
  write(r:0:10);
  close(input);
  close(output);
  halt(0);
end;

procedure makeline(x1_,y1_,x2_,y2_:longint;var a,b,c:real);
var
  d:real;
begin
  a:=y1_-y2_;
  b:=x2_-x1_;
  d:=sqrt(sqr(a)+sqr(b));
  a:=a/d;
  b:=b/d;
  c:=-(a*x1_+b*y1_);
end;

procedure makeline1(x1_,y1_,x2_,y2_:real;var a,b,c:real);
var
  d:real;
begin
  a:=y1_-y2_;
  b:=x2_-x1_;
  d:=sqrt(sqr(a)+sqr(b));
  a:=a/d;
  b:=b/d;
  c:=-(a*x1_+b*y1_);
end;

procedure swap(i,j:word);
var
  temp:real;
begin
  temp:=z[i];
  z[i]:=z[j];
  z[j]:=temp;
  temp:=x[i];
  x[i]:=x[j];
  x[j]:=temp;
  temp:=y[i];
  y[i]:=y[j];
  y[j]:=temp;
end;

procedure qsort(i,j:word);
var
  l,r:word;
  x:real;
begin
  if i>=j then exit;
  flag1:=false;
  for l:=i+1 to j do begin
    if z[l]<z[i] then begin
      x:=z[l];
      flag1:=true;
      break;
    end;
    if z[l]>z[i] then begin
      x:=z[i];
      flag1:=true;
      break;
    end;
  end;
  if not flag1 then exit;
  l:=i;
  r:=j;

  while l<=r do begin
    swap(l,r);
    while z[l]<=x do inc(l);
    while z[r]>x do dec(r);
  end;
  qsort(i,r);
  qsort(r+1,j);
end;

procedure sortpoints(var p1,p2:point;p3:point);
begin
  if ((p1.x=p3.x) and (p1.y=p3.y)) or ((p2.x=p3.x) and (p2.y=p3.y)) then begin
    exit;
  end;
  if (p1.x=p2.x) and (p1.y=p2.y) then begin
    p2:=p3;
    exit;
  end;
  if p1.x=p2.x then begin
    if (p3.y>p1.y) xor (p3.y>p2.y) then exit;
    if (p2.y>p1.y) xor (p2.y>p3.y) then begin
      p2:=p3;
    end else begin
      p1:=p3;
    end;
  end else begin
    if (p3.x>p1.x) xor (p3.x>p2.x) then exit;
    if (p2.x>p1.x) xor (p2.x>p3.x) then begin
      p2:=p3;
    end else begin
      p1:=p3;
    end;
  end;
end;

procedure perline(i,j:word;var x,y:real);
var
  d:real;
begin
  d:=(a[i]*b[j]-a[j]*b[i]);
  x:=(c[j]*b[i]-c[i]*b[j])/d;
  y:=(c[i]*a[j]-c[j]*a[i])/d;
end;

function leftrotate(x1,y1,x2,y2,x3,y3:real):boolean;
var
  a,b,c:real;
begin
  makeline1(x1,y1,x2,y2,a,b,c);
  leftrotate:=a*x3+b*y3+c>eps;
end;

begin
  assign(input,'convexh.in');
  reset(input);
  assign(output,'convexh.out');
  rewrite(output);
  readln(n);
  if n<=2 then out(0);
  readln(x1_,y1_,x2_,y2_);
  makeline(x1_,y1_,x2_,y2_,a[1],b[1],c[1]);
  readln(x1_,y1_,x2_,y2_);
  makeline(x1_,y1_,x2_,y2_,a[2],b[2],c[2]);
  perline(1,2,p.x,p.y);
  p1[1].x:=p.x;
  p1[1].y:=p.y;
  p2[1]:=p1[1];
  p1[2]:=p1[1];
  p2[2]:=p1[1];
  for i:=3 to n do begin
    readln(x1_,y1_,x2_,y2_);
    makeline(x1_,y1_,x2_,y2_,a[i],b[i],c[i]);
    perline(1,i,p1[i].x,p1[i].y);
    p2[i]:=p1[i];
    for j:=1 to i-1 do begin
      perline(i,j,p.x,p.y);
      sortpoints(p1[i],p2[i],p);
      sortpoints(p1[j],p2[j],p);
    end;
  end;

  m:=0;
  for i:=1 to n do begin
    inc(m);
    x[m]:=p1[i].x;
    y[m]:=p1[i].y;
    inc(m);
    x[m]:=p2[i].x;
    y[m]:=p2[i].y;
  end;

  p.x:=x[1];
  p.y:=y[1];
  j:=1;
  for i:=2 to m do begin
    if (y[i]<p.y) or ((y[i]=p.y) and (x[i]<p.x)) then begin
      j:=i;
      p.x:=x[i];
      p.y:=y[i];
    end;
  end;

  x[j]:=x[1];
  y[j]:=y[1];
  x[1]:=0;
  y[1]:=0;
  z[1]:=-1e50;

  for i:=2 to m do begin
    x[i]:=x[i]-p.x;
    y[i]:=y[i]-p.y;
    if y[i]>eps then
      z[i]:=x[i]/y[i]
    else
      z[i]:=x[i]*1e50;
  end;

  qsort(1,m);

  fillchar(f,sizeof(f),true);
  for i:=2 to m do
    if (abs(x[i]-x[i-1])<eps) and (abs(y[i]-y[i-1])<eps) then f[i]:=false;

  m1:=2;
  x1[1]:=x[1];
  y1[1]:=y[1];
  j:=2;
  while (not f[j]) and (j<=m) do
    inc(j);
  if j>m then out(0);
  x1[2]:=x[j];
  y1[2]:=y[j];

  for i:=j to m do if (f[i]) then begin
    while leftrotate(x1[m1-1],y1[m1-1],x1[m1],y1[m1],x[i],y[i]) do
      dec(m1);
    if not ((x[i]=x1[m1]) and (y[i]=y1[m1])) then begin
      inc(m1);
      x1[m1]:=x[i];
      y1[m1]:=y[i];
    end;
  end;

  s:=0;
  x1[0]:=x1[m1];
  y1[0]:=y1[m1];
  for i:=1 to m1 do
    s:=s+(x1[i]-x1[i-1])*(y1[i]+y1[i-1]);

  s:=abs(s/2);

{  for i:=1 to m do writeln(x[i]:10:2,' ',y[i]:10:2,' ',z[i]:10:2);}

  out(s);
end.
