program zzzz;

const
  maxn = 2000;
  inf = 1E20;
  eps = 1E-5;
type
  point = record
    x,y: double;
  end;
function more(p1,p2: point): boolean;
begin
  if abs(p1.x-p2.x) < eps then more := p1.y>p2.y else more := p1.x>p2.x;
end;
procedure intr(var res: point; p1,p2,p3,p4: point);
var a1,b1,c1,a2,b2,c2: double;
begin
  a1 := p1.y-p2.y; b1 := p2.x-p1.x; c1 := p1.y*(p2.x-p1.x)-p1.x*(p2.y-p1.y);
  a2 := p3.y-p4.y; b2 := p4.x-p3.x; c2 := p3.y*(p4.x-p3.x)-p3.x*(p4.y-p3.y);
  res.x := (c1*b2-c2*b1)/(a1*b2-b1*a2);
  res.y := (c2*a1-c1*a2)/(a1*b2-b1*a2);
end;
var
  can,con: array[1..maxn*2] of point;
  st: array[1..maxn*2] of longint;
  a: array[1..maxn,1..2] of point;
  vn,i,j,k,n,num,m: longint;
  rs: point;
  min,max: array[1..maxn] of point;
  answ,dd,ang,mn: double;
procedure swap(var a,b: double);
var buf: double;
begin
  buf := a;
  a := b;
  b := buf;
end;
procedure swapp(var a,b: point);
var buf: point;
begin
  buf := a;
  a := b;
  b := buf;
end;
function d(p1,p2: point): double;
begin
  d := sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
end;
function eqpoint(p1,p2: point): boolean;
begin
  eqpoint := (abs(p1.x-p2.x) < eps) and (abs(p1.y-p2.y)< eps);
end;
procedure pushdown(st,fin: longint);
var i,j: longint;
begin
  i := st;
  j := 2*st;
  while j <= fin do begin
    if j <> fin then if more(can[j+1],can[j]) then inc(j);
    if more(can[j],can[i]) then begin
      swapp(can[i],can[j]);
      i :=j;
      j := 2*i;
    end else break;
  end;
end;
function getangle(p1,p2,p3: point): double;
var a,b,c: double;
begin
  a := d(p1,p2); b := d(p1,p3); c := d(p2,p3);
  getangle := (sqr(b)-sqr(a)-sqr(c))/(2*a*c);
end;
procedure sort(n: longint);
var i: longint;
begin
  for i := n div 2 downto 2 do pushdown(i,n);
  for i := n downto 2 do begin
    pushdown(1,i);
    swapp(can[i],can[1]);
  end;
end;
begin
  assign(input,'convexh.in'); reset(input);
  assign(output,'convexh.out'); rewrite(output);
  read(n);
  for i := 1 to n do begin
    read(a[i,1].x,a[i,1].y,a[i,2].x,a[i,2].y);
  end;
  k := 1;
  if n = 2 then begin
    writeln('0.000');
    close(input);
    close(output);
    halt(0);
  end;
  for i := 1 to n do begin
    min[i].x := inf; min[i].y := inf;
    max[i].x := -inf; max[i].y := -inf;
    for j := 1 to n do begin
      if i = j then continue;
      intr(rs,a[i,1],a[i,2],a[j,1],a[j,2]);
      if more(rs,max[i]) then max[i] := rs;
      if more(min[i],rs) then min[i] := rs;
    end;
    can[i*2-1] := min[i];
    can[i*2] := max[i];
  end;
  sort(2*n);
  m := 1;
  mn := -inf;
  for i := 1 to 2*n do begin
    if not eqpoint(can[i],can[m]) then begin
      inc(m);
      can[m] := can[i];
    end;
  end;
  for i := 1 to m do begin
    if can[i].x > mn then begin
      mn := can[i].x;
      num := i;
    end;
  end;
  ang := -2;
  st[1] := num;
  vn := 2;
  for i := 1 to m do begin
    if i = num then continue;
    mn := (can[i].y-can[num].y)/d(can[i],can[num]);
    if mn > ang then begin
      ang := mn;
      st[2] := i;
    end;
  end;
  while st[1] <> st[vn] do begin
    ang := -2;
    for j := 1 to m do begin
      if (j = st[vn]) or (j = st[vn-1]) then continue;
      mn := getangle(can[st[vn-1]],can[st[vn]],can[j]);
      if abs(ang-mn) < eps then begin
        if d(can[st[vn]],can[st[vn+1]]) > d(can[st[vn]],can[j]) then st[vn+1] := j;
      end else if ang < mn then begin
        ang := mn;
        st[vn+1] := j;
      end;
    end;
    inc(vn);
  end;
  for i := 1 to vn-1 do begin
    answ := answ + (can[st[i]].x+can[st[i+1]].x)*(can[st[i]].y-can[st[i+1]].y);
  end;
  answ := 1/2*abs(answ);
  writeln(answ:0:3);
  close(input);
  close(output);
end.
