{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

Const INPUTFILE='matrix.in';
      OUTPUTFILE='matrix.out';

Const MaxM=300;
      MaxN=302;
Type Real=Double;

var a:Array[1..MaxN,1..MaxN] of Byte;
    b,OldB:Array[1..MaxM] of Byte;
    N,M:Longint;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(M);
for i:=1 to M do
  Read(b[i]);
Close(Input);

FillChar(a,SizeOf(a),0);
OldB:=b;
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);
if Answer>0 then
begin
  for i:=1 to Answer do
  begin
    for j:=1 to Answer do
      Write(a[i,j],' ');
    Writeln;
  end;
end;
Close(Output);
Halt;
end;

Procedure DoIt(N:Integer;Last:Integer);
var i:Integer;
begin
if N=1 then Exit;

if N<b[Last]+1 then
  FWrite(-1)
else if N=b[Last]+1 then
begin
  for i:=1 to N-1 do
  begin
    a[i,N]:=1;
    a[N,i]:=1;
  end;
  for i:=1 to Last do
    Dec(b[i]);
  DoIt(N-1,Last-1);
end
else
  DoIt(N-1,Last);
end;

Procedure Euristic;
var k,l,g:Longint;
    Sums:Array[1..MaxN] of Integer;
begin
for i:=1 to N do
begin
  k:=0;
  for j:=1 to N do
    Inc(k,a[i,j]);
  Sums[i]:=k
end;

for i:=1 to N do
begin
  g:=0;
  for l:=1 to M do
    if OldB[l]=Sums[i] then g:=1;
  if g=0 then FWrite(-1);
end;

for l:=1 to M do
begin
  g:=0;
  for i:=1 to N do
    if Sums[i]=OldB[l] then g:=1;
  if g=0 then FWrite(-1);
end;
end;

Procedure Solve;
begin
for j:=1 to M do
for i:=1 to M-j do
  if b[i]>b[i+1] then
  begin
    b[i]:=b[i] XOR b[i+1];
    b[i+1]:=b[i] XOR b[i+1];
    b[i]:=b[i] XOR b[i+1];
  end;

N:=b[M]+1;
if b[1]=0 then Inc(N);
DoIt(N,M);
Euristic;
FWrite(N);
end;

begin
FRead;
Solve;
end.
