program Company_Moves;

const
  MAXN = 300; {300}

var
  n, m, k, l : integer;
  g, o : array [1..MAXN,1..MAXN] of integer;
  sta, stb, mi : array [1..MAXN] of integer;
  md : array [1..MAXN,1..MAXN] of integer;

procedure Load(infile, outfile : string);
var
  i, j, t : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  fillchar(g,sizeof(g),0);
  fillchar(o,sizeof(o),0);
  fillchar(sta,sizeof(sta),0);
  fillchar(stb,sizeof(stb),0);
  read(n,m);
  l := 0;
  for i:=1 to n do
  begin
    read(mi[i]);
    for j:=1 to mi[i] do
    begin
      read(t);
      inc(g[i,t]);
      inc(sta[i]);
      inc(stb[t]);
      if sta[i]>l then
        l := sta[i];
      if stb[t]>l then
        l := stb[t];
      o[i,t] := j;
    end;
  end;
end;

procedure Solve;
var
  i, j, x, y, ql, qr, cur, bcur, temp : integer;
  found : boolean;
  asol, bsol, q, prev : array [1..MAXN] of integer;
begin
  if m>n then
    k := m
  else
    k := n;
  x := 1;
  y := 1;
  repeat
    while (x<=k) and (sta[x]=l) do
      inc(x);
    while (y<=k) and (stb[y]=l) do
      inc(y);
    if (x>k) or (y>k) then
      break;
    inc(g[x,y]);
    inc(sta[x]);
    inc(stb[y]);
  until false;

  for i:=1 to l do
  begin                                         {Kun}
    fillchar(asol,sizeof(asol),0);
    fillchar(bsol,sizeof(bsol),0);
    for j:=1 to k do
    begin                                       {BFS}
      fillchar(prev,sizeof(prev),0);
      ql := 1;
      qr := 1;
      q[1] := j;
      found := false;
      while (qr>=ql) and not found do
      begin
        cur := q[ql];
        inc(ql);
        for bcur:=1 to k do
          if g[cur,bcur]>0 then
          begin
            if bsol[bcur]=0 then
            begin
              found := true;
              break;
            end
            else
              if prev[bsol[bcur]]=0 then
              begin
                prev[bsol[bcur]] := cur;
                inc(qr);
                q[qr] := bsol[bcur];
              end;
          end;
      end;                                      {end BFS}
      if found then
        while cur<>0 do
        begin
          temp := asol[cur];
          asol[cur] := bcur;
          bsol[bcur] := cur;
          cur := prev[cur];
          bcur := temp;
        end
      else
      begin
        writeln('Holl is a fool');
        halt(13);
      end;
    end;                                        {end Kun}

    for cur:=1 to n do
    begin
      bcur := asol[cur];
      dec(g[cur,bcur]);
      if o[cur,bcur]<>0 then
      begin
        md[cur,o[cur,bcur]] := i;
        o[cur,bcur] := 0;
      end;
    end;
  end;
end;

procedure Save;
var
  i, j : integer;
begin
  for i:=1 to n do
  begin
    for j:=1 to mi[i] do
      write(md[i,j]-1,' ');
    writeln;
  end;
  close(input);
  close(output);
end;

begin
  Load('move.in','move.out');
  Solve;
  Save;
end.