{$I-,Q-,R-,S-}
type
  p_1=^t_1;
  t_1=record
    next,pred:p_1;
    i:integer;
  end;

var
  z,i,j,n,m:integer;
  a:array[1..300,1..300] of shortint;
  t:array[1..300,1..300] of integer;
  l1,r1,l,r:array[1..300] of boolean;
  flag1:boolean;
  sml,smr:array[1..300] of p_1;
  sm:array[1..300] of record
    c:integer;
    l:array[1..300] of integer;
  end;
  p1:p_1;

procedure add(var p:p_1;i:integer);
var
  p1:p_1;
begin
  new(p1);
  p1^.next:=p;
  if p<>nil then p^.pred:=p1;
  p1^.i:=i;
  p1^.pred:=nil;
  p:=p1;
end;

procedure delete(var p,p1:p_1);
begin
  if p1^.pred<>nil then p1^.pred^.next:=p1^.next;
  if p1^.next<>nil then p1^.next^.pred:=p1^.pred;
  if p=p1 then p:=p1^.next;
  dispose(p1);
end;

procedure clear(var p:p_1);
var
  p1:p_1;
begin
  p1:=p;
  while p1<>nil do begin
    p:=p1;
    p1:=p^.next;
    dispose(p);
  end;
  p:=nil;
end;

function dfsfromr(j:integer):boolean; forward;

{
function dfsfroml(i:integer):boolean;
var
  j:integer;
begin
  l1[i]:=true;
  for j:=1 to m do if (a[i,j]=1) and (not r1[j]) then
    if dfsfromr(j) then begin
      a[i,j]:=2;
      l[i]:=true;
      dfsfroml:=true;
      exit;
    end;
  dfsfroml:=false;
end;

function dfsfromr(j:integer):boolean;
var
  i:integer;
begin
  r1[j]:=true;
  if not r[j] then begin
    dfsfromr:=true;
    r[j]:=true;
    exit;
  end;
  for i:=1 to n do if (a[i,j]=2) and (not l1[i]) then
    if dfsfroml(i) then begin
      a[i,j]:=1;
      dfsfromr:=true;
      exit;
    end;
  dfsfromr:=false;
end;
}

function dfsfroml(i:integer):boolean;
var
  j:integer;
  p1:p_1;
begin
  l1[i]:=true;
  p1:=sml[i];
  while p1<>nil do begin
    j:=p1^.i;
    if not r1[j] then
      if dfsfromr(j) then begin
        delete(sml[i],p1);
        add(smr[j],i);
        a[i,j]:=2;
        l[i]:=true;
        dfsfroml:=true;
        exit;
      end;
    p1:=p1^.next;
  end;
  dfsfroml:=false;
end;

function dfsfromr(j:integer):boolean;
var
  i:integer;
  p1:p_1;
begin
  r1[j]:=true;
  if not r[j] then begin
    dfsfromr:=true;
    r[j]:=true;
    exit;
  end;
  p1:=smr[j];
  while p1<>nil do begin
    i:=p1^.i;
    if not l1[i] then
      if dfsfroml(i) then begin
        delete(smr[j],p1);
        add(sml[i],j);
        a[i,j]:=1;
        dfsfromr:=true;
        exit;
      end;
    p1:=p1^.next;
  end;
  dfsfromr:=false;
end;

begin
  assign(input,'move.in');
  reset(input);
  assign(output,'move.out');
  rewrite(output);
  fillchar(a,sizeof(a),0);
  readln(n,m);
  for i:=1 to n do
    sml[i]:=nil;
  for j:=1 to m do
    smr[j]:=nil;

  for i:=1 to n do
    for j:=1 to m do
      t[i,j]:=-1;
  for i:=1 to n do begin
    read(sm[i].c);
    for z:=1 to sm[i].c do begin
      read(j);
      sm[i].l[z]:=j;
      a[i,j]:=1;
      add(sml[i],j);
    end;
  end;

  flag1:=true;
  z:=0;
  while flag1 do begin
    fillchar(l,sizeof(l),false);
    fillchar(r,sizeof(r),false);
    for i:=1 to n do begin
      if not l[i] then begin
        fillchar(l1,sizeof(l1),false);
        fillchar(r1,sizeof(r1),false);
        dfsfroml(i);
      end;
    end;
    flag1:=false;

    for i:=1 to n do
      if sml[i]<>nil then flag1:=true;
    for j:=1 to m do begin
      p1:=smr[j];
      while p1<>nil do begin
        i:=p1^.i;
        a[i,j]:=-1;
        t[i,j]:=z;
        p1:=p1^.next;
      end;
      clear(smr[j]);
    end;

{
    for i:=1 to n do begin
      for j:=1 to m do begin
        if a[i,j]=2 then begin
          a[i,j]:=-1;
          t[i,j]:=z;
        end;
        if a[i,j]=1 then flag1:=true;
      end;
    end;
}
    inc(z);
  end;
  for i:=1 to n do begin
    for j:=1 to sm[i].c do begin
      write(t[i,sm[i].l[j]],' ');
    end;
    writeln;
  end;

  close(input);
  close(output);
end.
