{$I-,Q-,S-,R-}
const max=100;
var n,m:longint;
    c:array[1..max,1..max]of longint;
    flow,d:array[1..max,1..max]of extended;

    sp:array[1..50000,1..2]of longint;

    maxflow:extended;


procedure init;
var i,j,u,v:longint;
    l:extended;
begin
  assign(input,'flow.in');
  reset(input);
  read(n,m);
  fillchar(c,sizeof(c),0);
  for i:=1 to max do
    for j:=1 to max do
      d[i,j]:=0;
  for i:=1 to m do
    begin
      read(u,v,l);
      sp[i,1]:=u;
      sp[i,2]:=v;
      inc(c[u,v]);
      inc(c[v,u]);
      d[u,v]:=d[u,v]+l;
      d[v,u]:=d[v,u]+l;
    end;
  close(input);
end;

procedure run;
var x:array[1..max]of extended;
    g:array[1..max+1,1..max+1]of extended;
    k,i,j,cn:longint;
    cp,cof:extended;
begin
  fillchar(g,sizeof(g),0);
  g[1,n]:=1;
  g[2,1]:=1;
  g[2,n+1]:=-100000;
  for i:=2 to n-1 do
    begin
      cn:=0;
      for j:=1 to n do
        if c[i,j]>0 then
          begin
            inc(cn);
            g[i+1,j]:=-1;
          end;
      g[i+1,i]:=cn;
    end;

  fillchar(flow,sizeof(flow),0);
  maxflow:=0;
  for k:=1 to n-1 do
    begin
      cn:=k;
      for i:=k+1 to n do
        if abs(g[i,k])>abs(g[cn,k]) then
          cn:=i;
      g[max+1]:=g[cn];
      g[cn]:=g[k];
      g[k]:=g[max+1];
      if abs(g[k,k])<0.000001 then
        exit;
      for i:=k+1 to n do
        begin
          cp:=g[i,k];
          for j:=k to n+1 do
            g[i,j]:=g[i,j]-g[k,j]*cp/g[k,k];
        end;
    end;
  if abs(g[n,n])<0.000001 then
    begin
      if abs(g[n,n+1])<0.000001 then
        x[n]:=0
      else
        exit;
    end
  else
    x[n]:=-g[n,n+1]/g[n,n];
  for i:=n-1 downto 1 do
    begin
      x[i]:=0;
      for j:=i+1 to n do
        x[i]:=x[i]-x[j]*g[i,j];
      x[i]:=x[i]-g[i,n+1];
      x[i]:=x[i]/g[i,i];
    end;

  cof:=1E100;
  for i:=1 to n do
    for j:=1 to n do
      if (c[i,j]>0)and(abs(x[i]-x[j])>0.000001) then
        if d[i,j]/abs(x[i]-x[j])<cof then
          cof:=d[i,j]/abs(x[i]-x[j]);
  for i:=1 to n do
    for j:=1 to n do
      if c[i,j]>0 then
        flow[i,j]:=(x[i]-x[j])*cof;
  maxflow:=0;
  for i:=1 to n-1 do
    maxflow:=maxflow+flow[i,n];
end;

procedure done;
var i:longint;
begin
  assign(output,'flow.out');
  rewrite(output);
  writeln(maxflow:0:15);
  for i:=1 to m do
    writeln(flow[sp[i,1],sp[i,2]]/c[sp[i,1],sp[i,2]]:0:15);
  close(output);
end;

begin
  init;
  run;
  done;
end.
