{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 130;
 inf = 100000000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'flow.in';
 coutfile= 'flow.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 cmin :array [1..nmax,1..nmax] of int;
 num :array [1..nmax,1..nmax] of int;
 gr :array [1..nmax,1..nmax] of int;
 f :array [1..nmax,1..nmax] of int;
 start,finish :int;
 n,m :int;
 ans :int;

procedure init;
begin
 fillchar (num,sizeof(num),0);
 fillchar (gr,sizeof(gr),0);
 fillchar (f,sizeof(f),0);
 ans := 0;
end;

procedure readdata;
var i,j :int;
    u,v,z :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n,m);
 for i := 1 to n do
  for j := 1 to n do
   cmin[i,j] := inf;
 for i := 1 to m do
  begin
   read (u,v,z);
   inc(num[u,v]);
   inc(num[v,u]);
   if cmin[u,v] > z then
    cmin[u,v] := z;
   if cmin[v,u] > z then
    cmin[v,u] := z;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
    u,v,z :int;
begin
 assign (output,coutfile);
 rewrite (output);
 assign (input,cinfile);
 reset (input);
 read(n,m);
 writeln (ans);
 for i := 1 to m do
  begin
   read (u,v,z);
   writeln ((f[u,v]/num[u,v]):0:10);
  end;
 reset (input);
 close (output);
end;

function bfs :boolean;
var q :array [1..nmax] of int;
    used :array [1..nmax] of boolean;
    prev :array [1..nmax] of int;
    delta :array [1..nmax] of int;
    i,j :int;
    w,t :int;
    cur :int;

procedure add (v :int; from :int);
begin
 used[v] := true;
 prev[v] := from;
 inc(t);
 q[t] := v;
 if delta[from] < gr[from,v] then
  delta[v] := delta[from]
 else
  delta[v] := gr[from,v];
end;

begin
 fillchar (q,sizeof(q),0);
 fillchar (used,sizeof(used),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (delta,sizeof(delta),0);
 q[1] := start;
 w := 1;
 t := 1;
 used[start] := true;
 delta[start] := inf;
 while w <= t do
  begin
   cur := q[w];
   if cur = finish then
    break;
   inc(w);
   for i := 1 to n do
    if (gr[cur,i] > 0) and not used[i] then
     add (i,cur);
  end;
 bfs := false;
 if not used[finish] then
  exit;
 bfs := true;
 cur := finish;
 while not (cur = start) do
  begin
   gr[prev[cur],cur] := gr[prev[cur],cur] - delta[finish];
   gr[cur,prev[cur]] := gr[cur,prev[cur]] + delta[finish];
   f[prev[cur],cur] := f[prev[cur],cur] + delta[finish];
   f[cur,prev[cur]] := f[cur,prev[cur]] - delta[finish];
   cur := prev[cur];
  end;
 ans := ans + delta[finish];
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  for j := 1 to n do
   gr[i,j] := cmin[i,j]*num[i,j];
 start := 1;
 finish := n;
 while bfs do
  {do nothing};
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.