{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}

const maxn=100100;
type
  int = longint;
  ex = extended;
  bool = boolean;
type
  line = array [1..3] of int;
  plist=^tlist;
  tlist = record
    l :line;
    next : plist;
  end;
const eps=1E-7;
var
  i,ii,iii,j,jj,jjj : int;
  n : int;
  v,g : array [1..maxn] of line;
  vcol,gcol : int;
  prevx,prevy,x,y : int;
  ttp,tp,pend : plist;
  p : tlist;
  now : int;
  minend : int;
  first : bool;
  sortnow : int;
  res : int;

{procedure qsort ( l,r : int );
var
  i,j,x,t : int;
begin
  i:=l;
  j:=r;
  x:=a[l+Random(r-l+1)];
  repeat
    while a[i]<x do inc(i);
    while a[j]>x do dec(j);
    if i<=j then begin
      t:=a[i];
      a[i]:=a[j];
      a[j]:=t;

      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then qsort(i,r);
  if j>l then qsort(l,j);
end;}
procedure qsortg ( l,r : int );
var
  i,j,x : int;
  t : line;
begin
  i:=l;
  j:=r;
  x:=g[l+Random(r-l+1)][1];
  repeat
    while g[i][1]<x do inc(i);
    while g[j][1]>x do dec(j);
    if i<=j then begin
      t:=g[i];
      g[i]:=g[j];
      g[j]:=t;

      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then qsortg(i,r);
  if j>l then qsortg(l,j);
end;
procedure qsortv ( l,r : int );
var
  i,j,x : int;
  t : line;
begin
  i:=l;
  j:=r;
  x:=v[l+Random(r-l+1)][2];
  repeat
    while v[i][2]<x do inc(i);
    while v[j][2]>x do dec(j);
    if i<=j then begin
      t:=v[i];
      v[i]:=v[j];
      v[j]:=t;

      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then qsortv(i,r);
  if j>l then qsortv(l,j);
end;
begin
  res:=0;
  Randomize;
  Assign ( input , 'poly.in' );
  Reset ( input );
  Assign ( output , 'poly.out' );
  Rewrite ( output );
  read ( n );
  read ( prevx,prevy );
  vcol:=0;
  gcol:=0;
  for i:=2 to n do begin
    read ( x,y );
    if (x-prevx)=(y-prevy) then begin
      inc (gcol );
      g[gcol][1]:=y-x;
      if (prevy+prevx)<(y+x) then begin
        g[gcol][2]:=prevy+prevx;
        g[gcol][3]:=y+x;
      end else begin
        g[gcol][3]:=prevy+prevx;
        g[gcol][2]:=y+x;
      end;
    end else begin
      inc ( vcol );
      v[vcol][1]:=y+x;
      if (prevy-prevx)<(y-x) then begin
        v[vcol][2]:=prevy-prevx;
        v[vcol][3]:=y-x;
      end else begin
        v[vcol][3]:=prevy-prevx;
        v[vcol][2]:=y-x;
      end;
    end;
    prevx:=x;
    prevy:=y;
  end;

  qsortg ( 1 , gcol );
  qsortv ( 1 , vcol );

{
  writeln ( gcol );
  writeln ( '--' );
  for i:=1 to gcol do begin
    writeln ( g[i][1] , ' ',g[i][2],' ',g[i][3] );
  end;
  writeln ( '---' );
  writeln ( vcol );
  writeln ( '--' );
  for i:=1 to vcol do begin
    writeln ( v[i][1] , ' ',v[i][2],' ',v[i][3] );
  end;
}
  p.next:=nil;
  first:=true;
  pend:=Addr(p);
  sortnow:=0;
  for i:=1 to gcol do begin
    now:=g[i][1];
    while v[sortnow+1][2]<=now do begin
      new ( tp );
      tp^.l:=v[sortnow+1];
      if v[sortnow+1][3]<minend then begin
        minend:=v[sortnow+1][3];
      end;
      tp^.next:=nil;
      pend^.next:=tp;
      pend:=tp;
      inc ( sortnow );
    end;
    if first or (now>=minend) then begin
      minend:=-MaxLongint;
      first:=false;
      tp:=addr(p);
      while tp^.next<>nil do begin
        if tp^.next^.l[3]<=now then begin
          ttp:=tp^.next;
          tp^.next:=tp^.next^.next;
          dispose ( ttp );
        end else begin
          tp:=tp^.next;
          if tp^.l[3]<minend then minend:=tp^.l[3];
        end;
      end;
    end;
    tp:=p.next;
    while tp <> nil do begin
      pend:=tp;
      if (tp^.l[2]<now) and (tp^.l[3]>now) and (tp^.l[1]>g[i][2]) and (tp^.l[1]<g[i][3]) then begin
        inc ( res );
      end;
      tp:=tp^.next;
    end;
  end;

  writeln ( res );

  close ( input );
  close ( output );
end.
