{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 500000,0,655360}

Const INPUTFILE='mayors.in';
      OUTPUTFILE='mayors.out';

Const Max=20000;
Type Real=Double;
     Point=record
     x,y:Longint;
     end;

var a:Array[1..Max] of Point;
    NumsX,NumsY:Array[1..Max] of Integer;
    ANumsX,ANumsY:Array[1..Max] of Integer;

    Ans:Array[1..Max] of Shortint;
    N:Longint;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N do
  Read(a[i].x,a[i].y);
Close(Input);

FillChar(Ans,SizeOf(Ans),255);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
for i:=1 to N do
  Writeln(Ans[i]);

Close(Output);

Halt;
end;

Function CmpX(p,q:Integer):Shortint;
begin
if a[p].x<a[q].x then
  CmpX:=-1
else if a[p].x>a[q].x then
  CmpX:=1
else
begin
  if a[p].y<a[q].y then
    CmpX:=-1
  else if a[p].y>a[q].y then
    CmpX:=1
  else
    CmpX:=0;
end;
end;

Function CmpY(p,q:Integer):Shortint;
begin
if a[p].y<a[q].y then
  CmpY:=-1
else if a[p].y>a[q].y then
  CmpY:=1
else
begin
  if a[p].x<a[q].x then
    CmpY:=-1
  else if a[p].x>a[q].x then
    CmpY:=1
  else
    CmpY:=0;
end;
end;

Procedure QSortX(L,R:Longint);
var i,j:Longint;
    x,t:Longint;
begin
i:=L;
j:=R;
x:=NumsX[(i+j) div 2];

Repeat
  While CmpX(NumsX[i],x)=-1 Do Inc(i);
  While CmpX(NumsX[j],x)=1 Do Dec(j);
  if i<=j then
  begin
    t:=NumsX[i];
    NumsX[i]:=NumsX[j];
    NumsX[j]:=t;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if j>L then QSortX(L,j);
if i<R then QSortX(i,R);
end;

Procedure QSortY(L,R:Longint);
var i,j:Longint;
    x,t:Longint;
begin
i:=L;
j:=R;
x:=NumsY[(i+j) div 2];

Repeat
  While CmpY(NumsY[i],x)=-1 Do Inc(i);
  While CmpY(NumsY[j],x)=1 Do Dec(j);
  if i<=j then
  begin
    t:=NumsY[i];
    NumsY[i]:=NumsY[j];
    NumsY[j]:=t;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if j>L then QSortY(L,j);
if i<R then QSortY(i,R);
end;

Procedure SortAll;
var t:Longint;
begin
for i:=1 to N do
begin
  NumsX[i]:=i;
  NumsY[i]:=i;
end;
Randomize;
for i:=N downto 1 do
begin
  j:=Random(i)+1;
  t:=NumsX[i];
  NumsX[i]:=NumsX[j];
  NumsX[j]:=t;

  j:=Random(i)+1;
  t:=NumsY[i];
  NumsY[i]:=NumsY[j];
  NumsY[j]:=t;
end;

QSortX(1,N);
QSortY(1,N);

for i:=1 to N do
begin
  ANumsX[NumsX[i]]:=i;
  ANumsY[NumsY[i]]:=i;
end;
end;

var S:Array[1..Max] of Integer;

Procedure Solve;
var g,h:Longint;
    Cur:Integer;
    Last:Integer;
begin
SortAll;
for h:=1 to N do
if Ans[h]=-1 then
begin
Cur:=1;
Last:=1;
S[Cur]:=h;
Ans[S[Cur]]:=0;

Repeat
  g:=1-Ans[S[Cur]];
  i:=ANumsX[S[Cur]]+1;
  While (i<=N) AND (a[NumsX[i]].x=a[S[Cur]].x) Do
  begin
    if Ans[NumsX[i]]=-1 then
    begin
      Inc(Last);
      S[Last]:=NumsX[i];
      Ans[NumsX[i]]:=g;
      g:=1-g;
    end;
    Inc(i);
  end;

  g:=1-Ans[S[Cur]];
  i:=ANumsX[S[Cur]]-1;
  While (i>=1) AND (a[NumsX[i]].x=a[S[Cur]].x) Do
  begin
    if Ans[NumsX[i]]=-1 then
    begin
      Inc(Last);
      S[Last]:=NumsX[i];
      Ans[NumsX[i]]:=g;
      g:=1-g;
    end;
    Dec(i);
  end;

  g:=1-Ans[S[Cur]];
  i:=ANumsY[S[Cur]]+1;
  While (i<=N) AND (a[NumsY[i]].y=a[S[Cur]].y) Do
  begin
    if Ans[NumsY[i]]=-1 then
    begin
      Inc(Last);
      S[Last]:=NumsY[i];
      Ans[NumsY[i]]:=g;
      g:=1-g;
    end;
    Inc(i);
  end;

  g:=1-Ans[S[Cur]];
  i:=ANumsY[S[Cur]]-1;
  While (i>=1) AND (a[NumsY[i]].y=a[S[Cur]].y) Do
  begin
    if Ans[NumsX[i]]=-1 then
    begin
      Inc(Last);
      S[Last]:=NumsY[i];
      Ans[NumsY[i]]:=g;
      g:=1-g;
    end;
    Dec(i);
  end;

  Inc(Cur);
Until Cur>Last;
end;

FWrite(1543);
end;

begin
FRead;
Solve;
end.
