{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

Const INPUTFILE='poly.in';
      OUTPUTFILE='poly.out';

Const MaxN=100000;
Type Real=Double;
     Point=record
     x,y:Longint;
     end;

var a:Array[1..MaxN+1] of Point;
    N:Longint;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N do
  Read(a[i].x,a[i].y);
Close(Input);
a[N+1]:=a[1];
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Write(Answer);
Close(Output);

Halt;
end;

Function Min(a,b:Longint):Longint;
begin
if a<b then
  Min:=a
else
  Min:=b;
end;

Function Max(a,b:Longint):Longint;
begin
if a<b then
  Max:=b
else
  Max:=a;
end;

Function Inter(i,j:Longint):Boolean;
var K1,B1,K2,B2:Longint;
    x,t1,t2:Real;
begin
K1:=(a[i+1].y-a[i].y) div (a[i+1].x-a[i].x);
B1:=a[i].y-K1*a[i].x;
K2:=(a[j+1].y-a[j].y) div (a[j+1].x-a[j].x);
B2:=a[j].y-K2*a[j].x;
if K1<>K2 then
begin
  t1:=K1-K2;
  t2:=B2-B1;
  x:=t2/t1;
  if  (x>=Min(a[i].x,a[i+1].x)) AND (x<=Max(a[i].x,a[i+1].x))
  AND (x>=Min(a[j].x,a[j+1].x)) AND (x<=Max(a[j].x,a[j+1].x)) then
    Inter:=True
  else
    Inter:=False;
end
else
  Inter:=False;

end;

Procedure Solve;
var g,h:Longint;
    K:Longint;
begin
K:=0;
for i:=1 to N-1 do
for j:=i+2 to N-1 do
  if Inter(i,j) then Inc(K);
FWrite(K);
end;

begin
FRead;
Solve;
end.
