Const
 inf='parking.in';
 ouf='parking.out';
 max=100000;
 dl=1 shl 15;
var
 n,m,i,r,l,tk:longint;
 t1,t2,c,np,p,t:array [1..max] of longint;
 a:array [1..2*max] of longint;
function rmq(l,r:longint):longint;
var nmin:longint;
begin
 nmin:=a[l];
 while l<=r do
  begin
   if t[nmin]>t[a[l]] then nmin:=a[l];
   l:=(l+1) div 2;
   if t[nmin]>t[a[r]] then nmin:=a[r];
   r:=(r-1) div 2;
  end;
 rmq:=nmin;
end;
function rmqz(l,r:longint):longint;
begin
 rmqz:=t[rmq(n+l-1,n+r-1)];
end;
procedure refresh(i:longint);
begin
 while t[a[i div 2]]>t[a[i]] do
  begin
   a[i div 2]:=a[i];
   i:=i div 2;
  end;
end;
procedure swapli(var a,b:longint);
var t:longint;
begin
 t:=a;
 a:=b;
 b:=t;
end;
procedure heapsort;
var
 l,i:longint;
  procedure down(i:longint);
  var t:longint;
  begin
   repeat
    t:=i;
    if (2*i<=l) and (t1[p[t]]<t1[p[2*i]]) then t:=2*i;
    if (2*i+1<=l) and (t1[p[t]]<t1[p[2*i+1]]) then t:=2*i+1;
    swapli(p[i],p[t]);
    if t=i then break
    else i:=t;
   until false;
  end;
begin
 l:=m;
 for i:=m div 2 downto 1 do down(i);
 for i:=1 to m-1 do
  begin
   swapli(p[1],p[l]);
   dec(l);
   down(1);
  end;
end;
begin
 assign(input,inf);
 reset(input);
 assign(output,ouf);
 rewrite(output);
 readln(n,m);
 for i:=1 to m do readln(t1[i],t2[i],c[i]);
 for i:=1 to m do p[i]:=i;
 heapsort;
 tk:=t1[p[1]];
 for i:=1 to n do t[i]:=tk;
 for i:=n to 2*n-1 do a[i]:=i-n+1;
 for i:=n-1 downto 1 do
  begin
   if t[a[2*i]]<t[a[2*i+1]] then a[i]:=a[2*i]
   else a[i]:=a[2*i];
  end;
 for i:=1 to m do
  begin
   l:=c[p[i]];
   r:=l+dl;
   if r>n then r:=n;
   tk:=t1[p[i]];
   while rmqz(l,r)>tk do
    begin
     l:=r mod n+1;
     r:=l+dl;
     if r>n then r:=n;
    end;
   while r-l>0 do
    begin
     if rmqz(l,(l+r) div 2)>tk then l:=(l+r) div 2+1
     else r:=(l+r) div 2;
    end;
   t[l]:=t2[p[i]];
   np[p[i]]:=l;
   refresh(l);
  end;
 for i:=1 to m do writeln(np[i]);
 close(output);
 close(input);
end.
