{$I-,R-,S-,Q-}
const max=100000;
var cnt,n,size:longint;
    x,y:array[1..max]of longint;
    out:extended;

    spx,sph,spl:array[1..max]of longint;


procedure init;
var i:longint;
    ax,ay:longint;
begin
  assign(input,'poly.in');
  reset(input);
  read(n);
  for i:=1 to n do
    begin
      read(ax,ay);
      x[i]:=ax-ay;
      y[i]:=ax+ay;
    end;
  close(input);
end;

procedure swap(i,j:longint);
var k:longint;
begin
  k:=spx[i];
  spx[i]:=spx[j];
  spx[j]:=k;
  k:=sph[i];
  sph[i]:=sph[j];
  sph[j]:=k;
  k:=spl[i];
  spl[i]:=spl[j];
  spl[j]:=k;
end;

procedure add(ax,ah,al:longint);
var i:longint;
begin
  inc(size);
  spx[size]:=ax;
  sph[size]:=ah;
  spl[size]:=al;
  i:=size;
  while (i>1)and(spx[i div 2]<spx[i]) do
    begin
      swap(i,i div 2);
      i:=i div 2;
    end;
end;

procedure heapify(i:longint);
var m:longint;
begin
  m:=i;
  if 2*i<=size then
    if spx[2*i]>spx[m] then
      m:=2*i;
  if 2*i+1<=size then
    if spx[2*i+1]>spx[m] then
      m:=2*i+1;
  if m<>i then
    begin
      swap(m,i);
      heapify(m);
    end;
end;

procedure extract(var ax,ah,al:longint);
begin
  ax:=spx[1];
  ah:=sph[1];
  al:=spl[1];
  spx[1]:=spx[size];
  sph[1]:=sph[size];
  spl[1]:=spl[size];
  dec(size);
  heapify(1);
end;

procedure run;
var l,r,i,j:longint;
    minx,maxx,ax,al,ah:longint;
begin
  size:=0;
  for i:=1 to n-1 do
    if x[i]=x[i+1] then
      if y[i]>y[i+1] then
        add(x[i],y[i],y[i+1])
      else
        add(x[i],y[i+1],y[i]);
  cnt:=size;
  for i:=cnt downto 1 do
    begin
      extract(ax,ah,al);
      spx[i]:=ax;
      sph[i]:=ah;
      spl[i]:=al;
    end;
  for i:=1 to n-1 do
    if y[i]=y[i+1] then
      begin
        if x[i]<x[i+1] then
          minx:=x[i]
        else
          minx:=x[i+1];
        maxx:=x[i]+x[i+1]-minx;
        l:=1;
        r:=cnt;
        while l+1<=r do
          begin
            j:=(l+r)div 2;
            if spx[j]=minx then
              break;
            if spx[j]<minx then
              l:=j+1
            else
              r:=j;
          end;
        if spx[j]=minx then
          l:=j;
        while (l>1)and(spx[l-1]>=minx) do
          dec(l);
        while (l<=cnt)and(spx[l]<=maxx) do
          begin
            if (sph[l]>y[i])and(spl[l]<y[i]) then
              out:=out+1;
            inc(l);
          end;
      end;
end;

procedure done;
begin
  assign(output,'poly.out');
  rewrite(output);
  write(out:0:0);
  close(output);
end;

begin
  init;
  run;
  done;
end.