{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
Const maxn = 20000;

Type Point = Record
              x, y, v, h, k: Longint;
             End;

Var i, n, p: Longint;
    c: array[0..maxn] of Point;
    k, v, h: array[1..maxn] of Longint;

Procedure SwapPoint(var a, b: Point);
 Var c: Point;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure SwapInt(var a, b: Longint);
 Var c: Longint;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure HoarX(left, right: Longint);
 Var i, j, x: Longint;
 Begin
  i := left;
  j := right;
  x := c[Random(j - i + 1) + i].x;
  While i < j do
   Begin
    While c[i].x < x do Inc(i);
    While c[j].x > x do Dec(j);
    If i <= j Then
     Begin
      SwapPoint(c[i], c[j]);
      SwapInt(k[c[i].k], k[c[j].k]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then HoarX(left, j);
  If i < right Then HoarX(i, right);
 End;

Procedure HoarY(left, right: Longint);
 Var i, j, x: Longint;
 Begin
  i := left;
  j := right;
  x := c[Random(j - i + 1) + i].y;
  While i < j do
   Begin
    While c[i].y < x do Inc(i);
    While c[j].y > x do Dec(j);
    If i <= j Then
     Begin
      SwapPoint(c[i], c[j]);
      SwapInt(k[c[i].k], k[c[j].k]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then HoarY(left, j);
  If i < right Then HoarY(i, right);
 End;

Procedure Init;
 Begin
  Read(n);
  For i := 1 to n do
   Begin
    Read(c[i].x, c[i].y);
    c[i].k := i;
    k[i] := i;
   End;
  HoarX(1, n);
  c[0] := c[1];
  p := 1;
  For i := 1 to n do
   Begin
    If c[i].x <> c[i - 1].x Then Inc(p);
    c[i].v := p;
    Inc(v[p]);
   End;
  HoarY(1, n);
  c[0] := c[1];
  p := 1;
  For i := 1 to n do
   Begin
    If c[i].y <> c[i - 1].y Then Inc(p);
    c[i].h := p;
    Inc(h[p]);
   End;
  For i := 1 to n do
   If k[i] > i Then SwapPoint(c[i], c[k[i]]);
 End;

Begin
 Assign(input, 'mayors.in');
 Assign(output, 'mayors.out');
 Reset(input);
 Rewrite(output);
 Init;
 For i := 1 to n do
  If (v[c[i].v] > 1) and (h[c[i].h] > 1)
   Then
    Begin
     k[i] := 0;
     Dec(v[c[i].v], 2);
     Dec(h[c[i].h], 2);
    End
   Else
    k[i] := 1;
 For i := 1 to n do
  Writeln(k[i]);
 Close(input);
 Close(output);
End.