const
  prob='parking';
  inp=prob+'.in';
  out=prob+'.out';

var
  n,i,j,m,k,t,last:longint;
  a,a1:array[1..100000,1..3]of longint;
  b,b1,b2:array[1..100000]of longint;
  cur:array[1..100000]of integer;

procedure swap(i,j:longint);
var
  c:longint;
begin
  c:=a[i,1];
  a[i,1]:=a[j,1];
  a[j,1]:=c;
  c:=a[i,2];
  a[i,2]:=a[j,2];
  a[j,2]:=c;
  c:=a[i,3];
  a[i,3]:=a[j,3];
  a[j,3]:=c;
  c:=b[i];
  b[i]:=b[j];
  b[j]:=c;
end;

procedure sort(l,r:longint);
var
  i,j,x:longint;
begin
  i:=l;
  j:=r;
  x:=a[(l+r) div 2,1];
  repeat
    while a[i,1]<x do
      inc(i);
    while a[j,1]>x do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then sort(i,r);
  if l<j then sort(l,j);
end;
procedure sort2(l,r:longint);
var
  i,j,x:longint;
begin
  i:=l;
  j:=r;
  x:=a[(l+r) div 2,2];
  repeat
    while a[i,2]<x do
      inc(i);
    while a[j,2]>x do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then sort2(i,r);
  if l<j then sort2(l,j);
end;

procedure init;
begin
  assign(input,inp);
  reset(input);

    read(n,m);
    if m>n then halt(57);
    for i:=1 to m do
      read(a[i,1],a[i,2],a[i,3]);

  close(input);
end;

procedure done;
begin
  assign(output,out);
  rewrite(output);

    for i:=1 to m do
      writeln(a1[b1[i],3]);

  close(output);
  halt(0);
end;

function find(q,l,r,n:longint):longint;
begin
  if n>a1[r,2] then begin
    find:=r;
    exit;
  end;
  if n<a1[l,2] then begin
    find:=l-1;
    exit;
  end;
  if (abs(l-r)=1)and(a1[l,2]<n)and(n<a1[r,2])then begin
    find:=l;
    exit;
  end;


  if a1[(l+r)div 2,2]>n then
    find:=find(2,l,(l+r)div 2-1,n)
  else
    find:=find(2,(l+r)div 2,r,n);
end;

procedure solve;
begin
  for i:=1 to m do
    b[i]:=i;
  sort2(1,m);
  a1:=a;
  b1:=b;
  sort(1,m);
  b2:=b1;
  last:=maxlongint;
  for i:=1 to m do
    b1[b2[i]]:=i;
  for i:=1 to m do begin
    t:=a[i,1];
    k:=find(2,1,m,t);
    for j:=last to k do
      cur[a1[j,3]]:=0;
    j:=a[i,3];
    while cur[j]=1 do begin
      inc(j);
      if j=n+1 then j:=1;
      if j=a[i,3] then halt(43);
    end;
    cur[j]:=1;
    a1[b1[b[i]],3]:=j;

    last:=k+1;
  end;
end;

begin
  init;
  solve;
  done;
end.
