const MaxN = 100010;

type Tauto = record
       t1,t2,c: longint;
     end;
     Tev = record
       t,id: longint;
     end;

var n,m: longint;
    auto: array[1..MaxN] of Tauto;
    ev: array[1..MaxN*2] of Tev;
    res: array[1..MaxN] of longint;

function Min(a,b: longint): longint;
begin
  if a<b then min:=a else min:=b;
end;

procedure sort(l,r: longint);
  var
     i,j,x: longint;
     y: Tev;
  begin
     i:=l;
     j:=r;
     x:=ev[(l+r) div 2].t;
     repeat
       while ev[i].t<x do
        inc(i);
       while x<ev[j].t do
        dec(j);
       if not(i>j) then
         begin
            y:=ev[i];
            ev[i]:=ev[j];
            ev[j]:=y;
            inc(i);
            j:=j-1;
         end;
     until i>j;
     if l<j then
       sort(l,j);
     if i<r then
       sort(i,r);
  end;

var a: array[0..270000] of longint;
    l2: longint;

function Get2(i: longint):longint;
var t: longint;
begin
  if i=0 then begin
    Get2:=0;
    exit;
  end;
  t:=1;
  while i>t do
    t:=t shl 1;
  Get2:=t;
end;

function GetMin(i,j: longint):longint;
var cmin: longint;
begin
  cmin:=MaxLongint;
  i:=i+l2-1; j:=j+l2-1;
  while i<=j do begin
    if cmin>a[i] then cmin:=a[i];
    i:=(i+1) div 2;
    if cmin>a[j] then cmin:=a[j];
    j:=(j-1) div 2;
  end;
  GetMin:=cmin;
end;

procedure heap(i: longint);
begin
  i:=i+l2-1;
  while i>0 do begin
    if i mod 2=1 then dec(i);
    a[i div 2]:=min(a[i],a[i+1]);
    i:=i div 2;
  end;
end;

procedure Solve;
var i,t: longint;
begin
  For i:=1 to m do begin
    ev[i*2-1].t:=auto[i].t1;
    ev[i*2-1].id:=i;
    ev[i*2].t:=auto[i].t2;
    ev[i*2].id:=i;
  end;
  sort(1,m*2);
  l2:=Get2(n);
  For i:=1 to n do
    a[l2+i-1]:=i;
  For i:=n+1 to l2 do
    a[l2+i-1]:=MaxLongint;
  i:=2*l2-2;
  while i>1 do begin
    a[i div 2]:=min(a[i],a[i+1]);
    dec(i,2);
  end;

  For i:=1 to m*2 do begin
    if res[ev[i].id]=0 then begin
      t:=getmin(auto[ev[i].id].c,n);
      if t=MaxLongint then
        t:=getmin(1,auto[ev[i].id].c-1);
      res[ev[i].id]:=t;
      a[t+l2-1]:=MaxLongint;
    end else begin
      a[res[ev[i].id]+l2-1]:=res[ev[i].id];
      t:=res[ev[i].id];
    end;
    heap(t)
  end;
end;

procedure Save;
var f: text;
    i: longint;
begin
  Assign(f,'parking.out');
  Rewrite(f);
  For i:=1 to m do
    WriteLn(f,res[i]);
  Close(f);
end;

procedure Load;
var f: text;
    i: longint;
begin
  Assign(f,'parking.in');
  Reset(f);
  Read(f,n,m);
  For i:=1 to m do
    with auto[i] do
      Read(f,t1,t2,c);
  Close(f);
end;


Begin
  Load;
  Solve;
  Save;
End.
