const MaxN = 100010;

procedure Swap(var a,b: longint);
var c: longint;
begin
  c:=a; a:=b; b:=c;
end;

type Tmseg = record
       p1,p2,h: longint;
     end;
     Tev = record
       tp: byte;
       t,id: longint;
     end;

var
  hseg,vseg: array[0..MaxN] of Tmseg;
  hn,vn,en: longint;
  ev: array[0..MaxN*2] of Tev;

function gsv(i: longint):longint;
begin
  gsv:=ev[i].t*10+ev[i].tp;
end;

procedure sortev(l,r: longint);
  var
     i,j,x: longint;
     y: Tev;
  begin
     i:=l;
     j:=r;
     x:=gsv((l+r) div 2);
     repeat
       while gsv(i)<x do
        inc(i);
       while x<gsv(j) do
        dec(j);
       if not(i>j) then
         begin
            y:=ev[i];
            ev[i]:=ev[j];
            ev[j]:=y;
            inc(i);
            j:=j-1;
         end;
     until i>j;
     if l<j then
       sortev(l,j);
     if i<r then
       sortev(i,r);
  end;

var a: array[1..270000{!!!}] of longint;
    l2: longint;

function Get2(i: longint):longint;
var t: longint;
begin
  if i=0 then begin
    Get2:=0;
    exit;
  end;
  t:=1;
  while i>t do
    t:=t shl 1;
  Get2:=t;
end;

function GetSum(i,j: longint):longint;
var csum: longint;
begin
  csum:=0;
  i:=i+l2-1; j:=j+l2-1;
  while i<=j do begin
    if i mod 2=1 then begin
      csum:=csum+a[i]; inc(i);
    end;
    i:=i div 2;

    if j mod 2=0 then begin
      csum:=csum+a[j]; dec(j);
    end;
    j:=j div 2;
    {if cmin>a[i] then cmin:=a[i];
    i:=(i+1) div 2;
    if cmin>a[j] then cmin:=a[j];
    j:=(j-1) div 2;}
  end;
  GetSum:=csum;
end;

procedure heap(i: longint);
begin
  i:=i+l2-1;
  while i>0 do begin
    if i mod 2=1 then dec(i);
    a[i div 2]:=a[i]+a[i+1];
    i:=i div 2;
  end;
end;

var Count: longint;

procedure Solve;
var i,l,r,m,k,s,e: longint;
begin
  For i:=1 to hn do begin
    inc(en);
    ev[en].t:=hseg[i].p1;
    ev[en].id:=i;
    ev[en].tp:=3;
    inc(en);
    ev[en].t:=hseg[i].p2;
    ev[en].id:=i;
    ev[en].tp:=1;
  end;
  For i:=1 to vn do begin
    inc(en);
    ev[en].t:=vseg[i].h;
    ev[en].id:=i;
    ev[en].tp:=2;
  end;
  sortev(1,en);
  l2:=Get2(hn);

  {For i:=1 to hn do
    a[l2+i-1]:=1;

  i:=2*l2-2;
  while i>1 do begin
    a[i div 2]:=a[i]+a[i+1];
    dec(i,2);
  end;

  WriteLn(GetSum(4,4));}

  For i:=1 to en do
  case ev[i].tp of
1:  begin
      a[ev[i].id+l2-1]:=0;
      heap(ev[i].id);
    end;
2:  begin
      l:=1; r:=hn;
      k:=vseg[ev[i].id].p1;
      while l<r do begin
        m:=(l+r) div 2;
        if m=k then break;
        if hseg[m].h<k then l:=m+1 else r:=m-1;
      end;
      if hseg[m].h<>k then m:=l;
      if hseg[m].h<k then inc(m);
      s:=m;

      l:=1; r:=hn;
      k:=vseg[ev[i].id].p2;
      while l<r do begin
        m:=(l+r) div 2;
        if m=k then break;
        if hseg[m].h<k then l:=m+1 else r:=m-1;
      end;
      if hseg[m].h<>k then m:=l;
      if hseg[m].h>k then dec(m);
      e:=m;
      inc(count,getsum(s,e));
    end;
3:  begin
      a[ev[i].id+l2-1]:=1;
      heap(ev[i].id);
    end;
  end;
end;

procedure Save;
var f: text;
begin
  Assign(f,'poly.out');
  Rewrite(f);
  WriteLn(f,count);
  Close(f);
end;

type Tseg = array[1..2] of record
       x,y: longint;
     end;

var pn: longint;
    pts: array[1..MaxN] of Tseg;

procedure sort(l,r: longint);
  var
     i,j,x: longint;
     y: Tmseg;
  begin
     i:=l;
     j:=r;
     x:=hseg[(l+r) div 2].h;
     repeat
       while hseg[i].h<x do
        inc(i);
       while x<hseg[j].h do
        dec(j);
       if not(i>j) then
         begin
            y:=hseg[i];
            hseg[i]:=hseg[j];
            hseg[j]:=y;
            inc(i);
            j:=j-1;
         end;
     until i>j;
     if l<j then
       sort(l,j);
     if i<r then
       sort(i,r);
  end;

procedure Load;
var f: text;
    i,px,py: longint;
begin
  Assign(f,'poly.in');
  Reset(f);
  Read(f,pn);
  Read(f,px,py);
  dec(pn);
  For i:=1 to pn do begin
    pts[i,1].x:=px; pts[i,1].y:=py;
    Read(f,px,py);
    pts[i,2].x:=px;
    pts[i,2].y:=py;
  end;
  Close(f);
  For i:=1 to pn do
    if (pts[i,1].x+pts[i,1].y)<>(pts[i,2].x+pts[i,2].y) then begin
      inc(hn);
      hseg[hn].p1:=pts[i,1].x+pts[i,1].y;
      hseg[hn].p2:=pts[i,2].x+pts[i,2].y;
      hseg[hn].h:=pts[i,1].x-pts[i,1].y;
      if hseg[hn].p1>hseg[hn].p2 then swap(hseg[hn].p1,hseg[hn].p2);
    end else begin
      inc(vn);
      vseg[vn].p1:=pts[i,1].x-pts[i,1].y;
      vseg[vn].p2:=pts[i,2].x-pts[i,2].y;
      vseg[vn].h:=pts[i,1].x+pts[i,1].y;
      if vseg[vn].p1>vseg[vn].p2 then swap(vseg[vn].p1,vseg[vn].p2);
    end;
  sort(1,hn)
end;


Begin
  Load;
  Solve;
  Save;
End.
