type Tvert = record
       el,en: longint;
     end;
     Teg = record
       s,d: byte;
       rev: boolean;
       {cs: string;}
     end;

var n,st,en: longint;
    vs: array[0..26] of Tvert;
    mark,cl: array[0..26] of boolean;
    es: array[1..3000] of Teg;
    inf: boolean;
    res: longint;


procedure DFS(v: integer);
var i: integer;
begin
  mark[v]:=true;
  cl[v]:=true;
  For i:=vs[v].el to vs[v].el+vs[v].en-1 do
    if es[i].rev then
      if mark[es[i].d] then begin
        if cl[es[i].d] then inf:=true;
      end else
        DFS(es[i].d);
  cl[v]:=false;
end;


procedure Solve;
begin
  DFS(0);
  if inf then res:=MaxLongint;
  if not mark[st] then res:=0;
  if not (mark[st] and (not inf)) then exit;
  res:=1;
end;

procedure Save;
var f: text;
begin
  Assign(f,'left.out');
  Rewrite(f);
  if res=MaxLongint then WriteLn(f,'infinity')
    else WriteLn(f,res);
  Close(f);
end;

procedure sort(l,r: longint);
  var
     i,j,x: longint;
     y: Teg;
  begin
     i:=l;
     j:=r;
     x:=es[(l+r) div 2].s;
     repeat
       while es[i].s<x do
        inc(i);
       while x<es[j].s do
        dec(j);
       if not(i>j) then
         begin
            y:=es[i];
            es[i]:=es[j];
            es[j]:=y;
            inc(i);
            j:=j-1;
         end;
     until i>j;
     if l<j then
       sort(l,j);
     if i<r then
       sort(i,r);
  end;

procedure Load;
var f: text;
    ch: char;
    i: integer;
begin
  Assign(f,'left.in');
  Reset(f);
  Read(f,n);
  repeat
    Read(f,ch);
  until ch<>' ';
  st:=ord(ch)-ord('A')+1;
  For i:=1 to n do begin
    ReadLn(f);
    repeat
      Read(f,ch);
    until ch<>' ';
    inc(en);
    es[en].s:=ord(ch)-ord('A')+1;
    ch:=#0;
    repeat
      Read(f,ch);
    until (ch in ['A'..'Z','a'..'z']) or eoln(f);
    if ch in ['A'..'Z'] then
      es[en].d:=ord(ch)-ord('A')+1
    else {if ch in ['a'..'z'] then es[en].cs:=ch};

    {while not eoln(f) do begin
      repeat
        Read(f,ch);
      until ch in ['a'..'z'];
      es[en].cs:=ch+es[en].cs;
    end;}
    inc(en);
    es[en].s:=es[en-1].d;
    es[en].d:=es[en-1].s;
    es[en].rev:=true;
  end;
  Close(f);
  Sort(1,en);
  For i:=1 to en do begin
    inc(vs[es[i].s].en);
    if vs[es[i].s].el=0 then vs[es[i].s].el:=i;
  end;
end;


Begin
  Load;
  Solve;
  Save;
End.
i