program Mountain;
{$N+}
const
  MAXL = 41; {41}

var
  h, l, k : integer;
  z : array [1..MAXL] of integer;
  p : array [0..MAXL,0..MAXL,0..MAXL,boolean] of Comp;

procedure Load(infile, outfile : string);
var
  i : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(h,l,k);
  for i:=1 to k do
    read(z[i]);
end;

procedure Solve;
var
  i, j, t : integer;
  f : boolean;
begin
  fillchar(p,sizeof(p),0);
  p[0,0,0,false] := 1;
  for i:=1 to l do
    for j:=0 to h do
      for t:=0 to k do
        for f:=false to true do
        begin
          if (j=0) xor (i=l) then
            continue;
          if (j=h) and not f then
            continue;
          p[i,j,t,f] := 0;
          if (t>0) and (z[t]=j) then
          begin
            p[i,j,t,f] := p[i,j,t,f] + p[i-1,j,t-1,f];
            if (j>0) then
              p[i,j,t,f] := p[i,j,t,f] + p[i-1,j-1,t-1,f];
            if (j<h) then
              p[i,j,t,f] := p[i,j,t,f] + p[i-1,j+1,t-1,f];
            if (j=h) then
              p[i,j,t,f] := p[i,j,t,f] + p[i-1,j-1,t-1,false];
          end
          else
          begin
            p[i,j,t,f] := p[i,j,t,f] + p[i-1,j,t,f];
            if (j>0) then
              p[i,j,t,f] := p[i,j,t,f] + p[i-1,j-1,t,f];
            if (j<h) then
              p[i,j,t,f] := p[i,j,t,f] + p[i-1,j+1,t,f];
            if (j=h) then
              p[i,j,t,f] := p[i,j,t,f] + p[i-1,j-1,t,false];
          end;
        end;
end;

procedure Save;
begin
  writeln(p[l,0,k,true]:0:0);
  close(input);
  close(output);
end;

begin
  Load('mountain.in','mountain.out');
  Solve;
  Save;
end.