{$I-,Q-,R-,S-}
uses
  game;

const maxn=50;
var
  k,i,n:integer;
  x,y,v1,v2,u1,u2:integer;
  a:array[1..maxn,1..maxn] of boolean;
  z:array[1..maxn*maxn,1..2] of integer;

procedure line(x_,y_:integer);
var
  x,y,i,j:integer;
begin
  if x_<y_ then begin
    x:=x_;
    y:=y_;
  end else begin
    x:=y_;
    y:=x_;
  end;
  for i:=1 to n do begin
    a[x,i]:=false;
    a[i,x]:=false;
    a[y,i]:=false;
    a[i,y]:=false;
  end;
  for i:=x+1 to y-1 do begin
    for j:=y+1 to n do begin
      a[i,j]:=false;
      a[j,i]:=false;
    end;
    for j:=1 to x-1 do begin
      a[i,j]:=false;
      a[j,i]:=false;
    end;
  end;
end;

procedure move1(v1,v2:integer; var u1,u2:integer);
begin
  line(v1,v2);
  move(v1,v2,u1,u2);
  line(u1,u2);
end;

begin
  n:=init;
  randseed:=12345;
  fillchar(a,sizeof(a),true);
  for i:=1 to n do
    a[i,i]:=false;
  while true do begin
    k:=0;
    for x:=n downto 1 do begin
      for y:=n downto 1 do
        if a[x,y] then begin
          inc(k);
          z[k,1]:=x;
          z[k,2]:=y;
        end;
    end;
    k:=random(k)+1;
    v1:=z[k,1];
    v2:=z[k,2];
    move1(v1,v2,u1,u2);
  end;
end.
