{$I-,Q-,R-,S-}
{$M 131072, 2097152}
uses Game;
const maxsize=200000;
      hsize=65536;
      step=167;
type TPos=array[0..50] of integer;
     TTH=record
      pos:TPos; inm,na:integer;
      win:byte; next:longint;
     end;
var n,u,v,i:integer;
    mno:array[0..200,0..50] of integer;
    lmn:integer;
    inmno:array[1..50] of integer;
    hv:array[1..maxsize] of TTH;
    ht:array[0..hsize] of longint;
    lhv:longint;


function Equ(var a,b:TPos):boolean;
var i:integer;
begin
 Equ:=false;
 if a[0]<>b[0] then exit;
 for i:=1 to a[0] do if a[i]<>b[i] then exit;
 Equ:=true;
end;

function HF(var a:TPos):longint;
var s,v:int64;
    i:integer;
begin
 v:=1; s:=0;
 for i:=1 to a[0] do begin
  s:=s*v+a[i];
  s:=s and (hsize-1);
  v:=(v*step) and (hsize-1);
 end;
 HF:=s;
end;

procedure Sort(var v,vv:TPos; l,r:integer);
var i,j,k,t:integer;
begin
 if l>=r then exit;
 i:=l; j:=r; k:=v[(l+r) shr 1];
 repeat
  while v[i]>k do inc(i);
  while v[j]<k do dec(j);
  if i<=j then begin
   t:=v[i]; v[i]:=v[j]; v[j]:=t;
   t:=vv[i]; vv[i]:=vv[j]; vv[j]:=t;
   inc(i); dec(j);
  end;
 until i>j;
 sort(v,vv,l,j);
 sort(v,vv,i,r);
end;

procedure Sort2(var v:TPos; l,r:integer);
var i,j,k,t:integer;
begin
 if l>=r then exit;
 i:=l; j:=r; k:=v[(l+r) shr 1];
 repeat
  while v[i]>k do inc(i);
  while v[j]<k do dec(j);
  if i<=j then begin
   t:=v[i]; v[i]:=v[j]; v[j]:=t;
   inc(i); dec(j);
  end;
 until i>j;
 sort2(v,l,j);
 sort2(v,i,r);
end;

procedure Separate(u,v:integer);
var i,j,nm,k,l1,l2:integer;
begin
 nm:=inmno[u];
 i:=1; while mno[nm,i]<>u do inc(i);
 j:=1; while mno[nm,j]<>v do inc(j);
 if i>j then begin k:=i; i:=j; j:=k end;
 inc(lmn,2); l1:=0; l2:=0;
 for k:=1 to mno[nm,0] do if (k<>i)and(k<>j) then begin
  if (k<i)or(k>j) then begin
   inc(l1); mno[lmn-1,l1]:=mno[nm,k]; inmno[mno[nm,k]]:=lmn-1;
  end else begin
   inc(l2); mno[lmn,l2]:=mno[nm,k]; inmno[mno[nm,k]]:=lmn;
  end;
 end;
 if l1=1 then l1:=0;
 if l2=1 then l2:=0;
 mno[lmn-1,0]:=l1;
 mno[lmn,0]:=l2;
 mno[nm,0]:=0;
end;

function CountMov(var p:TPos):longint;
var hn,hnn,i,towin,tolose:longint;
    j,k,m_win,n_win,m_lose,n_lose:integer;
    p3:TPos;
begin
 towin:=0; tolose:=0;
 Sort2(p,1,p[0]); m_win:=0;
 j:=p[0];
{ for i:=1 to p[0] do if (p[i]=1)or(p[i]=0) then begin j:=i; break end;}
 while (j>=1)and((p[j]=0)or(p[j]=1)) do dec(j);
 p[0]:=j;
 hn:=HF(p);
 i:=ht[hn];
 while i<>0 do begin
  if Equ(hv[i].pos,p) then break;
  i:=hv[i].next;
 end;
 if i<>0 then CountMov:=i else begin
  for i:=1 to p[0] do begin
   for j:=0 to p[i] div 2-1 do begin
    p3[i]:=j;
    p3[i+1]:=p[i]-2-j;
    for k:=i+1 to p[0] do p3[k+1]:=p[k];
    p3[0]:=p[0]+1;
    hnn:=CountMov(p3);
    if hv[hnn].win=1 then begin
     inc(towin); if towin=1 then begin m_win:=i; n_win:=j+2 end;
    end else begin
     inc(tolose); if tolose=1 then begin m_lose:=i; n_lose:=j+2 end;
    end;
   end;
   p3[i]:=p[i];
  end;
  inc(lhv);
  hv[lhv].next:=ht[hn];
  ht[hn]:=lhv;
  hv[lhv].pos:=p;
  if (tolose>0)or(towin+tolose=0) then begin
   hv[lhv].win:=1;
   hv[lhv].inm:=m_lose;
   hv[lhv].na:=n_lose;
  end else begin
   if m_win=0 then begin m_win:=1; n_win:=2 end;
   hv[lhv].win:=0;
   hv[lhv].inm:=m_win;
   hv[lhv].na:=n_win;
  end;
  CountMov:=lhv;
 end;
end;

procedure Think(var u,v:integer);
var cur,curv:TPos;
    i,j:integer;
    hn:longint;
    m:integer;
begin
 u:=1;
 fillchar(cur,sizeof(cur),0);
 j:=0;
 for i:=1 to lmn do if mno[i,0]>0 then begin
  inc(j);
  cur[j]:=mno[i,0];
  curv[j]:=i;
 end;
 Sort(cur,curv,1,j);
 cur[0]:=j;
 hn:=CountMov(cur);
 v:=hv[hn].na;
 m:=hv[hn].inm;
 m:=curv[m];
 u:=mno[m,u];
 v:=mno[m,v];
end;

begin
 fillchar(ht,sizeof(ht),0);
 n:=Init;
 lmn:=1;
 mno[1,0]:=n;
 for i:=1 to n do begin
  mno[1,i]:=i;
  inmno[i]:=1;
 end;
 lhv:=0;
 repeat
  Think(u,v);
  Separate(u,v);
  Move(u,v,u,v);
  Separate(u,v);
 until false;
end.
