#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

#define nZ 256

class TNum {
  private:
    long*a;
    short l,z;
  public:
    TNum(void);
    ~TNum();
    void print(FILE*);
    void set(long);
    void set(void);
    void set(TNum*);
    void mul(long);
    void div(long);
    int cmp(TNum*);
};

struct TInfo {
  long k,l;
  TNum x;
};

long m,n,c;
TInfo*a,z;

void pick(TNum&y) {
  short i; short j;
  y.set(&a[0].x);
  a[0].l++;
  if (a[0].l<=a[0].k/2) {
    a[0].x.mul(a[0].k-a[0].l+1);
    a[0].x.div(a[0].l);
  } else {
    z=a[0]; a[0]=a[n-1]; a[n-1]=z;
    n--;
  }
    z=a[0];
    i=0; j=1; if (j+1<n) if (a[j+1].x.cmp(&a[j].x)<0) j++;
    while (j<n) {
      if (z.x.cmp(&a[j].x)<=0) break;
      a[i]=a[j];
      i=j; j=(j<<1)+1;
      if (j+1<n) if (a[j+1].x.cmp(&a[j].x)<0) j++;
    }
    a[i]=z;
}

TNum y,yy;

int main(void) {
  fi=fopen("cnk.in","rt");
  fscanf(fi,"%ld%ld",&m,&c);
  fclose(fi);
  n=m+1;
  long i;
  a=new TInfo[n];
  for (i=0; i<n; i++) {
    a[i].k=i; a[i].l=0;
    a[i].x.set(1);
  }
  pick(y);
  for (i=1; i<c; i++) {
    do { pick(yy); } while (!yy.cmp(&y));
    y.set(&yy);
  }
  fo=fopen("cnk.out","wt");
  y.print(fo);
  fclose(fo);
  //delete[]a;
  return(0);
}


TNum::TNum(void) {
  z=nZ;
  a=new long[z];
}
TNum::~TNum() {
  delete[]a;
}
void TNum::print(FILE*f) {
  if (l) {
    short i;
    fprintf(f,"%ld",a[l-1]);
    for (i=l-2; i>=0; i--) fprintf(f,"%ld%ld%ld%ld",
    a[i]/1000,(a[i]/100)%10,(a[i]/10)%10,a[i]%10);
  } else fprintf(f,"0");
}
void TNum::set(long y) {
  memset(a,0,z*sizeof(long));
  if (y) {
    a[0]=y;
    l=1;
  } else l=0;
}
void TNum::set(void) {
  memset(a,0,z*sizeof(long));
  l=0;
}
void TNum::set(TNum*b) {
  memcpy(a,b->a,z*sizeof(long));
  l=b->l;
}
void TNum::mul(long y) {
  short i;
  long x=0;
  for (i=0; ((i<l)||(x))&&(i<z); i++) {
    x+=a[i]*y;
    a[i]=x%10000;
    x/=10000;
  }
  for (l=i; l>0; l--) if (a[l-1]) break;
}
void TNum::div(long y) {
  short i;
  long x=0;
  for (i=l-1; i>=0; i--) {
    x+=a[i];
    a[i]=x/y;
    x=(x%y)*10000;
  }
  for (; l>0; l--) if (a[l-1]) break;
}
int TNum::cmp(TNum*b) {
  short i;
  for (i=((l>=b->l)?l:b->l)-1; i>=0; i--) {
    if (a[i]<b->a[i]) return(-1);
    if (a[i]>b->a[i]) return(+1);
  }
  return(0);
}

