#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

#define nZ 256

class TNum {
  private:
    long*a,*d;
    short l,z;
  public:
    TNum(void);
    ~TNum();
    void print(FILE*);
    void set(long);
    void set(void);
    void set(TNum*);
    void mul(long);
    void add(TNum*);
    void mul(TNum*);
};

short n;
TNum*a,*b;

int main(void) {
  fi=fopen("brackets.in","rt");
  fscanf(fi,"%hd",&n);
  fclose(fi);
  short k,i,j; TNum x;
  a=new TNum[n+1]; b=new TNum[n+1];
  a[0].set(1); b[0].set(1);
  for (k=1; k<=n; k++) {
    a[k].set(); b[k].set();
    for (i=k-1,j=0; i>=0; i--,j++) {
      x.set(&b[i]); x.mul(&a[j]);
      a[k].add(&x);
      x.set(&a[i]); x.mul(&a[j]);
      a[k].add(&x);
      a[k].add(&x);
      x.set(&b[i]); x.mul(&b[j]);
      b[k].add(&x);
      b[k].add(&x);
    }
  }
  fo=fopen("brackets.out","wt");
  a[n].print(fo);
  fclose(fo);
  delete[]a; delete[]b;
  return(0);
}


TNum::TNum(void) {
  z=nZ;
  a=new long[z]; d=new long[z];
}
TNum::~TNum() {
  delete[]a; delete[]d;
}
void TNum::print(FILE*f) {
  if (l) {
    short i;
    fprintf(f,"%ld",a[l-1]);
    for (i=l-2; i>=0; i--) fprintf(f,"%ld%ld%ld%ld",
    a[i]/1000,(a[i]/100)%10,(a[i]/10)%10,a[i]%10);
  } else fprintf(f,"0");
}
void TNum::set(long y) {
  memset(a,0,z*sizeof(long));
  if (y) {
    a[0]=y;
    l=1;
  } else l=0;
}
void TNum::set(void) {
  memset(a,0,z*sizeof(long));
  l=0;
}
void TNum::set(TNum*b) {
  memcpy(a,b->a,z*sizeof(long));
  l=b->l;
}
void TNum::mul(long y) {
  short i;
  long x=0;
  for (i=0; ((i<l)||(x))&&(i<z); i++) {
    x+=a[i]*y;
    a[i]=x%10000;
    x/=10000;
  }
  for (l=i; l>0; l--) if (a[l-1]) break;
}
void TNum::add(TNum*b) {
  short i;
  long x=0;
  for (i=0; ((i<l)||(i<b->l)||(x))&&(i<z); i++) {
    x+=a[i]+b->a[i];
    a[i]=x%10000;
    x/=10000;
  }
  for (l=i; l>0; l--) if (a[l-1]) break;
}
void TNum::mul(TNum*b) {
  short i,j,k;
  long x;
  memset(d,0,z*sizeof(long)); k=0;
  for (j=0; j<b->l; j++) {
    x=0;
    for (i=0; ((i<l)||(x))&&(i+j<z); i++) {
      x+=d[i+j]+a[i]*b->a[j];
      d[i+j]=x%10000;
      x/=10000;
    }
    if (k<i+j) k=i+j;
  }
  //memcpy(a,d,z*sizeof(long));
  long*e=a; a=d; d=e;
  for (l=k; l>0; l--) if (a[l-1]) break;
}

