program Broken_Keyboard;

const
  MAXL = 300; {300}

var
  s : array [1..MAXL] of char;
  l : integer;

procedure Load(infile, outfile : string);
var
  c : char;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  l := 0;
  repeat
    read(c);
    if not (c in ['a'..'z','A'..'Z']) then
      break;
    inc(l);
    s[l] := c;
  until eof;
end;

procedure Solve;
var
  i : integer;
  t : boolean;
begin
  t := false;
  for i:=1 to l do
    if (i=1) or (s[i]<>s[i-1]) or t then
      write(s[i])
    else
    begin
      write('<',s[i],'>');
      t := true;
    end;
end;

procedure Save;
begin
  close(input);
  close(output);
end;

begin
  Load('keyboard.in','keyboard.out');
  Solve;
  Save;
end.