#include <stdio.h>
#include <string.h>

#include "game.h"

#define hN 0x400
#define hA 0x3FF
#define hB 409

void init(short&,short&,short&,TFence);

short n,m,k;

struct TState {
  short a[40];
  short hash(void);
  int operator==(TState&);
  int oppaint(short,short);
};
struct TMove {
  short x,y;
};
struct THash {
  TState d;
  TMove g;
  char o;
  THash*z;
};

void clearhash(void);
void deletehash(void);
THash* gethash(TState&);

TFence A; TState a;
long hc;
THash**h;

int calc(TState u,TMove&g) {
  THash*uh=gethash(u);
  if (uh->o>=0) { g=uh->g; return(uh->o); }
  short i,j; TState w;
  uh->o=0; uh->g.y=uh->g.x=-1;
  for (i=0; (i<n)&&(!uh->o); i++)
  for (j=i+2; (j<n)&&(j-i+1<=k)&&(!uh->o); j++) {
    w=u;
    if (!w.oppaint(i,j)) continue;
    if (!calc(w,g)) {
      uh->o=1; uh->g.x=i; uh->g.y=j;
    } else if (uh->g.x<0) {
      uh->g.x=i; uh->g.y=j;
    }
  }
  g=uh->g; return(uh->o);
}

int main(void) {
  init(n,m,k,A);
  short i;
  for (i=0; i<n; i++) a.a[i]=(short)A[i]-1;
  h=new THash*[hN];
  clearhash();
  TMove g; int X,Y;
  calc(a,g);
  while ((g.x>=0)&&(g.y>=0)) {
    a.oppaint(g.x,g.y);
    Move((int)g.x,(int)g.y,&X,&Y);
    g.x=(short)X; g.y=(short)Y;
    if ((g.x<0)||(g.y<0)) break;
    a.oppaint(g.x,g.y);
    calc(a,g);
  }
  deletehash();
  return(0);
}


void clearhash(void) {
  memset(h,0,hN*sizeof(THash*)); hc=0;
}
void deletehash(void) {
  short i; THash*x,*y;
  for (i=0; i<hN; i++) {
    x=h[i]; y=x->z;
    while (x) {
      delete[]h[i];
      x=y; y=y->z;
    }
    h[i]=0;
  }
  hc=0;
}
THash* gethash(TState&e) {
  short x; THash*y;
  x=e.hash();
  for (y=h[x]; y; y=y->z) if (e==y->d) return(y);
  y=new THash;
  y->d=e; y->g.x=-1; y->g.y=-1; y->o=-1;
  y->z=h[x]; h[x]=y; hc++;
  return(y);
}


short TState::hash(void) {
  short i,z;
  long x;
  z=0; x=hB;
  for (i=0; i<n; i++) {
    z+=(short)(( x*((long)a[i]+1) )&hA);
    z&=hA;
    x=(x*x)&hA;
  }
  return(z);
}
int TState::operator==(TState&b) {
  return(! memcmp(a,b.a,n*sizeof(short)) );
}
int TState::oppaint(short v,short w) {
  short i,j;
  if (a[w]!=a[v]) return(0);
  for (j=0,i=v+1; i<w; i++) if (a[i]!=a[v]) { a[i]=a[v]; j++; }
  return(j>0);
}


void init(short&n,short&m,short&k,TFence a) {
  int N,M,K;
  Init(&N,&M,&K,a);
  n=(short)N; m=short(M); k=short(K);
}

