{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$ifdef debug}
{$R+,Q+,S+,I+,N+}
{$else}
{$R-,Q-,S-,I-,N+}
{$endif}

program template;
uses
 game;
const
 nmax = 42;
 maxpos = 500000;
{ p = 1667;} p = 100003;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
type
 int = longint;
 real = extended;
{ tfence = array [0..nmax-1] of byte;}
 tptr = ^tlist;
 tlist = record
  v :tfence;
  next :tptr;
  num :int;
 end;
 tchoice = record
  u,v :integer;
 end;
var
 pr :array [1..nmax-1] of int;
 hash :array [0..p-1] of tptr;
 state :array [1..maxpos] of boolean;
 choice :array [1..maxpos] of tchoice;
 n,k,w :integer;
 st :tfence;
 positions :int;

procedure initialize;
begin
 fillchar (st,sizeof(st),0);
{ fillchar (hash,sizeof(hash),0);}
 positions := 0;
 fillchar (state,sizeof(state),0);
 fillchar (choice,sizeof(choice),0);
end;

procedure readdata;
var i,j :int;
begin
{ assign (input,cinfile);
 reset (input);
 read (n,k,w);
 for i := 0 to n-1 do
  read (st[i]);
 close (input);}
 init (n,k,w,st);
end;

function q (var a,b :tfence):boolean;
var i :int;
begin
 q := false;
 for i := 0 to n-1 do
  if not (a[i] = b[i]) then
   exit;
 q := true;
end;

function h (var v :tfence):int;
var res :int;
    i :int;
begin
 res := 0;
 for i := 0 to n-1 do
  res := (res + pr[i+1]*v[i]) mod p;
 h := res;
end;

function add (var v :tfence; var number :int):boolean;
var hs :int;
    x :tptr;
begin
 hs := h(v);
 x := hash[hs];
 add := false;
 while not (x = nil) do
  begin
   if q (v,x^.v) then
    begin
     number := x^.num;
     exit;
    end;
   x := x^.next;
  end;
 add := true;
 inc(positions);
 number := positions;
 new(x);
 x^.v := v;
 x^.next := hash[hs];
 x^.num := positions;
 hash[hs] := x;
 if positions mod 10000 = 0 then
  writeln (positions);
end;

function rec (var v :tfence):boolean;
var number :int;
    i,j,u :int;
    res,temp :boolean;
    t :tfence;
begin
 if not add (v,number) then
  begin
   rec := state[number];
   exit;
  end;
 state[number] := false;
 choice[number].u := -1;
 choice[number].v := -1;
 for i := 0 to n-2 do
  for j := n-1 downto i+1 do
   if v[i] = v[j] then
    begin
     if j < i then
      continue;
     if j-i+1 > w then
      continue;
     res := false;
     for u := i+1 to j-1 do
      if not (v[u] = v[i]) then
       begin
        res := true;
        break;
       end;
     if not res then
      continue;
     for u := 0 to n-1 do
      t[u] := v[u];
     for u := i+1 to j-1 do
      t[u] := t[i];
     temp := not rec(t);
     if temp then
      begin
       state[number] := true;
       choice[number].u := i;
       choice[number].v := j;
       rec := true;
       exit;
      end;
    end;
 rec := state[number];
end;

function prime (x :int):boolean;
var i :int;
begin
 prime := false;
 for i := 2 to trunc(sqrt(x)) do
  if x mod i = 0 then
   exit;
 prime := true;
end;

procedure swap (var a,b :integer);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;


procedure anymove (var v :tfence; var res :tchoice);
var i,j,u :int;
begin
 for i := 0 to n-2 do
  for j := i+1 to n-1 do
   if v[i] = v[j] then
    for u := i+1 to j-1 do
     if not (v[u] = v[i]) then
      begin
       res.u := i;
       res.v := j;
       exit;
      end;
end;

procedure solve;
var i,j :int;
    uu,vv :integer;
    number :int;
begin
 fillchar (pr,sizeof(pr),0);
 j := 0;
 for i := 2 to 2000 do
  if prime(i) then
   begin
    inc(j);
    pr[j] := i;
    if j = n then
     break;
   end;
 rec (st);
 {$ifdef debug}
 writeln (positions);
 {$endif}
 while true do
  begin
   add (st,number);
   {$ifdef debug}
   writeln (state[number]);
   {$endif}
   if choice[number].u < 0 then
    anymove (st,choice[number]);
   for i := choice[number].u+1 to choice[number].v-1 do
    st[i] := st[choice[number].u];
   move (choice[number].u,choice[number].v,uu,vv);
   if uu > vv then
    swap (uu,vv);
   for i := uu+1 to vv-1 do
    st[i] := st[uu];
  end;
end;

begin
 initialize;
 readdata;
 solve;
end.
