#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

struct VOPL {
  char s[110];
  long f;
};

struct WORD {
  char s[5];
  int l;
  long f;
};

FILE *fi, *fo;
char alf[30];
WORD b[110];
VOPL a[110];
int n,k,m;

void GetWord(WORD *p)
{
  char c;
  int q;
  c=getc(fi);
  while(!isalpha(c)) c=getc(fi);
  q=0;
  while(isalpha(c))
  {
	p->s[q]=c;
	q++;
	c=getc(fi);
  }
  p->l=q;
  p->s[q]='\0';
  fscanf(fi,"%li",&p->f);
}

int IsEnd(int q,VOPL *t, WORD w)
{
  int i;
  if(q<w.l) return 0;
  for(i=0;i<w.l;i++)
  {
	if(w.s[i]!=t->s[q-w.l+i]) return 0;
  }
  return 1;
}

void CopyVopl(VOPL *a, VOPL *b)
{
  strcpy(a->s,b->s);
  a->f=b->f;
}

void AddWord(int q, int p)
{
  int i,j;
  VOPL t;
  int f;
/*  if(p>0)
  {
	if(IsEnd(q,&a[q],b[p])) a[q].f+=b[p].f;
  }*/
  for(i=1;(i<=b[p].l)&&(i<=q);i++)
  {
	CopyVopl(&t,&a[q-i]);
	for(j=0;j<=i;j++)
	{
	  t.s[q-i+j]=b[p].s[b[p].l-i+j];
	}
//	if(IsEnd(q,&t,b[p])) t.f+=b[p].f;
	for(j=0;j<k;j++)
	{
	  if(IsEnd(q,&t,b[j])) t.f+=b[j].f;
	}
	if(t.f>a[q].f) CopyVopl(&a[q],&t);
  }
}

void GetFear(VOPL *p)
{
  int i;
  char *c;
  p->f=0;
  for(i=0;i<k;i++)
  {
	c=strstr(p->s,b[i].s);
	while(c!=NULL)
	{
	  p->f+=b[i].f;
	  c++;
	  c=strstr(c,b[i].s);
	}
  }
}

void Rec(int q, int n, VOPL *p, VOPL *bp)
{
  if(q>=n)
  {
	p->s[q]='\0';
	GetFear(p);
	if(p->f>bp->f) CopyVopl(bp,p);
  }
  else
  {
	for(p->s[q]='a';p->s[q]<='a'+m;p->s[q]++) Rec(q+1,n,p,bp);
  }
}

void Pereb(int n,VOPL *p)
{
  VOPL tmp;
  p->f=0;
  p->s[0]='\0';
  Rec(0,n,&tmp,p);
}

int main()
{
  int i,j;
  fi=fopen("input.txt","rt");
  fo=fopen("output.txt","wt");

  fscanf(fi,"%i%i%i\n",&n,&m,&k);
  fgets(alf,30,fi);
  for(i=0;i<k;i++)
  {
	GetWord(&b[i]);
  }

  a[0].s[0]='\0';
  a[0].f=0;
/*  a[1].s[0]='\0';
  a[1].f=0;
  a[2].s[0]='\0';
  a[2].f=0;*/

  for(i=1;i<=5;i++)
  {
	Pereb(i,&a[i]);
  }

  for(i=6;i<=n;i++)
  {
	for(j=0;j<k;j++)
	{
	  AddWord(i,j);
	}
  }

  fprintf(fo,"%li\n",a[n].f);
  fputs(a[n].s,fo);

  fclose(fi);
  fclose(fo);
  return 0;
}