  {$I+,Q+,R+,S-}
type
  tReg=array['a'..'d']of Boolean;
  tK=^tRec;
  tRec=record
    R:tReg;
    Time:Longint;
    Next:tK;
  end;
  tField=record
    R:tReg;
    S:String[250];
  end;

var
  Now:tReg;
  N,M:Integer;
  Time,K:Longint;
  A,X,Y:Integer;
  P,Q:Integer;
  Field:array[1..30,1..30]of tField;
  Rec:array[1..30,1..30]of tK;

procedure OpenFiles;
begin
  assign(input,'input.txt');
  assign(output,'output.txt');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

function Calc(Inp:String):Boolean;
begin
  if Inp='true' then
  begin
    Calc:=True;
    exit;
  end;
  if Inp='false' then
  begin
    Calc:=false;
    exit;
  end;
  Calc:=Now[inp[1]];
end;

procedure OutSol;
var
  C:Char;
begin
  Time:=0;
  while True do
  begin
    if Field[Y,X].S<>'' then
      if Calc(Field[Y,X].S) then
        A:=(A+90)mod 360
        else
        A:=(A+270) mod 360;
    for C:='a' to 'd' do
      if Field[Y,X].R[C] then
        Now[C]:=not(Now[C]);
    case A of
      0:Y:=Y-1;
      90:X:=X+1;
      180:Y:=Y+1;
      270:X:=X-1;
    end;
    if (X<1)or(Y<1)or(X>M)or(Y>N) then
    begin
      write(-1);
      exit;
    end;
    inc(Time);
    if Time=K then
    begin
      write(X,' ',Y);
      exit;
    end;
  end;
end;

function Ravn(A,B:tReg):Boolean;
var
  C:Char;
  L:Boolean;

begin
  L:=true;
  for C:='a' to 'd' do
    L:=L and (A[C]=B[C]);
  Ravn:=L;
end;

procedure Solve;
var
  I:Integer;
  X1,Y1:Integer;
  C:Char;
  Po,Po1:tK;

begin
  read(M,N,P,Q,K,X,Y,A);
  for I:=1 to P do
  begin
    read(X1,Y1,C,C);
    field[Y1,X1].R[lowercase(C)]:=true;
  end;
  for I:=1 to Q do
  begin
    read(X1,Y1,C);
    readln(Field[Y1,X1].S);
    Field[Y1,X1].S:=lowercase(Field[Y1,X1].S);
  end;
  Time:=0;
  while true do
  begin
      Po:=Rec[Y,X];
      while Po<>nil do
        if Ravn(Po^.R,Now) then
        begin
          K:=(K-Po^.Time) mod (Time-Po^.Time);
          OutSol;
          Exit;
        end
        else
          Po:=Po^.Next;
      new(Po);
      Po^.R:=Now;
      Po^.Time:=Time;
      Po^.Next:=nil;
      if Rec[Y,X]=nil then
        Rec[Y,X]:=Po
      else
      begin
        Po1:=Rec[Y,X];
        while Po1^.Next<> nil do
          Po1:=Po1^.Next;
        Po1^.Next:=Po;
      end;
    if Field[Y,X].S<>'' then
      if Calc(Field[Y,X].S) then
        A:=(A+90)mod 360
        else
        A:=(A+270) mod 360;
    for C:='a' to 'd' do
      if Field[Y,X].R[C] then
        Now[C]:=not(Now[C]);
    case A of
      0:Y:=Y-1;
      90:X:=X+1;
      180:Y:=Y+1;
      270:X:=X-1;
    end;
    if (X<1)or(Y<1)or(X>M)or(Y>N) then
    begin
      write(-1);
      exit;
    end;
    inc(Time);
    if Time=K then
    begin
      write(X,' ',Y);
      exit;
    end;
  end;
end;

procedure Init;
var
  I,I1:Integer;

begin
  for I:=1 to 30 do
    for I1:=1 to 30 do
    begin
      fillchar(Field[I,I1].R,Sizeof(Field[I,I1].R),false);
      Field[I,I1].S:='';
      Rec[I,I1]:=nil;
    end;
end;

begin
  Init;
  OpenFiles;
  Solve;
  CloseFiles;
end.
