#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

struct POINT {
  long x, y;
};

FILE *fi, *fo;
POINT wq1, wq2, bk;

void GetPoint(POINT *p)
{
  fscanf(fi,"%li%li",&p->x, &p->y);
}

int QueenBeat(POINT a, POINT q)
{
  return ((a.x==q.x)||(a.y==q.y)||(a.x-a.y==q.x-q.y)||(q.x+q.y==a.x+a.y))?1:0;
}

int main()
{
  POINT p;
  fi=fopen("2queens.in","rt");
  fo=fopen("2queens.out","wt");

  GetPoint(&wq1);
  GetPoint(&wq2);
  GetPoint(&bk);

  if(((wq1.x==bk.x+1)&&(wq1.y==bk.y+2))||((wq1.x==bk.x+1)&&(wq1.y==bk.y-2)))
  {
    p.x=bk.x-1;
    p.y=bk.y;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n2 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if(((wq1.x==bk.x+2)&&(wq1.y==bk.y+1))||((wq1.x==bk.x-2)&&(wq1.y==bk.y+1)))
  {
    p.x=bk.x;
    p.y=bk.y-1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n2 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if(((wq1.x==bk.x-1)&&(wq1.y==bk.y+2))||((wq1.x==bk.x-1)&&(wq1.y==bk.y-2)))
  {
    p.x=bk.x+1;
    p.y=bk.y;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n2 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if(((wq1.x==bk.x+2)&&(wq1.y==bk.y-1))||((wq1.x==bk.x-2)&&(wq1.y==bk.y-1)))
  {
    p.x=bk.x;
    p.y=bk.y+1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n2 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  p=wq1;
  wq1=wq2;
  wq2=p;
  if(((wq1.x==bk.x+1)&&(wq1.y==bk.y+2))||((wq1.x==bk.x+1)&&(wq1.y==bk.y-2)))
  {
    p.x=bk.x-1;
    p.y=bk.y;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n1 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if(((wq1.x==bk.x+2)&&(wq1.y==bk.y+1))||((wq1.x==bk.x-2)&&(wq1.y==bk.y+1)))
  {
    p.x=bk.x;
    p.y=bk.y-1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n1 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if(((wq1.x==bk.x-1)&&(wq1.y==bk.y+2))||((wq1.x==bk.x-1)&&(wq1.y==bk.y-2)))
  {
    p.x=bk.x+1;
    p.y=bk.y;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n1 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if(((wq1.x==bk.x+2)&&(wq1.y==bk.y-1))||((wq1.x==bk.x-2)&&(wq1.y==bk.y-1)))
  {
    p.x=bk.x;
    p.y=bk.y+1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"1\n1 %li %li\n",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  
  p=wq1;
  wq1=wq2;
  wq2=p;
  if((wq1.x==bk.x+1)&&(wq1.y==bk.y+2))
  {
    p.x=bk.x-2;
    p.y=bk.y-1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x+1)&&(wq1.y==bk.y-2))
  {
    p.x=bk.x-2;
    p.y=bk.y+1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-1)&&(wq1.y==bk.y+2))
  {
    p.x=bk.x+2;
    p.y=bk.y-1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-1)&&(wq1.y==bk.y-2))
  {
    p.x=bk.x+2;
    p.y=bk.y+1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x+2)&&(wq1.y==bk.y+1))
  {
    p.x=bk.x-1;
    p.y=bk.y-2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x+2)&&(wq1.y==bk.y-1))
  {
    p.x=bk.x-1;
    p.y=bk.y+2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-2)&&(wq1.y==bk.y+1))
  {
    p.x=bk.x+1;
    p.y=bk.y-2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-2)&&(wq1.y==bk.y-1))
  {
    p.x=bk.x+1;
    p.y=bk.y+2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n2 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  p=wq1;
  wq1=wq2;
  wq2=p;
  if((wq1.x==bk.x+1)&&(wq1.y==bk.y+2))
  {
    p.x=bk.x-2;
    p.y=bk.y-1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x+1)&&(wq1.y==bk.y-2))
  {
    p.x=bk.x-2;
    p.y=bk.y+1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-1)&&(wq1.y==bk.y+2))
  {
    p.x=bk.x+2;
    p.y=bk.y-1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-1)&&(wq1.y==bk.y-2))
  {
    p.x=bk.x+2;
    p.y=bk.y+1;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x+2)&&(wq1.y==bk.y+1))
  {
    p.x=bk.x-1;
    p.y=bk.y-2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x+2)&&(wq1.y==bk.y-1))
  {
    p.x=bk.x-1;
    p.y=bk.y+2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-2)&&(wq1.y==bk.y+1))
  {
    p.x=bk.x+1;
    p.y=bk.y-2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  if((wq1.x==bk.x-2)&&(wq1.y==bk.y-1))
  {
    p.x=bk.x+1;
    p.y=bk.y+2;
    if(QueenBeat(p,wq2))
    {
      fprintf(fo,"2\n1 %li %li",p.x,p.y);
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  p=wq1;
  wq1=wq2;
  wq2=p;

  p.x=bk.x+1;
  p.y=bk.y+2;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  p.x=bk.x+1;
  p.y=bk.y-2;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  p.x=bk.x-1;
  p.y=bk.y+2;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  p.x=bk.x-1;
  p.y=bk.y-2;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  p.x=bk.x+2;
  p.y=bk.y+1;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  p.x=bk.x+2;
  p.y=bk.y-1;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  p.x=bk.x-2;
  p.y=bk.y+1;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  p.x=bk.x-2;
  p.y=bk.y-1;
  if(QueenBeat(p,wq1))
  {
    fprintf(fo,"3\n1 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(QueenBeat(p,wq2))
  {
    fprintf(fo,"3\n2 %li %li",p.x,p.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
