{Filimonov Vladislav}
Const
  InFileName='d.in';
  OutFileName='d.out';
  MaxN=20000;
  White=1;
  Gray=2;
  Black=3;

Var
  Fail:Text;
  N:LongInt;
  M:LongInt;
{  Adj:Array[1..MaxN,1..MaxN] Of LongInt;}
  A:Array[1..MaxN,1..MaxN] Of Boolean;
  K:Array[1..MaxN] Of LongInt;
  D:Array[1..MaxN] Of LongInt;
  F:Array[1..MaxN] OF LongInt;
  Time:LongInt;
  Color:Array[1..MaxN] Of LongInt;
  C:Array[1..MaxN] Of LongInt;
  Kol:LongInt;
  P:Array[1..MaxN] Of LongInt;


Procedure Get;
Var
  I:LongInt;
  X,Y:Integer;
  Begin
{    FillChar(A,SizeOf(A),False);}
    FillChar(K,SizeOf(K),0);
    Assign(FAil,InFileName);
    ReSet(Fail);
    ReadLn(Fail,N,M);
    For I:=1 To M Do Begin
      ReadLn(FAil,X,Y);
{      Adj[X,K[X]+1]:=Y;
      Inc(K[X]);
      Adj[Y,K[Y]+1]:=X;
      Inc(K[Y]);}
      A[X,Y]:=True;
      A[Y,X]:=True;
    End;
    Close(Fail);
  End;


Procedure DFSVisit(V,Col:LongInt);
Var
  I:Integer;
  Begin
    C[V]:=Col;
    Inc(Time);
    D[V]:=Time;
    Color[V]:=Gray;
    For I:=1 To {K[V]}N Do Begin
      If (A[V,I]=True) And (Color[I]=White) Then Begin
        P[I]:=V;
        DFSVisit(I,Col);
      End;
    End;
    Color[V]:=Black;
    Inc(Time);
    F[V]:=Time;
  End;

Procedure DFS;
Var
  I:LongInt;
  Begin
    Time:=0;
    FillChar(D,SizeOf(D),0);
    FillChar(F,SizeOf(F),0);
    For I:=1 To N Do Begin
      Color[I]:=White;
      C[I]:=0;
      P[I]:=0;
    End;
    Kol:=0;
    For I:=1 To N Do Begin
      If Color[I]=White Then Begin
        Inc(Kol);
        DFSVisit(I,Kol);
      End;
    End;
  End;

Procedure Save;
Var
  I:LongInt;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,Kol);
    For I:=1 To N Do Write(Fail,C[I],' ');
    Close(Fail);
  End;


Begin
  Get;
  DFS;
  Save;
End.











