{Filimonov Vladislav}
Const
  InFileName='e.in';
  OutFileName='e.out';
  MaxN=20000;
  White=1;
  Gray=2;
  Black=3;
  MaxM=200000;

Var
  Fail:Text;
  N:LongInt;
  M:LongInt;
  A:Array[1..MaxN,1..MaxN] Of Boolean;
  R:Array[1..MaxM,1..2] Of Integer;
  K:Array[1..MaxN] Of Integer;
  D:Array[1..MaxN] Of Integer;
  F:Array[1..MaxN] OF Integer;
  Time:LongInt;
  Color:Array[1..MaxN] Of Integer;
  C:Array[1..MaxN] Of Integer;
  Kol:LongInt;
  P:Array[1..MaxN] Of Integer;
  S:Array[1..MaxN] Of Integer;
  Count:LongInt;


Procedure Get;
Var
  I:LongInt;
  X,Y:Integer;
  Begin
    FillChar(K,SizeOf(K),0);
    Assign(FAil,InFileName);
    ReSet(Fail);
    ReadLn(Fail,N,M);
    For I:=1 To M Do Begin
      ReadLn(Fail,X,Y);
      A[X,Y]:=True;
      A[Y,X]:=True;
      R[I,1]:=X;
      R[I,2]:=Y;
    End;
    Close(Fail);
  End;


Procedure Push(V:Integer);
  Begin
    S[Count+1]:=V;
    Inc(Count);
  End;


Function Pop:Integer;
  Begin
    Pop:=S[Count];
    Dec(Count);
  End;

Procedure DFSVisit(V,Col:LongInt);
Var
  I:Integer;
  Begin
    C[V]:=Col;
    Inc(Time);
    D[V]:=Time;
    Push(V);
    Color[V]:=Gray;
    For I:=1 To N Do Begin
      If (A[V,I]=True) And (Color[I]=White) Then Begin
        P[I]:=V;
        DFSVisit(I,Col);
      End;
    End;
    Color[V]:=Black;
    Inc(Time);
    F[V]:=Time;
  End;


Procedure DFS;
Var
  I:LongInt;
  Begin
    Time:=0;
    FillChar(D,SizeOf(D),0);
    FillChar(F,SizeOf(F),0);
    For I:=1 To N Do Begin
      Color[I]:=White;
      C[I]:=0;
      P[I]:=0;
    End;
    Kol:=0;
    For I:=1 To N Do Begin
      If Color[I]=White Then Begin
        Inc(Kol);
        DFSVisit(I,Kol);
      End;
    End;
  End;


Procedure Save;
Var
  I:LongInt;
  W:Array[1..MaxM] Of Boolean;
  KK:LongInt;
  Begin
    FillChar(W,SizeOf(W),False);
    KK:=0;
    For I:=1 To M Do Begin
      If C[R[I,1]]<>C[R[I,2]] Then Begin
        W[I]:=True;
        Inc(KK);
      End;
    End;
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,KK);
    For I:=1 To M Do If W[I]=True Then Write(Fail,I,' ');
    Close(Fail);
  End;


Procedure Solve;
Var
  I:LongINt;
  Begin
    Count:=0;
    DFS;
    For I:=1 To N Do Begin
      If P[I]<>0 Then A[P[I],I]:=False;
      Color[I]:=White;
    End;
    For I:=1 To Count Do If Color[I]=White Then DFSVisit(S[I],I);
  End;

Begin
  Get;
  Solve;
  Save;
End.











