{$I-,Q-,R-,S-}
program         Template;

var
  N, Found, Clr : LongInt;
  Numbers       : array[1..250000] of LongInt;
  Colors        : array[1..250000] of LongInt;
  Last          : array[1..250000, 1..2] of LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'color.in');
  Reset(Input);
  Assign(Output, 'color.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : LongInt;
begin
  ReadLn(N);
  for I := 1 to N do
    Read(Numbers[I]);
end;

procedure       Solve;
var
  I, J, U, D, M : LongInt;
begin
  FillChar(Colors, SizeOf(Colors), 0); Found := 0; Clr := 1;
  FillChar(Last, SizeOf(Last), 0); M := 1;
  Last[1, 1] := Numbers[1]; Last[1, 2] := 1; Colors[1] := 1;

  if N > 1 then
    for I := 2 to N do begin
      U := M + 1; D := 1; J := 0;
      while (U + D) div 2 <> J do begin
        J := (U + D) div 2;

        if Last[J, 1] < Numbers[I] then
          U := J
        else
          D := J;
      end;

      if Last[U, 2] = 0 then begin
        Inc(Clr);
        Colors[I] := Clr;
        Last[U, 2] := Clr;
        Inc(M);
      end else
        Colors[I] := Last[U, 2];
      Last[U, 1] := Numbers[I];
    end;

  WriteLn(Clr);
  for I := 1 to N do begin
    Write(Colors[I]);
    if I < N then
      Write(' ');
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
