type
  tReb=record
    X,Y,LastX,LastY:Integer;
  end;

var
  Reb:array[1..200000]of tReb;
  Last:array[1..20000]of Longint;
  V,Enter:array[1..20000]of Longint;
  Mark,Lst:array[1..20000]of Integer;
  S:array[1..20000]of Boolean;
  Time:Longint;
  N,M,Count:Longint;

procedure OpenFiles;
begin
  assign(input,'f.in');
  assign(output,'f.out');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

procedure DFS(Q:Longint);
var
  K,K1:Longint;

begin
  K:=Last[Q];
  inc(Time);
  Mark[Q]:=1;
  Enter[Q]:=Time;
  V[Q]:=Time;
  while K<>0 do
  begin
    if Reb[K].X=Q then
    begin
      K1:=Reb[K].Y;
      K:=Reb[K].LastX;
    end
    else
    begin
      K1:=Reb[K].X;
      K:=Reb[K].LastY;
    end;
    if Mark[K1]=0 then
    begin
      Lst[K1]:=Q;
      DFS(K1);
      if V[K1]<V[Q] then
        V[Q]:=V[K1];
    end;
    if Enter[K1]<V[Q] then
      V[Q]:=Enter[K1];
  end;
  inc(Time);
end;

procedure Solve;
var
  I:Longint;
  L:BOOLean;

begin
  read(N,M);
  fillchar(Last,sizeof(Last),0);
  for I:=1 to M do
  begin
    read(Reb[I].X,Reb[I].Y);
    Reb[I].LastX:=Last[Reb[I].X];
    Reb[I].Lasty:=Last[Reb[I].Y];
    Last[Reb[I].X]:=I;
    Last[Reb[I].Y]:=I;
  end;
  fillchar(Mark,sizeof(Mark),0);
  fillchar(S,Sizeof(S),false);
  Time:=0;
  DFS(1);
  Lst[1]:=0;
  Count:=0;
  L:=false;
  for I:=2 to N do
    if Lst[I]=1 then
    begin
      if L then
      begin
        if not(S[1]) then
          inc(Count);
        S[1]:=true;
      end
      else
        L:=true;
    end
    else
      if V[I]>=Enter[Lst[I]] then
        if not(S[Lst[I]])then
        begin
          inc(Count);
          S[Lst[I]]:=true;
        end;
  writeln(Count);
  for I:=1 to N do
    if S[I] then
      writeln(I);
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
