Const
  FIn='e.in';
  FOut='e.out';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=20000;
  MaxM=200000;
Type
  TReb=Record
    X,Y:Word;
    Num:LongInt;
  end;
  TGr=array[1..2*MaxM]of TReb;
Var
  N,M:LongInt;
  Reb:TGr;
  {}
  X,Y,NM,V,_M:LongInt;
  Gr:TGr;
  SSS,Col,R:LongInt;
  Mark:array[1..MaxN]of Boolean;
  Enter:array[1..MaxN]of Word;
  Mas:array[1..MaxN]of Word;
  Ans:LongInt;
  Res:array[1..MaxM]of Word;
  Start:array[1..MaxN]of LongInt;
  F:Boolean;

procedure Sort2(l,r:LongInt);
var
  t,i,j,x:LongInt;
  Y:TReb;
begin
  i := l; j := r; x:=Gr[(l+r) DIV 2].x;
  repeat
    while Gr[i].X < x do i := i + 1;
    while x < Gr[j].X do j := j - 1;
    if i <= j then
    begin
      y := Gr[i]; Gr[i] := Gr[j]; Gr[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort2(l, j);
  if i < r then Sort2(i, r);
end;

procedure Sort(l,r:LongInt);
var
  i,j,x:LongInt;
  Y:TReb;
begin
  i := l; j := r; x:=Reb[(l+r) DIV 2].x;
  repeat
    while Reb[i].X < x do i := i + 1;
    while x < Reb[j].X do j := j - 1;
    if i <= j then
    begin
      y := Reb[i]; Reb[i] := Reb[j]; Reb[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

Procedure Glub(Pr,V:Word);
Var R:LongInt;
begin
  Mark[V]:=True;
  {}
  Col:=Col+1;
  Enter[Col]:=V;
  {}
  R:=Start[V];
  If R<>0 then
    While Reb[R].X=V do
    begin
      If Not Mark[Reb[R].Y] then
      begin
        _M:=_M+1;
        Gr[_M].X:=Reb[R].Y;
        Gr[_M].Y:=V;
        Gr[_M].Num:=Reb[R].Num;
        Glub(V,Reb[R].Y);
      end else
      If Reb[R].Y<>Pr then
      begin
        _M:=_M+1;
        Gr[_M].Num:=Reb[R].Num;
        Gr[_M].X:=Reb[R].Y;
        Gr[_M].Y:=V;
      end;
      R:=R+1;
    end;
end;

Procedure Go(V:Word);
Var R:LongInt;
begin
  Mas[V]:=SSS;
  R:=Start[V];
  If R<>0 then
    While Gr[R].X=V do
    begin
      If Mas[Gr[R].Y]=0 then Go(Gr[R].Y) else
      If Mas[Gr[R].Y]<>SSS then
      begin
        Ans:=Ans+1;
        Res[Ans]:=Gr[R].Num;
      end;
      R:=R+1;
    end;
end;

begin
  Init;
  {}
  ReadLn(Input,N,M);
  NM:=0;
  For R:=1 to M do
  begin
    ReadLn(Input,X,Y);
    NM:=NM+1;
    Reb[NM].X:=X;
    Reb[NM].Y:=Y;
    Reb[NM].Num:=R;
    NM:=NM+1;
    Reb[NM].X:=Y;
    Reb[NM].Y:=X;
    Reb[NM].Num:=R;
  end;
  Sort(1,NM);
  FillChar(Start,SizeOf(Start),0);
  V:=0;
  For R:=1 to NM do
    If Reb[R].X<>V then
    begin
      While Reb[R].X<>V do V:=V+1;
      Start[V]:=R;
    end;
  {}
  _M:=0;
  V:=1;
  repeat
    Glub(0,V);
    F:=False;
    For R:=1 to N do
      If Not Mark[R] then
      begin
        F:=True;
        V:=R;
        Break;
      end;
  until Not F;
  {}
  Sort2(1,_M);
  FillChar(Start,SizeOf(Start),0);
  V:=0;
  For R:=1 to _M do
    If Gr[R].X<>V then
    begin
      While Gr[R].X<>V do V:=V+1;
      Start[V]:=R;
    end;
  {}
  SSS:=0;
  Ans:=0;
  For R:=1 to Col do
    If Mas[R]=0 then
    begin
      SSS:=SSS+1;
      Go(Enter[R]);
    end;
  {}
  WriteLn(Output,Ans);
  For R:=1 to Ans do Write(Output,Res[R],' ');
  {}
  Done;
end.
