const
     FileIn='color.in';
     FileOut='color.out';
     MaxN=250000;
type
    TBrick=record
                 Value: LongInt;
                 Color: LongInt;
           end;
var
   N: LongInt;
   Bricks: array [1..MaxN] of TBrick;
   Answer: LongInt;
   Colors: array [1..MaxN] of LongInt;
   MinColor: LongInt;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do begin
            Read (F, Bricks [NItem].Value);
            Bricks [NItem].Color:=0;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     for NItem:=1 to N-1
         do Write (F, Bricks [NItem].Color, #32);
     Writeln (F, Bricks [N].Color);
     Close (F);
end;

procedure DrawBrick (aBrick: LongInt);
var
   NColor, NBestColor: LongInt;
begin
     if Bricks [aBrick].Value>Bricks [Colors [MinColor]].Value
        then for NBestColor:=1 to Answer
                 do if Bricks [Colors [NBestColor]].Value<Bricks [aBrick].Value
                       then begin
                            for NColor:=NBestColor+1 to Answer
                                do if (Bricks [Colors [NColor]].Value<Bricks [aBrick].Value) and (Bricks [Colors [NColor]].Value>Bricks [Colors [NBestColor]].Value)
                                      then NBestColor:=NColor;
                            Bricks [aBrick].Color:=NBestColor;
                            Colors [NBestColor]:=aBrick;
{                           if NBestColor=MinColor
                               then begin
                                    Write ('''');
                                    for NColor:=1 to Answer
                                        do if Bricks [Colors [NColor]].Value<Bricks [Colors [MinColor]].Value
                                              then begin
                                                   MinColor:=NColor;
                                                   Writeln ('!');
                                              end;
                                    Write ('`');
                               end; }
                            Exit;
                       end;
     Inc (Answer);
     Bricks [aBrick].Color:=Answer;
     Colors [Answer]:=aBrick;
     MinColor:=Answer;
end;

procedure Solve;
var
   NItem: LongInt;
begin
     Answer:=1;
     Bricks [1].Color:=Answer;
     Colors [Answer]:=1;
     MinColor:=1;
     for NItem:=2 to N
         do DrawBrick (NItem);
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
