const
     FileIn='d.in';
     FileOut='d.out';
     MaxN=20000;
     MaxM=200000;
type
    TStick=record
                 Node1, Node2: Integer;
           end;
var
   Sticks: array [1..MaxM] of TStick;
   M, N, L: LongInt;
   Nodes: array [1..MaxN] of Integer;
   FIFO: array [1..MaxN] of Integer;
   FIFOLength: LongInt;

procedure ReadData;
var
   F: Text;
   NStick: Integer;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M);
     for NStick:=1 to M
         do Readln (F, Sticks [NStick].Node1, Sticks [NStick].Node2);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NNode: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, L);
     for NNode:=1 to N
         do Write (F, Nodes [NNode], #32);
     Close (F);
end;

procedure ProcessNode (aNode: LongInt);

procedure Push (aItem: LongInt);
begin
     Inc (FIFOLength);
     FIFO [FIFOLength]:=aItem;
     Nodes [aItem]:=L;
end;

var
   FIFONode: LongInt;
   NStick: LongInt;
begin
     Push (aNode);
     FIFONode:=1;
     while FIFONode<=FIFOLength
           do begin
              for NStick:=1 to M
                  do if (Sticks [NStick].Node1=FIFO [FIFONode]) and (Nodes [Sticks [NStick].Node2]=0)
                        then Push (Sticks [NStick].Node2)
                        else if (Sticks [NStick].Node2=FIFO [FIFONode]) and (Nodes [Sticks [NStick].Node1]=0)
                                then Push (Sticks [NStick].Node1);
              Inc (FIFONode);
           end;
end;

procedure Solve;
var
   NNode: LongInt;
begin
     L:=0;
     FillChar (Nodes, SizeOf (Nodes), 0);
     for NNode:=1 to N
         do if Nodes [NNode]=0
               then begin
                    Inc (L);
                    ProcessNode (NNode);
               end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
