{.$define debug}
{$I-,Q-,R-}

program template;
const
 {$ifdef debug}
 h = 40;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 h = 1700;
 cinfile = 'common.in';
 coutfile = 'common.out';
 {$endif}
 maxcount = h*h div 2;
type
 int = longint;
 tstr = array [1..h] of byte;
var
 n,m,k :int;
 s :array [1..2] of tstr;
 count :array [1..2] of int;
 e :array [1..2,1..maxcount,0..1] of int;
 cc :array [1..2,1..maxcount] of byte;
 p :array [1..2,1..maxcount] of int;
 processed :array [1..2,1..maxcount] of boolean;
 suflink :array [1..2,1..maxcount] of int;
 l :array [1..2,1..h] of int;
 mark :array [1..2,1..maxcount] of byte;
 d :int;
 ans :tstr;
 cnt :int;

procedure init;
begin
 fillchar (s,sizeof(s),0);
 fillchar (e,sizeof(e),0);
 fillchar (p,sizeof(p),0);
 fillchar (cc,sizeof(cc),0);
 fillchar (processed,sizeof(processed),0);
 fillchar (suflink,sizeof(suflink),0);
 fillchar (l,sizeof(l),0);
 fillchar (mark,sizeof(mark),0);
 d := 0;
end;

procedure readstr (var s :tstr; var len :int);
var c :char;
begin
 len := 0;
 while not eoln do
  begin
   read (c);
   inc (len);
   s[len] := ord(c) - ord('0');
  end;
 readln;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readstr (s[1],n);
 readstr (s[2],m);
 readln (k);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := cnt downto 1 do
  write (ans[i]);
 close (output);
 halt;
end;

procedure automat (num :int;v :int; up :int);
var i,j :int;
    k :int;
begin
 k := 1;
 for i := v to up do
  begin
   if not (e[num,k,s[num][i]] = 0) then
    k := e[num,k,s[num][i]]
   else
    begin
     inc (count[num]);
     p[num,count[num]] := k;
     e[num,k,s[num][i]] := count[num];
     k := count[num];
     cc[num,count[num]] := s[num][i];
    end;
  end;
end;
{
procedure process (i :int; num :int);
begin
 if processed[num,i] then
  exit;
 if not (i = 1) then
  begin
   if p[num,i] = 1 then
    suflink[num,i] := 1
   else
    begin
     process(p[num,i],num);
     suflink[num,i] := e[num,suflink[num,p[num,i]],cc[num,i]];
     process (suflink[num,i],num);
     if e[num,i,1] = 0 then
      e[num,i,1] := e[num,suflink[num,i],1];
     if e[num,i,0] = 0 then
      e[num,i,0] := e[num,suflink[num,i],0];
    end
  end
 else
  begin
   if e[num,i,0] = 0 then
    e[num,i,0] := 1;
   if e[num,i,1] = 0 then
    e[num,i,1] := 1;
  end;
 processed[num,i] := true;
end;}

procedure getstr (v :int; var res :tstr);
var i,j :int;
begin
 fillchar (res,sizeof(res),0);
 cnt := 0;
 while not (v = 1) do
  begin
   inc (cnt);
   res[cnt] := cc[1,v];
   v := p[1,v];
  end;
end;
{
procedure bfs;
type
 tpair = record
  u,v :int;
 end;
var q :array [1..maxcount] of tpair;
    cur :tpair;
    w,t :int;

procedure add (prev :tpair; u,v :int);
begin
 if (u = 0) or (v = 0) then
  exit;
 if (mark[1,u] = 1) then
  begin
   mark[2,v] := 1;
   exit;
  end;
 if (mark[2,v] = 1) then
  begin
   mark[1,u] := 1;
   exit;
  end;
 mark[1,u] := 1;
 mark[2,v] := 1;
 inc (t);
 q[t].u := u;
 q[t].v := v;
 inc (d);
 if d = k then
  begin
   getstr (u,ans);
   outdata;
  end;
end;

begin
 fillchar (q,sizeof(q),0);
 t := 1;
 w := 1;
 q[1].u := 1;
 q[1].v := 1;
 mark[1,1] := 1;
 mark[2,1] := 1;
 while w <= t do
  begin
   cur := q[w];
   inc (w);
   add (cur,e[1,cur.u,0],e[2,cur.v,0]);
   add (cur,e[1,cur.u,1],e[2,cur.v,1]);
  end;
end;}

procedure dfs (u,v :int);
begin
 if (u = 0) or (v = 0) then
  exit;
 if (mark[1,u] = 1) and (mark[2,v] = 1) then
  exit;
 if mark[1,u] = 1 then
  begin
   mark[2,v] := 1;
   exit;
  end;
 if mark[2,v] = 1 then
  begin
   mark[1,u] := 1;
   exit;
  end;
 mark[1,u] := 1;
 mark[2,v] := 1;
 if not ((u = 1) and (v = 1)) then
  inc (d);
 if d = k then
  begin
   getstr (u,ans);
   outdata;
  end;
 dfs (e[1,u,0],e[2,v,0]);
 dfs (e[1,u,1],e[2,v,1]);
end;


procedure solve;
var i,j :int;
begin
 count[1] := 1;
 count[2] := 1;
 for i := 1 to n do
  automat (1,i,m);
 for i := 1 to m do
  automat (2,i,m);
{ for i := 1 to count[1] do
  process(i,1);
 for i := 1 to count[2] do
  process(i,2);}
{ bfs;}
 dfs(1,1);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.