{Filimonov Vladislav}
Const
  InFileName='common.in';
  OutFileName='common.out';
  MaxN=4002;
  MaxV=2000000;

Var
  Fail:Text;
  N,M:LongInt;
  S1:Array[1..MaxN] Of Boolean;
  S2:Array[1..MaxN] Of Boolean;
  K:LongInt;


Procedure Get;
Var
  X:Char;
  Begin
    Assign(Fail,InFileName);
    ReSet(Fail);
    N:=0;
    M:=0;
    While Not EoLN(Fail) Do Begin
      Read(Fail,X);
      S1[N+1]:=(X='1');
      Inc(N);
    End;
    ReadLn(Fail);
    While Not EoLN(Fail) Do Begin
      Read(Fail,X);
      S2[M+1]:=(X='1');
      Inc(M);
    End;
    ReadLn(Fail);
    ReadLn(Fail,K);
    Close(Fail);
  End;


Var
  L:Array[0..MaxN] Of Integer;
  Len:Integer;

Function Is(X,Y:Integer):Boolean;
Var
  I:Integer;
  K:Integer;
  Begin
    L[1]:=0;
    For I:=X+1 To Y Do Begin
      Len:=L[I-X];
      While (Len>0) And (S1[X+Len+1]<>S1[I]) Do Len:=L[Len];
      If S1[X+Len+1]=S1[I] Then L[I]:=Len+1 Else L[I]:=0;
    End;
    K:=0;
    For I:=1 To M Do Begin
      While (K>0) And (S1[X+K]<>S2[I]) Do K:=L[K];
      If S1[X+K]=S2[I] Then Inc(K);
      If K>=Y-X+1 Then Begin
        Is:=True;
        Exit;
      End;
    End;
    Is:=False;
  End;

Var
  E:Array[1..MaxV,False..True] Of LongInt;
  P:Array[1..MaxV] Of LongInt;
  Mark:Array[1..MaxV] Of Boolean;
  VN:LongInt;

Procedure Push(X,Y:Integer);
Var
  I:Integer;
  K:LongInt;
  Begin
    K:=1;
    For I:=X To Y Do Begin
      If E[K,S1[I]]=0 Then Begin
        Inc(VN);
        E[K,S1[I]]:=VN;
        P[VN]:=K;
      End;
      K:=E[K,S1[I]];
    End;
    Mark[K]:=True;
  End;

Var
  S:Array[1..MaxV] Of LongInt;
  Count:LongInt;
  Cur:LongInt;
  Kol:LongInt;

Procedure Save(V:LongInt);
Var
  I:Integer;
  Cur:LongInt;
  Ans:Array[1..MaxN] Of Boolean;
  KK:LongInt;
  Begin
    Cur:=V;
    KK:=0;
    While Cur<>1 Do Begin
      Ans[KK+1]:=(E[P[Cur],True]=Cur);
      Inc(KK);
      Cur:=P[Cur];
    End;
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    For I:=KK DownTo 1 Do Write(Fail,Ord(Ans[I]));
    Close(Fail);
    Halt;
  End;

Procedure SPush(Num:LongInt);
  Begin
    S[Count+1]:=Num;
    Inc(Count);
  End;

Function Pop:LongInt;
  Begin
    Pop:=S[Count];
    Dec(Count);
  End;

Procedure Found;
  Begin
    Count:=0;
    Cur:=1;
    Kol:=0;
    While Kol<K Do Begin
      While E[Cur,False]<>0 Do Begin
        Cur:=E[Cur,False];
        SPush(Cur);
        If Mark[Cur]=True Then Begin
          Inc(Kol);
          If Kol=K Then Save(Cur);
        End;
      End;
      While E[Cur,True]=0 Do Cur:=Pop;
      Cur:=E[Cur,True];
      If Mark[Cur]=True Then Begin
        Inc(Kol);
        If Kol=K Then Save(Cur);
      End;
    End;
  End;

Procedure Solve;
Var
  I,J:Integer;
  Begin
    FillChar(E,SizeOf(E),0);
    FillChar(Mark,SizeOf(Mark),False);
    FillChar(P,SizeOf(P),0);
    VN:=1;
    For I:=1 To N Do Begin
      For J:=I To N Do Begin
        If Is(I,J) Then Push(I,J);
      End;
    End;
    Found;
  End;

Begin
  Get;
  Solve;
End.
