{$Q-,R-,I-}
{.$define debug}

program template;
const
 h = 130;
 dig = 4;
 osn = 10000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'square.in';
 coutfile = 'square.out';
 {$endif}
type
 int = longint;
 tlong = array [0..h] of int;
var
 n :tlong;
 ans :tlong;

procedure init;
begin
 fillchar (n,sizeof(n),0);
 fillchar (ans,sizeof(ans),0);
end;

procedure readdata;
var i,j :int;
    t :array [1..h*dig] of byte;
    c :char;
    d :int;
    base :int;
begin
 fillchar (t,sizeof(t),0);
 assign (input,cinfile);
 reset (input);
 d := 0;
 while not eoln do
  begin
   read (c);
   inc (d);
   t[d] := ord(c) - ord('0');
  end;
 base := 1;
 for i := d downto 1 do
  if base = 1 then
   begin
    inc (n[0]);
    n[n[0]] := base*t[i];
    base := base*10;
   end
  else
   begin
    n[n[0]] := n[n[0]] + base*t[i];
    base := base*10;
    if base = osn then
     base := 1;
   end;
 close (input);
end;

procedure outdata;
var i,j :int;
    s :string;
begin
 assign (output,coutfile);
 rewrite (output);
 write (ans[ans[0]]);
 for i := ans[0]-1 downto 1 do
  begin
   str (ans[i],s);
   while length(s) < dig do
    s := '0' + s;
   write (s);
  end;
 close (output);
end;

procedure summ (var a,b :tlong; var res :tlong);
var i,j :int;
    ost :int;
    tmp :int;
begin
 fillchar (res,sizeof(res),0);
 if a[0] > b[0] then
  res[0] := a[0]
 else
  res[0] := b[0];
 ost := 0;
 for i := 1 to res[0] do
  begin
   tmp := a[i] + b[i] + ost;
   if tmp > osn then
    begin
     res[i] := tmp - osn;
     ost := 1;
    end
   else
    begin
     res[i] := tmp;
     ost := 0;
    end;
  end;
 if ost > 0 then
  begin
   inc (res[0]);
   res[res[0]] := ost;
  end;
end;

procedure div2 (var a :tlong);
var i,j :int;
    ost :int;
    tmp :int;
begin
 ost := 0;
 for i := a[0] downto 1 do
  begin
   tmp := a[i] + ost*osn;
   a[i] := tmp div 2;
   ost := tmp mod 2;
  end;
 while (a[0] > 1) and (a[a[0]] = 0) do
  dec (a[0]);
end;

procedure sub (var a,b :tlong; var res :tlong);
var i,j :int;
    tmp :int;
    ost :int;
begin
 fillchar (res,sizeof(res),0);
 if a[0] > b[0] then
  res[0] := a[0]
 else
  res[0] := b[0];
 ost := 0;
 for i := 1 to res[0] do
  begin
   tmp := a[i] - b[i] - ost;
   if tmp < 0 then
    begin
     res[i] := tmp + osn;
     ost := 1;
    end
   else
    begin
     res[i] := tmp;
     ost := 0;
    end;
  end;
 while (res[0] > 1) and (res[res[0]] = 0) do
  dec (res[0]);
end;

procedure summ2 (var res :tlong; var a :tlong);
var i,j :int;
    tmp :int;
    ost :int;
begin
 ost := 0;
 if a[0] > res[0] then
  res[0] := a[0];
 for i := 1 to res[0] do
  begin
   tmp := a[i] + res[i] + ost;
   if tmp > osn then
    begin
     res[i] := tmp - osn;
     ost := 1;
    end
   else
    begin
     res[i] := tmp;
     ost := 0;
    end;
  end;
 if ost > 0 then
  begin
   inc (res[0]);
   res[res[0]] := ost;
  end;
end;


procedure sqr (var a :tlong; var res :tlong);
var tmp :tlong;
    i,j :int;
    t :int;
    ost :int;
begin
 fillchar (res,sizeof(res),0);
 res[0] := 1;
 for i := 1 to a[0] do
  begin
   fillchar (tmp,sizeof(tmp),0);
   tmp[0] := a[0] + i - 1;
   ost := 0;
   for j := 1 to a[0] do
    begin
     t := a[j]*a[i] + ost;
     tmp[j+i-1] := t mod osn;
     ost := t div osn;
    end;
   while ost > 0 do
    begin
     inc (tmp[0]);
     tmp[tmp[0]] := ost mod osn;
     ost := ost div osn;
    end;
   summ2 (res,tmp);
  end;
end;

function less (var a,b :tlong):boolean;
var i :int;
begin
 if not (a[0] = b[0]) then
  begin
   less := a[0] < b[0];
   exit;
  end;
 i := a[0];
 while (i > 1) and (a[i] = b[i]) do
  dec (i);
 less := a[i] < b[i];
end;

function q (var a,b :tlong):boolean;
var i :int;
begin
 q := false;
 if not (a[0] = b[0]) then
  exit;
 for i := 1 to a[0] do
  if not (a[i] = b[i]) then
   exit;
 q := true;
end;

procedure outno;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (-1);
 close (output);
 halt;
end;


procedure solve;
var i,j :int;
    l,r :tlong;
    mid :tlong;
    res :tlong;
    len :tlong;
begin
 fillchar (l,sizeof(l),0);
 l[0] := 1;
 fillchar (r,sizeof(r),0);
 r[0] := (n[0] div 2) + 2;
 r[r[0]] := 1;
 repeat
  summ (l,r,mid);
  div2 (mid);
  sqr (mid,res);
  if less (n,res) then
   move (mid,r,sizeof(mid))
  else
   move (mid,l,sizeof(mid));
  sub (r,l,len);
 until (len[0] = 1) and (len[1] <= 1);
 sqr (l,res);
 if q (res,n) then
  ans := l
 else
  begin
   sqr (r,res);
   if q (res,n) then
    ans := r
   else
    outno;
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.