{Filimonov Vladislav}
Program Square_Root;
Const
  InFileName='square.in';
  OutFileName='square.out';
  MaxN=1012;


Type TNumber=Record
  N:Integer;
  A:Array[1..MaxN] Of Integer;
End;

Var
  Fail:Text;
  N:Integer;
  A:TNumber;
  L:TNumber;
  R:TNumber;
  M:TNumber;
  S:TNumber;

Procedure Get;
Var
  I:Integer;
  C:Char;
  P:Integer;
  Begin
    FillChar(A.A,SizeOf(A.A),0);
    Assign(Fail,InFileName);
    ReSet(Fail);
    A.N:=0;
    While Not Eof(Fail) Do Begin
      Read(Fail,C);
      If Not ((Ord(C)>=Ord('0')) And (Ord(C)<=Ord('9'))) Then Break;
      A.A[A.N+1]:=Ord(C)-Ord('0');
      Inc(A.N);
    End;
    For I:=1 To A.N Div 2 Do Begin
      P:=A.A[I];
      A.A[I]:=A.A[A.N-I+1];
      A.A[A.N-I+1]:=P;
    End;
    Close(Fail);
  End;


Procedure Incr(Var What,X:TNumber);
Var
  I:Integer;
  Dig:Integer;
  Dob:Integer;
  Begin
    X:=What;
    I:=1;
    Dob:=1;
    While (Dob=1) And (I<X.N+1) Do Begin
      Inc(X.A[I]);
      If X.A[I]>=10 Then Begin
        X.A[I]:=X.A[I] Mod 10;
        Inc(I);
      End Else Dob:=0;
    End;
    If Dob=1 Then Begin
      X.A[X.N+1]:=1;
      Inc(X.N);
    End;
  End;

Procedure MakeM;
Var
  I:Integer;
  Dob:Integer;
  P:TNumber;
  Begin
    M:=R;
    Dob:=0;
    For I:=1 To L.N Do Begin
      Inc(M.A[I],L.A[I]+Dob);
      If M.A[I]>=10 Then Begin
        M.A[I]:=M.A[I] Mod 10;
        Dob:=1;
      End Else Dob:=0;
    End;
    I:=L.N+1;
    While (Dob=1) And (I<M.N+1) Do Begin
      Inc(M.A[I]);
      If M.A[I]>=10 Then Begin
        M.A[I]:=M.A[I] Mod 10;
        Dob:=1;
        Inc(I);
      End Else Dob:=0;
    End;
    If Dob=1 Then Begin
      M.A[M.N+1]:=1;
      Inc(M.N);
    End;
    If M.A[1] Mod 2 = 1 Then Begin
      P:=M;
      Incr(P,M);
    End;

    For I:=1 To M.N Do Begin
      If M.A[I] Mod 2 = 0 Then M.A[I]:=M.A[I] Div 2 Else Begin
        M.A[I]:=M.A[I] Div 2;
        If I<>1 Then Inc(M.A[I-1],5);
      End;
    End;
    If M.A[M.N]=0 Then Dec(M.N);
  End;

Function Equal(Var X,Y:TNumber):Integer;
Var
  I:Integer;
  Begin
    If X.N>Y.N Then Begin
      Equal:=1;
      Exit;
    End;
    If X.N<Y.N Then Begin
      Equal:=-1;
      Exit;
    End;
    For I:=X.N DownTo 1 Do Begin
      If X.A[I]>Y.A[I] Then Begin
        Equal:=1;
        Exit;
      End;
      If X.A[I]<Y.A[I] Then Begin
        Equal:=-1;
        Exit;
      End;
    End;
    Equal:=0;
  End;

Function Good:Boolean;
  Begin
    Incr(L,M);
    Good:=((Equal(M,R)=0) Or (Equal(L,R)=0));
  End;

Procedure MakeS;
Var
  I,J:Integer;
  Mult:Integer;
  Dob:Integer;
  Cur:Integer;
  Begin
    FillChar(S.A,SizeOf(S.A),0);
    S.N:=0;
    For I:=1 To M.N Do Begin
      For J:=1 To M.N Do Begin
        Mult:=M.A[I]*M.A[J];
        Dob:=0;
        Inc(S.A[I+J-1],Mult Mod 10);
        If I+J-1>S.N Then S.N:=I+J-1;
        If S.A[I+J-1]>=10 Then Begin
          Dob:=1;
          S.A[I+J-1]:=S.A[I+J-1] Mod 10;
        End Else Dob:=0;
        Inc(S.A[I+J],(Mult Div 10)+Dob);
        If (S.A[I+J]>0) And (I+J>S.N) Then S.N:=I+J;
        If S.A[I+J]>=10 Then Begin
          Dob:=S.A[I+J] Div 10;
          S.A[I+J]:=S.A[I+J] Mod 10;
        End Else Dob:=0;
        Cur:=I+J+1;
        While Dob=1 Do Begin
          Inc(S.A[Cur]);
          If S.A[Cur]>=10 Then Begin
            Dob:=1;
            S.A[Cur]:=S.A[Cur] Mod 10;
            Inc(Cur);
            If Cur>S.N Then S.N:=Cur;
          End Else Dob:=0;
        End;
      End;
    End;
  End;


Procedure Save;
Var
  I:Integer;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    For I:=M.N DownTo 1 Do Write(Fail,M.A[I]);
    Close(Fail);
    Halt;
  End;

Procedure NotSquare;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,-1);
    Close(Fail);
    Halt;
  End;

Procedure Solve;
Var
  I:Integer;
  E:Integer;
  Dig:Integer;
  St10:LongInt;
  F:LongInt;
  SQ:LongInt;
  ST:String;
  Begin
    If (A.N=1) And (A.A[1]=0) Then Begin
      M.N:=1;
      M.A[1]:=0;
      Save;
    End;
    FillChar(L.A,SizeOf(L.A),0);
    FillChar(R.A,SizeOf(R.A),0);
    If A.N<=50 Then Begin
      L.A[1]:=1;
      L.N:=1;
      R:=A;
    End Else Begin
      If A.N<100 Then Begin
        Dig:=A.N Div 2;
        L.N:=Dig;
        L.A[L.N]:=1;
        R.N:=Dig+1;
        R.A[R.N]:=1;
      End Else Begin
        St10:=1;
        F:=0;
        If A.N Mod 2 = 1 Then Begin
          For I:=A.N-8 To A.N Do Begin
            Inc(F,St10*A.A[I]);
            St10:=St10*10;
          End;
          SQ:=Trunc(SQRT(F));
          Dig:=(A.N-9) Div 2;
          L.N:=Dig+5;
          R.N:=Dig+5;
          STR(SQ,ST);
          For I:=1 To 5 Do L.A[Dig+I]:=Ord(ST[6-I])-Ord('0');
          STR(SQ+1,ST);
          For I:=1 To 5 Do R.A[Dig+I]:=Ord(ST[6-I])-Ord('0');
        End Else Begin
          For I:=A.N-7 To A.N Do Begin
            Inc(F,St10*A.A[I]);
            St10:=St10*10;
          End;
          SQ:=Trunc(SQRT(F));
          Dig:=(A.N-8) Div 2;
          L.N:=Dig+4;
          R.N:=Dig+4;
          STR(SQ,ST);
          For I:=1 To 4 Do L.A[Dig+I]:=Ord(ST[5-I])-Ord('0');
          STR(SQ+1,ST);
          For I:=1 To 4 Do R.A[Dig+I]:=Ord(ST[5-I])-Ord('0');
        End;
      End;
    End;
    While Not Good Do Begin
      MakeM;
      MakeS;
      E:=Equal(S,A);
      If E=0 Then Save;
      If E=1 Then R:=M;
      If E=-1 Then L:=M;
    End;
    M:=L;
    MakeS;
    If Equal(S,A)=0 Then Save;
    M:=R;
    MakeS;
    If Equal(S,A)=0 Then Save;
    NotSquare;
  End;

Begin
  Get;
  Solve;
End.
