{Filimonov Vladislav}
Program Permutations;
Const
  InFileName='perm.in';
  OutFileName='perm.out';
  MaxN=100000;

Var
  Fail:Text;
  N:LongInt;
  A:Array[1..MaxN] Of LongInt;
  Was:Boolean;

Procedure Get;
Var
  I:LongInt;
  Begin
    Was:=False;
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(Fail,N);
    For I:=1 To N Do Begin
      Read(Fail,A[I]);
      If (I>1) Then If (A[I]>A[I-1]) Then Was:=True;
    End;
    Close(Fail);
  End;

Procedure Save;
Var
  I:LongInt;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    If Was=False Then Begin
      For I:=1 To N Do Write(Fail,I,' ');
    End Else Begin
      For I:=1 To N Do Write(Fail,A[I],' ');
    End;
    Close(Fail);
    Halt;
  End;

Procedure Solve;
Var
  I,J,K:LongInt;
  P:longInt;
  Begin
    If Was=False Then Save;
    I:=N-1;
    While (I>0) And (A[I]>A[I+1]) Do Dec(I);
    J:=I+1;
    While (J<N) And (A[J+1]>A[I]) Do Inc(J);
    P:=A[I];
    A[I]:=A[J];
    A[J]:=P;
    For K:=I+1 To I+((N-I) Div 2) Do Begin
      P:=A[K];
      A[K]:=A[N-(K-I)+1];
      A[N-(K-I)+1]:=P;
    End;
  End;

Begin
  Get;
  Solve;
  Save;
End.
