const infile = 'square.in'; outfile = 'square.out';
      osn = 10000; maxc = 500;
type tlong = array [0..maxc] of longint;
var n,up,down,tmp_s,tmp: tlong;
    ok: boolean;

procedure read_long(var a: tlong);
var i: longint;
    ch: char;
begin
     read(ch); a[0]:=0;
     while not (ch in ['0'..'9']) do read(ch);
     while ch in ['0'..'9'] do begin
           for i:=a[0] downto 1 do begin
               a[i+1]:=a[i+1]+(a[i]*10) div osn;
               a[i]:=(a[i]*10) mod osn;
           end;
           a[1]:=a[1]+ord(ch)-48;
           if a[a[0]+1] > 0 then inc(a[0]);
           read(ch);
     end;
end;

procedure write_long(a: tlong);
var st,s: string;
    i: longint;
begin
     str(osn div 10,st);
     write(a[a[0]]);
     for i:=a[0]-1 downto 1 do begin
         str(a[i],s);
         while length(s) < length(st) do s:='0'+s;
         write(s);
     end;
end;

procedure init;
begin
     assign(input,infile);
     reset(input);
     read_long(n);
     close(input);
end;

procedure mul_long(a,b: tlong; var c: tlong);
var i,j,dt: longint;
begin
     fillchar(c,sizeOF(c),0);
     for i:=1 to a[0] do
         for j:=1 to b[0] do begin
             dt:=a[i]*b[j]+c[i+j-1];
             c[i+j]:=c[i+j]+(dt div osn);
             c[i+j-1]:=dt mod osn;
         end;
     c[0]:=a[0]+b[0];
     while (c[0] > 1)and(c[c[0]] = 0) do c[0]:=c[0]-1;
end;

function more(a,b: tlong): byte;
var i: longint;
begin
     if a[0] > b[0] then begin more:=1; exit; end;
     if b[0] > a[0] then begin more:=2; exit; end;
     for i:=a[0] downto 1 do
         if a[i] <> b[i] then break;
     if a[i] > b[i] then begin more:=1; exit; end;
     if a[i] < b[i] then begin more:=2; exit; end;
     more:=0;
end;

procedure div2(a: tlong; var b: tlong);
var i,ost,r: longint;
begin
     fillchar(b,sizeOf(b),0); ost:=0;
     for i:=a[0] downto 1 do begin
         r:=a[i]+ost*osn;
         ost:=r mod 2;
         b[i]:=(r-ost) div 2;
     end;
     if b[a[0]] = 0 then b[0]:=a[0]-1 else b[0]:=a[0];
end;

procedure sum(a,b: tlong; var c: tlong);
var k,i: longint;
begin
     fillchar(c,SizeOF(c),0);
     if a[0] > b[0] then k:=a[0] else k:=b[0];
     for i:=1 to k do begin
         c[i+1]:=(c[i]+a[i]+b[i]) div osn;
         c[i]:=(c[i]+a[i]+b[i]) mod osn;
     end;
     if c[k+1] > 0 then c[0]:=k+1 else c[0]:=k;
end;

procedure solve;
var i: longint;
begin
     ok:=false;
     down[0]:=1; down[1]:=1;
     if (n[0] div 2) > 20 then begin
        down[0]:=(n[0] div 2)-3; down[down[0]]:=1;
        for i:=1 to down[0]-1 do down[i]:=0;
     end;
     up[0]:=(n[0] div 2)+3; up[up[0]]:=1;
     for i:=1 to up[0]-1 do up[i]:=0;
     sum(up,down,tmp_s); div2(tmp_s,tmp);
     while (more(tmp,down) <> 0)and(more(tmp,up) <> 0) do begin
           mul_long(tmp,tmp,tmp_s);
           if more(tmp_s,n) = 0 then begin ok:=true; exit; end;
           if more(tmp_s,n) = 1 then up:=tmp
              else down:=tmp;
           sum(up,down,tmp_s); div2(tmp_s,tmp);
     end;
     mul_long(tmp,tmp,tmp_s);
     if more(tmp_s,n) = 0 then begin ok:=true; end;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     if (n[0] = 0)and(n[1] = 0) then write(0)
     else begin
        if ok then write_long(tmp)
           else write(-1);
     end;
     close(output);
end;

begin
     init;
     solve;
     done;
end.