{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const infile = 'smooth.in'; outfile = 'smooth.out'; maxc = 50;
var n,ansN,t: longint;
    f: array [0..maxc,0..9] of extended;
    ans: array [1..maxc] of longint;

procedure init;
begin
     assign(input,infile);
     reset(input);
     read(n);
     close(input);
end;

procedure create;
var i,j,k: longint;
begin
     fillchar(f,sizeOF(f),0);
     for i:=1 to 9 do f[1,i]:=1;
     for i:=2 to maxc do begin
         for j:=0 to 9 do f[i,0]:=f[i,0]+f[i-1,j];
         for j:=1 to 9 do begin
             for k:=0 to 9-j do
                 f[i,j]:=f[i,j]+f[i-1,j+k];
         end;
     end;
     for i:=1 to maxc do
         for j:=1 to 9 do
             f[i,j]:=f[i,j]+f[i,j-1];
end;

procedure solve;
var i,j,pr: longint;
    r: extended;
begin
     r:=n;
     for i:=1 to maxc do begin
         for j:=1 to 9 do
             if (f[i,j] >= r)and(f[i,j-1] < r) then break;
         if (f[i,j] >= r)and(f[i,j-1] < r) then break;
     end;
     ansN:=i; ans[1]:=j; pr:=j;
     n:=n-round(f[i,j-1]);
     for i:=2 to ansN do begin
         r:=n;
         for j:=pr to 9 do
             if (f[ansN-i+1,j]-f[ansN-i+1,pr-1] >= r)and
                (f[ansN-i+1,j-1]-f[ansN-i+1,pr-1] < r) then break;
         n:=n-round(f[ansN-i+1,j-1]-f[ansN-i+1,pr-1]);
         ans[i]:=j; pr:=j;
     end;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     for i:=1 to ansN do
         write(ans[i]);
     close(output);
end;

begin
     init;
     create;
     solve;
     done;
end.