const infile = 'cooling.in'; outfile = 'cooling.out'; max = 205;
var a,c,l: array [1..max,1..max] of longint;
    nnew: array [1..max] of byte;
    num: array [1..max*max,1..2] of longint;
    sm: array [1..max] of longint;
    n,m: longint;
    ok: boolean;

procedure init;
var i,x,y: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,m);
     fillchar(a,SizeOF(a),0);
     fillchar(l,SizeOf(l),0);
     fillchar(c,SizeOf(c),0);
     for i:=1 to m do begin
         read(x,y); read(l[x,y],c[x,y]);
         a[x,y]:=l[x,y];
         num[i,1]:=x; num[i,2]:=y;
     end;
     close(input);
end;

procedure reweight(v: longint);
var r,i,dt: longint;
begin
     r:=sm[v];
     if r > 0 then begin
        for i:=1 to n do
            if a[i,v] > 0 then
               if a[i,v] <= c[i,v] then begin
                  if r > c[i,v]-a[i,v] then dt:=c[i,v]-a[i,v]
                     else dt:=r;
                  a[i,v]:=a[i,v]+dt;
                  sm[v]:=sm[v]-dt; sm[i]:=sm[i]+dt;
                  r:=r-dt; if r = 0 then exit;
               end;
        for i:=1 to n do
            if a[v,i] > 0 then
               if a[v,i] <= c[v,i] then begin
                  if abs(r) > a[v,i]-l[v,i] then dt:=a[v,i]-l[v,i]
                     else dt:=abs(r);
                  a[v,i]:=a[v,i]-dt;
                  sm[v]:=sm[v]-dt; sm[i]:=sm[i]+dt;
                  r:=r-dt; if r = 0 then exit;
               end;
     end
        else begin
        for i:=1 to n do
            if a[v,i] > 0 then
               if a[v,i] < c[v,i] then begin
                  if abs(r) > c[v,i]-a[v,i] then dt:=c[v,i]-a[v,i]
                     else dt:=abs(r);
                  a[v,i]:=a[v,i]+dt;
                  sm[v]:=sm[v]+dt; sm[i]:=sm[i]-dt;
                  r:=r+dt; if r = 0 then exit;
               end;
        for i:=1 to n do
            if a[i,v] > 0 then
               if a[i,v] <= c[i,v] then begin
                  if abs(r) > a[i,v]-l[i,v] then dt:=a[i,v]-l[i,v]
                     else dt:=abs(r);
                  a[i,v]:=a[i,v]-dt;
                  sm[v]:=sm[v]+dt; sm[i]:=sm[i]-dt;
                  r:=r+dt; if r = 0 then exit;
               end;
     end;
end;

procedure solve;
var i,j,v: longint;
begin
     for i:=1 to n do
         for j:=1 to n do
             if a[i,j] > 0 then begin
                sm[i]:=sm[i]+a[i,j];
                sm[j]:=sm[j]-a[i,j];
             end;
     for i:=1 to n+1 do begin
         ok:=true;
         for v:=1 to n do
             if sm[v] <> 0 then begin
                reweight(v); ok:=false;
             end;
         if ok then break;
     end;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     if ok then begin
        writeln('YES');
        for i:=1 to m do
            writeln(a[num[i,1],num[i,2]]);
     end
        else write('NO');
     close(output);
end;

begin
     init;
     solve;
     done;
end.