Const
  FIn='square.in';
  FOut='square.out';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxL=520;
Type
  TLong=Record
    L:Word;
    C:array[1..MaxL]of Byte;
  end;
Var
  _c,_b,B,A,C,Ans:TLong;
  {}
  Ch:Char;
  __a,_A,F,y,x,R:LongInt;

{}
Procedure Mul(A:TLong; B:LongInt; Var C:TLong);
Var
  O,S,R:LongInt;
begin
  FillChar(C,SizeOf(C),0);
  O:=0;
  For R:=1 to A.L do
  begin
    S:=A.C[R]*B+O;
    C.C[R]:=S mod 10;
    O:=S div 10;
  end;
  While O<>0 do
  begin
    R:=R+1;
    C.C[R]:=O mod 10;
    O:=O div 10;
  end;
  C.L:=R;
end;

Procedure Zero(Var A:TLong);
begin
  While (A.C[A.L]=0)and(A.L<>1) do A.L:=A.L-1;
end;

Procedure Sub(A,B:TLong; Var C:TLong);
Var
  S,O,R:LongInt;
begin
  FillChar(C,SizeOf(C),0);
  O:=0;
  For R:=1 to A.L do
  begin
    S:=A.C[R]-B.C[R]-O;
    If S>=0 then
    begin
      C.C[R]:=S;
      O:=0;
    end else
    begin
      C.C[R]:=S+10;
      O:=1;
    end;
  end;
  C.L:=A.L;
  Zero(C);
end;

Procedure Invert(Var C:TLong);
Var Temp,R:LongInt;
begin
  For R:=1 to C.L div 2 do
  begin
    Temp:=C.C[R];
    C.C[R]:=C.C[C.L-R+1];
    C.C[C.L-R+1]:=Temp;
  end;
end;

Function Cmp(C,T2:TLong):Byte;
Var R:LongInt;
begin
  If C.L<T2.L then Cmp:=1 else
  If C.L>T2.L then Cmp:=2 else
  If C.L=T2.L then
  begin
    Cmp:=0;
    For R:=C.L downto 1 do
      If C.C[R]<T2.C[R] then
      begin
        Cmp:=1;
        Break;
      end else
      If C.C[R]>T2.C[R] then
      begin
        Cmp:=2;
        Break;
      end;
  end;
end;

Procedure LongSqr(A:TLong; Var C:TLong);
Var
  O,S,i,j:LongInt;
begin
  FillChar(C,SizeOf(C),0);
  For i:=1 to A.L do
  begin
    O:=0;
    For j:=1 to A.L do
    begin
      S:=C.C[i+j-1]+A.C[i]*A.C[j]+O;
      C.C[i+j-1]:=S mod 10;
      O:=S div 10;
    end;
    While O<>0 do
    begin
      j:=j+1;
      C.C[i+j-1]:=O mod 10;
      O:=O div 10;
    end;
    If i+j-1>C.L then C.L:=i+j-1;
  end;
end;


begin
  Init;
  {}
  Ch:=#0;
  While Not (Ch in ['0'..'9']) do Read(Input,Ch);
  While Ch in ['0'..'9'] do
  begin
    C.L:=C.L+1;
    C.C[C.L]:=Ord(Ch)-Ord('0');
    Read(Input,Ch);
  end;
  If C.L mod 2<>0 then
  begin
    For R:=C.L downto 1 do
      C.C[R+1]:=C.C[R];
    C.C[1]:=0;
    C.L:=C.L+1;
  end;
  {}
  For R:=9 downto 0 do
    If R*R<=C.C[1]*10+C.C[2] then Break;
  Ans.C[1]:=R;
  Ans.L:=1;
  A.C[1]:=C.C[2];
  A.C[2]:=C.C[1];
  A.L:=2;
  Zero(A);

  B.C[1]:=R*R mod 10;
  B.C[2]:=R*R div 10;
  B.L:=2;
  Zero(B);
  R:=2;
  {}
  While R<C.L do
  begin
    Sub(A,B,B);
    Invert(B);
    R:=R+1; B.L:=B.L+1;
    B.C[B.L]:=C.C[R];
    R:=R+1; B.L:=B.L+1;
    B.C[B.L]:=C.C[R];
    Invert(B);
    Zero(B);
    Mul(Ans,2,_b);

    For y:=9 downto 0 do
    begin
      Invert(_b);
      If y=9 then _b.L:=_b.L+1;
      _b.C[_b.L]:=y;
      Invert(_b);
      Zero(_b);

      Mul(_b,y,_c);
      F:=Cmp(_c,b);
      If F<=1 then Break;
      {_c ne prevosh b}
    end;
    A:=b;
    B:=_c;
    Invert(Ans);
    Ans.L:=Ans.L+1;
    Ans.C[Ans.L]:=y;
    Invert(Ans);
  end;
  {}
  Invert(C);
  Zero(C);
  LongSqr(Ans,A);
  If Cmp(A,C)<>0 then Write(Output,-1) else
  For R:=Ans.L downto 1 do Write(Output,Ans.C[R]);
  {}
  Done;
end.