  {$I-,Q-,R-,S-}
const
  inputfile = 'square.in';
  outputfile = 'square.out';
  maxn = 511;

type
  int = longint;
  bool = boolean;
  tlong = record
    n: int;
    d: array[1..maxn]of int;
  end;

var
  find: bool;
  a, down, up, mid, sq: tlong;
  m, count: int;

procedure readlong(var a: tlong);
var
  i, t: int;
  c: char;
begin
  read(c);
  while(not(c in['0'..'9']))do
    read(c);
  while(not seekeof)and(c = '0')do
    read(c);
  while(c in ['0'..'9'])do begin
    inc(a.n);
    a.d[a.n] := ord(c) - ord('0');
    read(c);
  end;
  for i := 1 to a.n div 2 do begin
    t := a.d[i];
    a.d[i] := a.d[a.n - i + 1];
    a.d[a.n - i + 1] := t;
  end;
end;

function more(var a, b: tlong): int;
var
  i: int;
begin
  if(a.n > b.n)then
    more := 0
  else
    if(a.n < b.n)then
      more := 1
    else begin
      i := a.n;
      while(i > 1)and(a.d[i] = b.d[i])do
        dec(i);
      if(a.d[i] > b.d[i])then
        more := 0
      else
        if(a.d[i] < b.d[i])then
          more := 1
        else
          more := 2;
    end;
end;

procedure sqrlong(var a, c: tlong);
var
  i, j, d: int;
begin
  fillchar(c, sizeof(c), 0);
  for i := 1 to a.n do
    for j := 1 to a.n do begin
      d := c.d[i + j - 1] + a.d[i] * a.d[j];
      c.d[i + j - 1] := d mod 10;
      c.d[i + j] := c.d[i + j] + d div 10;
    end;
  c.n := 2 * a.n + 1;
  while(c.n > 1)and(c.d[c.n] = 0)do
    dec(c.n);
end;

procedure sumlong(var a, b, c: tlong);
var
  i, k, d: int;
begin
  fillchar(c, sizeof(c), 0);
  if(a.n > b.n)then
    k := a.n
  else
    k := b.n;

  for i := 1 to k do begin
    d := c.d[i] + a.d[i] + b.d[i];
    c.d[i] := d mod 10;
    c.d[i + 1] := d div 10;
  end;

  c.n := a.n + b.n + 1;
  while(c.n > 1)and(c.d[c.n] = 0)do
    dec(c.n);

end;

procedure div2(var a: tlong);
var
  i: int;
begin
  for i := a.n downto 1 do begin
    if(i > 1)then
      a.d[i - 1] := a.d[i - 1] + a.d[i] mod 2 * 10;
    a.d[i] := a.d[i] div 2;
  end;
  if(a.n > 1)and(a.d[a.n] = 0)then
    dec(a.n);
end;

procedure writelong(var a: tlong);
var
  i: int;
begin
  for i := a.n downto 1 do
    write(a.d[i]);
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  readlong(a);
  if(a.n > 350)then begin
    write(-1);
    close(output);
    halt(0);
  end;
  if(a.n = 1)then begin
    if(a.d[1] in[0, 1, 4, 9])then
      write(sqrt(a.d[1]):0:0)
    else
      write(-1);
  end else begin
    if(a.n > 2)then
      down.n := a.n div 2
    else
      down.n := 1;
    down.d[down.n] := 1;

    up.n := a.n div 2 + 2;
    up.d[up.n] := 1;

    while(true)do begin
      inc(count);
      if(count > 4 * a.n)then
        break;
      sumlong(down, up, mid);
      div2(mid);
      sqrlong(mid, sq);
      m := more(sq, a);
      case m of
        0: up := mid;
        1: down := mid;
        2: begin
          find := true;
          writelong(mid);
          break;
        end;
      end;
    end;
  end;
  if(not find)then
    write(-1);
  close(output);
  close(input);
end.
