{$I-,Q-,R-,S-}
{$H+}
function KillFirstZeroes (aA: string): string;
var
   NChar: LongInt;
begin
     for NChar:=1 to Length (aA)
         do if aA [NChar]<>'0'
               then Break;
     KillFirstZeroes:=Copy (aA, NChar, Length (aA)-NChar+1)
end;

function LongSumCh (aA, aB: Char): Char;
begin
     LongSumCh:=Chr (Ord (aA)-Ord ('0')+Ord (aB));
end;

function LongSum (aA, aB: string): string;
var
   C: string;
   NChar: LongInt;
begin
     if Length (aA)<Length (aB)
        then LongSum:=LongSum (aB, aA)
        else begin
             C:=aA;
             C:='0'+C;
             for NChar:=0 to Length (aB)-1
                 do C [Length (C)-NChar]:=LongSumCh (C [Length (C)-NChar], aB [Length (aB)-NChar]);
             for NChar:=Length (C) downto 2
                 do while C [NChar]>'9'
                          do begin
                             C [NChar]:=Chr (Ord (C [NChar])-10);
                             C [NChar-1]:=Chr (Ord (C [NChar-1])+1);
                          end;
             LongSum:=KillFirstZeroes (C);
        end;
end;

function LongMinCh (aA, aB: Char): Char;
begin
     LongMinCh:=Chr (Ord (aA)-(Ord (aB)-Ord ('0')));
end;

function LongMin (aA, aB: string): string;
var
   C: string;
   NChar: LongInt;
begin
     C:=aA;
     C:=C;
     for NChar:=0 to Length (aB)-1
         do C [Length (C)-NChar]:=LongMinCh (C [Length (C)-NChar], aB [Length (aB)-NChar]);
     for NChar:=Length (C) downto 2
         do while C [NChar]<'0'
                  do begin
                     C [NChar]:=Chr (Ord (C [NChar])+10);
                     C [NChar-1]:=Chr (Ord (C [NChar-1])-1);
                  end;
     LongMin:=KillFirstZeroes (C);
end;

function LongMulCh (aA, aB: Char): Char;
begin
     LongMulCh:=Chr ((Ord (aA)-Ord ('0'))*(Ord (aB)-Ord ('0'))+Ord ('0'));
end;

function LongMulOnCh (aA: string; aCh: Char): string;
var
   C: string;
   NChar: LongInt;
begin
     C:='0'+aA;
     for NChar:=1 to Length (C)
         do C [NChar]:=LongMulCh (C [NChar], aCh);
     for NChar:=Length (C) downto 2
         do while C [NChar]>'9'
                  do begin
                     C [NChar]:=Chr (Ord (C [NChar])-10);
                     C [NChar-1]:=Chr (Ord (C [NChar-1])+1);
                  end;
     if C [1]='0'
        then begin
             for NChar:=2 to Length (C)
                 do C [NChar-1]:=C [NChar];
             SetLength (C, Length (C)-1);
        end;
     LongMulOnCh:=C;
end;

function LongMul (aA, aB: string): string;
var
   C, ZeroOffset: string;
   NChar: LongInt;
begin
     if Length (aA)<Length (aB)
        then LongMul:=LongMul (aB, aA)
        else begin
             ZeroOffset:='';
             C:='0';
             for NChar:=Length (aB) downto 1
                 do begin
                    C:=LongSum (C, LongMulOnCh (aA, aB [NChar])+ZeroOffset);
                    ZeroOffset:=ZeroOffset+'0';
                 end;
             LongMul:=C;
        end;
end;

function FirstIsGreater (aA, aB: string): Boolean;
begin
     while Length (aA)<Length (aB)
           do aA:='0'+aA;
     while Length (aB)<Length (aA)
           do aB:='0'+aB;
     FirstIsGreater:=aA>aB;
end;

function LongSqr (const aA: string): string;
begin
     LongSqr:=LongMul (aA, aA);
end;

const
     FileIn='square.in';
     FileOut='square.out';
var
   Number, Answer: string;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, Number);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure Solve;
var
   PartsComplete, TotalParts: LongInt;
   Part1, Part2: string;
   ABig, ASmall, X: string;

function GetPart (aNPart: LongInt): string;
begin
     GetPart:=Number [(aNPart-1)*2+1]+Number [(aNPart-1)*2+2];
end;

procedure Step1;
begin
     Answer:='';
     while (Length (Number)<4) or (Length (Number) mod 2<>0)
           do Number:='0'+Number;
     Part1:=GetPart (1);
     Part2:=GetPart (2);
     PartsComplete:=0;
     TotalParts:=(Length (Number) div 2)+(Length (Number) mod 2);
end;

procedure Step2;
begin
     X:='0';
     while FirstIsGreater (Part1, LongSqr (X))
           do X:=LongSum (X, '1');
     if FirstIsGreater (LongSqr (X), Part1)
        then X:=LongMin (X, '1');
     Answer:=X;
     Inc (PartsComplete);
end;

procedure Step3;
begin
     ABig:=LongMin (Part1, LongSqr (Answer))+Part2;
     ASmall:=LongMul (Answer, '2');
     X:='0';
     while FirstIsGreater (ABig, LongMul (ASmall+X, X))
           do X:=LongSum (X, '1');
     if FirstIsGreater (LongMul (ASmall+X, X), ABig)
        then X:=LongMin (X, '1');
     Answer:=Answer+X;
     Inc (PartsComplete);
end;

procedure Step4;
var
   BBig, BSmall, Part: string;
begin
     Part:=GetPart (PartsComplete+1);
     BBig:=LongMin (ABig, LongMul (ASmall+X, X))+Part;
     BSmall:=LongMul (Answer, '2');
     X:='0';
     while FirstIsGreater (BBig, LongMul (BSmall+X, X))
           do X:=LongSum (X, '1');
     if FirstIsGreater (LongMul (BSmall+X, X), BBig)
        then X:=LongMin (X, '1');
     Answer:=Answer+X;
     ABig:=BBig;
     ASmall:=BSmall;
     Inc (PartsComplete);
end;

begin
     Step1;
     if TotalParts>PartsComplete
        then begin
             Step2;
             if TotalParts>PartsComplete
                then begin
                     Step3;
                     while TotalParts>PartsComplete
                           do Step4;
                end;
        end;
     Answer:=KillFirstZeroes (Answer);
     Number:=KillFirstZeroes (Number);
     if LongSqr (Answer)<>Number
        then Answer:='-1';
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
