{$I-,Q-,R-,S-}
const
     FileIn='perm.in';
     FileOut='perm.out';
     MaxN=100000;
var
   N: LongInt;
   Numbers: array [0..MaxN+1] of LongInt;

procedure ReadData;
var
   F: Text;
   NItem: Longint;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do Read (F, Numbers [NItem]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NItem:=1 to N-1
         do Write (F, Numbers [NItem], #32);
     Writeln (F, Numbers [N]);
     Close (F);
end;

procedure Swap (aIndex1, aIndex2: LongInt);
var
   T: LongInt;
begin
     if (aIndex1>=1) and (aIndex1<=N) and (aIndex2>=1) and (aIndex2<=N)
        then begin
             T:=Numbers [aIndex1];
             Numbers [aIndex1]:=Numbers [aIndex2];
             Numbers [aIndex2]:=T;
        end;
end;

procedure SwapRange (aLeft, aRight: LongInt);
var
   Left, Right: LongInt;
begin
     Left:=aLeft;
     Right:=aRight;
     repeat
           Swap (Left, Right);
           Inc (Left);
           Dec (Right);
     until Left>=Right;
end;

procedure Solve;
var
   K, T: LongInt;
begin
     K:=N-1;
     while (K>0) and (Numbers [K]>Numbers [K+1])
           do Dec (K);
     T:=K+1;
     while (T>0) and (T<N) and (Numbers [T+1]>Numbers [K])
           do Inc (T);
     Swap (K, T);
     SwapRange (K+1, N);
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
