program Tangent;
{$N+}
type
  tpoint = record
    x,y : extended;
  end;
  tcirc = record
    x,y,r : longint;
  end;
  tline = record
    a,b,c : extended;
  end;

const
  eps = 1e-10;

var
  c1,c2,c3 : tcirc;
  l : extended;
  kasno : integer;
  kas1,kas2,ok1,ok2 : tline;

procedure Inp;
begin
  assign(input,'tangent.in'); reset(input);
  assign(output,'tangent.out'); rewrite(output);
  read(c1.x,c1.y,c1.r,c2.x,c2.y,c2.r);
end;

procedure findkas(c : tcirc;x,y : longint);
var
  z : extended;
  sina,cosa : extended;
  l : extended;
  old : tline;
begin
  if (c.r=0) then
  begin
    kasno := 2;
    kas1.a := y-c.y;
    kas1.b := c.x-x;
    z := sqrt(sqr(kas1.a) + sqr(kas1.b));
    kas1.c := -kas1.a*x-kas1.b*y;
    kas1.a := kas1.a / z;
    kas1.b := kas1.b / z;
    kas1.c := kas1.c / z;
    kas2:=kas1;
  end;
  if sqr(c.x-x) + sqr(c.y-y) = sqr(c.r) then
  begin
    kasno := 0;
    kas1.a := x-c.x;
    kas1.b := y-c.y;
    z := sqrt(sqr(kas1.a) + sqr(kas1.b));
    kas1.c := -kas1.a*x-kas1.b*y;
    kas1.a := kas1.a / z;
    kas1.b := kas1.b / z;
    kas1.c := kas1.c / z;
    exit;
  end;
  l := sqrt(sqr(c.x-x) + sqr(c.y-y));

  kasno := 0;
  if l<c.r then exit;
  kasno := 2;
  sina := c.r / l;
  cosa := sqrt(1-sqr(sina));
  old.a := y-c.y;
  old.b := c.x-x;
  kas1.a := (old.a*cosa+old.b*sina);
  kas1.b := (-old.a*sina+old.b*cosa);
  z := sqrt(sqr(kas1.a) + sqr(kas1.b));
  kas1.a := kas1.a / z;
  kas1.b := kas1.b / z;
  kas2.a := (old.a*cosa-old.b*sina);
  kas2.b := (old.a*sina+old.b*cosa);
  z := sqrt(sqr(kas2.a) + sqr(kas2.b));
  kas2.a := kas2.a / z;
  kas2.b := kas2.b / z;
end;

procedure Run;
begin
  if c1.r<c2.r then
  begin
    c3 := c1;
    c1 := c2;
    c2 := c3;
  end;
  if (c1.x=c2.x) and (c1.y=c2.y) then
  begin
    if c1.r=c2.r then
      writeln(-1)
    else
      writeln(0);
  end else
  if (l+c2.r+eps<c1.r) then
    writeln(-1)
  else
  begin
    c3 := c1;
    c3.r := c1.r - c2.r;
    findkas(c3,c2.x,c2.y);
    kas1.c := -c1.r + kas1.a*c1.x + kas1.b*c1.y;
    if abs(c2.r-abs(kas1.a*c2.x + kas1.b*c2.y + kas1.c))>10*eps then
      kas1.c := +c1.r + kas1.a*c1.x + kas1.b*c1.y;
    kas2.c := +c1.r + kas2.a*c1.x + kas2.b*c1.y;
    if abs(c2.r-abs(kas2.a*c2.x + kas2.b*c2.y + kas2.c))>10*eps then
      kas2.c := -c1.r + kas2.a*c1.x + kas2.b*c1.y;
    ok1 := kas1;
    ok2 := kas2;
    c3 := c1;
    c3.r := c1.r + c2.r;
    findkas(c3,c2.x,c2.y);
    if kasno>=1 then
    kas1.c := +c1.r + (kas1.a*c1.x + kas1.b*c1.y);
    if abs(c2.r-abs(kas1.a*c2.x + kas1.b*c2.y + kas1.c))>10*eps then
      kas1.c := -c1.r + (kas1.a*c1.x + kas1.b*c1.y);
    if kasno>=2 then
    kas2.c := +c1.r + (kas2.a*c1.x + kas2.b*c1.y);
    if abs(c2.r-abs(kas2.a*c2.x + kas2.b*c2.y + kas2.c))>10*eps then
      kas2.c := +c1.r - (kas2.a*c1.x + kas2.b*c1.y);
    writeln(2+kasno);
    writeln(ok1.a:0:6,' ',ok1.b:0:6,' ',ok1.c:0:6);
    writeln(ok2.a:0:6,' ',ok2.b:0:6,' ',ok2.c:0:6);
    if kasno>=1 then
    writeln(kas1.a:0:6,' ',kas1.b:0:6,' ',kas1.c:0:6);
    if kasno>=2 then
    writeln(kas2.a:0:6,' ',kas2.b:0:6,' ',kas2.c:0:6);
  end;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.