{$D-,E+,I-,L-,P-,Q-,R-,S+,T+,V+,X+}
type real   = extended;
     point  = record x,y : real end;
     circle = record o : point; r : real end;

const eps : real = 1e-10;
      inf = 1e+10;
      pointinf : point = (x:inf; y:inf);

var c1,c2:circle;
p:array[1..2]of point;
res,i:byte;

function eq(const a,b : real) : boolean;
begin
  eq:=abs(a-b)<=eps;
end;

function dist(const p1,p2 : point) : real;
begin
  dist:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
end;

function sqrdist(const p1,p2 : point) : real;
begin
  sqrdist:=sqr(p1.x-p2.x)+sqr(p1.y-p2.y);
end;

procedure moveto(const p1,p2 : point; const k : real; var p : point);
begin
  p.x:=p1.x+(p2.x-p1.x)*k;
  p.y:=p1.y+(p2.y-p1.y)*k;
end;

function fun(const c : circle; const p : point; var p1,p2 : point) : byte;
var d,t,xx,yy : real;
begin
  p1:=pointinf; p2:=pointinf;
  with c do
  begin
    d:=dist(o,p); fun:=0;
    if eq(d,r) then fun:=1
    else if d<r then fun:=2
    else exit;

    t:=sqr(r)-sqr(d);
    if t<0 then t:=0 else t:=sqrt(t)/d;
    xx:=(p.x-o.x)*t; yy:=(p.y-o.y)*t;
    p1.x:=p.x-yy; p1.y:=p.y+xx;
    p2.x:=p.x+yy; p2.y:=p.y-xx;
  end;
end;


function circlepersek(const c1,c2 : circle; var p1,p2 : point) : byte;
var p : point;
    d2,t : real;
begin
  d2:=sqrdist(c1.o,c2.o);
  t:=(sqr(c1.r)-sqr(c2.r)+d2)/(2*d2);
  moveto(c1.o,c2.o,t,p);
  circlepersek:=fun(c1,p,p1,p2);
end;

begin
assign(input,'circles.in');reset(input);
read(c1.o.x,c1.o.y,c1.r);
read(c2.o.x,c2.o.y,c2.r);
close(input);
assign(output,'circles.out');rewrite(output);
if (c1.o.x=c2.o.x)and(c1.o.y=c2.o.y)then
 begin
 if (c1.r=c2.r) then writeln(-1) else writeln(0);
 close(output);
 exit;
 end;
res:=circlepersek(c1,c2,p[1],p[2]);
writeln(res);
for i:=1 to res do
writeln(p[i].x:0:6,' ',p[i].y:0:6);
close(output);

end.