{$N+}
const eps = 1e-7;
var x1, y1, x2, y2, r1, r2: extended;
var xx, yy, a, b, c, d, aa, bb: extended;

begin
  assign(input, 'circles.in');
  assign(output, 'circles.out');
  reset(input);
  rewrite(output);
  read(x1, y1, r1);
  read(x2, y2, r2);
  if (abs(x1 - x2) < eps) and (abs(y1 - y2) < eps) and (abs(r1 - r2) < eps) then
    begin
      writeln(-1);
      close(input);
      close(output);
      exit;
    end;
  d:=sqrt(sqr(x1 - x2) + sqr(y1 - y2));
  if (d > r1 + r2 + eps) or (d + r2  + eps < r1) or (d + r1 + eps < r2) then
    begin
      writeln(0);
      close(input);
      close(output);
      exit;
    end;
  if abs(d - r1 - r2) < eps then
    begin
      aa:=x2 - x1;
      bb:=y2 - y1;

      d:=sqrt(sqr(aa) + sqr(bb));
      aa:=aa / d;
      bb:=bb / d;

      x1:=x1 + aa * r1;
      y1:=y1 + bb * r1;
      writeln(1);
      writeln(x1 : 0 : 6, ' ', y1 : 0 : 6);
      close(input);
      close(output);
      exit;
    end;

  if abs(d + r2 - r1) < eps then
    begin
      aa:=x2 - x1;
      bb:=y2 - y1;

      d:=sqrt(sqr(aa) + sqr(bb));
      aa:=aa / d;
      bb:=bb / d;

      x1:=x2 + aa * r2;
      y1:=y2 + bb * r2;
      writeln(1);
      writeln(x1 : 0 : 6, ' ', y1 : 0 : 6);
      close(input);
      close(output);
      exit;
    end;

  if abs(d + r1 - r2) < eps then
    begin
      aa:=x1 - x2;
      bb:=y1 - y2;

      d:=sqrt(sqr(aa) + sqr(bb));
      aa:=aa / d;
      bb:=bb / d;

      x1:=x1 + aa * r1;
      y1:=y1 + bb * r1;
      writeln(1);
      writeln(x1 : 0 : 6, ' ', y1 : 0 : 6);
      close(input);
      close(output);
      exit;
    end;


  a:=2 * (x2 - x1);
  b:=2 * (y2 - y1);
  c:= x1 * x1 + y1 * y1 - x2 * x2 - y2 * y2 - r1 * r1 + r2 * r2;
  d:=sqrt(a * a + b * b);
  a:=a / d;
  b:=b / d;
  c:=c / d;

  d:=sqrt(sqr(x1 - x2) + sqr(y1 - y2));
  d:=(r1 * r1 - r2 * r2) / d + d;
  d:=d / 2;

  xx:=d;
  yy:=sqrt(r1 * r1 - xx * xx);

  aa:=x2 - x1;
  bb:=y2 - y1;

  d:=sqrt(sqr(aa) + sqr(bb));
  aa:=aa / d;
  bb:=bb / d;

  x1:=x1 + aa * xx;
  y1:=y1 + bb * xx;

  writeln(2);
  writeln((x1 - b * yy) : 0 : 6, ' ', (y1 + a * yy) : 0 : 6);
  writeln((x1 + b * yy) : 0 : 6, ' ', (y1 - a * yy) : 0 : 6);
  close(input);
  close(output);
end.