{$N+}
const
  inf = 'circles.in'; ouf = 'circles.out';
  eps = 10e-8;
type
  real = extended;
  function dist(x1, y1, x2, y2: real): real;
  begin
    dist := sqr(x1 - x2) + sqr(y1 - y2);
  end;
var
  ca, sa, xn, yn, x, y, x1, y1, tm, r1, x2, y2, r2, d: real;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, x1, y1, r1);
  readln(input, x2, y2, r2);
  d := dist(x1, y1, x2, y2);
  if (d = 0) then
  begin
    if (r1 = r2) then
      writeln(-1)
    else
      writeln(0);
  end
  else
  begin
    if (r1 < r2) then
    begin
      tm := x1; x1 := x2; x2 := tm;
      tm := y1; y1 := y2; y2 := tm;
      tm := r1; r1 := r2; r2 := tm;
    end;
    d := sqrt(d);
    if (d - r1 - r2 > 0) or (d + r2 < r1) then
      writeln(output, 0)
    else
    begin
      ca := (sqr(r1) + sqr(d) - sqr(r2))/(2 * d * r1);
      sa := sqrt(1 - sqr(ca));
      if (abs(sa) < eps) then
      begin
        writeln(output, 1);
        x := x2 - x1; y := y2 - y1;
        x := (x * r1)/d; y := (y * r1)/d;
        x := x + x1; y := y + y1;
        writeln(output, x:6:6, ' ', y:6:6);
      end
      else
      begin
        writeln(output, 2);
        x := x2 - x1; y := y2 - y1;
        xn := ca * x + sa * y;
        yn :=-sa * x + ca * y;
        xn := (xn * r1) / d;  yn := (yn * r1) / d;
        xn := xn + x1; yn := yn + y1;
        writeln(output, xn:6:6, ' ', yn:6:6);
        sa := -sa;
        xn := ca * x + sa * y;
        yn := -sa * x + ca * y;
        xn := (xn * r1) / d;  yn := (yn * r1) / d;
        xn := xn + x1; yn := yn + y1;
        writeln(output, xn:6:6, ' ',yn:6:6);
      end;
    end;
  end;
  close(input); close(output);
end.