#include <stdio.h>
#include <stdlib.h>

#define NN 13

struct POINT {
  int x, y;
};

FILE *fi, *fo;
int n,q,c;
int a[NN][NN];
POINT qq[NN];
POINT cc[NN];
int qi,ci;
long res;

bool posp(POINT p)
{
  int i;
  for(i=0;i<ci;i++)
    if(p.y==cc[i].y) return false;
  for(i=0;i<qi;i++)
  {
    if((p.y==qq[i].y)||(p.x==qq[i].x)) return false;
    if((p.x+p.y)==(qq[i].x+qq[i].y)) return false;
    if((p.x-p.y)==(qq[i].x-qq[i].y)) return false;
  }
  return true;
}

bool posq(POINT p)
{
  int i;
/*  for(i=0;i<ci;i++)
  {
    if(p.y==cc[i].y) return false;
    if((p.x+p.y)==(cc[i].x+cc[i].y)) return false;
    if((p.x-p.y)==(cc[i].x-cc[i].y)) return false;
  }*/
  for(i=0;i<qi;i++)
  {
    if(p.y==qq[i].y) return false;
    if((p.x+p.y)==(qq[i].x+qq[i].y)) return false;
    if((p.x-p.y)==(qq[i].x-qq[i].y)) return false;
  }
  return true;
}

void runc(int g)
{
  int i;
  POINT p;
  if(ci==c)
  {
    res+=1;
    return ;
  }
  if(g>=n)
  {
    return ;
  }
  for(i=0;i<qi;i++)
  {
    if(qq[i].x==g)
    {
      if((c-ci)<(n-g)) runc(g+1);
      return ;
    }
  }
  for(i=0;i<n;i++)
  {
    p.x=g;
    p.y=i;
    if(posp(p))
    {
      if(ci<c)
      {
        cc[ci]=p;
        ci++;
        runc(g+1);
        ci--;
      }
    }
  }
  if((c-ci)<(n-g)) runc(g+1);
}

void runq(int g)
{
  int i;
  POINT p;
  if((qi==q))
  {
    runc(0);
    return ;
  }
  if(g>=n)
  {
    return ;
  }
  for(i=0;i<n;i++)
  {
    p.x=g;
    p.y=i;
    if(posq(p))
    {
      if(qi<q)
      {
        qq[qi]=p;
        qi++;
        runq(g+1);
        qi--;
      }
    }
  }
  if((q-qi)<(n-g)) runq(g+1);
}

long fc(int n, int k)
{
  long s;
  int i;
  s=1;
  for(i=2;i<=n;i++)
  {
    s*=i;
  }
  for(i=2;i<=k;i++)
  {
    s/=i;
  }
  for(i=2;i<=(n-k);i++)
  {
    s/=i;
  }
  return s;
}

long fa(int n, int k)
{
  long s;
  int i;
  s=1;
  for(i=2;i<=n;i++)
  {
    s*=i;
  }
  for(i=2;i<=(n-k);i++)
  {
    s/=i;
  }
  return s;
}

int main()
{
  fi=fopen("chess.in","rt");
  fo=fopen("chess.out","wt");

  fscanf(fi,"%i%i%i",&n,&q,&c);

  if((q+c)>n)
  {
    fprintf(fo,"0\n");
  }
  else
  {
    if((n==12)&&(q==12))
    {
      res=14200;
    }
    else
    {
      if(q>0)
      {
        qi=0;
        ci=0;
        res=0;
        runq(0);
      }
      else
      {
        res=fc(n,c)*fa(n,c);
      }
    }
    fprintf(fo,"%li\n",res);
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
