{$N+,Q-,R-,I-}
{.$define debug}

program template;
const
 h = 12;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'chess.in';
 coutfile = 'chess.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 n :int;
 ans :real;
 q,c :int;
 gr :array [1..h,1..h] of byte;
 queen :array [1..h] of int;
 pc,pr :array [1..h] of byte;

procedure init;
begin
 ans := 0;
 fillchar (queen,sizeof(queen),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,q,c);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans:0:0);
 close (output);
end;

function can (u,v :int):boolean;
var i :int;
begin
 can := false;
 for i := 1 to u-1 do
  if queen[i] > 0 then
  if (abs(u-i) = abs(queen[i] - v)) or
    (queen[i] = v) then
     exit;
 can := true;
end;

procedure calculate;
var i,j :int;
    res :real;

procedure rec (c :int; pos :int);
var i :int;
begin
 if c = 0 then
  begin
   res := res + 1;
   exit;
  end;
 if pos > n then
  exit;
 rec (c,pos+1);
 if pr[pos] > 0 then
  exit;
 for i := 1 to n do
  if pc[i] = 0 then
   if gr[pos,i] = 1 then
    begin
     pr[pos] := 1;
     pc[i] := 1;
     rec (c-1,pos+1);
     pr[pos] := 0;
     pc[i] := 0;
    end;
end;


begin
 fillchar (gr,sizeof(gr),1);
 fillchar (pc,sizeof(pc),0);
 fillchar (pr,sizeof(pr),0);
 res := 0;
 for i := 1 to n do
  if queen[i] > 0 then
   begin
    pr[i] := 2;
    pc[queen[i]] := 2;
    for j := 1 to n do
     gr[i,j] := 0;
    for j := 1 to n do
     begin
      if not (queen[i] - abs(i-j) < 1) then
        gr[j,queen[i]-abs(i-j)] := 0;
      if not (queen[i] + abs(i-j) > n) then
       gr[j,queen[i] + abs(i-j)] := 0;
      gr[j,queen[i]] := 0;
     end;
   end;
 rec (c,1);
 ans := ans + res;
end;

procedure rec1 (pos :int; q :int);
var i :int;
begin
 if q = 0 then
  begin
   calculate;
   exit;
  end;
 if n-pos+1 < q then
  exit;
 rec1(pos+1,q);
 for i := 1 to n do
  if can (pos,i) then
   begin
    queen[pos] := i;
    rec1 (pos+1,q-1);
    queen[pos] := 0;
   end;
end;

procedure solve;
var i,j :int;
begin
 if q + c > n then
  exit;
 if q = 0 then
  begin
   ans := 1;
   for i := 1 to c do
    ans := ans*(n-i+1)*(n-i+1);
   exit;
  end;
 rec1(1,q);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.