const infile = 'chess.in'; outfile = 'chess.out'; maxn = 15;
type mas = array [1..maxn,1..maxn] of byte;
var q,c,n: integer;
    ans: longint;
    a: mas;

procedure init;
begin
     assign(input,infile);
     reset(input);
     read(n,q,c);
     fillchar(a,SizeOf(a),0);
     close(input);
end;

function can_l(x,y: integer): boolean;
begin
     can_l:=a[x,y] = 0;
end;

function can_f(x,y: integer): boolean;
begin
     can_f:=a[x,y] = 0;
end;

function can(x,y,r: integer): boolean;
begin
     can:=(1 <= x)and(x <= n)and(1 <= y)and(y <= n)and
             (a[x,y] = r);
end;

procedure put_f(x,y: integer);
var i: integer;
begin
     a[x,y]:=1;
     for i:=1 to n do begin
         if a[x,i] = 0 then a[x,i]:=3;
         if a[i,y] = 0 then a[i,y]:=3;
     end;
     for i:=-n to n do begin
         if can(x+i,y+i,0) then a[x+i,y+i]:=3;
         if can(x+i,y-i,0) then a[x+i,y-i]:=3;
     end;
end;

procedure put_l(x,y: integer);
var i: integer;
begin
     a[x,y]:=2;
     for i:=1 to n do begin
         if a[x,i] = 0 then a[x,i]:=3;
         if a[i,y] = 0 then a[i,y]:=3;
     end;
end;

procedure rec(nf,nl,t: integer);
var i,j: integer;
    tmp: mas;
begin
     if (t = 1)and(nf = q+1) then begin
        rec(nf,nl,2); exit; end;
     if (t = 2)and(nl = c+1) then begin
        inc(ans); exit; end;
     if t = 1 then begin
        for i:=1 to n do
            for j:=1 to n do
                if can_f(i,j) then begin
                   tmp:=a; put_f(i,j);
                   rec(nf+1,nl,1);
                   a:=tmp;
                end;
     end
        else begin
        for i:=1 to n do
            for j:=1 to n do
                if can_l(i,j) then begin
                   tmp:=a; put_l(i,j);
                   rec(nf,nl+1,2);
                   a:=tmp;
                end;
     end;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(ans div 2);
     close(output);
end;

begin
     init;
     if n = 1 then begin
        if q+c > n then ans:=0
           else ans:=2;
        done;
        exit;
     end;
     if q+c > n then ans:=0
        else rec(1,1,1);
     done;
end.