{$I+,Q-,R-,S+}
program         Template;

var
  X1, Y1, R1    : Extended;
  X2, Y2, R2    : Extended;
  X0, Y0        : Extended;

procedure       OpenFiles;
begin
  Assign(Input, 'circles.in');
  Reset(Input);
  Assign(Output, 'circles.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
begin
  ReadLn(X1, Y1, R1);
  ReadLn(X2, Y2, R2);
end;

procedure       Solve;
var
  K, Q, A, B, C : Extended;
  D, X, Y       : Extended;
begin
  if (X1 = X2) and (Y1 = Y2) and (R1 = R2) then begin
    WriteLn(-1);
    Exit;
  end;

  X0 := X2 - X1; Y0 := Y2 - Y1;
  if X0 <> 0 then begin
    K := (X0 * X0 + Y0 * Y0 + R1 * R1 - R2 * R2) / (2 * X0);
    Q := -Y0 / X0;
    A := Q * Q + 1;
    B := -2 * K * Q;
    C := K * K - R1 * R1;

    D := B * B - 4 * A * C;
    if D < 0 then
      WriteLn(0)
    else if D = 0 then begin
      WriteLn(1);
      Y := -B / (2 * A);
      X := K - Q * Y + X1;
      WriteLn(X:0:6, ' ', Y + Y1:0:6);
    end else begin
      WriteLn(2);
      Y := (-B - Sqrt(D)) / (2 * A);
      X := K - Q * Y;
      WriteLn(X1 + X:0:6, ' ', Y1 + Y:0:6);
      Y := (-B + Sqrt(D)) / (2 * A);
      X := K - Q * Y;
      WriteLn(X1 + X:0:6, ' ', Y1 + Y:0:6);
    end;
  end else begin
    Y := (R1 * R1 - R2 * R2 - Y0 * Y0) / (2 * Y0);
    A := R2 * R2 - Y * Y;

    if A < 0 then
      WriteLn(0)
    else if A = 0 then begin
      WriteLn(1);
      WriteLn(Sqrt(A) + X1:0:6, ' ', Y + Y1:0:6);
    end else begin
      WriteLn(2);
      WriteLn(X1 + Sqrt(A):0:6, ' ', Y + Y1:0:6);
      WriteLn(X1 - Sqrt(A):0:6, ' ', Y + Y1:0:6);
    end;
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
