program Borders;

const
  maxn = 102; {10002}

type
  TPoint = record
     x,y : longint;
  end;

var
  gd : array [1..maxn*2] of longint;
  gb,ge : array [1..maxn] of longint;
  gra,grb : array [1..maxn] of longint;
  gs : longint;
  n : longint;
  m : longint;
  p : array [1..maxn] of tpoint;
  count : array [1..maxn] of longint;
  cdata,cnext : array [1..maxn] of longint;
  cx : array [1..maxn] of longint;
  cs,curr : longint;
  ansn : longint;
  ans : array [1..maxn] of longint;
  v,is : array [1..maxn] of integer;
  vv,pp : array [1..maxn] of integer;
  css : integer;
  bord,bord2,obord : array [1..maxn] of integer;
  bp,bn,bp2,bn2 : array [1..maxn] of integer;
  s : array [1..maxn] of longint;

function cfind(pp : tpoint) : longint;
var
  i : integer;
begin
  for i:=1 to m do
    if (p[i].x=pp.x) and (p[i].y=pp.y) then
    begin
      cfind := i;
      exit;
    end;
  inc(m);
  p[m] := pp;
  cfind := m;
end;

procedure add_list(a,b : integer);
begin
  inc(cs);
  cdata[cs] := b;
  cnext[cs] := cx[a];
  cx[a] :=cs;
end;

procedure Inp;
var
  i : integer;
  p1,p2 : tpoint;
  cc : longint;
begin
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  m := 0;
  read(n);
  fillchar(count,sizeof(count),0);
  fillchar(cx,sizeof(cx),0);
  cs := 0;
  for i:=1 to n do
  begin
    read(p1.x,p1.y,p2.x,p2.y);
    gra[i] := cfind(p1);
    grb[i] := cfind(p2);
    inc(count[gra[i]]);
    inc(count[grb[i]]);
    add_list(gra[i],grb[i]);
    add_list(grb[i],gra[i]);
  end;
  gs := 0;
  for i:=1 to m do
  begin
    gb[i] := gs+1;
    cc := cx[i];
    while (cc<>0) do
    begin
      inc(gs);
      gd[gs] := cdata[cc];
      cc := cnext[cc];
    end;
    ge[i] := gs;
  end;
  ansn := 0;
end;

procedure dfs(a : integer);
var
  b : integer;
begin
  v[a] := css;
  for b:=gb[a] to ge[a] do
    if v[gd[b]]=0 then
      dfs(gd[b]);
end;

var
  eurika : integer;

procedure dfs2(a : integer);
var
  b : integer;
  q : integer;
begin
  if eurika<>0 then exit;
  if bord[a]<>0 then
  begin
    eurika := a;
    exit;
  end;
  vv[a] := curr;
  for q:=gb[a] to ge[a] do
    if gd[q] = pp[a] then
      break;
  for b:=q+1 to ge[a] do
    if vv[gd[b]]<>curr then
    begin
      pp[gd[b]] := a;
      dfs2(gd[b]);
    end;
  for b:=gb[a] to q-1 do
    if vv[gd[b]]<>curr then
    begin
      pp[gd[b]] := a;
      dfs2(gd[b]);
    end;
end;

procedure work2(a : integer);
var
  s : longint;
  ccc,old : integer;
begin
  inc(ansn);
  s := 0;
  for ccc:=1 to m do
    if bord2[ccc] = a then break;
  old := ccc;
  repeat
      s := s + (p[ccc].x+p[bn2[ccc]].x)*(p[ccc].y-p[bn2[ccc]].y);
      ccc := bn2[ccc];
  until ccc=old;
  ans[ansn] := -s;
end;

procedure get(a : integer);
var
  i,c1,c2,j : integer;
  bord3 : array [1..maxn] of integer;
  bn3,bp3 : array [1..maxn] of longint;
  ccc : integer;
  ca,cb : integer;
begin
  if s[a]=0 then exit;
  repeat
    eurika := 0;
    fillchar(vv,sizeof(vv),0);
    for i:=1 to n do
    begin
      if bord[i] <> a then continue;
      vv[i] := i;
      curr := i;
      for c1 := gb[i] to ge[i] do
        if gd[c1] = bn[i] then
          break;
      for c2 := gb[i] to ge[i] do
        if gd[c2] = bp[i] then
          break;
      if (c1<=c2) then
      begin
        for j:=c1+1 to c2-1 do
          if vv[gd[j]]<>curr then
          begin
            pp[gd[j]] := curr;
            dfs2(gd[j]);
          end;
      end
      else
      begin
        for j:=c2+1 to ge[curr] do
          if vv[gd[j]]<>curr then
          begin
            pp[gd[j]] := curr;
            dfs2(gd[j]);
          end;
        for j:=c1-1 to gb[curr] do
          if vv[gd[j]]<>curr then
          begin
            pp[gd[j]] := curr;
            dfs2(gd[j]);
          end;
      end;
      if eurika<>0 then break;
    end;
    if eurika=0 then break;
    fillchar(bord3,sizeof(bord3),0);
    ccc := eurika;
    cb := eurika;
    while ccc<>vv[ccc] do
    begin
      bord3[ccc] := a;
      bn3[ccc] := pp[ccc];
      bp3[pp[ccc]] := ccc;
      ccc := pp[ccc];
    end;
    bord3[ccc] := a;
    ca := i;
    fillchar(bord2,sizeof(bord2),0);
    ccc := ca;
    bn2 := bn;
    bp2 := bp;
    obord := bord;
    while (ccc<>cb) do
    begin
      bord2[ccc] := a;
      if ccc<>ca then bord[ccc] := 0;
      ccc := bn[ccc];
    end;
    for i:=1 to m do
    begin
      if i=ca then bn[ca] := bp3[ca]
      else if i=cb then bp[cb] := bn3[cb]
      else if obord[i]<>a then
      begin
        bp[i] := bn3[i];
        bn[i] := bp3[i];
      end;
    end;
    for i:=1 to n do
    if (bord2[i]=a) or (bord3[i]=a) then
      bord2[i] := a;
    bord2[cb] := a;
    for i:=1 to m do
    begin
      if i=ca then bp2[ca] := bp3[ca]
      else if i=cb then bn2[cb] := bn3[cb]
      else if obord[i]<>a then
      begin
        bp2[i] := bp3[i];
        bn2[i] := bn3[i];
      end;
    end;
    if (bord[i]=a) or (bord3[i]=a) then
      bord[i] := a;
    work2(a);
  until false;
  bord2 := bord;
  bn2 := bn;
  bp2 := bp;
  work2(a);
end;

procedure scount(a : integer);
var
  i : integer;
  cur,old,prev : integer;
begin
  cur := 0;
  s[a] := 0;
  for i:=1 to m do
  begin
    if is[i] <> a then continue;
    if (cur=0) or (p[i].y<p[cur].y) or ((p[i].y=p[cur].y) and (p[i].x<p[cur].x)) then
      cur := i;
  end;
  if cur=0 then exit;
  bord[cur] := a;
  old := cur;
  prev := 0;
  repeat
    bord[cur] := a;
    if prev=0 then
    begin
      prev := cur;
      cur := gd[gb[prev]];
      s[a] := s[a] + (p[cur].x+p[prev].x)*(p[cur].y-p[prev].y);
      bp[cur] := prev;
      bn[prev] := cur;
    end else
    begin
      for i:=gb[cur] to ge[cur] do
        if gd[i] = prev then
          break;
      prev := cur;
      if i=ge[cur] then
        cur := gd[gb[cur]]
      else
        cur := gd[i+1];
      s[a] := s[a] + (p[cur].x+p[prev].x)*(p[cur].y-p[prev].y);
      bp[cur] := prev;
      bn[prev] := cur;
    end;
  until old=cur;
end;

function less(a,b,c : tpoint) : boolean;
var
  p1,p2 : tpoint;
begin
  p1.x := b.x - a.x;
  p1.y := b.y - a.y;
  p2.x := c.x - a.x;
  p2.y := c.y - a.y;
  if (p1.x*p2.y = p1.y*p2.x) then
  begin
    if (p1.x*p2.x<0) then
      less := p1.x > 0
    else
    if (p1.x=0) then
      less := p1.y > 0
    else
      less := (p1.x>p2.x) or (p1.y>p2.y);
  end
  else
  begin
    if p1.y*p2.y<0 then
      less := p1.y>0
    else
      less := p2.x*p1.y - p1.x*p2.y < 0;
  end;
end;

procedure Run;
var
  ql,qr : integer;
  q : array [1..maxn*4] of longint;
  i,j,k : integer;
  t,tt : integer;
begin
  css := 0;
  fillchar(v,sizeof(v),0);
  for i:=1 to m do
    if v[i]=0 then
    begin
      inc(css);
      dfs(i);
    end;
  ql := 1;
  qr := 0;
  for i:=1 to m do
    if count[i]<=1 then
    begin
      inc(qr);
      q[qr] := i;
    end;
  while (qr>=ql) do
  begin
    t := q[ql];
    inc(ql);
    if v[t]=0 then continue;
    v[t] := 0;
    if count[t]=0 then continue;
    tt := gd[gb[t]];
    dec(count[tt]);
    if (count[tt]<=1) and (v[tt]<>0) then
    begin
      inc(qr);
      q[qr] := tt;
    end;
  end;
  for i:=1 to m do
  begin
    for j:=gb[i] to ge[i] do
      for k:=gb[i] to j-1 do
        if (v[gd[k]]=0) or (less(p[i],p[gd[j]],p[gd[k]])) then
        begin
          t := gd[j];
          gd[j] := gd[k];
          gd[k] := t;
        end;
    while (ge[i]>=gb[i]) and (v[gd[ge[i]]]=0) do
      dec(ge[i]);
  end;
  is := v;
  fillchar(bord,sizeof(bord),0);
  for i:=1 to css do
    scount(i);
  for i:=1 to css do
    get(i);
end;

procedure Outp;
var
  i : integer;
begin
  writeln(ansn);
  for i:=1 to ansn do
    writeln(ans[i]/2:0:6);
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.