{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
const infile = 'input.txt'; outfile = 'output.txt'; max = 5005; eps = 0.000001;
type pt = record x,y: extended; end;
     line = record a,b,c: extended; end;
var a: array [1..max*2,1..2] of integer;
    mnew,nnew: array [1..max*2] of byte;
    f: array [0..max*2] of integer;
    cur: array [1..max*2] of integer;
    ans: array [1..max*2] of extended;
    n,nv,k,tmp,ansN: integer;
    cd: array [1..max*2,1..2] of integer;
    ppt: array [1..max*2,1..2,1..2] of integer;
    ok: boolean;

procedure init;
var i,j,p1,p2: longint;
begin
     assign(input,infile);
     reset(input);
     read(n); nv:=0;
     for i:=1 to n do begin
         read(ppt[i,1,1],ppt[i,1,2],ppt[i,2,1],ppt[i,2,2]);
         p1:=0;
         for j:=1 to nv do
             if (ppt[i,1,1] = cd[j,1])and(ppt[i,1,2] = cd[j,2]) then begin
                p1:=j; break;
             end;
         p2:=0;
         for j:=1 to nv do
             if (ppt[i,2,1] = cd[j,1])and(ppt[i,2,2] = cd[j,2]) then begin
                p2:=j; break;
             end;
         if p1 = 0 then begin
            inc(nv); cd[nv,1]:=ppt[i,1,1]; cd[nv,2]:=ppt[i,1,2]; p1:=nv;
         end;
         if p2 = 0 then begin
            inc(nv); cd[nv,1]:=ppt[i,2,1]; cd[nv,2]:=ppt[i,2,2]; p2:=nv;
         end;
         a[i,1]:=p1; a[i,2]:=p2;
         a[i+n,1]:=p2; a[i+n,2]:=p1;
     end;
     n:=2*n;
     close(input);
end;

procedure sort(l,r: integer);
var i,j,x,y: integer;
begin
     i:=l; j:=r; x:=a[(l+r) div 2,1];
     repeat
           while a[i,1] < x do i:=i+1;
           while x < a[j,1] do j:=j-1;
           if i <= j then
           begin
                y:=a[i,1]; a[i,1]:=a[j,1]; a[j,1]:=y;
                y:=a[i,2]; a[i,2]:=a[j,2]; a[j,2]:=y;
                i:=i+1; j:=j-1;
           end;
     until i > j;
     if l < j then sort(l,j);
     if i < r then sort(i,r);
end;

procedure del_vis;
var i,j,r,it: longint;
begin
     for it:=1 to nv do
         for i:=1 to nv do begin
             r:=0;
             for j:=f[i-1]+1 to f[i] do
                 if a[j,2] < 10000 then inc(r);
             if r = 1 then begin
                r:=j;
                for j:=f[a[r,2]-1]+1 to f[a[r,2]] do
                    if a[j,2] = i then break;
                a[j,1]:=10000; a[j,2]:=10000;
                a[r,1]:=10000; a[r,2]:=10000;
             end;
         end;
end;

procedure create;
var i,j: integer;
begin
     sort(1,n); f[0]:=0;
     for i:=1 to n do f[a[i,1]]:=i;
     del_vis;
     fillchar(nnew,SizeoF(nnew),0);
     fillchar(mnew,SizeoF(mnew),0);
     ansN:=0;
end;

function finds(nn: longint): extended;
var i: longint;
    ss: extended;
begin
     ss:=0;
     for i:=1 to nn-1 do
         ss:=ss+cd[cur[i],1]*cd[cur[i+1],2]-cd[cur[i+1],1]*cd[cur[i],2];
     ss:=ss+cd[cur[nn],1]*cd[cur[1],2]-cd[cur[1],1]*cd[cur[nn],2];
     finds:=ss/2;
end;

function sq(p1x,p1y,p2x,p2y,p3x,p3y: longint): longint;
begin
     sq:=(p1x*p2y-p2x*p1y+p2x*p3y-p3x*p2y+p3x*p1y-p1x*p3y);
end;

function dist(q1,q2: pt): extended;
begin
     dist:=sqrt((q1.x-q2.x)*(q1.x-q2.x)+(q1.y-q2.y)*(q1.y-q2.y));
end;

function pr(q1,q2,q3: pt): boolean;
begin
     pr:=abs(dist(q1,q3)+dist(q3,q2)-dist(q1,q2))<eps;
end;

procedure point_to_line(t1,t2: pt; var l: line);
begin
     l.a:=t2.y-t1.y;
     l.b:=t1.x-t2.x;
     l.c:=-(t1.x*l.a+t1.y*l.b);
end;

function prs(l1,l2: line; var p: pt): boolean;
var dt: extended;
begin
     dt:=l1.a*l2.b-l1.b*l2.a;
     if abs(dt) < eps then prs:=false
        else begin
             prs:=true;
             p.x:=-(l1.c*l2.b-l2.c*l1.b)/dt;
             p.y:=(l2.a*l1.c-l1.a*l2.c)/dt;
        end;
end;

function peres(p1x,p1y,p2x,p2y,p3x,p3y,p4x,p4y: longint): boolean;
var l1,l2: line;
    p1,p2,p3,p4,e: pt;
begin
     p1.x:=p1x; p1.y:=p1y; p2.x:=p2x; p2.y:=p2y;
     p3.x:=p3x; p3.y:=p3y; p4.x:=p4x; p4.y:=p4y;
     point_to_line(p1,p2,l1);
     point_to_line(p3,p4,l2);
     peres:=prs(l1,l2,e) and pr(p1,p2,e) and pr(p3,p4,e);
end;

function findmin(p1,p2: longint; var tt: longint): longint;
var i,j: longint;
begin
     findmin:=0;
     for i:=f[p2-1]+1 to f[p2] do if a[i,2] < 10000 then
         if (nnew[a[i,2]] = 0)and(mnew[i] = 0)and(a[i,2] <> p1) then break;
     if not((a[i,2] = 10000)or((nnew[a[i,2]] = 0)and(mnew[i] = 0)and(a[i,2] <> p1))) then exit;
     j:=a[i,2]; tt:=i;
     for i:=f[p2-1]+1 to f[p2] do if (a[i,2] < 10000)and(a[i,2] <> p1)and(mnew[i] = 0) then begin
         if sq(cd[p2,1],cd[p2,2],cd[j,1],cd[j,2],cd[a[i,2],1],cd[a[i,2],2]) > 0 then
            if not peres(cd[p1,1],cd[p1,2],cd[p2,1],cd[p2,2],cd[j,1],cd[j,2],cd[a[i,2],1],cd[a[i,2],2]) then begin
               j:=a[i,2]; tt:=i;
            end;
         if ((sq(cd[p1,1],cd[p1,2],cd[p2,1],cd[p2,2],cd[a[i,2],1],cd[a[i,2],2]) > 0)and
            (sq(cd[p1,1],cd[p1,2],cd[p2,1],cd[p2,2],cd[j,1],cd[j,2]) < 0)) then begin
            j:=a[i,2]; tt:=i;
         end;
     end;
     findmin:=j;
end;

procedure solve(vf: longint);
var i,j,pr,h: longint;
begin
     cur[1]:=vf; pr:=0; h:=0;
     for i:=f[vf-1]+1 to f[vf] do
         if (mnew[i] = 0)and(a[i,2] < 10000) then
            if (pr = 0)or(sq(cd[vf,1],cd[vf,2],cd[a[i,2],1],cd[a[i,2],2],cd[pr,1],cd[pr,2]) > 0) then begin
               pr:=a[i,2]; h:=i; end;
     if pr = 0 then begin nnew[vf]:=1; exit; end;
     cur[2]:=pr; mnew[h]:=1; pr:=2;
     while cur[pr] <> cur[1] do begin
           j:=findmin(cur[pr-1],cur[pr],h);
           if j = 0 then begin nnew[vf]:=1; exit; end;
           inc(pr); cur[pr]:=j; mnew[h]:=1;
     end;
     inc(ansN); ans[ansN]:=finds(pr-1);
     if ans[ansN] < -eps then begin
        dec(ansN); nnew[vf]:=1; end;
end;

procedure done;
var i: integer;
begin
     assign(output,outfile);
     rewrite(output);
     writeln(ansN);
     for i:=1 to ansN do
         writeln(ans[i]:0:5);
     close(output);
end;

begin
     init;
     create;
     for tmp:=1 to nv*nv do begin
         for n:=1 to nv do if nnew[n] = 0 then break;
         solve(n);
     end;
     done;
end.
