{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p21_14_b;

const
  max = 5000;

type
  xy = record
    x, y : longint;
  end;

var
  dots : array[1..max * 2] of xy;
  color : array[1..max * 2] of longint;
  rebs : array[1..max, 1..2] of xy;
  son, next, start : array[0..max * 2] of longint;
  no1, no2, indots, free, i, j, k, m, n : longint;

function nodot(x, y : longint) : longint;
var
  ps : longint;
begin
  for ps := 1 to indots do
    if (dots[ps].x = x) and (dots[ps].y = y) then begin
      nodot := ps;
      exit;
    end;
  nodot := 0;
end;

procedure adddot(x, y : longint);
begin
  inc(indots);
  dots[indots].x := x;
  dots[indots].y := y;
end;

procedure addlink(x, y : longint);
var
  px, py, pst, ps : longint;
begin
  px := start[x];
  if px = 0 then begin
    start[x] := free;
    free := next[free];
    next[start[x]] := 0;
    son[start[x]] := y;
  end else begin
    while next[px] <> 0 do px := next[px];
    next[px] := free;
    free := next[free];
    px := next[px];
    son[px] := y;
    next[px] := 0;
  end;
  px := start[y];
  if px = 0 then begin
    start[y] := free;
    free := next[free];
    next[start[y]] := 0;
    son[start[y]] := x;
  end else begin
    while next[px] <> 0 do px := next[px];
    next[px] := free;
    free := next[free];
    px := next[px];
    son[px] := x;
    next[px] := 0;
  end;
end;

procedure rec(x : longint);
var
  ps : longint;
  used : array[0..5] of boolean;
begin
  fillchar(used, sizeof(used), false);
  ps := start[x];
  while ps <> 0 do begin
    used[color[son[ps]]] := true;
    ps := next[ps];
  end;
  for ps := 1 to 5 do
    if not used[ps] then begin
      color[x] := ps;
      break;
    end;
  if color[x] = 0 then begin
    writeln('IMPOSSIBLE');
    close(output);
    halt;
  end;
  ps := start[x];
  while ps <> 0 do begin
    if color[son[ps]] = 0 then rec(son[ps]);
    ps := next[ps];
  end;

end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);
  fillchar(rebs, sizeof(rebs), 0);
  read(n);
  for i := 1 to n do read(rebs[i, 1].x, rebs[i, 1].y, rebs[i, 2].x, rebs[i, 2].y);
  fillchar(son, sizeof(son), 0);
  for i := 1 to n * 2 do next[i] := i + 1;
  fillchar(start, sizeof(start), 0);
  indots := 0;
  free := 1;
  for i := 1 to n do begin
    no1 := nodot(rebs[i, 1].x, rebs[i, 1].y);
    if no1 = 0 then begin
      adddot(rebs[i, 1].x, rebs[i, 1].y);
      no1 := indots;
    end;
    no2 := nodot(rebs[i, 2].x, rebs[i, 2].y);
    if no2 = 0 then begin
      adddot(rebs[i, 2].x, rebs[i, 2].y);
      no2 := indots;
    end;
    addlink(no1, no2);
  end;
  fillchar(color, sizeof(color), 0);
  for i := 1 to indots do begin
    if color[i] = 0 then rec(i);
  end;
  for i := 1 to indots do
    writeln(dots[i].x, ' ', dots[i].y, ' ', color[i]);
  close(output);

end.
