{$I-,Q-,R-,S-}
type
  PType1=^Type1;
  PType2=^Type2;
  PType3=^Type3;

  Type1=record
    next:PType1;
    camefrom:PType1;
    marked:byte;
    x,y:integer;
    sm:PType2;
  end;
  Type2=record
    next:PType2;
    v:PType1;
  end;
  Type3=record
    next:PType3;
    x,y:longint;
  end;
var
  i,n:word;
  x1,y1,x2,y2:integer;
  v0,v1,v2,v,vb:PType1;
  sm:PType2;
  flag1:boolean;
  k:word;
  pe:PType3;
  s:array[0..10010] of real;

procedure addxyb(x_,y_:longint);
var
  p1:PType3;
begin
  new(p1);
  p1^.x:=x_;
  p1^.y:=y_;
  if pe<>nil then begin
    p1^.next:=pe^.next;
    pe^.next:=p1;
  end else begin
    p1^.next:=p1;
    pe:=p1;
  end;
end;

procedure addxye(x_,y_:longint);
var
  p1:PType3;
begin
  new(p1);
  p1^.x:=x_;
  p1^.y:=y_;
  if pe<>nil then begin
    p1^.next:=pe^.next;
    pe^.next:=p1;
  end else begin
    p1^.next:=p1;
    pe:=p1;
  end;
  pe:=p1;
end;

procedure addway(v1,v2:PType1);
var
  p1,p2:PType3;
  v:ptype1;
begin
  if pe<>nil then begin
    p1:=pe^.next;
    while p1<>pe do begin
      p2:=p1;
      p1:=p1^.next;
      dispose(p2);
    end;
    dispose(pe);
    pe:=nil;
  end;
  v:=v1;
  while v<>v0 do begin
    addxyb(v^.x,v^.y);
    v:=v^.camefrom;
  end;

  v:=v2;
  while v<>v0 do begin
    addxye(v^.x,v^.y);
    v:=v^.camefrom;
  end;
  addxye(v0^.x,v0^.y);

  inc(k);
  s[k]:=0;

  p1:=pe;
  repeat
    s[k]:=s[k]+(p1^.x-p1^.next^.x)*(p1^.y+p1^.next^.y)/2;
    p1:=p1^.next;
  until p1=pe;
  s[k]:=abs(s[k]);
end;

procedure gofrom(vfrom,v:PType1);
var
  sm:PType2;
begin
  if v^.marked>0 then begin
    if v^.marked=1 then
      addway(vfrom,v);
  end else begin
    v^.camefrom:=vfrom;
    v^.marked:=1;
    sm:=v^.sm;
    while sm<>nil do begin
      if sm^.v<>vfrom then
        gofrom(v,sm^.v);
      sm:=sm^.next;
    end;
    v^.marked:=2;
  end;
end;

begin
  assign(input,'input.txt');
  reset(input);
  assign(output,'output.txt');
  rewrite(output);
  readln(n);
  if n=0 then begin
    writeln(0);
    close(input);
    close(output);
    halt;
  end;

  k:=0;
  vb:=nil;
  for i:=1 to n do begin
    readln(x1,y1,x2,y2);

    v:=vb;
    flag1:=false;
    while (not (v=nil)) and (not flag1) do begin
      if (v^.x=x1) and (v^.y=y1) then begin
        flag1:=true;
        v1:=v;
      end;
      v:=v^.next;
    end;
    if not flag1 then begin
      new(v1);
      v1^.marked:=0;
      v1^.next:=vb;
      v1^.sm:=nil;
      v1^.x:=x1;
      v1^.y:=y1;
      vb:=v1;
    end;

    v:=vb;
    flag1:=false;
    while (not (v=nil)) and (not flag1) do begin
      if (v^.x=x2) and (v^.y=y2) then begin
        flag1:=true;
        v2:=v;
      end;
      v:=v^.next;
    end;
    if not flag1 then begin
      new(v2);
      v2^.marked:=0;
      v2^.next:=vb;
      v2^.sm:=nil;
      v2^.x:=x2;
      v2^.y:=y2;
      vb:=v2;
    end;

    new(sm);
    sm^.next:=v1^.sm;
    sm^.v:=v2;
    v1^.sm:=sm;

    new(sm);
    sm^.next:=v2^.sm;
    sm^.v:=v1;
    v2^.sm:=sm;
  end;

  v0:=vb;
  while v0<>nil do begin
    if (v0^.marked=0) then
      gofrom(nil,v0);
    v0:=v0^.next;
  end;

  writeln(k);
  for i:=1 to k do
    writeln(s[i]:0:6);

  close(input);
  close(output);
end.
