{$I-,Q-,R-,S-}
type
  PType1=^Type1;
  PType2=^Type2;

  Type1=record
    next:PType1;
    marked:byte;
    x,y:integer;
    sm:PType2;
  end;
  Type2=record
    next:PType2;
    v:PType1;
  end;

var
  byte1:byte;
  i,n:word;
  x1,y1,x2,y2:integer;
  v0,v1,v2,v,vb:PType1;
  sm:PType2;
  flag1:boolean;
  colors:array[1..5] of boolean;

procedure crush;
begin
  write('IMPOSSIBLE');
  close(input);
  close(output);
end;

procedure gofrom(vfrom,v:PType1);
var
  sm:PType2;
begin
  if v^.marked=0 then begin
    fillchar(colors,sizeof(colors),true);
    sm:=v^.sm;
    while sm<>nil do begin
      if sm^.v^.marked>0 then
        colors[sm^.v^.marked]:=false;
      sm:=sm^.next;
    end;
    for byte1:=1 to 5 do
      if colors[byte1] then begin
        v^.marked:=byte1;
        break;
    end;
    if v^.marked=0 then crush;
    sm:=v^.sm;
    while sm<>nil do begin
      if sm^.v<>vfrom then
        gofrom(v,sm^.v);
      sm:=sm^.next;
    end;
  end;
end;

begin
  assign(input,'input.txt');
  reset(input);
  assign(output,'output.txt');
  rewrite(output);
  readln(n);
  if n=0 then begin
    close(input);
    close(output);
    halt;
  end;

  vb:=nil;
  for i:=1 to n do begin
    readln(x1,y1,x2,y2);

    v:=vb;
    flag1:=false;
    while (not (v=nil)) and (not flag1) do begin
      if (v^.x=x1) and (v^.y=y1) then begin
        flag1:=true;
        v1:=v;
      end;
      v:=v^.next;
    end;
    if not flag1 then begin
      new(v1);
      v1^.marked:=0;
      v1^.next:=vb;
      v1^.sm:=nil;
      v1^.x:=x1;
      v1^.y:=y1;
      vb:=v1;
    end;

    v:=vb;
    flag1:=false;
    while (not (v=nil)) and (not flag1) do begin
      if (v^.x=x2) and (v^.y=y2) then begin
        flag1:=true;
        v2:=v;
      end;
      v:=v^.next;
    end;
    if not flag1 then begin
      new(v2);
      v2^.marked:=0;
      v2^.next:=vb;
      v2^.sm:=nil;
      v2^.x:=x2;
      v2^.y:=y2;
      vb:=v2;
    end;

    new(sm);
    sm^.next:=v1^.sm;
    sm^.v:=v2;
    v1^.sm:=sm;

    new(sm);
    sm^.next:=v2^.sm;
    sm^.v:=v1;
    v2^.sm:=sm;
  end;

  v0:=vb;
  while v0<>nil do begin
    if (v0^.marked=0) then
      gofrom(nil,v0);
    v0:=v0^.next;
  end;

  v0:=vb;
  while v0<>nil do begin
    writeln(v0^.x,' ',v0^.y,' ',v0^.marked);
    v0:=v0^.next;
  end;

  close(input);
  close(output);
end.
