program Math;
{$N+}
const
  maxn = 305; {305}
  eps = 1e-7;

var
  gm,gmin,gmax : array [1..maxn,1..maxn,-1..1] of real;
  ge : array [1..maxn,1..maxn,-1..1] of boolean;
  gxm : array [1..maxn,1..maxn,-1..1,0..1] of real;
  gn : array [1..maxn] of longint;
  gi : array [1..maxn,1..maxn*3] of longint;
  n : longint;

procedure Inp;
var
  i,j : longint;
  ss : longint;
  c : char;
  a : longint;
  b : extended;
begin
  assign(input,'math.in'); reset(input);
  assign(output,'math.out'); rewrite(output);
  fillchar(ge,sizeof(ge),0);
  read(n);
  fillchar(gn,sizeof(gn),0);
  for i:=1 to n do
  begin
    ge[i,i,1] := true;
    gxm[i,i,1,1] := 0;
    gxm[i,i,1,0] := 0;
    inc(gn[i]);
    gi[i,gn[i]] := i;
  end;
  for i:=1 to n do
  begin
    readln(ss);
    for j:=1 to ss do
    begin
      readln(c,b,a);
      if c='/' then 
b := 1/b;
         inc(gn[i]);
         gi[i,gn[i]] := a;
      if b>0 then
      begin
        if not ge[i,a,1] then
        begin
          ge[i,a,1] := true;
        gxm[i,a,1,0] := ln(b)/ln(10);
        gxm[i,a,1,1] := ln(b)/ln(10);
        end
        else
        begin
        if gxm[i,a,1,1] < ln(b)/ln(10) then
        begin
        gxm[i,a,1,1] := ln(b)/ln(10);
        end;
        if gxm[i,a,1,0] > ln(b)/ln(10) then
        begin
        gxm[i,a,1,0] := ln(b)/ln(10);
        end;
        end;
      end
      else if b<0 then
      begin
        if not ge[i,a,-1] then
        begin
          ge[i,a,-1] := true;
        gxm[i,a,-1,0] := ln(-b)/ln(10);
        gxm[i,a,-1,1] := ln(-b)/ln(10);
        end
        else
        begin
        if gxm[i,a,-1,1] < ln(-b)/ln(10) then
        begin
        gxm[i,a,-1,1] := ln(-b)/ln(10);
        end;
        if gxm[i,a,-1,0] > ln(-b)/ln(10) then
        begin
        gxm[i,a,-1,0] := ln(-b)/ln(10);
        end;
        end;
      end
      else
      begin
        ge[i,a,0] := true;
        gxm[i,a,0,0] := 0;
        gxm[i,a,0,1] := 0;
        inc(gn[i]);
        gi[i,gn[i]] := a;
      end;
    end;
  end;
end;

procedure relax_min(a,b,c : longint; d : extended);
begin
  if (not ge[a,b,c]) or (gm[a,b,c]>d) then
  begin
    ge[a,b,c] := true;
    gm[a,b,c] := d;
  end;
end;

procedure outnum(a : extended);
var
  k : longint;
begin
  k := - 100000000 + trunc(a+100000000);
  a := a-k;
  write(exp(ln(10)*a):0:6);
  writeln('E',k);
end;

procedure Run;
var
  i,j,k,kk,q : longint;
begin
  for i:=1 to n do
  for j:=1 to n do
  for k:=-1 to 1 do
    gm[i,j,k] := gxm[i,j,k,1];

  for q:=1 to 2 do
  for j:=1 to n do
  begin
    for kk:=1 to gn[j] do
    begin
    k := gi[j,kk];
    for i:=1 to n do
    begin
      if ge[i,j,1] and ge[j,k,1] then relax_min(i,k,1,gm[i,j,1]+gm[j,k,1]);
      if ge[i,j,-1] and ge[j,k,-1] then relax_min(i,k,1,gm[i,j,-1]+gm[j,k,-1]);
      if ge[i,j,1] and ge[j,k,-1] then relax_min(i,k,-1,gm[i,j,1]+gm[j,k,-1]);
      if ge[i,j,-1] and ge[j,k,1] then relax_min(i,k,-1,gm[i,j,-1]+gm[j,k,1]);
      if ge[i,j,0] and (ge[j,k,-1] or ge[j,k,0] or ge[j,k,1]) then ge[i,k,0] := true;
      if ge[j,k,0] and (ge[i,j,-1] or ge[i,j,0] or ge[i,j,1]) then ge[i,k,0] := true;
    end;
    end;
  end;

  gmin := gm;

  for i:=1 to n do
  for j:=1 to n do
  for k:=-1 to 1 do
    gm[i,j,k] := -gxm[i,j,1,0];

  for q:=1 to 2 do
  for j:=1 to n do
  begin
    for kk:=1 to gn[j] do
    begin
    k := gi[j,kk];
    for i:=1 to n do
    begin
      if ge[i,j,1] and ge[j,k,1] then relax_min(i,k,1,gm[i,j,1]+gm[j,k,1]);
      if ge[i,j,-1] and ge[j,k,-1] then relax_min(i,k,1,gm[i,j,-1]+gm[j,k,-1]);
      if ge[i,j,1] and ge[j,k,-1] then relax_min(i,k,-1,gm[i,j,1]+gm[j,k,-1]);
      if ge[i,j,-1] and ge[j,k,1] then relax_min(i,k,-1,gm[i,j,-1]+gm[j,k,1]);
      if ge[i,j,0] and (ge[j,k,-1] or ge[j,k,0] or ge[j,k,1]) then ge[i,k,0] := true;
      if ge[j,k,0] and (ge[i,j,-1] or ge[i,j,0] or ge[i,j,1]) then ge[i,k,0] := true;
    end;
  end;
  end;

  gmax := gm;

  for i:=1 to n do
  begin
    if ge[1,i,1] then
    begin
      if gmax[i,i,1]<-eps then writeln('INF') else
      outnum(-gmax[1,i,1]);;
    end
    else
    if ge[1,i,0] then
    begin
      writeln('0.000000E+000');
    end
    else
    if ge[1,i,-1] then
    begin
      if gmin[i,i,1]<-eps then writeln('INF') else
      begin
      write('-');
      outnum(gmin[1,i,-1]);
      end;
    end
    else
    writeln('NONE');
  end;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.
