{$I-,Q-,R-,S-}
Const
  FIn='math.in';
  FOut='math.out';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=300;
  MaxE=200000;
  MMM=MaxInt;
  Eps=1E-10;
Var
  N:LongInt;
  Mas:array[1..MaxE] of Record
    V1,V2:LongInt;
    Ch:Char;
    C:LongInt;
  end;
  Start:array[1..MaxN] of LongInt;
  Col:LongInt;
  {}
  Flag:Boolean;
  Num,R,R1:LongInt;
  P:array[1..MaxN]of Real;
  V,Max:Real;
  U:array[1..MaxN]of Boolean;
  INF:array[1..MaxN]of Boolean;

Procedure Rec(Num:LongInt);
Var R:LongInt;
begin
  INF[Num]:=True;
  R:=Start[Num];
  While Mas[R].V1=Num do
  begin
    If Not INF[Mas[R].V2] then Rec(Mas[R].V2);
    R:=R+1;
  end;
end;

Function Cmp(A,B:Real):Boolean; {A<B}
begin
  Cmp:=Eps<B-A;
end;

begin
  Init;
  {}
  Start[1]:=1;
  Col:=0;
  ReadLn(Input,N);
  For R:=1 to N do
  begin
    ReadLn(Input,R1);
    Start[R+1]:=Start[R]+R1;
    For R1:=1 to R1 do
    begin
      Col:=Col+1;
      Mas[Col].V1:=R;
      ReadLn(Input,Mas[Col].Ch,Mas[Col].C,Mas[Col].V2);
    end;
    P[R]:=-MMM;
  end;
  Start[R+1]:=0;
  {}
  P[1]:=1;
  FillChar(U,SizeOf(U),0);
  While True do
  begin
    Flag:=False;
    Max:=-MMM;
    For R:=1 to N do
     If Not U[R] then
       If (Max<P[R])and(P[R]<>MMM) then
       begin
         Num:=R;
         Max:=P[R];
         Flag:=True;
       end;
    If Not Flag then Break;
    U[Num]:=True;
    {}
    R:=Start[Num];
    While Mas[R].V1=Num do
    begin
      Case Mas[R].Ch of
        '*': V:=Max*Mas[R].C;
        '/': V:=Max/Mas[R].C;
      end;
      If U[Mas[R].V2] then
      begin
        If Cmp(P[Mas[R].V2],Abs(V)) then
        begin
          INF[Mas[R].V2]:=True;
          Rec(Mas[R].V2);
        end;
      end else
      begin
        If P[Mas[R].V2]<V then P[Mas[R].V2]:=V;
      end;
      R:=R+1;
    end;
  end;
  {}
  For R:=1 to N do
    If INF[R] then WriteLn(Output,'INF') else
    If P[R]=-MMM then WriteLn(Output,'NONE') else WriteLn(Output,P[R]);
  {}
  Done;
end.
