#include <stdio.h>
#include <stdlib.h>

#define NN 110
#define MM 1100

struct REB {
  int a;
  REB *p;
  int n;
};

struct PR {
  int l1,l2;
  int p1[NN];
  int p2[NN];
};

FILE *fi, *fo;
int n,m;
REB *g[NN];
int used[NN];
int d[NN];
int w[NN];
bool ff[NN][NN];
PR res[MM];
int k;
int qw[NN];
int head,tail;

void AddReb(int a, int b,int ind)
{
  REB *t;
  t=new REB;
  t->n=ind;
  t->a=b;
  t->p=g[a];
  g[a]=t;
}

void AddPr(int a, int b, int p)
{
  int tmp[NN];
  int i,j;
  int l,m;
  l=0;
  while(d[a]>=0)
  {
    tmp[l]=w[a];
    l++;
    a=d[a];
  }
  res[k].l1=l;
  for(i=l-1;i>=0;i--)
  {
    res[k].p1[l-i-1]=tmp[i];
  }
  l=0;
  while(d[b]>=0)
  {
    tmp[l]=w[b];
    l++;
    b=d[b];
  }
  res[k].l2=l+1;
  for(i=l-1;i>=0;i--)
  {
    res[k].p2[l-i-1]=tmp[i];
  }
  res[k].p2[res[k].l2-1]=p;
  k++;
}

/*void glub(int b, int q,int p1, int p2)
{
  REB *t;
  int i,j;
  used[b]=q;
  d[b]=p1;
  w[b]=p2;
  for(t=g[b];t!=NULL;t=t->p)
  {
    if(!used[t->a])
    {
      glub(t->a,q,b,t->n);
    }
    else
    {
       if((used[t->a]!=q)&&(!ff[q][used[t->a]]))
       {
         AddPr(t->a,b,t->n);
         ff[q][used[t->a]]=true;
         ff[used[t->a]][q]=true;
       }
    }
  }
} */

void shir()
{
  int c;
  REB *t;
  while(head<tail)
  {
    c=qw[head];
    for(t=g[c];t!=NULL;t=t->p)
    {
      if(!used[t->a])
      {
//        glub(t->a,q,b,t->n);
         used[t->a]=used[c];
         d[t->a]=c;
         w[t->a]=t->n;
         qw[tail]=t->a;
         tail++;
      }
      else
      {
         if((used[t->a]!=used[c])&&(!ff[used[c]][used[t->a]]))
         {
           AddPr(t->a,c,t->n);
           ff[used[c]][used[t->a]]=true;
           ff[used[t->a]][used[c]]=true;
         }
      }
    }
    head++;
  }
}

int main()
{
  int i,j,l;
  int xx,yy;
  int qq;
  REB *t;
  fi=fopen("comm.in","rt");
  fo=fopen("comm.out","wt");

  for(i=0;i<NN;i++)
    g[i]=NULL;
  fscanf(fi,"%i%i",&n,&m);
  for(i=0;i<m;i++)
  {
    fscanf(fi,"%i%i",&xx,&yy);
    AddReb(xx-1,yy-1,i+1);
  }
  k=0;

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
      used[j]=0;
      d[j]=-1;
      for(l=0;l<n;l++)
        ff[j][l]=false;
    }
    used[i]=10000;
    qq=1;
    head=1;
    tail=1;
    for(t=g[i];t!=NULL;t=t->p)
    {
      if(!used[t->a])
      {
        used[t->a]=qq;
        d[t->a]=i;
        w[t->a]=t->n;
        qw[tail]=t->a;
        tail++;
        qq++;
      }
      else
      {
        res[k].l1=1;
        res[k].l2=1;
        res[k].p1[0]=t->n;
        res[k].p2[0]=w[t->a];
        k++;
      }
    }
    shir();
  }

  fprintf(fo,"%i\n",k);
  for(i=0;i<k;i++)
  {
    for(j=0;j<res[i].l1;j++)
    {
      fprintf(fo,"%i ",res[i].p1[j]);
    }
    fprintf(fo,"=");
    for(j=0;j<res[i].l2;j++)
    {
      fprintf(fo," %i",res[i].p2[j]);
    }
    fprintf(fo,"\n");
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
