{$I+,Q-,R-,S+}
program         Template;

uses
  SysUtils;

var
  N, MK         : LongInt;
  S, B          : array[1..100000] of LongInt;
  Invited, II   : array[1..100000] of Boolean;
  Start         : TDateTime;

procedure       OpenFiles;
begin
  Assign(Input, 'beauty.in');
  Reset(Input);
  Assign(Output, 'beauty.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : LongInt;
begin
  ReadLn(N);
  for I := 1 to N do
    ReadLn(S[I], B[I]);
end;

function        CanInvite(M: LongInt): Boolean;
var
  I             : LongInt;
begin
  CanInvite := False;
  for I := 1 to N do
    if Invited[I] and (((B[I] >= B[M]) and (S[I] <= S[M])) or ((B[I] <= B[M]) and (S[I] >= S[M]))) then
      Exit;

  CanInvite := True;
end;

procedure       Answer;
var
  I             : LongInt;
begin
  WriteLn(MK);
  if MK > 0 then
    for I := 1 to N do begin
      if II[I] then begin
        Write(I);
        Dec(MK);

        if MK > 0 then
          Write(' ')
        else
          WriteLn;
      end;
    end;

  CloseFiles;
  Halt;
end;

procedure       Rec(IK: LongInt);
var
  I             : LongInt;
  Flag          : Boolean;
begin
  if (Time - Start) * 86400 >= 1.7 then
    Answer;

  Flag := True;
  for I := 1 to N do
    if not Invited[I] and CanInvite(I) then begin
      Invited[I] := True;
      Rec(IK + 1);
      Invited[I] := False;

      Flag := False;
    end;

  if Flag then
    if IK > MK then begin
      MK := IK;
      Move(Invited, II, SizeOf(II));
    end;
end;

procedure       Solve;
var
  I             : LongInt;
begin
  FillChar(Invited, SizeOf(Invited), 0);

  Start := Time;

  MK := 0;

  for I := 1 to N do begin
    Invited[I] := True;

    Rec(1);

    Invited[I] := False;
  end;

  Answer;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
