{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_b;
const
  inpfile='beauty.in';
  outfile='beauty.out';
  nm=10005;
type
  Gentle=record
    s,b,n : LongInt;
  end;
var
  a : array [1..nm] of Gentle;
  rs,rb : array [1..nm] of LongInt;
  ks,kb : LongInt;
  n : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do
  begin
    read(a[i].s,a[i].b);
    a[i].n:=i;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ks>=kb then
  begin
    writeln(ks);
    for i:=1 to ks do write(rs[i],' ');
  end else
  begin
    writeln(kb);
    for i:=1 to kb do write(rb[i],' ');
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
end;
{}
Procedure Swap(var q,w : Gentle);
var
  bak : Gentle;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure SortS(l, r: LongInt);
var
  i, j, x: LongInt;
begin
  i := l; j := r; x := a[(l+r) DIV 2].s;
  repeat
    while a[i].s < x do i := i + 1;
    while x < a[j].s do j := j - 1;
    if i <= j then
    begin
      if (a[i].s=a[j].s)and(a[i].b>a[j].b)or(a[i].s>a[j].s)
      then Swap(a[i],a[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortS(l, j);
  if i < r then SortS(i, r);
end;

{}
Procedure SortB(l, r: LongInt);
var
  i, j, x: LongInt;
begin
  i := l; j := r; x := a[(l+r) DIV 2].b;
  repeat
    while a[i].b < x do i := i + 1;
    while x < a[j].b do j := j - 1;
    if i <= j then
    begin
      if (a[i].b=a[j].b)and(a[i].s>a[j].s)or(a[i].b>a[j].b)
      then Swap(a[i],a[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortB(l, j);
  if i < r then SortB(i, r);
end;

{}

Procedure Solve;
var
  i,j : LongInt;
  ns,nb : LongInt;
begin
  SortS(1,n); ns:=1;
  ks:=1; rs[1]:=a[1].n;
  for i:=2 to n do
  begin
    if (a[i].s>a[ns].s) and (a[i].b>a[ns].b) then
    begin
      inc(ks); ns:=i;
      rs[ks]:=a[i].n;
    end;
  end;

  {}
  SortB(1,n); nb:=1;
  kb:=1; rb[1]:=a[1].n;
  for i:=2 to n do
  begin
    if (a[i].s>a[nb].s) and (a[i].b>a[nb].b) then
    begin
      inc(kb); nb:=i;
      rb[kb]:=a[i].n;
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
