const eps = 1e-10;

var n,m: double;
    k: longint;

procedure Solve;
var b,c,d,x: double;
begin
  if m=1 then k:=1 else begin
    b:=-(m+n+1);
    c:=m*n-1;
    d:=b*b-4*c;
    x:=(-b-sqrt(d))/2;
    k:=trunc(x);
    if frac(x)>eps then inc(k);
  end;
end;

procedure Save;
var f: text;
begin
  Assign(f,'rooks.out');
  Rewrite(f);
  WriteLn(f,k);
  Close(f);
end;

procedure Load;
var f: text;
    t: double;
begin
  Assign(f,'rooks.in');
  reset(f);
  Read(f,n,m);
  if m>n then begin
    t:=m;
    m:=n;
    n:=t;
  end;
  Close(f);
end;

Begin
  Load;
  Solve;
  Save;
End.