#include <stdio.h>
long s[100000L],b[100000L],*A,n,k[100000L],*An,bn[100000L],
sn[100000L],size,*T,bc[100000L],sc[100000L],kc[100],kn[100],num,
bb[100000L],a[100000L],t[100000L];
void read(void)
{
  long i;
  scanf("%ld",&n);
  for(i=1;i<=n;i++)
  {
	sc[i]=sn[i]=bc[i]=bn[i]=i;
	scanf("%ld%ld",&s[i],&b[i]);
  }
}
long max(long a,long b)
{
  if(a>b)return a;
  return b;
}
long parent( long i )
{
  return i / 2;
}

long left( long i )
{
  return 2 * i;
}

long right( long i )
{
  return 2 * i + 1;
}

void sift_down( long i )
{
  while (1)
  {
	long smallest = i;
	long l, r;
	long x;

	l = left(i);
	if ((l <= size) && (A[smallest] > A[l]))
	  smallest = l;
	r = right(i);
	if ((r <= size) && (A[smallest] > A[r]))
	  smallest = r;
	if (i == smallest)
	  break;
	x = A[i];
	A[i] = A[smallest];
	A[smallest] = x;
	x = An[i];
	An[i] = An[smallest];
	An[smallest] = x;
	T[An[i]]=i;
	i = smallest;
	T[An[smallest]]=smallest;
  }
}

void sift_up( long i )
{
  long x = A[i],y=An[i];

  while ((i > 1) && (A[parent(i)] > x))
  {
	A[i] = A[parent(i)];
	An[i] = An[parent(i)];
	i = parent(i);
  }
  A[i] = x;
  An[i] = y;
}

void insert( long x )
{
  size++;
  A[size] = x;
  sift_up(size);
}

long get_min( void )
{
  return A[1];
}

long extract_min( void )
{
  long x = get_min();

  A[1] = A[size];
  An[1]=An[size];
  T[An[1]]=1;
  size--;
  sift_down(1);
  return x;
}

void increase_key( long i, long x )
{
  A[i] = x;
  sift_down(i);
}

void decrease_key( long i, long x )
{
  A[i] = x;
  sift_up(i);
}

void change_key( long i, long x )
{
  if (A[i] > x)
	decrease_key(i, x);
  else
	increase_key(i, x);
}

void delete( long i )
{
  long x = A[size];

  size--;
  change_key(i, x);
}

void build( void )
{
  long i;

  for (i = size; i > 0; i--)
	sift_down(i);
}

void sort( void )
{
  long i,x;

  build();
  for (i = size; i > 0; i--)
  {
	x=An[1];
	A[i]=extract_min();
	An[i]=x;
	T[An[i]]=i;
  }
}
long find(long x)
{
  long r=1,l=num,m;
  if(s[bc[x]]>s[bc[1]])
  {
	a[bc[x]]=num+1;
	bb[num+1]=s[bc[x]];
	num++;
	t[num]=0;
	return num;
  }
  while(1)
  {
	if(l==r)
	{
	  if(s[bc[x]]<bb[l])
	  {
		//s[bc[x]]=l;
		a[bc[x]]=l;
		bb[l]=s[bc[x]];
		return l;
	  }
	  return -1;
	}
	m=(l+r)/2;
	if(s[bc[x]]>bb[m])
	  r=m;
	else
	  l=m;
  }
}
void solve(void)
{
  long i,last,count,w[100/*000L*/],j,m;
  size=n;
  A=b; An=bn; T=bc;
  sort();
  /*
  for(i=2;i<=n;i++)
	if(b[i]==b[i-1])
	  bc[i]=bc[i-1];
  for(i=2;i<=n;i++)
	if(s[i]==s[i-1])
	  sc[i]=sc[i-1];
  */
  t[1]=a[1]=1;
  num=1;
  bb[1]=s[bc[1]];
  for(i=2;i<=n;i++)
  {
	j=find(i);
	a[i]=j;
	if(j!=-1)
	  t[j]++;
  }
  m=1;
  for(i=2;i<=n;i++)
	if(t[m]<t[i])
	  i=m;
  printf("%ld\n",t[m]);
  for(i=1;i<=n;i++)
	if(a[i]==m)
	  printf("%ld ",bc[i]);
}
long main(void)
{
  freopen("beauty.in","rt",stdin);
  freopen("beauty.out","wt",stdout);
  read();
  solve();
  return 0;
}
