{$I-,Q-,R-,S-}
const
  inputfile = 'rooks.in';
  outputfile = 'rooks.out';
  maxn = 101;
  eps = 1e-7;

type
  int = integer;
  bool = boolean;
  real = extended;

var
  n, m, k, down, up, mid: int;
  x: real;

function min(a, b: int): int;
begin
  if(a < b)then
    min  := a
  else
    min := b;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n, m);
  down := 1;
  up := min(n, m);
  k := 1;
  while(down + 1 < up)do begin
    k := (down + up) div 2;
    x := (n - k + 1) * (m - k + 1) / k;
    if(x + eps > 1.0)then
      down := k
    else
      up := k;
  end;

  x := (n - up + 1) * (m - up + 1) / k;
  if(x + eps >= 1.0)then
    k := up
  else
   k := down;
  write(k);

  close(output);
  close(input);
end.