{$define debug}

program template;
uses
 save;
const
 h = 101000;
 months : array [0..11] of string =
  ('January',
  'February',
  'March',
  'April',
  'May',
  'June',
  'July',
  'August',
  'September',
  'October',
  'November',
  'December');
type
 int = longint;
 real = int;
var
 n :int;
 ans :int;
 last :real;
 first :real;
 q :int;
 d :array [1..h] of string;

procedure init;
begin
 ans := 0;
 fillchar (d,sizeof(d),0);
end;

function mn (s :string):int;
var i :int;
begin
 mn := 0;
 for i := 0 to 11 do
  if months[i] = s then
   begin
    mn := i;
    exit;
   end;
end;

function number (s :string):real;
var month :string;
    day :int;
    h,m,s_ :int;
    space :int;
    i,j :int;
begin
 space := 0;
 month := '';
 day := 0;
 h := 0;
 m := 0;
 s_ := 0;
 for i := 1 to length(s) do
  begin
   if (s[i] = ' ') or (s[i] = ':') then
    begin
     inc (space);
     continue;
    end;
   case space of
    0: day := day*10 + ord(s[i]) - ord('0');
    1: month := month + s[i];
    2: h := h*10 + ord(s[i]) - ord('0');
    3: m := m*10 + ord(s[i]) - ord('0');
    4: s_ := s_*10 + ord(s[i]) - ord('0');
   end;
  end;
 number := s_ + 60*m + 3600*h + 90000*day + 3000000*mn(month);
end;

function loadgame_ (v :int):string;
begin
 if length(d[v]) > 0 then
  loadgame_ := d[v]
 else
  begin
   d[v] := loadgame(v);
   loadgame_ := d[v];
  end;
end;

procedure solve;
var i,j :int;
    l,r :int;
    mid :int;
    t :int;
begin
 last := number (loadgame_ (n));
 first := number (loadgame_ (1));
 if first < last then
  begin
   lastgame (n);
   halt;
  end;
 l := 1;
 r := n;
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   t := number (loadgame_ (mid));
   if t > last then
    l := mid
   else
    r := mid;
  end;
 if number(loadgame_(l)) > number(loadgame_(r)) then
  ans := l
 else
  ans := r;
 lastgame (ans);
end;


begin
 init;
 n := getslotnumber;
 solve;
end.