{.$define debug}

program template;
const
 {$ifdef debug}
 h = 15;
 cinfile = 'input.txt';
 coutfile = '';
 {$else}
 h = 102;
 cinfile = '';
 coutfile = '';
 {$endif}
type
 int = longint;
 tsubject = record
  name :string;
  s :boolean;
 end;
 tdoing = record
  name :string;
  obj :string;
 end;
const
 nobody :tsubject =
  (name:'nobody';s:true);
 everybody :tsubject =
  (name:'everybody';s:true);
 i_ :tsubject =
  (name:'I';s:false);
 you :tsubject =
  (name:'you';s:false);
 {======}
 dont = 'don''t';
 doesnt = 'doesn''t';
 do_ = 'do';
 does_ = 'does';
 what_ = 'what';
 who_ = 'who';
 maybe = 'maybe.';
 abroad = 'I''m abroad.';
 dontknow = 'I don''t know.';
 {=======}
 _nobody = -2;
 _everybody = -1;
 _i = -3;
 _you = -4;
var
 n,m :int;
 ans :int;
 doing :array [1..h] of tdoing;
 subject :array [-4..h] of tsubject;
 gr :array [1..h,-4..h] of int;
 s :string;

procedure init;
begin
 ans := 0;
 n := 0;
 m := 0;
 fillchar (doing,sizeof(doing),0);
 fillchar (subject,sizeof(subject),0);
 fillchar (gr,sizeof(gr),0);
 subject[_i] := i_;
 subject[_you] := you;
 subject[_nobody] := nobody;
 subject[_everybody] := everybody;
end;

function haves (s :string):boolean;
begin
 haves := s[length(s)] = 's';
end;

function searchsubj (subj :string; s :boolean):int;
var i :int;
begin
 if subj = nobody.name then
  begin
   searchsubj := _nobody;
   exit;
  end;
 if subj = everybody.name then
  begin
   searchsubj := _everybody;
   exit;
  end;
 if subj = i_.name then
  begin
   searchsubj := _i;
   exit;
  end;
 if subj = you.name then
  begin
   searchsubj := _you;
   exit;
  end;
 for i := 1 to m do
  if subject[i].name = subj then
   begin
    searchsubj := i;
    exit;
   end;
 inc(m);
 subject[m].name := subj;
 subject[m].s := s;
 searchsubj := m;
end;

function searchpred (pred :string; ob :string):int;
var i :int;
begin
 for i := 1 to n do
  if (doing[i].name = pred) and (doing[i].obj = ob) then
   begin
    searchpred := i;
    exit;
   end;
 inc (n);
 doing[n].name := pred;
 doing[n].obj := ob;
 searchpred := n;
end;

procedure add (subj :string; s :boolean; pred :string; ob :string;
                value :int);
var t1,t2 :int;
begin
 while (ob[length(ob)] = ' ') do
  delete(ob,length(ob),1);
 t1 := searchsubj (subj,s);
 if s then
  delete (pred,length(pred),1); {deletes letter "s"}
 t2 := searchpred (pred,ob);
 if gr[t2,t1] <> 0 then
  gr[t2,t1] := 3
 else
  gr[t2,t1] := value;
end;


procedure sentence (s :string);
var s_ :array [1..4] of string;
    space :int;
    i,j :int;
begin
 fillchar (s_,sizeof(s_),0);
 space := 1;
 for i := 1 to length(s)-1 do
  begin
   if ((s[i] = ' ') and not ((i=1) or (s[i-1] = ' '))) and (space < 4) then
    inc (space);
   if not (s[i] = ' ') then
    begin
     if space < 4 then
      s_[space] := s_[space] + s[i]
     else
      s_[4] := s_[4] + s[i];
    end;
  end;
 if (s_[2] = dont) or (s_[2] = doesnt) then
  begin
   if s_[2] = doesnt then
    add (s_[1],true,s_[3],s_[4],-1)
   else
    add (s_[1],false,s_[3],s_[4],-1);
  end
  else
    add (s_[1],haves(s_[2]),s_[2],s_[3]+' '+s_[4],1);
end;

function letter (b :boolean):string;
begin
 if b  then
  letter := 's'
 else
  letter := '';
end;

function minus (b :boolean):string;
begin
 if b then
  minus := doesnt
 else
  minus := dont;
end;

function bb (s :string):string;
begin
 if not (s = '') then
  bb := ' '+s
 else
  bb := '';
end;

function dodoes (subj :string; pred :string; obj :string):string;
var t1,t2 :int;
    i :int;
    s :boolean;
begin
 while obj[length(obj)] = ' ' do
  delete (obj,length(obj),1);
 while obj[1] = ' ' do
  delete (obj,1,1);
 t1 := 0;
 t2 := 0;
 if subj = everybody.name then
  begin
   t1 := _everybody;
   s := everybody.s;
  end
 else
  if subj = nobody.name then
   begin
    t1 := _nobody;
    s := nobody.s;
   end
 else
  if subj = i_.name then
   begin
    t1 := _i;
    subj := you.name;
    s := i_.s;
   end
 else if subj = you.name then
   begin
    t1 := _you;
    subj := i_.name;
    s := you.s;
   end
 else
 for i := 1 to m do
  if subject[i].name = subj then
   begin
    t1 := i;
    s := subject[t1].s;
    break;
   end;
 for i := 1 to n do
  if (doing[i].name = pred) and (doing[i].obj = obj) then
   begin
    t2 := i;
    break;
   end;
 if (gr[t2,_everybody] = 1) and not (gr[t2,t1] = -1) then
  begin
   dodoes := 'yes, '+subj+' '+pred+letter(s)+bb(obj)+'.';
   exit;
  end;
 if (gr[t2,_nobody] = 1) and not (gr[t2,t1] = 1) then
  begin
   dodoes := 'no, '+subj+' '+minus(s)+' '+pred+bb(obj)+'.';
   exit;
  end;


 if (t1 = 0) or (t2 = 0) or
  (gr[t2,t1] = 0) then
   begin
    dodoes := maybe;
    exit;
   end;
 if (gr[t2,t1] = 3) or ((gr[t2,t1] = 1) and (gr[t2,_nobody]=1)) or
   ((gr[t2,t1] = -1) and (gr[t2,_everybody] = 1))
    then
  begin
   dodoes := abroad;
   exit;
  end;
 if gr[t2,t1] = 1 then
  dodoes := 'yes, '+subj+' '+pred+letter(subject[t2].s)+bb(obj)+'.'
 else
  dodoes := 'no, '+subj+' '+minus(subject[t2].s)+' '+pred+bb(obj)+'.';
end;

procedure who (pred :string; obj :string);
var i :int;
    t1 :int;
    bad,good :int;
    man :array [1..h] of int;
    k :int;
begin
 if pred[length(pred)] = 's' then
  delete (pred,length(pred),1);
 while obj[length(obj)] = ' ' do
  delete (obj,length(obj),1);
 t1 := 0;
 for i := 1 to n do
  if (doing[i].name = pred) and (doing[i].obj = obj) then
   begin
    t1 := i;
    break;
   end;
 if t1 = 0 then
  begin
   writeln (dontknow);
   exit;
  end;
 bad := gr[t1,_nobody];
 good := gr[t1,_everybody];
 if ((bad + good) = 2) then
  begin
   writeln (abroad);
   exit;
  end;
 fillchar (man,sizeof(man),0);
 k := 0;
 for i := 1 to m do
  if gr[t1,i] = 1 then
   begin
    inc(k);
    man[k] := i;
   end;
 if gr[t1,_i] = 1 then
  begin
   inc (k);
   man[k] := _you;
  end;
 if gr[t1,_you] = 1 then
  begin
   inc (k);
   man[k] := _i;
  end;
 if k = 0 then
  begin
   if bad > 0 then
    writeln (nobody.name+' '+pred+'s'+bb(obj),'.');
   if good > 0 then
    writeln (everybody.name+' '+pred+'s'+bb(obj),'.');
   exit;
  end;
 if good > 0 then
  begin
   writeln (everybody.name+' '+pred+'s'+bb(obj),'.');
   exit;
  end;
 if (bad > 0) and (k > 0) then
  begin
   writeln (abroad);
   exit;
  end;
 if k = 1 then
  begin
   writeln (subject[man[1]].name,' ',pred+letter(subject[man[1]].s)+bb(obj),'.');
   exit;
  end;
 for i := 1 to k-2 do
  write (subject[man[i]].name,', ');
 write (subject[man[k-1]].name,' and ',subject[man[k]].name);
 write (' ',pred);
 if not (obj = '') then
  write (' ',obj);
 writeln ('.');
end;

procedure what (subj :string; s :boolean);
var i :int;
    d :array [1..h] of int;
    v :array [1..h] of int;
    k :int;
    t1 :int;
begin
 for i := -4 to m do
  if subject[i].name = subj then
   begin
    t1 := i;
    break;
   end;
 if t1 = _i then
  subj := you.name;
 if t1 = _you then
  subj := i_.name;
 if t1 = 0 then
  begin
   writeln (dontknow);
   exit;
  end;
 fillchar (d,sizeof(d),0);
 fillchar (v,sizeof(v),0);
 k := 0;
 for i := 1 to n do
  begin
   if not (gr[i,t1] = 0) then
    begin
     inc (k);
     d[k] := i;
     v[k] := gr[i,t1];
    end
   else
    if (gr[i,_nobody] = 1) and (gr[i,_everybody] = 0) then
     begin
      inc (k);
      d[k] := i;
      v[k] := -1;
     end
    else
     if gr[i,_everybody] = 1 then
      begin
       inc (k);
       d[k] := i;
       v[k] := 1;
      end;
  end;
 write (subj,' ');
 for i := 1 to k-1 do
  begin
   if v[i] = -1 then
    begin
     write (minus(s),' ',doing[d[i]].name);
     if doing[d[i]].obj <> '' then
      write (' ',doing[d[i]].obj,', ')
     else
      write (', ');
    end
   else
    begin
     write (doing[d[i]].name+letter(s));
     if doing[d[i]].obj <> '' then
      write (' ',doing[d[i]].obj,', ')
     else
      write (', ');
    end;
  end;
 write ('and ');
 if v[k] = -1 then
  write (minus(s),' ',doing[d[k]].name)
 else
  write (doing[d[k]].name+letter(s));
 if doing[d[k]].obj <> '' then
  write (' ',doing[d[k]].obj);
 writeln('.');
end;

procedure question (s :string);
var i,j :int;
    s_ :array [1..4] of string;
    space :int;
begin
 space := 1;
 fillchar (s_,sizeof(s_),0);
 for i := 1 to length(s)-1 do
  begin
   if ((s[i] = ' ') and not ((i=1) or (s[i-1] = ' '))) and (space < 4) then
    inc (space);
   if not (s[i] = ' ') or (space = 4) then
    begin
     if space < 4 then
      s_[space] := s_[space] + s[i]
     else
      s_[4] := s_[4] + s[i];
    end;
  end;
 if (s_[1] = do_) or (s_[1] = does_) then
  begin
   writeln (dodoes (s_[2],s_[3],s_[4]));
   exit;
  end;
 if s_[1] = who_ then
  begin
   who(s_[2],s_[3]+' '+s_[4]);
   exit;
  end;
 if s_[1] = what_ then
  begin
   what (s_[3],haves(s_[2]));
   exit;
  end;
end;

begin
 init;
 {$ifdef debug}
 assign (input,cinfile);
 reset (input);
 assign (output,coutfile);
 rewrite (output);
 {$endif}
 while not eof do
  begin
   readln (s);
   if s[length(s)] = '!' then
    break;
   if s[length(s)] = '.' then
    sentence (s);
   if s[length(s)] = '?' then
    question (s);
   end;
 {$ifdef debug}
 close (input);
 close (output);
 {$endif}
end.