{$I+,Q-,R-,S+}
program         Template;

var
  N, S, LM, CC  : Integer;
  A, B          : array[1..1000] of Integer;

procedure       OpenFiles;
begin
  Assign(Input, 'input.txt');
  Reset(Input);
  Assign(Output, 'output.txt');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : Integer;
begin
  ReadLn(N, S);
  for I := 1 to N do
    ReadLn(A[I], B[I]);
end;

(** CUT HERE ******************************************************************

procedure       QSort(L, R: Integer);
var
  I, J, X, T    : Integer;
begin
  I := L; J := R; X := A[(L + R) div 2];
  repeat
    while A[I] < X do
      Inc(I);
    while A[J] > X do
      Dec(J);

    if I <= J then begin
      if (A[I] > A[J]) or ((A[I] = A[J]) and (B[I] > B[J])) then begin
        T := A[I];
        A[I] := A[J];
        A[J] := T;

        T := B[I];
        B[I] := B[J];
        B[J] := T;
      end;

      Inc(I);
      Dec(J);
    end;
  until I > J;

  if I < R then
    QSort(I, R);
  if L < J then
    QSort(L, J);
end;

***************************************************************** CUT HERE **)

procedure       Solve;
var
  I, J, Temp    : Integer;
begin
  {
    QSort(1, N);
    QSort(1, N);
  }

  if N > 1 then
    for I := 1 to N - 1 do
      for J := 1 to N - 1 do
        if (A[J] > A[J + 1]) or ((A[J] = A[J + 1]) and (B[J] > B[J + 1])) then begin
          Temp := A[J + 1];
          A[J + 1] := A[J];
          A[J] := Temp;

          Temp := B[J + 1];
          B[J + 1] := B[J];
          B[J] := Temp;
        end;

  LM := A[1]; CC := 0;
  for I := 1 to N do begin
    if LM < A[I] then
      LM := A[I];

    if LM <= B[I] then begin
      Inc(CC);
      Inc(LM);
    end;
  end;

  WriteLn(CC);
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
