{$I+,Q-,R-,S-}
const
  inputfile = 'input.txt';
  outputfile = 'output.txt';
  maxn = 1101;

type
  int = longint;
  bool = boolean;

var
  n, i, j, max: int;
  a, b, l, c: array[1..maxn]of int;

procedure quicksort(l, r: int);
var
  w, x, i, j, d, y: int;
begin
  i := l;
  j := r;
  d := i + random(j - i + 1);
  x := b[d];
  y := a[d];
  repeat
    while(x > b[i])or(x = b[i])and(a[i] < y)do
      inc(i);
    while(x < b[j])or(x = b[j])and(a[j] > y)do
      dec(j);
    if(i <= j)then begin
      w := a[i];
      a[i] := a[j];
      a[j] := w;

      w := b[i];
      b[i] := b[j];
      b[j] := w;

      inc(i);
      dec(j);
    end;
  until i > j;

  if(i < r)then
    quicksort(i, r);
  if(l < j)then
    quicksort(l, j);
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n, i);
  for i := 1 to n do
    read(a[i], b[i]);

  quicksort(1, n);

  c[1] := 1;
  l[1] := a[1];
  max := 1;
  for i := 2 to n do
    for j := 1 to i - 1 do
      if(l[j] + 1 <= b[i])and(c[j] + 1 > c[i])then begin
        if(l[j] + 1 >= a[i])then
          l[i] := l[j] + 1
        else
          l[i] := a[i];
        c[i] := c[j] + 1;
        if(c[i] > max)then
          max := c[i];
      end;

  write(max);
  close(output);
  close(input);
end.