#include <stdio.h>
#include <string.h>

int gd(char *c)
{
  if(!strcmp(c, "MON"))
    return 0;
  if(!strcmp(c, "TUE"))
    return 1;
  if(!strcmp(c, "WED"))
    return 2;
  if(!strcmp(c, "THU"))
    return 3;
  if(!strcmp(c, "FRI"))
    return 4;
  if(!strcmp(c, "SAT"))
    return 5;
  if(!strcmp(c, "SUN"))
    return 6;
  
  return 0;
}

int main()
{
  int n, m;
  int rov[301][301];
  int res[301];
  
  
  scanf("%d %d ", &m, &n);
  
  while(n || m)
  {
    char aa[4], bb[4];
    int q;
    
    
    memset(rov, 0, sizeof(rov));
    
    int i,j,k,l;
    
    for(i=0; i<n; i++)
    {
      scanf("%d %s %s ", &q, aa, bb);
      
      res[i]=(8+gd(bb)-gd(aa))%7;
      
      for(j=0; j<q; j++)
      {
        scanf("%d ", &k);
        
        rov[i][k-1]++;
        rov[i][k-1]%=7;
      }
    }
    
    int rev[7];
    
    rev[0]=0;
    rev[1]=1;
    rev[2]=4;
    rev[3]=5;
    rev[4]=2;
    rev[5]=3;
    rev[6]=6;
    
    int u;
    
    for(i=0, j=0; i<n && j<m; j++)
    {
      for(k=i; k<n; k++)
        if(rov[k][j]!=0)
          break;
      if(k==n)
        continue;
      
      if(k!=i)
      {
        for(l=0; l<m; l++)
          u=rov[i][l], rov[i][l]=rov[k][l], rov[k][l]=u;
        
        u=res[i]; res[i]=res[k]; res[k]=u;
      }
      
      u=rov[i][j];
      
      for(l=0; l<m; l++) rov[i][l]=(rov[i][l]*rev[u])%7;
      res[i]=(res[i]*rev[u])%7;
      
      for(k=0; k<n; k++)
        if(k!=i && rov[k][j]!=0)
      {
        u=rov[k][j];
        
        for(l=0; l<m; l++)
          rov[k][l]=(49+rov[k][l]-u*rov[i][l])%7;
        res[k]=(49+res[k]-u*res[i])%7;
      }
      
      i++;
    }
    
    int grr=0;
    
    if(n>=m)
    {
      for(i=0; i<m; i++)
        if(rov[i][i]!=1)
          break;
      
     if(i==m)
     {
      
      for(; i<n; i++)
      {
        int good=0;
        
        for(j=0; j<m; j++)
          good+=rov[i][j]*res[j];
        
        if(good%7!=res[i])
        {
          printf("Inconsistent data.\n");
          goto end;
        }
      }

      for(i=0; i<m; i++)
        printf("%d%s", (res[i]+4)%7+3, (i==m-1)?"\n":" ");
      
      goto end;
     }
    }
    
    for(i=0; i<n; i++)
    {
      int empty=1;
      int poc=0;
      for(j=0; j<m; j++)
        if(rov[i][j])
        {
          poc++;
          empty=0;
          break;
        }
      
      if(empty && res[i])
      {
        printf("Inconsistent data.\n");
        goto end;
      }
      
      if(poc>=2)
        grr++;
    }
    
    printf("Multiple solutions.\n");

    end:
    
    scanf("%d %d ", &m, &n);
  }
  
  return 0;
}
