#include <stdio.h>
#include <string.h>

int n, m;
int mat[310][310];

int gd (char * c) {
  if (c[0] == 'M') {
    return 1;
  };
  if (c[2] == 'E') {
    return 2;
  };
  if (c[0] == 'W') {
    return 3;
  };
  if (c[2] == 'U') {
    return 4;
  };
  if (c[0] == 'F') {
    return 5;
  };
  if (c[2] == 'T') {
    return 6;
  };
  return 7;
};

int div (int a, int b) {
  for (int i = 0; i < 7; i ++) {
    if ((i * b) % 7 == a % 7) {
      return i;
    };
  };
  return 0;
};

void swap (int a, int b) {
  int tmp;
  for (int i = 0; i <= n; i ++) {
    tmp = mat[a][i];
    mat[a][i] = mat[b][i];
    mat[b][i] = tmp;
  };
  return;
};

void sub (int a, int b, int c) {
  for (int i = 0; i <= n; i ++) {
    mat[a][i] = (mat[a][i] - mat[b][i] * c + 49) % 7;
  };
};

int main () {
  scanf ("%d %d", &n, &m);
  while (n != 0 || m != 0) {
    memset (mat, 0, sizeof (mat));
    for (int i = 0; i < m; i ++) {
      int num;
      char d1[100], d2[100];
      scanf ("%d %s %s", &num, &d1, &d2);
      mat[i][n] = (8 + gd (d2) - gd(d1)) % 7;
      int c;
      for (int j = 0; j < num; j ++) {
	scanf ("%d", &c);
	mat[i][c - 1] ++;
      };
      for (int j = 0; j < n; j ++) {
	mat[i][j] %= 7;
      };
    };
    bool mult = false;
    int row = 0;
    for (int i = 0; i < n; i ++) {
      bool did = false;
      for (int j = row; j < m; j ++) {
	if (mat[j][i] != 0) {
	  swap (row, j);
	  did = true;
	  break;
	};
      };
      if (did == false) {
	mult = true;
      } else {
        sub (row, row, div ((mat[row][i] + 6) % 7, mat[row][i]));
        for (int j = 0; j < m; j ++) {
	  if (row != j) {
	    sub (j, row, div (mat[j][i], mat[row][i]));
	  };
        };
	row ++;
      };
    };
    bool inc = false;
    for (int i = row; i < n; i ++) {
      if (mat[i][n] != 0) {
	printf ("Inconsistent data.\n");
	inc = true;
	break;
      };
    };
    if (inc == false) {
      for (int i = n; i < m; i ++) {
        if (mat[i][n] != 0) {
	  printf ("Inconsistent data.\n");
	  inc = true;
	  break;
        };
      };
    };
    if (inc == false) {
      if (mult || n > m) {
	printf ("Multiple solutions.\n");
      } else {
	for (int i = 0; i < n; i ++) {
	  if (i > 0) {
	    printf (" ");
	  };
	  if (mat[i][n] < 3) {
	    printf ("%d", mat[i][n] + 7);
	  } else {
	    printf ("%d", mat[i][n]);
	  };
	};
	printf ("\n");
      };
    };
    scanf ("%d %d", &n, &m);
  };
  return 0;
};
