#include <cstdio>
#include <algorithm>
#include <iterator>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;

#define MP make_pair
#define FOR(i,a,b) for(int i=a; i<=b; ++i)
#define FORD(i,a,b) for(int i=a; i>=b; --i)
#define REP(i,n) for(int i=0;i<n; ++i)
#define VAR(v,i) __typeof(i) v=(i)
#define FOREACH(i,c) for(VAR(i,(c).begin()); i!=(c).end(); ++i)
#define PB push_back
#define ST frirst
#define ND second
#define ALL(c) c.begin(),c.end()
#define SIZE(x) (int)x.size()

#define P 7

int Rev[] = {0,1,4,5,2,3,6};

int Gauss(vector<vector<int> > &a, vector<int>& b, vector<int>& x) {
    int m=a.size(), n= a[0].size(), k,r;
    vector<int> q;
    for(k=0; k < min(m,n); k++) {
	int i,j;
	for(j=k;j<n;j++)
	for(i=k;i<m;i++)
	if (a[i][j] != 0) goto FOUND;
	break;
	FOUND:
	if (j != k) REP(t,m) swap(a[t][j], a[t][k]);
	q.push_back(j);
	if (i!=k) {swap(a[i],a[k]); swap(b[i], b[k]);}
	FOR(j,k+1,m-1) if (a[j][k]!=0) {
	    int l =(a[j][k]*Rev[a[k][k]]) % P;
	    FOR(i,k+1,n-1) a[j][i] = (P+a[j][i] - (l*a[k][i]) % P) % P;
	    b[j] = (P+b[j]-(l*b[k])%P)%P;
	}
    }
    r=k;
    x.clear(); x.resize(n,0);
    FOR(k,r,m-1) if (b[k] != 0) return -1;
    FORD(k,r-1,0) {
	int s = b[k];
	FOR(j,k+1,r-1) s = (P+s-(a[k][j] * x[j]) % P) % P;
	x[k] = (s*Rev[a[k][k]] ) % P;
    }
    FORD(k,r-1,0) swap(x[k], x[q[k]]);
    return n-r;
}

int Day(char *d) {
    if (d[0]=='M' ) return 0;
    if (d[0]=='T' && d[1]=='U') return 1;
    if (d[0]=='W') return 2;
    if (d[0]=='T') return 3;
    if (d[0]=='F') return 4;
    if (d[0]=='S' && d[1]=='A') return 5;
    if (d[0]=='S') return 6;
}

int main(){  
    int size,ile,ill;
    while(1) {
	scanf("%d %d", &size, &ile);
	vector<vector<int> > a(ile, size);
	vector<int> b(ile),x;
	if(size+ile==0) break;
	REP(x,ile) {
	    char d1[10], d2[10];
	    scanf("%d %s %s", &ill, d1, d2);
	    int Len = (7+1+Day(d2)-Day(d1)+4*ill) % 7;
	    b[x]=Len; //printf("%d %d %d %d\n", Len, Day(d2), Day(d1), ill);
//	    int vlen=Len;
	    REP(y, ill) {
		int val;
		scanf("%d", &val);
		a[x][val-1]++;
	    }
	    
	}
        REP(x,ile) REP(y,size) a[x][y]=a[x][y] % 7;
	int res = Gauss(a,b,x);
	if (res==-1) printf("Inconsistent data.\n"); else
	if (res > 0) printf("Multiple solutions.\n"); else
	{
	    REP(xx,size) printf("%d ", x[xx]+3);
	    printf("\n");
	}
    }
    return 0;
}
