{$APPTYPE CONSOLE}

// (C) .  -- ਣ ⥪ (. ਣ  kruskal.dpr)
// () . 类 --  ணࠬ  ࠡ祣 ﭨ

program kruskal_fixed;

uses
  Math;

var a:array[1..1000,1..1000] of boolean;
    t,r1,r2:array[1..1000] of longint;
    i,j,k,l,n,m:longint;
    f1,f2:text;

function find_set(i:longint):longint;
begin
  Result := t[i];
end;

procedure merge(i,j:longint);
var
  k: integer;
  col1, col2, newCol: integer;
begin
  col1 := t[i];
  col2 := t[j];
  newCol := Min(col1, col2);
  for k := 1 to n do
    if (t[k] = col1) or (t[k] = col2) then
      t[k] := newCol;
end;

begin
assign(f1,'input.txt');
assign(f2,'output.txt');
reset(f1);
rewrite(f2);
read(f1,n,m);
for i:=1 to m do begin
   read(f1,j,l);
   a[j,l]:=true;
   a[l,j]:=true;
end;
for i:=1 to n do begin
   t[i]:=i;
end;
k:=0;
for i:=1 to n do begin
   for j:=i + 1 to n do begin
      if (a[i,j]) and (find_set(i)<>find_set(j)) then begin
         inc(k);
         r1[k]:=i;
         r2[k]:=j;
         merge(i,j);
      end;
   end;
end;
writeln(f2,k);
for i:=1 to k do begin
   writeln(f2,r1[i],' ',r2[i]);
end;
k:=0;
for i:=1 to n do begin
   for j:=i + 1 to n do begin
      if (not(a[i,j])) and (find_set(i)<>find_set(j)) then begin
         inc(k);
         r1[k]:=i;
         r2[k]:=j;
         merge(i,j);
      end;
   end;
end;
writeln(f2,k);
for i:=1 to k do begin
   writeln(f2,r1[i],' ',r2[i]);
end;
close(f1);
close(f2);
end.
