{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem D. Drying                                             }
{                                                               }
{ Original idea         Pavel Mavrin                            }
{ Problem statement     Andrew Lopatin                          }
{ Testset               Andrew Lopatin                          }
{---------------------------------------------------------------}
{ Solution                                                      }
{                                                               }
{ Author                Pavel Mavrin                            }
{---------------------------------------------------------------}

{$o-,q+,r+}
uses
   sysutils, math;


var
  aa, a, b: array[0..100000] of integer;

procedure sort(l, r: integer);
var
  x, i, j, t: integer;
begin
  x := a[l + random(r - l + 1)];
  i := l;
  j := r;
  while i <= j do begin
    while a[i] < x do inc(i);
    while a[j] > x do dec(j);
    if i <= j then begin
      t := a[i];
      a[i] := a[j];
      a[j] := t;
      t := aa[i];
      aa[i] := aa[j];
      aa[j] := t;
      t := b[i];
      b[i] := b[j];
      b[j] := t;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then sort(i, r);
  if l < j then sort(l, j);
end;

var
  n, k, r: integer;
  i, j: integer;
  t, tt, ttt, d, t1, t2, jj: integer;

begin
  reset(input, 'drying.in');
  rewrite(output, 'drying.out');

  read(n);
  for i := 1 to n do read(a[i]);

  read(k);

  sort(1, n);

  if (k = 1) then begin
    writeln(a[n]);
    exit;
  end;

  t := 0;
  tt := 0;

  for i := 1 to n do aa[i] := a[i];

  i := 1;
  j := n;


  while true do begin
    if (j = i) then begin
      d := a[n] - t;
      d := d div (k + n - j);
      inc(b[n], d);
      dec(b[j - 1], d);
      tt := tt + d * (n - j + 1);
      break;
    end else begin
      d := a[n] - a[j - 1];
      if d < k - 1 then begin
        dec(j);
      end else begin
        t2 := a[i];
        if (tt + 1.0 * (d div (k - 1)) * (n - j + 1) <= t2 + 1) then
          t1 := tt + (d div (k - 1)) * (n - j + 1)
        else
          t1 := t2;
        ttt := min(t1, t2);
        t := ttt;
        while a[i] <= t do inc(i);
        r := (ttt - tt) div (n - j + 1);
        inc(b[n], r);
        dec(b[j - 1], r);
        a[n] := a[n] - (k - 1) * r;
        tt := tt + r * (n - j + 1);
      end;
    end;
  end;




  j := 0;
  jj := 0;
  for i := n downto 1 do begin
    j := j + b[i];
    b[i] := j;
    jj := jj + j;
    a[i] := aa[i] - tt - (k - 1) * j;
    if (a[i] < 0) then
      a[i] := 0;
  end;
  assert(jj = tt);



  sort(1, n);
  j := 0;
  for i := n downto 1 do begin
    b[i] := b[i] - j;
    j := j + b[i];
  end;

  while (a[n] > 0) do begin

  i := 1;
  for j := n + 1 downto 1 do begin
    t := n + 1 - j;
    while (i < j) and (a[i] <= t) do inc(i);
    if i >= j then begin
      inc(b[n]);
      dec(b[j - 1]);
      tt := tt + n - j + 1;
      break;
    end;
  end;

  j := 0;
  jj := 0;
  for i := n downto 1 do begin
    j := j + b[i];
    b[i] := j;
    jj := jj + j;
    a[i] := aa[i] - tt - (k - 1) * j;
    if (a[i] < 0) then
      a[i] := 0;
  end;
  assert(jj = tt);

  sort(1, n);

  j := 0;
  for i := n downto 1 do begin
    b[i] := b[i] - j;
    j := j + b[i];
  end;

  end;

  writeln(tt);

end.