{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem E. Expectation                                        }
{                                                               }
{ Original idea         Andrew Stankevich                       }
{ Problem statement     Andrew Lopatin                          }
{ Testset               Andrew Lopatin                          }
{---------------------------------------------------------------}
{ Model solution (Delphi)                                       }
{                                                               }
{ Author                Andrew Lopatin                          }
{---------------------------------------------------------------}

{$O-,Q+,R+}
uses SysUtils;
const MaxK=1000;
      Max=1000000000;

procedure readr (var x:integer; a, b:integer);
begin
  assert (not seekeoln); read (x); assert ((a<=x) and (x<=b));
end;

procedure readl;
begin
  assert (seekeoln); assert (not eof); readln
end;

var k, i, l, t, p1, p2:integer;
    sum:extended;

begin
  reset (input, 'expectation.in'); rewrite (output, 'expectation.out');
  readr (k, 1, MaxK); readl;
  for i:=1 to k do begin
    readr (l, 1, Max); readl;
    k:=0; sum:=0;
    while (1 shl k)<=l do begin
      p1:=(l shr (k+1)) shl k; p2:=p1;
      t:=l and (1 shl (k+1) - 1);
      if t>1 shl k then begin inc (p1, 1 shl k); inc (p2, t - 1 shl k) end
      else inc (p1, t);
      sum:=sum+(1 shl k)*(2.0*p1*p2/(sqr (1.0*(p1+p2))));
      inc (k);
    end;
    writeln (sum:0:10);
  end;
  assert (eof);
end.