{ fp }


{$I-,Q-,R-,S-}


type tpoint=record
    x,y:real;
  end;

var fi,fo:text;
  c:tpoint;
  rc:real;
  p:array[0..200]of tpoint;
  n,i,j:integer;
  pii:real;

const ep=1e-9;

function eq(a,b:real):boolean;
 begin
   eq:=abs(a-b)<ep;
 end;

function le(a,b:real):boolean;
 begin
   le:=b-a>-ep;
 end;

function mo(a,b:real):boolean;
 begin
   mo:=a-b>-ep;
 end;


function liem(x1,x2,x3:real):boolean;
 begin
   liem:=le(x1,x2)and le(x2,x3) or mo(x1,x2)and mo(x2,x3);
 end;

procedure swapt(var p1,p2:tpoint);
 var sw:tpoint;
 begin
   sw:=p1;
   p1:=p2;
   p2:=sw;
 end;

function lie(const p1,p2,p3:tpoint):boolean;
 begin
  lie:=liem(p1.x,p2.x,p3.x)and liem(p1.y,p2.y,p3.y);
 end;


function vd(const t1,t2:tpoint):real;
 begin
   vd:=t1.x*t2.y-t2.x*t1.y;
 end;

function sd(const t1,t2:tpoint):real;
 begin
   sd:=t1.x*t2.x+t1.y*t2.y;
 end;


function vec(const p1,p2:tpoint):tpoint;
 var t:tpoint;
 begin
   t.x:=p2.x-p1.x;
   t.y:=p2.y-p1.y;
   vec:=t;
 end;

procedure intersect(const p1,p2:tpoint;var num:integer;var r1,r2:tpoint);
 var kkk:tpoint;
  k,b,a1,b1,c1,d1:real;
 begin
  kkk:=vec(p2,p1);
  if kkk.x=0
   then
    begin
      a1:=1;
      b1:=-2*c.y;
      c1:=c.y*c.y+(p1.x-c.x)*(p1.x-c.x)-rc*rc;
      d1:=b1*b1-4*a1*c1;
      if d1<0
       then
        num:=0
       else
        if d1=0
         then
          begin
           num:=1;
           r1.y:=(-b1)/2/a1;
           r1.x:=p1.x;
           if lie(p1,r1,p2)
            then
            else
             dec(num);
          end
         else
          begin
            num:=2;
            r1.y:=(-b1-sqrt(d1))/2/a1;
            r2.y:=(-b1+sqrt(d1))/2/a1;
            r1.x:=p1.x;
            r2.x:=p1.x;
            if lie(p1,r1,p2)
             then
              if lie(p1,r2,p2)
               then
               else
                dec(num)
             else
              begin
                dec(num);
                r1:=r2;
                if lie(p1,r1,p2)
                 then
                 else dec(num);
              end;
            if (num=2)and lie(p1,r2,r1)and lie(r2,r1,p2)
             then swapt(r1,r2);


          end;
    end
   else
    begin
      k:=kkk.y/kkk.x;
      b:=p1.y-p1.x*k;
      a1:=1+k*k;
      b1:=2*k*b-2*k*c.y-2*c.x;
      c1:=c.x*c.x+(b-c.y)*(b-c.y)-rc*rc;
      d1:=b1*b1-4*a1*c1;
      if d1<0
       then
        num:=0
       else
        if d1=0
         then
          begin
           num:=1;
           r1.x:=(-b1)/2/a1;
           r1.y:=r1.x*k+b;
           if lie(p1,r1,p2)
            then
            else dec(num);
          end
         else
          begin
            num:=2;
            r1.x:=(-b1-sqrt(d1))/2/a1;
            r2.x:=(-b1+sqrt(d1))/2/a1;
            r1.y:=r1.x*k+b;
            r2.y:=r2.x*k+b;
            if lie(p1,r1,p2)
             then
              if lie(p1,r2,p2)
               then
               else dec(num)
             else
              begin
                dec(num);
                r1:=r2;
                if lie(p1,r1,p2)
                 then
                 else
                   dec(num);
              end;
            if (num=2)and lie(p1,r2,r1)and lie(r2,r1,p2)
             then swapt(r2,r1);

          end;
    end;
 end;

function dist(const p1,p2:tpoint):real;
 begin
   dist:=sqrt(  sqr(p2.x-p1.x)+sqr(p2.y-p1.y)  );
 end;

function arrctan(coss,sinn:real):real;
 begin
   if mo(sinn,0)and eq(coss,0)
    then
     arrctan:=pii/2
    else
     if le(sinn,0)and eq(coss,0)
      then
       arrctan:=-pii/2
      else
        if mo(coss,0)
         then arrctan:=arctan(sinn/coss)
         else arrctan:=arctan(sinn/coss)+pii;
 end;

var tempo:tpoint;
  istemp:boolean;

function sector(const p1,p2:tpoint;inner:boolean):real;
 var d1,d2,vd1,sd1,sk,sm,at:real;
 begin
   if (p2.x=0)and(p2.y=0)
    then
     begin
       istemp:=true;
       exit;
     end;
   if istemp
    then
     begin
       istemp:=false;
       exit;
     end;
   d1:=dist(c,p1);
   d2:=dist(c,p2);
   vd1:=vd(vec(c,p1),vec(c,p2));
   sd1:=sd(vec(c,p1),vec(c,p2));
   at:=arrctan(sd1,vd1);
   if inner
    then
     sector:=0.5*vd1
    else
     sector:=0.5*sqr(rc)*at;
 end;


procedure proceed;
 var curp,prep,p1,p2:tpoint;
   inner:boolean;
   num:integer;
   curs:real;
 begin
{   curs:=pii*sqr(rc);
}
   curs:=0;
   curp:=p[1];
   inner:=le(dist(p[1],c),rc);
   istemp:=false;
   for i:=2 to n+1 do
    begin
      intersect(p[i-1],p[i],num,p1,p2);
      if num=0
       then
        curs:=curs+sector(p[i-1],p[i],inner)
       else
        if num=1
         then
          begin
           curs:=curs+sector(p[i-1],p1,inner)+sector(p1,p[i],not inner);
           inner:=not inner;
          end
         else
           curs:=curs+sector(p[i-1],p1,false)
              +sector(p1,p2,true)+sector(p2,p[i],false);
    end;
   writeln(curs:0:14);
 end;



begin
  pii:=pi;
  read(c.x,c.y,rc,n);
  for i:=1 to n do
   read(p[i].x,p[i].y);
{  if vd(x[2]-x[1],y[2]-y[1],x[3]-x[2],y[3]-y[2])<0
   then
    begin

    end;
}
  p[n+1]:=p[1];
  if (p[1].x=0)and(p[2].y=0)
   then
    begin
      for i:=1 to n do
        p[i]:=p[i+1];
      p[n+1]:=p[1];
    end;

  proceed;
end.

