{ XV ᨩ᪠  誮쭨  ଠ⨪       }
{  "⥪"                                            }
{ :  ..                                          }
{ 襭:  祢                                     }
{$Q+,R+,S+,I+}
{$M 65520,0,655360}
Program IceAge;
Const
  TaskID='glass';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
Type
  Integer=LongInt;
  TTriangle=Array[0..2]Of Record
    X,Y:System.Integer;
    Can:(_None,_Horz,_Vert);
    Coord:System.Integer;
  End;
  TSegment=Record
    L,R:System.Integer;
  End;
Const
  MaxT=2002;
  Undefined=135766657;
Type
  TSegmentArray=Array[1..MaxT]Of TSegment;
  TSegments=Record
    Num:Integer;
    Item:TSegmentArray;
  End;
Var
  N:Integer;
  IsSol,NoSol:Boolean;
  T:Array[1..MaxT]Of TTriangle;
  NumCan:Array[1..MaxT]Of Byte;
  Which:Array[1..MaxT]Of Byte;
  Perm:Array[1..MaxT]Of System.Integer;
  Perm2:Array[1..MaxT]Of System.Integer;
  Left,Right,Top,Bottom:Integer;
  NumRightAngles:Integer;
  LS,RS,TS,BS:^TSegments;
Function Min(A,B:Integer):Integer;
Begin
  If A<B Then Min:=A Else Min:=B;
End;
Function Max(A,B:Integer):Integer;
Begin
  If A>B Then Max:=A Else Max:=B;
End;
Procedure Load;
Var
  I,J:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do
    For J:=0 To 2 Do
      With T[I][J] Do
        Read(X,Y);
  Close(Input);
End;
Procedure FillTriangles;
Var
  I,J,A,B:Integer;
Begin
  FillChar(NumCan,SizeOf(NumCan),0);
  NumRightAngles:=0;
  For I:=1 To N Do Begin
    For J:=0 To 2 Do With T[I][J] Do Begin
      A:=(J+1) Mod 3;
      B:=(A+1) Mod 3;
      Can:=_None;
      If T[I][A].X=T[I][B].X Then Begin
        Can:=_Vert;
        Coord:=T[I][A].X-X;
        Inc(NumCan[I]);
      End Else If T[I][A].Y=T[I][B].Y Then Begin
        Can:=_Horz;
        Coord:=T[I][A].Y-Y;
        Inc(NumCan[I]);
      End;
    End;
    If NumCan[I]=0 Then Begin
      NoSol:=True;
      Exit;
    End;
    If NumCan[I]>1 Then
      Inc(NumRightAngles);
  End;
  If NumRightAngles>8 Then
    NoSol:=True;
End;
Procedure SortBuggies(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=perm[(l+r) DIV 2];
  repeat
    while (NumCan[perm[i]]>1)<(NumCan[x]>1) do Inc(I);
    while (NumCan[x]>1)<(NumCan[perm[j]]>1) do Dec(J);
    if i<=j then
    begin
      y:=perm[i]; perm[i]:=perm[j]; perm[j]:=y;
      Inc(I); Dec(J);
    end;
  until i>j;
  if l<j then SortBuggies(l,j);
  if i<r then SortBuggies(i,r);
end;
Procedure SortSegments(Var A:TSegmentArray; l,r:integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=perm2[(l+r) DIV 2];
  repeat
    while a[perm2[i]].l<a[x].l do Inc(I);
    while a[x].l<a[perm2[j]].l do Dec(J);
    if i<=j then
    begin
      y:=perm2[i]; perm2[i]:=perm2[j]; perm2[j]:=y;
      Inc(I); Dec(J);
    end;
  until i>j;
  if l<j then SortSegments(A,l,j);
  if i<r then SortSegments(A,i,r);
end;
Function CheckIfSingleCover(Var S:TSegments; Start,Finish:Integer):Boolean;
Var
  I:Integer;
Begin
  For I:=1 To S.Num Do
    Perm2[I]:=I;
  SortSegments(S.Item,1,S.Num);
  CheckIfSingleCover:=False;
  If S.Item[Perm2[1]].L<>Start Then Exit;
  If S.Item[Perm2[S.Num]].R<>Finish Then Exit;
  For I:=2 To S.Num Do
    If S.Item[Perm2[I-1]].R<>S.Item[Perm2[I]].L Then Exit;
  CheckIfSingleCover:=True;
End;
Procedure Recurse(Start:Integer);
Var
  Cur:Integer;
  I,A,B:Byte;
  WasUndef:Boolean;
Begin
  If Start>N Then Begin
    If Left=Undefined Then Exit;
    If Right=Undefined Then Exit;
    If Top=Undefined Then Exit;
    If Bottom=Undefined Then Exit;
    IsSol:=CheckIfSingleCover(LS^,Bottom,Top) And
           CheckIfSingleCover(RS^,Bottom,Top) And
           CheckIfSingleCover(TS^,Left,Right) And
           CheckIfSingleCover(BS^,Left,Right);
    Exit;
  End;
  Cur:=Perm[Start];
  Inc(Start);
  For I:=0 To 2 Do Begin
    A:=(I+1) Mod 3;
    B:=(A+1) Mod 3;
    Which[Cur]:=I;
    With T[Cur][I] Do Case Can Of
      _None:;
      _Vert:Begin
        If Coord<0 Then Begin
          WasUndef:=False;
          If Left=Undefined Then Begin WasUndef:=True; Left:=Coord; End Else If Left<>Coord Then Continue;
          Inc(LS^.Num);
          With LS^.Item[LS^.Num] Do Begin
            L:=Min(T[Cur][A].Y-T[Cur][I].Y,T[Cur][B].Y-T[Cur][I].Y);
            R:=Max(T[Cur][A].Y-T[Cur][I].Y,T[Cur][B].Y-T[Cur][I].Y);
          End;
          Recurse(Start);
          If IsSol Then Exit;
          Dec(LS^.Num);
          If WasUndef Then
            Left:=Undefined;
        End Else Begin
          WasUndef:=False;
          If Right=Undefined Then Begin WasUndef:=True; Right:=Coord; End Else If Right<>Coord Then Continue;
          Inc(RS^.Num);
          With RS^.Item[RS^.Num] Do Begin
            L:=Min(T[Cur][A].Y-T[Cur][I].Y,T[Cur][B].Y-T[Cur][I].Y);
            R:=Max(T[Cur][A].Y-T[Cur][I].Y,T[Cur][B].Y-T[Cur][I].Y);
          End;
          Recurse(Start);
          If IsSol Then Exit;
          Dec(RS^.Num);
          If WasUndef Then
            Right:=Undefined;
        End;
      End;
      _Horz:Begin
        If Coord<0 Then Begin
          WasUndef:=False;
          If Bottom=Undefined Then Begin WasUndef:=True; Bottom:=Coord; End Else If Bottom<>Coord Then Continue;
          Inc(BS^.Num);
          With BS^.Item[BS^.Num] Do Begin
            L:=Min(T[Cur][A].X-T[Cur][I].X,T[Cur][B].X-T[Cur][I].X);
            R:=Max(T[Cur][A].X-T[Cur][I].X,T[Cur][B].X-T[Cur][I].X);
          End;
          Recurse(Start);
          If IsSol Then Exit;
          Dec(BS^.Num);
          If WasUndef Then
            Bottom:=Undefined;
        End Else Begin
          WasUndef:=False;
          If Top=Undefined Then Begin WasUndef:=True; Top:=Coord; End Else If Top<>Coord Then Continue;
          Inc(TS^.Num);
          With TS^.Item[TS^.Num] Do Begin
            L:=Min(T[Cur][A].X-T[Cur][I].X,T[Cur][B].X-T[Cur][I].X);
            R:=Max(T[Cur][A].X-T[Cur][I].X,T[Cur][B].X-T[Cur][I].X);
          End;
          Recurse(Start);
          If IsSol Then Exit;
          Dec(TS^.Num);
          If WasUndef Then
            Top:=Undefined;
        End;
      End;
    End;
  End;
End;
Procedure Solve;
Var
  I:Integer;
Begin
  NoSol:=False;
  FillTriangles;
  If NoSol Then Begin
    IsSol:=False;
    Exit;
  End;
  For I:=1 To N Do
    Perm[I]:=I;
  SortBuggies(1,N);
  IsSol:=False;
  New(LS);
  New(RS);
  New(TS);
  New(BS);
  LS^.Num:=0;
  RS^.Num:=0;
  TS^.Num:=0;
  BS^.Num:=0;
  Left:=Undefined;
  Right:=Undefined;
  Top:=Undefined;
  Bottom:=Undefined;
  Recurse(1);
  Dispose(LS);
  Dispose(RS);
  Dispose(TS);
  Dispose(BS);
End;
Procedure Save;
Var
  I,J:Integer;
  DX,DY:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If IsSol Then Begin
    For I:=1 To N Do Begin
      DX:=-Left-T[I][Which[I]].X;
      DY:=-Bottom-T[I][Which[I]].Y;
      For J:=0 To 2 Do Begin
        If J>0 Then Write(' ');
        Write(T[I][J].X+DX,' ',T[I][J].Y+DY);
      End;
      WriteLn;
    End;
  End Else Begin
    WriteLn('NO');
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
