{$I+,Q-,R-,S-}
const MaxWs = 1002;

var n: integer;
    s: string;
    ws: array[1..MaxWs] of string[10];
    ls: array[ord('a')..ord('z')] of integer;

procedure sort(l,r: integer);
var
  i,j: integer;
  x: char;
  y: string;
begin
  i:=l; j:=r; x:=ws[(l+r) DIV 2,1];
  repeat
    while ws[i,1]<x do i:=i+1;
    while x<ws[j,1] do j:=j-1;
    if i<=j then
    begin
      y:=ws[i]; ws[i]:=ws[j]; ws[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

const MaxLen = 100000;
var a: array[ord('a')..ord('z'),1..MaxLen] of byte;
    b: array[1..MaxLen] of boolean;
    p: array[ord('a')..ord('z'),1..MaxLen] of integer;
    wo: array[1..MaxLen] of integer;
    wn: longint;

procedure Solve;
var i,j,k,l: longint;
    ch: byte;
    flag: boolean;
begin
  sort(1,n);
  For i:=1 to n do
    if ls[ord(ws[i,1])]=0 then
      ls[ord(ws[i,1])]:=i;
  fillchar(a,sizeof(a),255);
  For ch:=ord('a') to ord('z') do
    if ls[ch]>0 then begin
      if s[1]=chr(ch) then a[ch,1]:=1 else a[ch,1]:=0;
    end else a[ch,1]:=255;
  b[1]:=true;
  flag:=false;
  For i:=1 to MaxLen do begin
    if b[i] then
      For ch:=ord('a') to ord('z') do
        if a[ch,i]<>255 then begin
          if a[ch,i]=length(s) then begin
            flag:=true; break;
          end;
          j:=ls[ch];
          while (j<=n) and (ws[j,1]=chr(ch)) do begin
            l:=a[ch,i];
            For k:=2 to length(ws[j]) do begin
              if l=length(s) then break;
              if ws[j,k]=s[l+1] then inc(l);
            end;
            k:=length(ws[j]);
            if (a[ord(ws[j,k]),i+k-1]=255) or (a[ord(ws[j,k]),i+k-1]<l) then begin
              a[ord(ws[j,k]),i+k-1]:=l;
              p[ord(ws[j,k]),i+k-1]:=j;
              b[i+k-1]:=true;
            end;
            inc(j);
          end;
        end;
    if flag then break;
  end;
  if flag then begin
    while p[ch,i]>0 do begin
      inc(wn);
      wo[wn]:=p[ch,i];
      j:=p[ch,i];
      ch:=ord(ws[j,1]);
      i:=i-length(ws[j])+1;
    end;
  end;
end;

procedure Save;
var f: text;
    i: longint;
begin
  Assign(f,'chain.out');
  Rewrite(f);
  if wn>0 then begin
    For i:=wn downto 1 do
      WriteLn(f,ws[wo[i]]);
  end else WriteLn(f,'?');
  Close(f);
end;

procedure Load;
var f: text;
    i,j,k,t: integer;
    st: string[10];
    flag: boolean;
begin
  Assign(f,'chain.in');
  Reset(f);
  ReadLn(f,s);
  ReadLn(f,t);
  For i:=1 to t do begin
    ReadLn(f,st);
    flag:=true;
    if st[1]=st[length(st)] then begin
      flag:=false;
      For j:=1 to length(st) do begin
        For k:=1 to length(s) do
          if st[j]=s[k] then begin
            flag:=true;
            break;
          end;
        if flag then break;
      end;
    end;
    if flag then begin
      inc(n);
      ws[n]:=st;
    end;
  end;
  Close(f);
end;

Begin
  Load;
  Solve;
  Save;
End.
