program Glass;
{This program is used to solve the 5th zadacha
at 15th Russian Olympiade on Information Technology}
{It doesn't use any modules except System module}
var
F1,F2: text; {text variables}
S,i,N: 1..2000; {counter variables}
osk: array[1..2000,1..6] of Integer; {array of coordinates of triangle}
Square: array[1..2000] of Real; {array of squares of oskolki}
Versh: array[1..2000,1..2] of Integer; {array of tops of triangles}
a,h: Integer; {variables a and h (side and heigth of triangle)}
MaxX,MaxY: Integer; {variables of max sizes of glass}
keyX,keyY,key2X,key2Y,k: Integer; {4 variables of coordinates of key points}
Sq: Real;

procedure OpenF; {opens 2 files for input and output}
begin
assign(F1,'glass.in');
assign(F2,'glass.out');
reset(F1);
rewrite(F2);
end; {OpenF}

procedure ReadF; {reads data from input file}
begin
readln(F1,N);
for i:=1 to N do read(F1,osk[i,1],osk[i,2],osk[i,3],osk[i,4],osk[i,5],osk[i,6]);
end; {ReadF}

procedure WriteF(x1,x2,x3,x4,x5,x6: Integer); {writes data to output file}
begin
WriteLn(F2,x1,' ',x2,' ',x3,' ',x4,' ',x5,' ',x6);
end; {WriteF}

procedure CloseF; {closes all files}
begin
close(F1);
close(F2);
end; {CloseF}

function Min(x,y,z: Integer): Integer; {finds minimum of 3 parametres}
begin
if (x<=y) and (x<=z) then Min:=x;
if (y<=x) and (y<=z) then Min:=y;
if (z<=x) and (z<=y) then Min:=z;
end; {Min}

begin {starting the main part}
OpenF; {calling procedures}
ReadF;
{Solution strats from here:}
MaxX:=0; {these 3 variables are 0 at start of the program}
MaxY:=0;
Sq:=0;
for i:=1 to N do begin {Start of main loop}
if osk[i,1]=osk[i,3] then begin {All next strings are used to find top and square of triangles}
a:=abs(osk[i,2]-osk[i,4]);
h:=abs(osk[i,5]-osk[i,1]);
versh[i,1]:=osk[i,5];
versh[i,2]:=osk[i,6];
end;
if osk[i,2]=osk[i,4] then begin
a:=abs(osk[i,1]-osk[i,3]);
h:=abs(osk[i,6]-osk[i,2]);
versh[i,1]:=osk[i,5];
versh[i,2]:=osk[i,6];
end;
if osk[i,1]=osk[i,5] then begin
a:=abs(osk[i,2]-osk[i,6]);
h:=abs(osk[i,3]-osk[i,1]);
versh[i,1]:=osk[i,3];
versh[i,2]:=osk[i,4];
end;
if osk[i,2]=osk[i,6] then begin
a:=abs(osk[i,1]-osk[i,5]);
h:=abs(osk[i,4]-osk[i,2]);
versh[i,1]:=osk[i,3];
versh[i,2]:=osk[i,4];
end;
if osk[i,3]=osk[i,5] then begin
a:=abs(osk[i,4]-osk[i,6]);
h:=abs(osk[i,1]-osk[i,5]);
versh[i,1]:=osk[i,1];
versh[i,2]:=osk[i,2];
end;
if osk[i,4]=osk[i,6] then begin
a:=abs(osk[i,3]-osk[i,5]);
h:=abs(osk[i,2]-osk[i,6]);
versh[i,1]:=osk[i,5];
versh[i,2]:=osk[i,6];
end;
{If we did it, we should find key-points of triangles}
 if ((versh[i,2]>osk[i,2]) and (versh[i,2]>osk[i,4])) or ((versh[i,2]>osk[i,4]) and (versh[i,2]>osk[i,6])) or
 ((versh[i,2]>osk[i,2]) and (versh[i,2]>osk[i,6])) then begin
 keyX:=versh[i,1];
 keyY:=versh[i,2];
 key2X:=min(osk[i,1],osk[i,3],osk[i,5]);
 key2Y:=min(osk[i,2],osk[i,4],osk[i,6]);
 end;
Square[i]:=0.5*a*h; {Now we find square of each triangle}
Sq:=Sq+Square[i];   {And now we find sum of all squares}
end;
for i:=1 to N do begin     {Now we move all points (in russian it is - parallelny perenos)}
k:=versh[i,1]-keyX+key2X;
osk[i,1]:=osk[i,1]-k;
osk[i,3]:=osk[i,3]-k;
osk[i,5]:=osk[i,5]-k;
k:=versh[i,2]-keyY+key2Y;
osk[i,2]:=osk[i,2]-k;
osk[i,4]:=osk[i,4]-k;
osk[i,6]:=osk[i,6]-k;
if osk[i,1]>maxX then maxX:=osk[i,1];  {Now we find max length and width of rectangular}
if osk[i,3]>maxX then maxX:=osk[i,3];
if osk[i,5]>maxX then maxX:=osk[i,5];
if osk[i,2]>maxY then maxY:=osk[i,2];
if osk[i,4]>maxY then maxY:=osk[i,4];
if osk[i,6]>maxY then maxY:=osk[i,6];
end;
{Do we have them?}
if Sq=maxX*maxY then    {Then we check if rectangular square is equal to}
begin                   {the sum of squares of triangles}
 for i:=1 to N do begin {if it's so we write the answer using}
 WriteF(osk[i,1],osk[i,2],osk[i,3],osk[i,4],osk[i,5],osk[i,6]); {this procedure}
 end;
end
else             {if not then we write answer 'No'}
begin
WriteLn(F2,'NO');
end;
CloseF; {calling closing procedure}
end. {the end of the main part (and program too). Good bye!}