{ mamahacker :) }
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
const
  Nm = 1000;
  n1 = ord('a');
  n2 = ord('z');

type
  tw = String[10];
  ta = array [0..Nm] of Integer;

var
  loz: String[250];
  lloz,ps: Byte; { ps - position in lozung }
  fst: array [1..Nm] of Integer; { words in wich there is first letter }
  _fst: Integer;
  N,lnow,lbest: Integer;
  ws: array [1..Nm] of tw;
  ls: array [1..Nm] of Byte; { length of words in ws }
  ga: array [1..Nm] of Integer; { for working with graph }
  times: array [1..Nm] of Byte; { how many times the word can be used }
  a: array [n1..n2] of ^ta; { -=-=-=- }
  chain,chnow: array [1..Nm] of Integer;
  _,_now: Integer; { length of chain }
  timer: longint absolute $0:$046C;
  breakTime: longint;

procedure Done;
var
  i: Integer;
begin
  Assign(output,'chain.out'); ReWrite(output);

  if _=0 then Write('?') else
  for i:=1 to _ do WriteLn(ws[chain[i]]);
  for i:=n1 to n2 do if a[i]<>nil then Dispose(a[i]);

  Close(output);
  Halt(0);
end; { Done }

procedure Init;
var
  i,j: Integer;
  ch: char;
  ss: set of char;
begin
  FillChar(times,SizeOf(times),0); _fst:=0;
  Assign(input,'chain.in'); Reset(input);

  ReadLn(loz); lloz:=length(loz);
  ReadLn(N);
  for i:=1 to N do begin
    ReadLn(ws[i]);
    ls[i]:=length(ws[i]);
    if pos(loz[1],ws[i])<>0 then begin
      inc(_fst); fst[_fst]:=i;
    end;
    for j:=1 to lloz do if pos(loz[j],ws[i])<>0 then begin
      ss:=ss+[loz[j]]; inc(times[i]);
    end;
  end;
  for i:=1 to N do if times[i]=0 then times[i]:=1;
  for i:=1 to N do begin
    ch:=ws[i][1]; j:=ord(ch);
    if a[j]=nil then begin
      new(a[j]);
      a[j]^[0]:=1; a[j]^[1]:=i;
    end else begin
      inc(a[j]^[0]); a[j]^[a[j]^[0]]:=i;
    end;
  end;

  Close(input);
  i:=1; while (i<=lloz) and (loz[i] in ss) do inc(i);
  if i<=lloz then begin
    _:=0; Done;
  end;
  lbest:=maxint;
end; { Init }

procedure Check;
begin
  if (_=0)or((lnow<lbest)and(_now<>0)) then begin
    chain:=chnow; _:=_now; lbest:=lnow;
  end;
end; { Check }

procedure Solve1;
var
  fsta: array [1..Nm] of Integer;
  i,j,k,v: Integer;
  ch: Char;
  o: Integer;
  s: String[250];
  st,from: array [1..Nm] of Integer;
  pinc: array [1..Nm] of Integer;
  up,down: Integer;
  nnew: array [1..Nm] of Boolean;
  p: Boolean;
begin
{ Creating Graph }
  FillChar(st,SizeOf(st),0);
  FillChar(nnew,SizeOf(nnew),true);
  for i:=1 to _fst do begin
    st[i]:=fst[i];
  end;
  up:=i; down:=0;
  while down<up do begin
    inc(down);
    while (not (nnew[st[down]]))and(down<=up) do inc(down);
    if down<=up then begin
      v:=st[down]; nnew[v]:=false;
      ga[v]:=ord(ws[v][ls[v]]);
      j:=ga[v];
     if a[j]=nil then ga[v]:=0 else
      for i:=1 to a[j]^[0] do begin
        inc(up); st[up]:=a[j]^[i];
      end;
    end;
  end;
{ CG is done :) }

{ Main... e-e-e... perebor vobshem now begin }
  for i:=1 to _fst do begin
    FillChar(st,SizeOf(st),0); up:=1;
    FillChar(from,SizeOf(from),0);
    FillChar(nnew,SizeOf(nnew),true);
    FillChar(pinc,SizeOf(pinc),0);
    st[up]:=fst[i]; dec(times[st[1]]); if times[st[1]]=0 then nnew[st[1]]:=false;
    ps:=1; _now:=0; lnow:=0; v:=st[up];


    inc(_now); chnow[_now]:=v; lnow:=lnow+ls[v];
    s:=ws[v];
    k:=pos(loz[ps],s);
    while k<>0 do begin
      inc(ps); inc(pinc[up]); delete(s,1,k);
      k:=pos(loz[ps],s);
    end;



    while up>0 do begin
      v:=st[up]; p:=false;
      if ga[v]<>0 then begin
        j:=from[v]+1;
        while (not (nnew[a[ga[v]]^[j]]))and(j<=a[ga[v]]^[0]) do inc(j);
        if j<=a[ga[v]]^[0] then begin
          inc(up);
          st[up]:=a[ga[v]]^[j]; dec(times[st[up]]);
          if times[st[up]]=0 then nnew[a[ga[v]]^[j]]:=false;
          p:=true;
          from[v]:=j;
        end;
      end;

      if p then begin
        v:=st[up];
        inc(_now); chnow[_now]:=v; lnow:=lnow+ls[v];
        s:=ws[v];
        k:=pos(loz[ps],s);
        while k<>0 do begin
          inc(ps); inc(pinc[up]); delete(s,1,k);
          k:=pos(loz[ps],s);
        end;
      end;
      if ps>lloz then begin
        check;
        p:=false;
      end;
      if (not p) then begin
        dec(ps,pinc[up]); pinc[up]:=0;
        dec(up); dec(_now);
        nnew[v]:=true; inc(times[v]); lnow:=lnow-ls[v];
      end;
    end;

  end;

{ Main... e-e-e... perebor vobshem now begin }
  for i:=1 to _fst do begin
    FillChar(st,SizeOf(st),0); up:=1;
    FillChar(from,SizeOf(from),0);
    FillChar(nnew,SizeOf(nnew),true);
    FillChar(pinc,SizeOf(pinc),0);
    st[up]:=fst[i]; dec(times[st[1]]); if times[st[1]]=0 then nnew[st[1]]:=false;
    ps:=1; _now:=0; lnow:=0; v:=st[up];


    inc(_now); chnow[_now]:=v; lnow:=lnow+ls[v];
    s:=ws[v];
    k:=pos(loz[ps],s);
    while k<>0 do begin
      inc(ps); inc(pinc[up]); delete(s,1,k);
      k:=pos(loz[ps],s);
    end;



    while up>0 do begin
      if timer>=breaktime then Done;
      v:=st[up]; p:=false;
      if ga[v]<>0 then begin
        j:=from[v]+1;
        if (j>a[ga[v]]^[0]) then j:=1;
        while (not (nnew[a[ga[v]]^[j]]))and(j<=a[ga[v]]^[0]) do inc(j);
        if j<=a[ga[v]]^[0] then begin
          inc(up);
          st[up]:=a[ga[v]]^[j]; dec(times[st[up]]);
          if times[st[up]]=0 then nnew[a[ga[v]]^[j]]:=false;
          p:=true;
          from[v]:=j;
        end;
      end;

      if p then begin
        v:=st[up];
        inc(_now); chnow[_now]:=v; lnow:=lnow+ls[v];
        s:=ws[v];
        k:=pos(loz[ps],s);
        while k<>0 do begin
          inc(ps); inc(pinc[up]); delete(s,1,k);
          k:=pos(loz[ps],s);
        end;
      end;
      if ps>lloz then begin
        check;
        p:=false;
      end;
      if (not p) then begin
        dec(ps,pinc[up]); pinc[up]:=0; dec(from[st[up]]);
        dec(up); dec(_now);
        nnew[v]:=true; inc(times[v]); lnow:=lnow-ls[v];
      end;
    end;

    inc(times[st[1]]);
  end;


end; { Solve }

BEGIN
  breaktime:=timer + Round((2000/55))-10;
  Init;
  Solve1;
  Done;
END.