{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program task5;

const
  mx = 2000;
  maxm = 20000;

type
  coors = record
    x1, y1, x2, y2, x3, y3 : longint;
  end;

var
  st : array[-maxm..maxm] of longint;
  tr : array[1..mx] of coors;
  x1, x2, y1, y2, mnx, mny, mxx, mxy, i, j, k, m, n : longint;
  s, s2 : extended;
  flag : boolean;

function min(a, b : longint) : longint;
begin
  if a < b then min := a
  else min := b;
end;

function max(a, b : longint) : longint;
begin
  if a > b then max := a
  else max := b;
end;

begin
  assign(input, 'glass.in');
  reset(input);
  assign(output, 'glass.out');
  rewrite(output);
  read(n);
  mnx := maxlongint;
  mxx := -maxlongint;
  mny := maxlongint;
  mxy := -maxlongint;
  s := 0;
  for i := 1 to n do begin
    read(tr[i].x1, tr[i].y1, tr[i].x2, tr[i].y2, tr[i].x3, tr[i].y3);
    x1 := tr[i].x2 - tr[i].x1;
    x2 := tr[i].x3 - tr[i].x1;
    y1 := tr[i].y2 - tr[i].y1;
    y2 := tr[i].y3 - tr[i].y1;
    s := s + abs(x1 * y2 - x2 * y1) / 2;
    flag := true;
    if (flag) and (tr[i].x1 = tr[i].x2) or (tr[i].y1 = tr[i].y2) then begin
      tr[i].x1 := tr[i].x1 - tr[i].x3;
      tr[i].y1 := tr[i].y1 - tr[i].y3;
      tr[i].x2 := tr[i].x2 - tr[i].x3;
      tr[i].y2 := tr[i].y2 - tr[i].y3;
      tr[i].x3 := tr[i].x3 - tr[i].x3;
      tr[i].y3 := tr[i].y3 - tr[i].y3;
      flag := false;
    end;
    if (flag) and (tr[i].x1 = tr[i].x3) or (tr[i].y1 = tr[i].y3) then begin
      tr[i].x1 := tr[i].x1 - tr[i].x2;
      tr[i].y1 := tr[i].y1 - tr[i].y2;
      tr[i].x3 := tr[i].x3 - tr[i].x2;
      tr[i].y3 := tr[i].y3 - tr[i].y2;
      tr[i].x2 := tr[i].x2 - tr[i].x2;
      tr[i].y2 := tr[i].y2 - tr[i].y2;
      flag := false;
    end;
    if (flag) and (tr[i].x2 = tr[i].x3) or (tr[i].y2 = tr[i].y3) then begin
      tr[i].x2 := tr[i].x2 - tr[i].x1;
      tr[i].y2 := tr[i].y2 - tr[i].y1;
      tr[i].x3 := tr[i].x3 - tr[i].x1;
      tr[i].y3 := tr[i].y3 - tr[i].y1;
      tr[i].x1 := tr[i].x1 - tr[i].x1;
      tr[i].y1 := tr[i].y1 - tr[i].y1;
      flag := false;
    end;
    if tr[i].x1 < mnx then mnx := tr[i].x1;
    if tr[i].x2 < mnx then mnx := tr[i].x2;
    if tr[i].x3 < mnx then mnx := tr[i].x3;
    if tr[i].y1 < mny then mny := tr[i].y1;
    if tr[i].y2 < mny then mny := tr[i].y2;
    if tr[i].y3 < mny then mny := tr[i].y3;
    if tr[i].x1 > mxx then mxx := tr[i].x1;
    if tr[i].x2 > mxx then mxx := tr[i].x2;
    if tr[i].x3 > mxx then mxx := tr[i].x3;
    if tr[i].y1 > mxy then mxy := tr[i].y1;
    if tr[i].y2 > mxy then mxy := tr[i].y2;
    if tr[i].y3 > mxy then mxy := tr[i].y3;
  end;
  s2 := (mxx - mnx) * (mxy - mny);
  if s <> s2 then begin
    writeln('NO');
    close(output);
    halt;
  end;
  fillchar(st, sizeof(st), 0);
  for i := 1 to n do begin
    if (tr[i].x1 = mnx) and (tr[i].x2 = mnx) then begin
      y1 := min(tr[i].y1, tr[i].y2);
      y2 := max(tr[i].y1, tr[i].y2);
      for j := y1 + 1 to y2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].x1 = mnx) and (tr[i].x3 = mnx) then begin
      y1 := min(tr[i].y1, tr[i].y3);
      y2 := max(tr[i].y1, tr[i].y3);
      for j := y1 + 1 to y2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].x2 = mnx) and (tr[i].x3 = mnx) then begin
      y1 := min(tr[i].y2, tr[i].y3);
      y2 := max(tr[i].y2, tr[i].y3);
      for j := y1 + 1 to y2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
  end;
  for i := mny + 1 to mxy do
    if st[i] = 0 then begin
      writeln('NO');
      close(output);
      halt;
    end;
  fillchar(st, sizeof(st), 0);
  for i := 1 to n do begin
    if (tr[i].x1 = mxx) and (tr[i].x2 = mxx) then begin
      y1 := min(tr[i].y1, tr[i].y2);
      y2 := max(tr[i].y1, tr[i].y2);
      for j := y1 + 1 to y2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].x1 = mxx) and (tr[i].x3 = mxx) then begin
      y1 := min(tr[i].y1, tr[i].y3);
      y2 := max(tr[i].y1, tr[i].y3);
      for j := y1 + 1 to y2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].x2 = mxx) and (tr[i].x3 = mxx) then begin
      y1 := min(tr[i].y2, tr[i].y3);
      y2 := max(tr[i].y2, tr[i].y3);
      for j := y1 + 1 to y2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
  end;
  for i := mny + 1 to mxy do
    if st[i] = 0 then begin
      writeln('NO');
      close(output);
      halt;
    end;
  fillchar(st, sizeof(st), 0);
  for i := 1 to n do begin
    if (tr[i].y1 = mny) and (tr[i].y2 = mny) then begin
      x1 := min(tr[i].x1, tr[i].x2);
      x2 := max(tr[i].x1, tr[i].x2);
      for j := x1 + 1 to x2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].y1 = mny) and (tr[i].y3 = mny) then begin
      x1 := min(tr[i].x1, tr[i].x3);
      x2 := max(tr[i].x1, tr[i].x3);
      for j := x1 + 1 to x2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].y2 = mny) and (tr[i].y3 = mny) then begin
      x1 := min(tr[i].x2, tr[i].x3);
      x2 := max(tr[i].x2, tr[i].x3);
      for j := x1 + 1 to x2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
  end;
  for i := mnx + 1 to mxx do
    if st[i] = 0 then begin
      writeln('NO');
      close(output);
      halt;
    end;
  fillchar(st, sizeof(st), 0);
  for i := 1 to n do begin
    if (tr[i].y1 = mxy) and (tr[i].y2 = mxy) then begin
      x1 := min(tr[i].x1, tr[i].x2);
      x2 := max(tr[i].x1, tr[i].x2);
      for j := x1 + 1 to x2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].y1 = mxy) and (tr[i].y3 = mxy) then begin
      x1 := min(tr[i].x1, tr[i].x3);
      x2 := max(tr[i].x1, tr[i].x3);
      for j := x1 + 1 to x2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
    if (tr[i].y2 = mxy) and (tr[i].y3 = mxy) then begin
      x1 := min(tr[i].x2, tr[i].x3);
      x2 := max(tr[i].x2, tr[i].x3);
      for j := x1 to x2 do begin
        if st[j] <> 0 then begin
          writeln('NO');
          close(output);
          halt;
        end;
        st[j] := i;
      end;
    end;
  end;
  for i := mnx + 1 to mxx do
    if st[i] = 0 then begin
      writeln('NO');
      close(output);
      halt;
    end;
  for i := 1 to n do begin
    tr[i].x1 := tr[i].x1 - mnx;
    tr[i].x2 := tr[i].x2 - mnx;
    tr[i].x3 := tr[i].x3 - mnx;
    tr[i].y1 := tr[i].y1 - mny;
    tr[i].y2 := tr[i].y2 - mny;
    tr[i].y3 := tr[i].y3 - mny;
    writeln(tr[i].x1, ' ', tr[i].y1, ' ', tr[i].x2, ' ', tr[i].y2, ' ', tr[i].x3, ' ', tr[i].y3);
  end;
  close(output);
end.
