{$I-,R-,Q-}
const mx=3000;
      dn=0;
      lt=1;
      up=2;
      rt=3;
var n:longint;
    nx,ny,x,y:array[1..mx,1..3]of extended;
    ok:boolean;

    count:array[0..3]of longint;
    num:array[0..3,1..mx]of longint;
    ang,l,h,dx:array[0..3,1..mx]of extended;

function max(x,y:extended):extended;
begin
  if x>y then
    max:=x
  else
    max:=y;
end;

function min(x,y:extended):extended;
begin
  if x>y then
    min:=y
  else
    min:=x;
end;

function polar(x,y:extended):extended;
var a:extended;
begin
  if abs(x)<0.001 then
    begin
      if y>0 then
        polar:=pi/2
      else
        polar:=-pi/2;
      exit;
    end;
  a:=arctan(y/x);
  if x<0 then
    a:=a+pi
  else
    if y<0 then
      a:=a+2*pi;
  polar:=a;
end;

procedure init;
var i:longint;
begin
  assign(input,'glass.in');
  reset(input);
  readln(n);
  for i:=1 to n do
    readln(x[i,1],y[i,1],x[i,2],y[i,2],x[i,3],y[i,3]);
  close(input);
end;

procedure done;
var i:longint;
begin
  assign(output,'glass.out');
  rewrite(output);
  if not ok then
    write('NO')
  else
    begin
      for i:=1 to n do
        writeln(nx[i,1]:0:0,' ',ny[i,1]:0:0,' ',
                nx[i,2]:0:0,' ',ny[i,2]:0:0,' ',
                nx[i,3]:0:0,' ',ny[i,3]:0:0,' ');
    end;
  close(output);
  halt;
end;

procedure run;
var i,j,a,b:longint;
    rx,ry,curd,p:extended;
begin
  for i:=1 to n do
    begin
      ok:=false;
      for a:=1 to 2 do
        if not ok then
          for b:=a+1 to 3 do
            if not ok then
              begin
                if (y[i,a]=y[i,b])and(y[i,6-a-b]>y[i,a]) then
                  begin
                    inc(count[dn]);
                    l[dn,count[dn]]:=abs(x[i,a]-x[i,b]);
                    dx[dn,count[dn]]:=x[i,6-a-b]-min(x[i,a],x[i,b]);
                    h[dn,count[dn]]:=y[i,6-a-b]-y[i,a];
                    num[dn,count[dn]]:=i;
                    ok:=true;
                    break;
                  end;
                if (y[i,a]=y[i,b])and(y[i,6-a-b]<y[i,a]) then
                  begin
                    inc(count[up]);
                    l[up,count[up]]:=abs(x[i,a]-x[i,b]);
                    dx[up,count[up]]:=-(x[i,6-a-b]-max(x[i,a],x[i,b]));
                    h[up,count[up]]:=-(y[i,6-a-b]-y[i,a]);
                    num[up,count[up]]:=i;
                    ok:=true;
                    break;
                  end;
                if (x[i,a]=x[i,b])and(x[i,6-a-b]>x[i,a]) then
                  begin
                    inc(count[lt]);
                    l[lt,count[lt]]:=abs(y[i,a]-y[i,b]);
                    dx[lt,count[lt]]:=-(y[i,6-a-b]-max(y[i,a],y[i,b]));
                    h[lt,count[lt]]:=x[i,6-a-b]-x[i,a];
                    num[lt,count[lt]]:=i;
                    ok:=true;
                    break;
                  end;
                if (x[i,a]=x[i,b])and(x[i,6-a-b]<x[i,a]) then
                  begin
                    inc(count[rt]);
                    l[rt,count[rt]]:=abs(y[i,a]-y[i,b]);
                    dx[rt,count[rt]]:=(y[i,6-a-b]-min(y[i,a],y[i,b]));
                    h[rt,count[rt]]:=-(x[i,6-a-b]-x[i,a]);
                    num[rt,count[rt]]:=i;
                    ok:=true;
                    break;
                  end;
              end;
      if not ok then
        done;
    end;

  for i:=0 to 3 do
    for j:=1 to count[i] do
      ang[i,j]:=polar(dx[i,j],h[i,j]);

  for a:=0 to 3 do
    for i:=1 to count[a]-1 do
      for j:=i+1 to count[a] do
        if ang[a,i]>ang[a,j] then
          begin
            p:=ang[a,i];
            ang[a,i]:=ang[a,j];
            ang[a,j]:=p;
            p:=l[a,i];
            l[a,i]:=l[a,j];
            l[a,j]:=p;
            p:=h[a,i];
            h[a,i]:=h[a,j];
            h[a,j]:=p;
            p:=dx[a,i];
            dx[a,i]:=dx[a,j];
            dx[a,j]:=p;
            b:=num[a,i];
            num[a,i]:=num[a,j];
            num[a,j]:=b;
          end;

  ok:=true;
  for i:=0 to 3 do
    for j:=1 to count[i]-1 do
      if (h[i,j]<>h[i,j+1])or(dx[i,j]-l[i,j]<>dx[i,j+1]) then
        ok:=false;

  if (dx[dn,1]<>h[lt,count[lt]])or(h[dn,1]<>l[lt,count[lt]]-dx[lt,count[lt]]) then
    ok:=false;
  if (dx[lt,1]<>h[up,count[up]])or(h[lt,1]<>l[up,count[up]]-dx[up,count[up]]) then
    ok:=false;
  if (dx[up,1]<>h[rt,count[rt]])or(h[up,1]<>l[rt,count[rt]]-dx[rt,count[rt]]) then
    ok:=false;
  if (dx[rt,1]<>h[dn,count[dn]])or(h[rt,1]<>l[dn,count[dn]]-dx[dn,count[dn]]) then
    ok:=false;

  if not ok then
    done;

  curd:=0;
  for i:=1 to count[dn] do
    begin
      ok:=false;
      for a:=1 to 2 do
        if not ok then
          for b:=a+1 to 3 do
            if not ok then
              if y[num[dn,i],a]=y[num[dn,i],b] then
                begin
                  if x[num[dn,i],a]<x[num[dn,i],b] then
                    begin
                      nx[num[dn,i],a]:=curd;
                      nx[num[dn,i],b]:=curd+l[dn,i];
                    end
                  else
                    begin
                      nx[num[dn,i],b]:=curd;
                      nx[num[dn,i],a]:=curd+l[dn,i];
                    end;
                  nx[num[dn,i],6-a-b]:=dx[dn,i]+curd;
                  ny[num[dn,i],a]:=0;
                  ny[num[dn,i],b]:=0;
                  ny[num[dn,i],6-a-b]:=h[dn,i];
                  ok:=true;
                  curd:=curd+l[dn,i];
                end;
    end;

  rx:=curd;
  curd:=0;
  for i:=1 to count[rt] do
    begin
      ok:=false;
      for a:=1 to 2 do
        if not ok then
          for b:=a+1 to 3 do
            if not ok then
              if x[num[rt,i],a]=x[num[rt,i],b] then
                begin
                  nx[num[rt,i],a]:=rx;
                  nx[num[rt,i],b]:=rx;
                  nx[num[rt,i],6-a-b]:=rx-h[rt,i];
                  if y[num[rt,i],a]<y[num[rt,i],b] then
                    begin
                      ny[num[rt,i],a]:=curd;
                      ny[num[rt,i],b]:=curd+l[rt,i];
                    end
                  else
                    begin
                      ny[num[rt,i],b]:=curd;
                      ny[num[rt,i],a]:=curd+l[rt,i];
                    end;
                  ny[num[rt,i],6-a-b]:=curd+dx[rt,i];
                  curd:=curd+l[rt,i];
                  ok:=true;
                end;
    end;

  ry:=curd;
  curd:=0;
  for i:=1 to count[up] do
    begin
      ok:=false;
      for a:=1 to 2 do
        if not ok then
          for b:=a+1 to 3 do
            if not ok then
              if y[num[up,i],a]=y[num[up,i],b] then
                begin
                  if x[num[up,i],a]>x[num[up,i],b] then
                    begin
                      nx[num[up,i],a]:=rx-curd;
                      nx[num[up,i],b]:=rx-curd-l[up,i];
                    end
                  else
                    begin
                      nx[num[up,i],b]:=rx-curd;
                      nx[num[up,i],a]:=rx-curd-l[up,i];
                    end;
                  nx[num[up,i],6-a-b]:=rx-curd-dx[up,i];
                  ny[num[up,i],a]:=ry;
                  ny[num[up,i],b]:=ry;
                  ny[num[up,i],6-a-b]:=ry-h[up,i];
                  curd:=curd+l[up,i];
                  ok:=true;
                end;
    end;

  curd:=0;
  for i:=1 to count[lt] do
    begin
      ok:=false;
      for a:=1 to 2 do
        if not ok then
          for b:=a+1 to 3 do
            if not ok then
              if x[num[lt,i],a]=x[num[lt,i],b] then
                begin
                  nx[num[lt,i],a]:=0;
                  nx[num[lt,i],b]:=0;
                  nx[num[lt,i],6-a-b]:=h[lt,i];
                  if y[num[lt,i],a]>y[num[lt,i],b] then
                    begin
                      ny[num[lt,i],a]:=ry-curd;
                      ny[num[lt,i],b]:=ry-curd-l[lt,i];
                    end
                  else
                    begin
                      ny[num[lt,i],b]:=ry-curd;
                      ny[num[lt,i],a]:=ry-curd-l[lt,i];
                    end;
                  ny[num[lt,i],6-a-b]:=ry-curd-dx[lt,i];
                  curd:=curd+l[lt,i];
                  ok:=true;
                end;
    end;

  ok:=true;
end;

begin
  init;
  run;
  done;
end.
