{$Q-,S-,R-,I-,N+}
const
  cinfile = 'glass.in';
  coutfile = 'glass.out';
  nmax = 2000;
  eps = 1E-8;

type
  int = longint;
  real = extended;
  tpoint = record
             x,y : int;
           end;
  tttr = array[1..3] of tpoint;
  ttr = array[1..nmax] of tttr;

var
  n : int;
  ans : int;
  tr : ttr;
  used : array[1..nmax] of boolean;
  s : real;

procedure outdata;

var
  i,j : int;
  minx,miny : int;
  maxx,maxy : int;

begin
  minx := 20000;
  maxx := -20000;
  miny := 20000;
  maxy := -20000;
  for i := 1 to n do
    for j := 1 to 3 do
    begin
      if minx > tr[i,j].x then minx := tr[i,j].x;
      if miny > tr[i,j].y then miny := tr[i,j].y;
      if maxx < tr[i,j].x then maxx := tr[i,j].x;
      if maxy < tr[i,j].y then maxy := tr[i,j].y;
    end;
  if abs(round(s) - (maxx - minx)*(maxy-miny)) > eps then
  begin
    write('NO');
    exit;
  end;
  for i := 1 to n do
  begin
    for j := 1 to 3 do
    begin
      write(tr[i,j].x - minx,' ');
      write(tr[i,j].y - miny,' ');
    end;
    writeln;
  end;
  writeln;
end;

function max(a,b : int) : int;
begin
  if a > b then max := a else max := b;
end;

function min(a,b : int) : int;
begin
  if a < b then min := a else min := b;
end;

procedure solve;

var
  i,j : int;
  s : array[0..nmax] of int;
  cur : int;
  q : boolean;

  function connect(t1,t2 : int) : boolean;
  var
    i,j,i1,j1,i2,j2 : int;
    dx,dy : int;
    k : int;
    ld1,ld2,ru1,ru2 : tpoint;

  begin
    for i := 1 to 2 do
      for i1 := i+1 to 3 do
        for j := 1 to 2 do
          for j1 := j+1 to 3 do
          begin
            if i = 2 then i2 := 1 else if i1 = 2 then i2 := 3 else i2 := 2;
            if j = 2 then j2 := 1 else if j1 = 2 then j2 := 3 else j2 := 2;
            if tr[t1,i].x < tr[t1,i1].x then ld1 := tr[t1,i] else
              if (tr[t1,i].x = tr[t1,i1].x)and(tr[t1,i].y < tr[t1,i1].y)
              then ld1 := tr[t1,i] else ld1 := tr[t1,i1];
            if tr[t2,j].x < tr[t2,j1].x then ld2 := tr[t2,j] else
              if (tr[t2,j].x = tr[t2,j1].x)and(tr[t2,j].y < tr[t2,j1].y)
              then ld2 := tr[t2,j] else ld2 := tr[t2,j1];
            dx := ld2.x - ld1.x;
            dy := ld2.y - ld1.y;
            if (ld2.x = tr[t2,j1].x) and (ld2.y = tr[t2,j1].y) then
              ru2 := tr[t2,j] else ru2 := tr[t2,j1];
            if (ld1.x = tr[t1,i1].x) and (ld1.y = tr[t1,i1].y) then
              ru1 := tr[t1,i] else ru1 := tr[t1,i1];
            if (ru1.x + dx <> ru2.x) or (ru1.y + dy <> ru2.y) then continue;
            if not(((ld2.x = tr[t1,i2].x + dx) or
              (ld2.y = tr[t1,i2].y + dy))and
              ((ld2.x = tr[t2,j2].x)or(ld2.y = tr[t2,j2].y))) then
            begin
              if not(((ru2.x = tr[t1,i2].x + dx) or
                (ru2.y = tr[t1,i2].y + dy)) and
                ((ru2.x = tr[t2,j2].x)or(ru2.y = tr[t2,j2].y))) then
              continue;
            end;
            tr[t1,1].x := tr[t1,1].x + dx;
            tr[t1,1].y := tr[t1,1].y + dy;
            tr[t1,2].x := tr[t1,2].x + dx;
            tr[t1,2].y := tr[t1,2].y + dy;
            tr[t1,3].x := tr[t1,3].x + dx;
            tr[t1,3].y := tr[t1,3].y + dy;
            used[t1] := true;
            connect := true;
            for k := 2 to n do
              if (k <> t1) and (not used[k]) and (connect(k,t1)) then
                exit;
              if not used[t1] then connect := false;
              exit;
          end;
    if not used[t1] then connect := false;
  end;

begin
  if n < 4 then begin
    write('NO');
    close(output);
    halt(0);
  end;
  used[1] := true;
  for i := 2 to n do if connect(i,1) then break;
  q := false;
  for i := 1 to n do if not used[i] then
  begin
    write('NO');
    close(output);
    halt(0);
  end;
end;

procedure readdata;

var
  i,j : int;
  ttt : tttr;
  x1,x2,x3,y1,y2,y3 : real;
  a,b,c : real;
  p : real;

begin
  read(n);
  s := 0;
  for i := 1 to n do
  begin
    read(tr[i,1].x,tr[i,1].y,tr[i,2].x,tr[i,2].y,
    tr[i,3].x,tr[i,3].y);
    x1 := tr[i,1].x;
    y1 := tr[i,1].y;
    x2 := tr[i,2].x;
    y2 := tr[i,2].y;
    x3 := tr[i,3].x;
    y3 := tr[i,3].y;
    a := sqrt(sqr(x1-x2)+sqr(y1-y2));
    c := sqrt(sqr(x3-x2)+sqr(y3-y2));
    b := sqrt(sqr(x1-x3)+sqr(y1-y3));
    p := (a+b+c)/2;
    s := s + sqrt(p*(p-a)*(p-b)*(p-c));
  end;
  fillchar(used,sizeof(used),0);
end;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.