type
  integer=longint;

const
  infile='fishes.in';
  outfile='fishes.out';

var
  a:array[1..10000]of integer;
  num:array[1..10000]of integer;
  count:array[1..10000]of integer;
  n,k:integer;

procedure openfiles;
begin
  assign(input,infile);
  assign(output,outfile);
  reset(input);
  rewrite(output);
end;

procedure closefiles;
begin
  close(input);
  close(output);
end;

procedure ok(q:byte);
begin
  writeln('1 ',num[2]);
  write(0);
end;

procedure swap(var a,b:integer);
var
  tmp:integer;

begin
  tmp:=a;
  a:=b;
  b:=tmp;
end;

procedure compress;
var
  sum,i,j:integer;

begin
  num[1]:=1;
  sum:=count[1];
  for i:=2 to n do
  begin
    num[i]:=sum+1;
    sum:=sum+count[i];
  end;
  j:=1;
  i:=2;
  while i<=n do
  begin
    if a[i]<>a[j] then
    begin
      inc(j);
      a[j]:=a[i];
      num[j]:=i;
    end
    else
      count[j]:=count[j]+count[i];
    inc(i);
  end;
  num[1]:=1;
  sum:=count[1];
  for i:=2 to n do
  begin
    num[i]:=sum+1;
    sum:=sum+count[i];
  end;
  n:=j;
end;

function min(a,b:integer):integer;
begin
  if a<b then
    min:=a
  else
    min:=b;
end;

procedure solve;
var
  k1,i,c0,c1:integer;

begin
  read(n,K);
  for i:=1 to n do
  begin
    read(a[i]);
    num[i]:=i;
    count[i]:=1;
  end;
  compress;
  while true do
  begin
    c1:=0;
    C0:=0;
    for i:=1 to n do
    begin
      if a[i]=0 then
        inc(c0);
      if a[i]=1 then
        inc(c1);
    end;
    if ((c1=1)and(c0=1))or(c1=0)or(c0=0) then
    begin
      write(0);
      exit;
    end;
    if (c1=2)and((a[1]=1)or(a[n]=1)) then
    begin
      ok(1);
      exit;
    end;
    if (c0=2)and((a[1]=0)or(a[n]=0)) then
    begin
      ok(0);
      exit;
    end;
    k1:=1;
    write(min(k,n div 3+ord(n mod 3 = 2)),' ');
    for i:=1 to min(k,n div 3+ord(n mod 3 = 2)) do
    begin
      write(num[k1],' ');
      swap(a[k1],a[k1+1]);
      swap(count[k1],count[k1+1]);
      k1:=k1+3;
    end;
    compress;
    writeln;
  end;
end;

begin
  openfiles;
  solve;
  closefiles;
end.
