program Words;
const
  MaxN= 1000;
  inf= 10001;
var
  Ws: array[1..maxN,0..10] of byte;

  N: integer;
  Ms: array[1..250] of byte;
  nMs: integer;

  Soly: array[0..251,1..26] of integer;
  Prev: array[1..251,1..26] of integer;
  PrevL: array[1..251,1..26] of integer;

  mLetter: integer;

  Way: array[1..2000] of integer;
  nw: integer;

  procedure readIn;
  var
    f: text;
    i,j: integer;
    ss: string;
  begin
    assign(f,'chain.in');
    reset(f);
    readln(f,ss);
    nMs:= length(ss);
    for i:=1 to nMs do
      Ms[i]:= Ord(ss[i])-Ord('a')+1;
    Ms[nMs+1]:= 0;
    readLn(f,N);
    for i:=1 to N do
    begin
      readln(f,ss);
      Ws[i,0]:= length(ss);
      for j:=1 to Ws[i,0] do
        Ws[i,j]:= Ord(ss[j])-Ord('a')+1;
    end;
    close(f);
  end;

  procedure FillSoly;
  var
    i,j: integer;
  begin
    for i:=1 to nMs+1 do
    for j:=1 to 26 do
      Soly[i,j]:= inf;
    for j:=1 to 26 do
      Soly[1,j]:= 0;
  end;

  function FindNs(id,fn: integer): integer;
  var
    i: integer;
    rn: integer;
  begin
    rn:= fn;
    for i:= 2 to Ws[id,0] do
      if Ws[id,i]=Ms[rn] then
        inc(rn);
    FindNs:= rn;
  end;

  function FindNsF(id,fn: integer): integer;
  var
    i: integer;
    rn: integer;
  begin
    rn:= fn;
    for i:= 1 to Ws[id,0] do
      if Ws[id,i]=Ms[rn] then
        inc(rn);
    FindNsF:= rn;
  end;


  procedure Calc;
  var
    i,j: integer;
    ns: integer;
  begin
    for i:=1 to nMs do
    begin
      j:=1;
      repeat
        if i=1 then
          ns:= findNsF(j,i)
        else
          ns:= findNs(j,i);
        if Soly[i,Ws[j,1]]+Ws[j,0]< Soly[ns,Ws[j,Ws[j,0]]] then
        begin
          Prev[ns,Ws[j,Ws[j,0]]]:= j;
          PrevL[ns,Ws[j,Ws[j,0]]]:= i;
          Soly[ns,Ws[j,Ws[j,0]]]:= Soly[i,Ws[j,1]]+Ws[j,0];
          j:= 1;
        end
        else
          inc(j);
      until j>N;
    end;
  end;

  function FindMinSoly: boolean;
  var
    i: integer;
    minW: integer;
  begin
    minW:= inf;
    for i:=1 to 26 do
    begin
      if Soly[nMs+1,i]<minW then
      begin
        minW:= Soly[nMs+1,i];
        mLetter:= i;
      end;
    end;
    FindMinSoly:= minW<inf;
  end;

  procedure MakeWay;
  var
    pr,pl: integer;
  begin
    nw:= 0;
    pr:= nMs+1;
    pl:= mLetter;
    while Prev[pr,pl]>0 do
    begin
      inc(nw);
      Way[nw]:= Prev[pr,pl];
      pr:= PrevL[pr,pl];
      pl:= Ws[Way[nw],1];
    end;
  end;

  procedure WriteRes;
  var
    f: Text;
    i,j: integer;
  begin
    assign(f,'chain.out');
    rewrite(f);

    for i:=nw downto 1 do
    begin
      for j:=1 to Ws[Way[i],0] do
        write(f,Chr(Ord('a')-1+Ws[Way[i],j]));
      writeln(f);
    end;

    close(f);
  end;

  procedure WritenonRes;
  var
    f: Text;
  begin
    assign(f,'chain.out');
    rewrite(f);

    writeln(f,'?');

    close(f);
  end;

begin
  ReadIn;
  FillSoly;
  Calc;
  if FindMinSoly then
  begin
    MakeWay;
    WriteRes;
  end
  else
    WriteNonRes;
end.