#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

#define INF ((long)0x7FFFFF00)

#define N 250
#define M 26

int str2wrd(char*,int*);
int inscount(int*,int*,int,int);

struct TWord {
  int s[10];
  int l;
  char t[12];
};
struct TInfo {
  int x,y,z;
  long o;
};
typedef TInfo TTInfo[M];

int c,n,m;
TWord*a; int b[N];
TTInfo*d;
int*q; char*p;

int main(void) {
  int i; char st[256];
  fi=fopen("chain.in","rt");
  fscanf(fi,"%s%d",st,&c);
  a=new TWord[c];
  n=str2wrd(st,b);
  for (i=0; i<c; i++) {
    fscanf(fi,"%s",a[i].t);
    a[i].l=str2wrd(a[i].t,a[i].s);
  }
  fclose(fi);

  int j,k,l,z,r;
  d=new TTInfo[n+1];
  memset(d,-1,(n+1)*sizeof(TTInfo));
  for (i=0; i<=n; i++) for (j=0; j<M; j++) d[i][j].o=INF;

  q=new int[M]; p=new char[M];
  for (k=0; k<c; k++) {
    l=inscount(a[k].s,b,a[k].l,n);
    z=a[k].s[a[k].l-1];
    if (d[l][z].o>long(a[k].l)) {
      d[l][z].z=k;
      d[l][z].o=long(a[k].l);
    }
  }
  for (i=0; i<n; i++) {
    r=0; memset(p,1,M*sizeof(char));
    for (j=0; j<M; j++) if (d[i][j].o<INF) { q[r++]=j; p[j]=0; }
    for (j=0; j<r; j++) for (k=0; k<c; k++) if (a[k].s[0]==q[j]) {
      l=inscount(&a[k].s[1],&b[i],a[k].l-1,n-i)+i;
      z=a[k].s[a[k].l-1];
      if (d[l][z].o>d[i][q[j]].o+long(a[k].l-1)) {
        d[l][z].x=i; d[l][z].y=q[j];
        d[l][z].z=k;
        d[l][z].o=d[i][q[j]].o+long(a[k].l-1);
      }
      if (l<=i) if (p[z]) { q[r++]=z; p[z]=0; }
    }
  }
  delete[]q; delete[]p;

  for (k=0; k<M; k++) if (d[n][k].o<INF) break;
  for (i=k+1; i<M; i++) if (d[n][i].o<d[n][k].o) k=i;
  m=(k<M);
  q=new int[(n+2)*M];
  if (m) {
    q[0]=d[n][k].z; r=1;
    j=d[n][k].y; i=d[n][k].x;
    while ((i>=0)&&(j>=0)) {
      q[r++]=d[i][j].z;
      k=j; j=d[i][k].y; i=d[i][k].x;
    }
  }

  fo=fopen("chain.out","wt");
  if (m) {
    for (i=r-1; i>=0; i--) fprintf(fo,"%s\n",a[q[i]].t);
  } else fprintf(fo,"?");
  fclose(fo);
  delete[]q;
  delete[]d;
  delete[]a;
  return(0);
}


int str2wrd(char*s,int*t) {
  int l=strlen(s);
  int i;
  for (i=0; i<l; i++) t[i]=(int)( (((unsigned char)s[i])-'a') % M );
  return(l);
}
long zzz=0;
int inscount(int*a,int*b,int l,int n) {
  zzz++;
  int i,c;
  for (i=0,c=0; (i<l)&&(c<n); i++) if (a[i]==b[c]) c++;
  return(c);
}

