{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
Const MaxN=2000;
      INPUTFILE='glass.in';
      OUTPUTFILE='glass.out';

Type Real=Double;
     Point=record
     x,y:Longint;
     end;
var N:Longint;
    i,j,g:Longint;
    a:Array[1..MaxN,1..3] of Point;
    IsBusy:Array[1..MaxN,1..3] of Boolean;
    Left,Top,Right,Bottom:Array[1..MaxN] of Integer;
    LeftNum,TopNum,RightNum,BottomNum:Integer;
    HasBeenLast:Array[1..MaxN] of Boolean;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N do
for j:=1 to 3 do
  Read(a[i,j].x,a[i,j].y);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
if Answer=0 then
  Writeln('NO')
else
begin
  for i:=1 to N do
  begin
    for j:=1 to 3 do
      Write(a[i,j].x,' ',a[i,j].y,' ');
    Writeln;
  end;
end;
Close(Output);
Halt;
end;

var h,k,l:Longint;
    A1,B1,C1:Longint;
    t1,t2,t3,t4:Longint;
    Last:Longint;

Procedure DoLeft;
var OldLast:Longint;
begin
While True Do  {UBRAT KEYPRESSED!!!}
begin
  HasBeenLast[Last]:=True;
  OldLast:=Last;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to LeftNum do
    if Left[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Left[i],g].x-a[Left[i],h].x;
      t4:=a[Left[i],g].y-a[Left[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Left[i],g].x>a[Left[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Last,k].x>a[Last,l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Left[i],g].x-a[Last,k].x;
          t2:=a[Left[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Left[i],j].x,t1);
            Dec(a[Left[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Left[i],6-g-h].x+B1*a[Left[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Left[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
             else
            for j:=1 to 3 do
            begin
              Inc(a[Left[i],j].x,t1);
              Inc(a[Left[i],j].y,t2);
            end;
      end;
    end;
  end;
  if OldLast=Last then Exit;
end;
end;

Procedure DoLeftBottom;
begin
  HasBeenLast[Last]:=True;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to BottomNum do
    if Bottom[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Bottom[i],g].x-a[Bottom[i],h].x;
      t4:=a[Bottom[i],g].y-a[Bottom[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Bottom[i],g].x>a[Bottom[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Bottom[i],k].x>a[Bottom[i],l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Bottom[i],g].x-a[Last,k].x;
          t2:=a[Bottom[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Bottom[i],j].x,t1);
            Dec(a[Bottom[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Bottom[i],6-g-h].x+B1*a[Bottom[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Bottom[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
             else
             for j:=1 to 3 do
             begin
               Inc(a[Bottom[i],j].x,t1);
               Inc(a[Bottom[i],j].y,t2);
             end;

      end;
    end;
  end;

end;

Procedure DoBottom;
var OldLast:Longint;
begin
While True Do  {UBRAT KEYPRESSED!!!}
begin
  HasBeenLast[Last]:=True;
  OldLast:=Last;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to BottomNum do
    if Bottom[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Bottom[i],g].x-a[Bottom[i],h].x;
      t4:=a[Bottom[i],g].y-a[Bottom[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Bottom[i],g].x>a[Bottom[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Last,k].x>a[Last,l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Bottom[i],g].x-a[Last,k].x;
          t2:=a[Bottom[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Bottom[i],j].x,t1);
            Dec(a[Bottom[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Bottom[i],6-g-h].x+B1*a[Bottom[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Bottom[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
             else
             for j:=1 to 3 do
             begin
               Inc(a[Bottom[i],j].x,t1);
               Inc(a[Bottom[i],j].y,t2);
             end;

      end;
    end;
  end;
  if OldLast=Last then Exit;
end;
end;

Procedure DoBottomRight;
begin
  HasBeenLast[Last]:=True;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to RightNum do
    if Right[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Right[i],g].x-a[Right[i],h].x;
      t4:=a[Right[i],g].y-a[Right[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Right[i],g].x>a[Right[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Last,k].x>a[Last,l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Right[i],g].x-a[Last,k].x;
          t2:=a[Right[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Right[i],j].x,t1);
            Dec(a[Right[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Right[i],6-g-h].x+B1*a[Right[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Right[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
          else
          for j:=1 to 3 do
          begin
            Inc(a[Right[i],j].x,t1);
            Inc(a[Right[i],j].y,t2);
          end;
      end;
    end;
  end;
end;

Procedure DoRight;
var OldLast:Longint;
begin
While True Do  {UBRAT KEYPRESSED!!!}
begin
  HasBeenLast[Last]:=True;
  OldLast:=Last;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to RightNum do
    if Right[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Right[i],g].x-a[Right[i],h].x;
      t4:=a[Right[i],g].y-a[Right[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Right[i],g].x>a[Right[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Last,k].x>a[Last,l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Right[i],g].x-a[Last,k].x;
          t2:=a[Right[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Right[i],j].x,t1);
            Dec(a[Right[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Right[i],6-g-h].x+B1*a[Right[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Right[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
             else
             for j:=1 to 3 do
             begin
               Inc(a[Right[i],j].x,t1);
               Inc(a[Right[i],j].y,t2);
             end;

      end;
    end;
  end;
  if OldLast=Last then Exit;
end;
end;

Procedure DoRightTop;
begin
  HasBeenLast[Last]:=True;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to TopNum do
    if Top[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Top[i],g].x-a[Top[i],h].x;
      t4:=a[Top[i],g].y-a[Top[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Top[i],g].x>a[Top[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Last,k].x>a[Last,l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Top[i],g].x-a[Last,k].x;
          t2:=a[Top[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Top[i],j].x,t1);
            Dec(a[Top[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Top[i],6-g-h].x+B1*a[Top[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Top[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
          else
          for j:=1 to 3 do
          begin
            Inc(a[Top[i],j].x,t1);
            Inc(a[Top[i],j].y,t2);
          end;
      end;
    end;
  end;
end;

Procedure DoTop;
var OldLast:Longint;
begin
While True Do  {UBRAT KEYPRESSED!!!}
begin
  HasBeenLast[Last]:=True;
  OldLast:=Last;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to TopNum do
    if Top[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Top[i],g].x-a[Top[i],h].x;
      t4:=a[Top[i],g].y-a[Top[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Top[i],g].x>a[Top[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Last,k].x>a[Last,l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Top[i],g].x-a[Last,k].x;
          t2:=a[Top[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Top[i],j].x,t1);
            Dec(a[Top[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Top[i],6-g-h].x+B1*a[Top[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Top[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
             else
             for j:=1 to 3 do
             begin
               Inc(a[Top[i],j].x,t1);
               Inc(a[Top[i],j].y,t2);
             end;

      end;
    end;
  end;
  if OldLast=Last then Exit;
end;
end;

Procedure DoTopLeft;
begin
  HasBeenLast[Last]:=True;
  for k:=1 to 3 do
  for l:=k+1 to 3 do
  if IsBusy[Last,6-k-l]=False then
  begin
    t1:=a[Last,k].x-a[Last,l].x;
    t2:=a[Last,k].y-a[Last,l].y;
    for i:=1 to LeftNum do
    if Left[i]<>Last then
    for g:=1 to 3 do
    for h:=g+1 to 3 do
    begin
      t3:=a[Left[i],g].x-a[Left[i],h].x;
      t4:=a[Left[i],g].y-a[Left[i],h].y;
      if ((t1=t3) AND (t2=t4)) OR ((t1=-t3) AND (t2=-t4)) then
      begin
          if a[Left[i],g].x>a[Left[i],h].x then
          begin
            g:=g XOR h;
            h:=g XOR h;
            g:=g XOR h;
          end;
          if a[Last,k].x>a[Last,l].x then
          begin
            k:=k XOR l;
            l:=k XOR l;
            k:=k XOR l;
          end;

          t1:=a[Left[i],g].x-a[Last,k].x;
          t2:=a[Left[i],g].y-a[Last,k].y;
          for j:=1 to 3 do
          begin
            Dec(a[Left[i],j].x,t1);
            Dec(a[Left[i],j].y,t2);
          end;
          A1:=a[Last,k].y-a[Last,l].y;
          B1:=a[Last,l].x-a[Last,k].x;
          C1:=-A1*a[Last,k].x-B1*a[Last,k].y;
          if (A1*a[Last,6-k-l].x+B1*a[Last,6-k-l].y+C1)*
             (A1*a[Left[i],6-g-h].x+B1*a[Left[i],6-g-h].y+C1)<0 then
             begin
               IsBusy[Last,6-k-l]:=True;
               Last:=Left[i];
               IsBusy[Last,6-g-h]:=True;
               Exit;
             end
          else
          for j:=1 to 3 do
          begin
            Inc(a[Left[i],j].x,t1);
            Inc(a[Left[i],j].y,t2);
          end;
      end;
    end;
  end;
end;

Procedure Solve;
var k,l:Longint;
begin
LeftNum:=0;
RightNum:=0;
TopNum:=0;
BottomNum:=0;

for i:=1 to N do
for k:=1 to 3 do
for l:=k+1 to 3 do
  begin
    if (a[i,k].x=a[i,l].x) AND (a[i,6-k-l].x>a[i,k].x) then
    begin
      Inc(LeftNum);
      Left[LeftNum]:=i;
    end;
    if (a[i,k].x=a[i,l].x) AND (a[i,6-k-l].x<a[i,k].x) then
    begin
      Inc(RightNum);
      Right[RightNum]:=i;
    end;
    if (a[i,k].y=a[i,l].y) AND (a[i,6-k-l].y>a[i,k].y) then
    begin
      Inc(BottomNum);
      Bottom[BottomNum]:=i;
    end;
    if (a[i,k].y=a[i,l].y) AND (a[i,6-k-l].y<a[i,k].y) then
    begin
      Inc(TopNum);
      Top[TopNum]:=i;
    end;
  end;

FillChar(IsBusy,SizeOf(IsBusy),False);
FillChar(HasBeenLast,SizeOf(HasBeenLast),False);
if (LeftNum=0) OR (TopNum=0) OR (RightNum=0) OR (BottomNum=0) then
  FWrite(0);
Last:=Left[1];
DoLeft;
DoLeftBottom;
DoBottom;
DoBottomRight;
DoRight;
DoRightTop;
DoTop;
DoTopLeft;

t1:=a[1,1].x;
t2:=a[1,1].y;
for i:=1 to N do
for j:=1 to 3 do
begin
  if a[i,j].x<t1 then t1:=a[i,j].x;
  if a[i,j].y<t2 then t2:=a[i,j].y;
end;

for i:=1 to N do
for j:=1 to 3 do
begin
  Dec(a[i,j].x,t1);
  Dec(a[i,j].y,t2);
end;
for i:=1 to N do
  if HasBeenLast[i]=False then FWrite(0);
FWrite(1);
end;

begin
FRead;
Solve;
end.
