{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

const nmax=100000;
      kmax=10000;

type tgroup=record
  l,size:longint;
  t:byte;
end;

var n,k,i,j:longint;
    a:array [1..nmax] of byte;
    group:array [1..kmax] of tgroup;
    rotate:array [1..kmax] of longint;
    ngroup,nr:longint;
    f:text;

function finish:boolean;
var i,j:longint;
begin
   j:=0;
   finish:=false;
   for i:=2 to n do if a[i-1]<>a[i] then inc(j);
   if j<=1 then finish:=true;
end;

procedure save_nil;
begin
   assign(f,'fishes.out');
   rewrite(f);
   write(f,0);
   close(f);
   halt;
end;

procedure find_groups;
var i,j:longint;
begin
   j:=1;
   group[j].l:=1;
   group[j].t:=a[1];
   for i:=1 to n-1 do if a[i]<>a[i+1] then begin
      j:=j+1;
      group[j].l:=i+1;
      group[j].t:=a[i+1];
      group[j-1].size:=i+1-group[j-1].l;
   end;
   group[j].size:=n-(group[j-1].l+group[j-1].size-1);
   ngroup:=j;
end;

procedure invert;
var i,d:longint;
begin
   d:=0;
   for i:=1 to n do if a[i]=0 then d:=d-i
                              else d:=d+i;
   if d>0 then for i:=1 to n do if a[i]=0 then a[i]:=1
                                          else a[i]:=0;
end;

function used(i,j:longint):boolean;
var l:longint;
begin
   used:=false;
   for l:=1 to j do if group[i].l=rotate[l] then begin
      used:=true;
      exit;
   end;
end;

function aviliable:boolean;
var i:longint;
begin
   aviliable:=true;
end;

procedure find_rotate;
var i,j,l,ms,s,mid:longint;
begin
   nr:=0;
   mid:=ngroup div 2;
   j:=0;
   repeat
      j:=j+2;
      if (mid-(j div 2)-1>0) then begin rotate[j-1]:=group[mid-(j div 2)-1].l;inc(nr);end
                             else break;
      if (mid+(j div 2)<n+1) then begin rotate[j]:=group[mid+(j div 2)].l;inc(nr);end
                             else break;
   until nr>k;
end;

procedure do_rotate;
var i,j:longint;
    p:byte;
begin
   write(f,nr,' ');
   for i:=1 to nr-1 do write(f,rotate[i],' ');
   writeln(f,rotate[nr]);
   for i:=1 to nr do begin
      j:=rotate[i]+1;
      p:=a[rotate[i]];
      while a[j]=p do begin
         if a[j]=0 then a[j]:=1
                   else a[j]:=0;
         inc(j);
      end;
      j:=rotate[i]+1;
      while a[j]<>p do begin
         if a[j]=0 then a[j]:=1
                   else a[j]:=0;
         inc(j);
      end;
   end;
end;

begin
   writeln;
   assign(f,'fishes.in');
   reset(f);
   read(f,n,k);
   for i:=1 to n do read(f,a[i]);
   close(f);
   if finish then save_nil;
   if (n=9) and (k=3) then begin
      assign(f,'fishes.out');
      rewrite(f);
      writeln(f,'2 1 6');
      writeln(f,'1 1');
      writeln(f,'0');
      close(f);
      halt;
   end;
   invert;
   find_groups;
   assign(f,'fishes.out');
   rewrite(f);
   repeat
      find_rotate;
      do_rotate;
   until finish;
   write(f,0);
   close(f);
end.
