{$A+,B-,D-,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const maxn=2000;
type real=extended;
     tpoint=record
      x,y:real;
     end;
var
 a:array[1..maxn,1..3] of tpoint;
 n:integer;
 ans:boolean;
procedure print;forward;
procedure init;
 var i,j:integer;
 begin
  assign(input,'glass.in');
  reset(input);
   read(n);
   for i:=1 to n do
    for j:=1 to 3 do
     begin
      read(a[i,j].x,a[i,j].y);
     end;
  close(input);
 end;
function prov(p1,p2:tpoint):boolean;
 begin
  if (p1.x=p2.x)or(p1.y=p2.y) then prov:=true else prov:=false;
 end;
function rast2point(p1,p2:tpoint):real;
 begin
  rast2point:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
 end;
function eqreal(a,b:real):boolean;
 begin
  eqreal:=abs(a-b)<=1e-5;
 end;
function prov3(p1,p2:tpoint):boolean;
 begin
  prov3:=(eqreal(p1.x,p2.x))and(eqreal(p1.y,p2.y));
 end;
procedure search(var x,y:real;i0:integer;var ap,bp,cp:tpoint);
 var i,j:integer;
     pt:integer;
     p:array[1..4] of tpoint;
     p1:array[1..2] of tpoint;
 begin
  for i:=1 to 3 do p[i]:=a[i0,i];
  p[4]:=p[1];
  for i:=1 to 3 do
   if prov(p[i],p[i+1]) then
    begin
     p1[1]:=p[i];
     p1[2]:=p[i+1];
    end;
  bp:=p1[1];
  cp:=p1[2];
  for i:=1 to 4 do
   for j:=1 to 2 do
    if (not prov3(p[i],p1[1]))and(not prov3(p[i],p1[2])) then
     begin
      x:=p[i].x;
      y:=p[i].y;
      ap.x:=x;
      ap.y:=y;
      exit;
     end;
 end;
function sqt(p1,p2,p3:tpoint):real;
 begin
  sqt:=abs((p1.x*(p2.y-p3.y)+p2.x*(p3.y-p1.y)+p3.x*(p1.y-p2.y))/2);
 end;
function give(a,b,c:tpoint):real;
 var ra,rb,rc:real;
     cos,sin:real;
 begin
  ra:=rast2point(a,b);
  rb:=rast2point(b,c);
  rc:=rast2point(c,a);
  cos:=(sqr(ra)+sqr(rc)-sqr(rb))/(2*ra*rc);
  sin:=(2*sqt(a,b,c))/(ra*rc);
  give:=arctan(sin/cos);
 end;
function moreeq(a,b:real):boolean;
 begin
  moreeq:=(eqreal(a,b))or((a-b)>1e-5);
 end;
procedure solve;
 var i,j:integer;
     ap,bp,cp:tpoint;
     x,y:real;
     alfa:real;
 begin
  ans:=true;alfa:=0;
  for i:=1 to n do
   begin
    search(x,y,i,ap,bp,cp);
    for j:=1 to 3 do
     begin
      a[i,j].x:=a[i,j].x-x;
      a[i,j].y:=a[i,j].y-y;
     end;
    alfa:=alfa+give(ap,bp,cp);
   end;
  alfa:=abs(alfa);
  while moreeq(alfa,pi) do alfa:=alfa-pi;
  if not eqreal(abs(alfa),0) then ans:=false;
 end;
procedure print;
 var i,j:integer;
     x,y:real;
 begin
  assign(output,'glass.out');
  rewrite(output);
   if not ans then writeln('NO') else
    begin
     x:=maxint;y:=maxint;
     for i:=1 to n do
      for j:=1 to 3 do
       begin
        if a[i,j].x<x then x:=a[i,j].x;
        if a[i,j].y<y then y:=a[i,j].y;
       end;
     for i:=1 to n do
      begin
       for j:=1 to 3 do
        write(a[i,j].x-x:0:0,' ',a[i,j].y-y:0:0,' ');
        writeln;
      end;
    end;
  close(output);
 end;
begin
 init;
 solve;
 print;
end.
