#include <stdio.h>
#include <stdlib.h>

#define NN 2100

struct POINT {
  int x,y;
};

FILE *fi, *fo;
POINT a[NN][3];
POINT b[NN];
int f[NN];
int v[NN];
bool used[NN];
int n;

bool pos(POINT vv,int q,int *r, int *t)
{
  int i,j;
  for(i=0;i<3;i++)
  {
    for(j=0;j<3;j++)
    {
      if(((a[q][i].x-a[q][j].x)==vv.x)&&((a[q][i].y-a[q][j].y)==vv.y))
      {
        *r=j;
        *t=i;
        return true;
      }
    }
  }
  return false;
}

bool IsRect()
{
  int qq;
  int i;
  qq=0;
  for(i=1;i<n;i++)
  {
    if(((b[i-1].x-b[i].x)*(b[i].x-b[i+1].x)+(b[i-1].y-b[i].y)*(b[i].y-b[i+1].y))==0)
      qq++;
    else
      if((b[i-1].x-b[i].x)*(b[i].y-b[i+1].y)!=(b[i-1].y-b[i].y)*(b[i].x-b[i+1].x))
        return false;
  }
    if(((b[0].x-b[1].x)*(b[n-1].x-b[n].x)+(b[0].y-b[1].y)*(b[n-1].y-b[n].y))==0)
      qq++;
    else
      if((b[0].x-b[1].x)*(b[n-1].y-b[n].y)!=(b[0].y-b[1].y)*(b[n-1].x-b[n].x))
        return false;
  if(qq!=4)
    return false;
  return true;
}

int main()
{
  int i,j,k;
  int q;
  int r,t;
  int ii,jj,kk;
  int ff;
  int minx, miny;
  int maxx, maxy;
  bool flag;
  POINT vv;
  fi=fopen("glass.in","rt");
  fo=fopen("glass.out","wt");

  fscanf(fi,"%i",&n);
  if(n<4)
  {
    fprintf(fo,"NO\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  for(i=0;i<n;i++)
    for(j=0;j<3;j++)
      fscanf(fi,"%i%i",&a[i][j].x,&a[i][j].y);

  for(j=0;j<3;j++)
  {
    for(i=0;i<n;i++)
      used[i]=false;
    used[0]=true;
    f[0]=0;
    v[0]=j;
    q=0;
    for(k=0;k<3;k++)
    {
      if(k!=j)
      {
        b[q]=a[0][k];
        q++;
      }
    }
    for(k=1;k<n;k++)
    {
      vv.x=b[q-1].x-a[0][j].x;
      vv.y=b[q-1].y-a[0][j].y;
      for(i=1;i<n;i++)
      {
        if(!used[i])
        {
          if(pos(vv,i,&r,&t))
          {
            for(ii=0;ii<3;ii++)
              if((ii!=r)&&(ii!=t))
                ff=ii;
            if((a[i][ff].x==a[i][t].x)||(a[i][ff].y==a[i][t].y))
            {
              vv.x=a[0][j].x-a[i][r].x;
              vv.y=a[0][j].y-a[i][r].y;
              for(jj=0;jj<3;jj++)
              {
                a[i][jj].x+=vv.x;
                a[i][jj].y+=vv.y;
              }
              b[q]=a[i][ff];
              f[k]=i;
              used[i]=true;
              v[k]=r;
              i=n+1;
              q++;
            }
          }
        }
      }
    }
    if(q==(n+1))
    {
      if((b[0].x==b[n].x)&&(b[0].y==b[n].y))
      {
        if(IsRect())
        {
          minx=100000;
          miny=100000;
          maxx=-minx;
          maxy=-miny;
          flag=true;
          for(i=0;i<q;i++)
          {
            if(b[i].x<minx) minx=b[i].x;
            if(b[i].y<miny) miny=b[i].y;
            if(b[i].x>maxx) maxx=b[i].x;
            if(b[i].y>maxy) maxy=b[i].y;
          }
          for(i=0;i<n;i++)
          {
            for(ii=0;ii<3;ii++)
            {
              if(a[i][ii].x<minx) flag=false;
              if(a[i][ii].x>maxx) flag=false;
              if(a[i][ii].y<miny) flag=false;
              if(a[i][ii].y>maxy) flag=false;
            }
          }
          if(flag)
          {
            for(i=0;i<n;i++)
            {
              for(ii=0;ii<3;ii++)
              {
                a[i][ii].x-=minx;
                a[i][ii].y-=miny;
                fprintf(fo,"%i %i ",a[i][ii].x,a[i][ii].y);
              }
              fprintf(fo,"\n");
            }
            fclose(fi);
            fclose(fo);
            return 0;
          }
        }
      }
    }
  }
  fprintf(fo,"NO\n");

  fclose(fi);
  fclose(fo);
  return 0;
}
