Program Squares;

Var N, K : LongInt;
    I, J : LongInt;
    Temp1: LongInt;
    Temp2: LongInt;
    Temp3: LongInt;

Procedure IsMul(A, D: LongInt; Var B, C: LongInt);
Var Temp1, Temp2: LongInt;
Begin
 For Temp1 := 1 To A Div 2 Do
  For Temp2 := 1 To A Div 2 Do
   If (Temp1 * Temp2 = A) And (((Temp1 + Temp2) * 2) + 4 = D) Then
   Begin
    B := Temp1;
    C := Temp2;
   End;
End;

Function Pow(X: LongInt; P: Byte): LongInt;
Begin
 Case P Of
 0: Pow := 1;
 1: Pow := X;
 Else Pow := Pow(X, P - 1);
 End;
End;

Procedure IsSq(A, D: LongInt; Var B, C, E: LongInt);
Var Temp1 : Integer;
Begin
 Temp1 := 0;
 E := 0;
 IsMul(A, D, B, C);
 If B = 0 Then
  Repeat
   Temp1 := Temp1 + 1;
   IsMul(A, D - Temp1, B, C);
  Until (B = 0) Or (Temp1 = A Div 2);
 E := Temp1;
End;

Begin
 Assign(input, 'squares.in');
 Assign(output, 'squares.out');
 ReSet(input);
 ReWrite(output);

 Read(N, K);
 IsSq(K, N, I, J, Temp3);
 If (I <> 0) And (Temp3 = 0) Then
 Begin
  WriteLn('YES');
  For Temp1 := 0 To I + 1 Do
   Write(Temp1, ' ', 0, '  ');
   WriteLn;
  For Temp2 := 1 To J + 1 Do
   Write(I + 1, ' ', Temp2, '  ');
   WriteLn;
  For Temp1 := I DownTo 0 Do
   Write(Temp1, ' ', J + 1, '  ');
   WriteLn;
  For Temp2 := J DownTo 1 Do
   Write(0, ' ', Temp2, '  ');
   WriteLn;
 End Else
 If (I <> 0) And (Temp3 <> 0) Then
 Begin
  WriteLn('YES');
  For Temp1 := 0 To I + 1 - Temp3 Do
   Write(Temp1, ' ', 0, '  ');
   WriteLn;
  For Temp2 := 1 To Temp3 Do
   Write(I + 1 - Temp3, ' ', Temp2, '  ');
   WriteLn;
  For Temp1 := I + 2 - Temp3 To I + 1 Do
   Write(Temp1, ' ', Temp3, '  ');
   WriteLn;
  For Temp2 := Temp3 + 1 To J + 1 Do
   Write(I + 1, ' ', Temp2, '  ');
   WriteLn;
  For Temp1 := I DownTo 0 Do
   Write(Temp1, ' ', J + 1, '  ');
   WriteLn;
  For Temp2 := J DownTo 1 Do
   Write(0, ' ', Temp2, '  ');
   WriteLn;
 End Else
  WriteLn('NO');

 Close(input);
 Close(output);
End.