program TaskE;
{$E+}
type nexter=^elm;
     elm=record
       id:byte;
       x,y:array[0..2] of longint;
       nx,pv:nexter;
     end;

    ur=record
      a,b,c:extended;
      end;

    grnx=^grnode;
    grnode=record
      id:byte;
      nx,pv:grnx;
      children:array[1..100] of grnx;
      end;


var N,M,K,i,j,tm:longint;
    rt,cr:nexter;
    grt,cgr:grnx;
    p1,p2,p3:ur;
    x,y:extended;
    visited:array[0..100] of boolean;

procedure InitFiles(inp,outp:string);
begin
  Assign(input, inp);
  Assign(output, outp);
  Reset(input);
  Rewrite(output);
end;

procedure CloseFiles;
begin
  Close(input);
  Close(output);
end;


function lng(x1,y1,x2,y2:longint):extended;
begin
  lng:=sqrt(sqr(x2-x1)+sqr(y2-y1));
end;

function TrSq(a,b,c:extended):extended;
var p:extended;
begin
  p:=(a+b+c)/2;
  TrSq:=sqrt(p*(p-a)*(p-b)*(p-c));
end;

function isInTriang(x,y,x1,y1,x2,y2,x3,y3:longint):boolean;
var s:array[0..3] of extended;
begin
  s[0]:=TrSq(lng(x1,y1,x2,y2),lng(x2,y2,x3,y3),lng(x3,y3,x1,y1));
  s[1]:=TrSq(lng(x1,y1,x2,y2),lng(x2,y2,x,y),lng(x,y,x1,y1));
  s[2]:=TrSq(lng(x,y,x2,y2),lng(x2,y2,x3,y3),lng(x3,y3,x,y));
  s[3]:=TrSq(lng(x1,y1,x,y),lng(x,y,x3,y3),lng(x3,y3,x1,y1));
  if (s[0]*1.0000001)<(s[1]+s[2]+s[3]) then isInTriang:=false
  else isInTriang:=true;
end;


procedure FindUr(x1,y1,x2,y2:longint; var a,b,c:extended);
begin
  if x1=x2 then
   begin
     a:=1;
     b:=0;
     c:=-x1;
   end
  else if y1=y2 then
   begin
     a:=0;
     b:=1;
     c:=-y1;
   end
  else
   begin
     b:=1;
     a:=-(y2-y1)/(x2-x1);
     c:=-(y1+a*x1);
   end;
end;

function Peresek(pr1,pr2:ur):boolean;
begin
  if (pr1.b=1) and (pr2.b=1) then
    Peresek:=(abs(pr1.a-pr2.a)>0.000000001)
  else if ((pr1.b=0) and (pr2.b<>0)) or ((pr2.b=0) and (pr1.b<>0)) then
   Peresek:=true
  else Peresek:=false;
end;

procedure FindPerCoord(pr1,pr2:ur; var x,y:extended);
begin
  if pr1.b<>0 then
   begin
     x:=(pr2.b*pr1.c-pr2.c)/(pr2.a-pr2.b*pr1.a);
     y:=-pr1.c-pr1.a*x;
   end
  else
   begin
     x:=(pr1.b*pr2.c-pr1.c)/(pr1.a-pr1.b*pr2.a);
     y:=-pr2.c-pr2.a*x;
   end;
end;

function PeresInOtr(p1,p2:ur;x1,x2:longint):boolean;
var x,y:extended;
begin
 if Peresek(p1,p2) then
  begin
    FindPerCoord(p1,p2,x,y);
    if (x1>x2) and (x>=x1) and (x<=x2) then
      PeresInOtr:=true
    else
     if (x<=x1) and (x>=x2) then
      PeresInOtr:=true
    else
      PeresInOtr:=false;
  end
 else
  PeresInOtr:=false;
end;

function Suits(b,a:nexter):boolean;
var i:longint;
   found:boolean;
   n,l:byte;
   urv:array[0..2] of ur;
   ur1:array[0..2] of ur;
begin
  Suits:=false;
  found:=false;
  for i:=0 to 2 do
    if isInTriang(b^.x[i],b^.y[i],a^.x[0],a^.y[0],a^.x[1],a^.y[1],a^.x[2],a^.y[2]) and not found then
      begin
       found:=true;
       n:=i;
      end
    else if found and isInTriang(b^.x[i],b^.y[i],a^.x[0],a^.y[0],a^.x[1],a^.y[1],a^.x[2],a^.y[2]) then exit;
{Cycle end}
  if not found then exit;
{Found - n is only vertix in triangle}
  for i:=0 to 2 do
  begin
   FindUr(a^.x[i],a^.y[i], a^.x[(i+1) mod 3], a^.y[(i+1) mod 3],urv[i].a, urv[i].b, urv[i].c);
   FindUr(b^.x[i],b^.y[i], b^.x[(i+1) mod 3], b^.y[(i+1) mod 3],ur1[i].a, ur1[i].b, ur1[i].c);
  end;
  found:=false;
  for i:=0 to 2 do
   begin
     if (PeresInOtr(urv[i],ur1[n],a^.x[i], a^.x[(i+1) mod 3])) and (PeresInOtr(urv[i],ur1[(((n-1) mod 3)+3) mod 3], a^.x[i],
      a^.x[(i+1) mod 3])) and (not found) then
       begin
        found:=true;
        l:=i;
       end else
     if (PeresInOtr(urv[i],ur1[n],a^.x[i], a^.x[(i+1) mod 3])) and (PeresInOtr(urv[i],ur1[(((n-1) mod 3)+3) mod 3], a^.x[i],
      a^.x[(i+1) mod 3])) and found then
        begin
          Suits:=false;
          exit;
        end;
   end;
 if found then Suits:=true;
end;

function FindNode(id:byte):grnx;
var tmp:grnx;
begin
  tmp:=grt;
  while (tmp^.id<>id) and (tmp<>nil) do
    tmp:=tmp^.nx;
  FindNode:=tmp;
end;

procedure AddChild(prt:grnx;chld:nexter);
var i:byte;
  tmp:grnx;
begin
  for i:=1 to 100 do
    if prt^.Children[i]=nil then
    begin
      prt^.Children[i]:=FindNode(chld^.id);
      break;
    end;
end;

procedure GetMoves(trg:nexter);
var tmp:nexter;
begin
  tmp:=rt;
  while tmp<>nil do
   begin
     if Suits(tmp,trg) then
       AddChild(FindNode(trg^.id),tmp);
     tmp:=tmp^.nx;
   end;
end;

procedure Pass(id:byte; var double:boolean);
var i:byte;
tgr:grnx;
begin
  if visited[id] then
   begin
    double:=true;
    exit;
   end;
  visited[id]:=true;
  tgr:=FindNode(id);
  for i:=1 to 100 do
    if tgr^.Children[i]<>nil then Pass(tgr^.Children[i]^.id, double);
  visited[id]:=false;
end;

function HasCycle:boolean;
var i,j:byte;
  rst:boolean;
  label strt;
begin
  for i:=0 to N-1 do
   begin
    for j:=0 to N do visited[i]:=false;
    rst:=false;
    Pass(i, rst);
    if rst then begin HasCycle:=true; exit; end;
   end;
  HasCycle:=false;
end;

function NOChildren(a:grnx):byte;
var i:byte;
begin
  i:=1;
  while a^.Children[i]<>nil do
    inc(i);
  NoChildren:=i-1;
end;

function GetMaxLength(id:byte):longint;
var cmax:longint;
    i:byte;
begin
  if NOChildren(FindNode(id))=0 then
    GetMaxLength:=0
  else
   begin
     cmax:=1;
     for i:=1 to NOChildren(FindNode(id)) do
        if GetMaxLength(i)>cmax then
          cmax:=GetMaxLength(i);
     GetMaxLength:=cmax+1;
   end;
end;

function FindRad:integer;
var i:byte;
 maxRasst:longint;
begin
  maxRasst:=0;
  for i:=0 to N-1 do
   begin
     if GetMaxLength(i)>maxRasst then
       maxRasst:=GetMaxLength(i);
   end;
end;

begin
  InitFiles('travel.in','travel.out');
  Readln(N);
  New(rt);
  New(grt);
  grt^.nx:=nil;
  grt^.pv:=nil;
  rt^.pv:=nil;
  rt^.nx:=nil;
  for i:=1 to 100 do
    grt^.Children[i]:=nil;
  cgr:=grt;
  cr:=rt;
  cr^.id:=0;
  cgr^.id:=0;
  for i:=1 to N do
   begin
     Readln(cr^.x[0],cr^.y[0],cr^.x[1],cr^.y[1],cr^.x[2],cr^.y[2]);
     New(cr^.nx);
     cr^.nx^.nx:=nil;
     cr^.nx^.pv:=cr;
     cr:=cr^.nx;
     cr^.id:=cr^.pv^.id+1;
     New(cgr^.nx);
     cgr^.nx^.nx:=nil;
     cgr^.nx^.pv:=cgr;
     cgr:=cgr^.nx;
     cgr^.id:=cgr^.pv^.id+1;
     for j:=1 to 100 do
      begin
       cgr^.Children[j]:=nil;
      end;
   end;
  cr^.pv^.nx:=nil;
  cgr^.pv^.nx:=nil;
  dispose(cgr);
  dispose(cr);
  cgr:=grt;
  cr:=rt;
  while cr<>nil do
   begin
     getMoves(cr);
     cgr:=cgr^.nx;
     cr:=cr^.nx;
   end;
  if HasCycle then
   begin
    Writeln(-1);
   end
  else
   begin
    Writeln(FindRad-1);
   end;
  CloseFiles;
end.

