program problemE;

type typeSequence=array[1..100000] of longint;

procedure readInput(var inputFile: text; var N: longint;
                                var sequence: typeSequence);
    var i: longint;
    begin
        reset(inputFile);
        readln(inputFile, N);
        for i:=1 to N do
        begin
            read(inputFile, sequence[i]);
        end;
        close(inputFile);
    end;{readInput}

function possible(N, i: longint; var sequence: typeSequence): boolean;
    var
        answer: boolean;
        j: longint;
    begin
        answer:=true;
        for j:=1 to i do
        begin
            if ((2*i+1-j)<=N) then
            answer:=(answer and (sequence[j]=sequence[2*i+1-j]));
            if (answer=false) then break;
        end;
        possible:=answer;
    end;{posible}

procedure findAnswer(N: longint; var sequence: typeSequence;
                                            var outputFile: text);
    var i: longint;
    begin
        rewrite(outputFile);
        write(outputFile, N);
        write(outputFile, ' ');
        for i:=1 to (N div 2) do
        begin
            if possible(N, i, sequence)
                then begin
                    write(outputFile, N-i);
                    write(outputFile, ' ');
                end;
        end;
        close(outputFile);
    end;{findAnswer}

var
    sequence: typeSequence;
    N: longint;
    inputFile, outputFile: text;

begin
    assign(inputFile, 'cubes.in');
    assign(outputFile, 'cubes.out');
    readInput(inputFile, N, sequence);
    findAnswer(N, sequence, outputFile);
end.{problemE}
