{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  maxl = 200;
  InputName = 'c.in';
  OutputName = 'c.out';
var
  l, i, j, k : integer;
  prog, old : array[1..maxl+1] of char;
  c : char;
  cx, cy, x, y : longint;
  bad : boolean;

function readgood : boolean;
begin
  readgood := false;
  if eof or eoln then exit;
  repeat read(c); c := upcase(c) until (c in ['E', 'W', 'N', 'S']) or eoln or eof;
  if c in ['E', 'W', 'N', 'S'] then readgood := true;
end;

function rotate(c : char) : char;
begin
  case c of
    'E' : rotate := 'W';
    'W' : rotate := 'E';
    'N' : rotate := 'S';
    'S' : rotate := 'N';
  end;
end;

begin
  assign(input, InputName);
  reset(input);
  while readgood do begin
    inc(l);
    prog[l] := c;
  end;
  close(input);
  cx := 0;
  cy := 0;
  for i := 1 to l-1 do begin
    case prog[i] of
      'E' : inc(cx);
      'W' : dec(cx);
      'N' : inc(cy);
      'S' : dec(cy);
    end;
    if prog[i+1] = prog[i] then begin
      x := cx;
      y := cy;
      bad := false;
      for j := i+1 to l-1 do begin
        case prog[j] of
          'E' : inc(x);
          'W' : dec(x);
          'N' : inc(y);
          'S' : dec(y);
        end;
        if (x = cx) and (y = cy) then begin
          bad := true;
          break;
        end;
      end;
      if bad then begin
        old := prog;
        for k := j downto i+1 do
          prog[i+j-k+1] := rotate(old[k]);
      end;
    end;
  end;
  assign(output, OutputName);
  rewrite(output);
  for i := 1 to l do write(prog[i]);
  writeln;
  close(output);
end.