{
    ⭨ 祡-७஢ ᡮ  ଠ⨪ 2003.
    21.06.03  B. ண
    襭 () 堨 ৠﭮ
}

{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$APPTYPE CONSOLE}

program Shablon;

   uses
     SysUtils;

  const
    inFile = 'road.in';
    outFile = 'road.out';

    inf = maxlongint div 4;

    nmax = 3000;

  type
    int = longint;

  var
    n, m : int;
    ans : int;

    d : array [1..nmax, 1..nmax] of int;
    p : array [1..nmax] of int;

    x, y : array [1..nmax] of int;

  procedure OutData;
    var
      i, j : int;
  begin
    assign(output,outFile);
    rewrite(output);
    writeln(ans);
    for i := 2 to n do
      if d[p[i], i] > 0 then
        writeln(p[i], ' ', i);
    close(output);
  end;

  procedure Solve;
    var
      i, j : int;
      used : array [1..nmax] of boolean;
      r : array [1..nmax] of int;
      pmin, min : int;
  begin
    fillchar(used, SizeOf(used), 0);
    for i := 1 to n do r[i] := inf;
    r[1] := 0;

    while true do begin
      pmin := 0;
      min := inf;
      for i := 1 to n do
        if (not used[i]) and (min > r[i]) then begin
          min := r[i];
          pmin := i;
        end;
      if pmin = 0 then break;
      used[pmin] := true;
      for i := 1 to n do
        if (not used[i]) and (r[i] > d[pmin, i]) then begin
          r[i] := d[pmin, i];
          p[i] := pmin;
        end;
    end;

    ans := 0;
    for i := 2 to n do
      if d[p[i], i] > 0 then inc(ans);
  end;

  procedure error;
  begin
    writeln('Test Error');
    halt(239);
  end;

  procedure ReadData;
    var
      i, j : int;
      a, b : int;
      flag : boolean;
  begin
    assign(input,inFile);
    reset(input);

    read(n, m);

    if (n < 1) or (n > 3000) then error;
    if (m < 0) or (m > n * (n - 1) div 2) then error;

    for i := 1 to n do begin
      read(x[i], y[i]);
      flag := true;
      for j := 1 to i - 1 do
        if (x[i] = x[j]) and (y[i] = y[j]) then flag := false;
      if not flag then error;
    end;

    for i := 1 to n do
      for j := 1 to n do
        d[i, j] := sqr(x[i] - x[j]) + sqr(y[i] - y[j]);

    for i := 1 to m do begin
      read(a, b);
      if d[a][b] = 0 then
        error;
      d[a, b] := 0;
      d[b, a] := 0;
    end;

    close(input);
  end;

begin
  ReadData;
  Solve;
  OutData;
end.
