program zzz;

const
  maxn = 100;
  eps = 1E-4;
type
  point = record
    x,y: double;
    num : longint;
  end;
  vector = array[1..maxn+1] of point;
var
  egc,d,eg,cura,dc,ans: vector;
  best: array[1..maxn+1] of double;
  g: array[1..maxn,1..maxn] of boolean;
  sca,p,i,j,k,n,m,nm,scc,sc,scd: longint;
  bf: point;
  dd,pl,min,max: double;
  fl: boolean;
function orsq(p1,p2,p3: point): double;
begin
  orsq := (p1.x-p2.x)*(p2.y-p3.y) - (p1.y-p2.y)*(p2.x-p3.x);
end;
function dist(p1,p2: point): double;
begin
  dist := sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
end;
function calcs(v: vector; n: longint): double;
var i: longint;
    pl : double;
begin
  for i := 1 to n do begin
    pl := pl + (egc[i].x-egc[i+1].x)*(egc[i].y+egc[i+1].y);
  end;
  calcs := abs(pl/2);
end;
function eqpoint(a,b: point): boolean;
begin
  eqpoint := (abs(a.x-b.x) < eps) and (abs(a.y-b.y)<eps);
end;
function coss(p1,p2,p3: point): double;
var a,b,c: double;
begin
  a := dist(p1,p2); b := dist(p2,p3); c := dist(p1,p3);
  coss := (sqr(a)+sqr(b)-sqr(c))/(2*a*b);
end;
function inside(v: vector; n: longint; p: point): boolean;
var i : longint;
    s1,s2: double;
begin
  s1 := 0; s2 := 0;
  for i := 2 to n-1 do begin
    s1 := s1 + abs(orsq(v[1],v[i],v[i+1]));
  end;
  for i := 1 to n do begin
    s2 := s2 + abs(orsq(p,v[i],v[i+1]));
  end;
  inside := abs(s1-s2) < 0.1;
end;
begin
  assign(input,'birds.in'); reset(input);
  assign(output,'birds.out'); rewrite(output);
  read(n);
  for i := 1 to n do begin
    read(eg[i].x,eg[i].y);
    eg[i].num := i;
    if eg[i].x > bf.x then begin
      bf := eg[i];
    end;
  end;
  read(m);
  for i := 1 to m do read(d[i].x,d[i].y);
  egc[1] := bf;
  min := -2;
  for i := 1 to n do begin
    if i = egc[1].num then continue;
    if (egc[1].x-eg[i].x)/dist(egc[1],eg[i]) > min then begin
      min := (egc[1].x-eg[i].x)/dist(egc[1],eg[i]);
      egc[2] := eg[i];
    end;
  end;
  sc := 2;
  while not eqpoint(egc[sc],egc[1]) do begin
    min := 2;
    for i := 1 to n do begin
      if (eg[i].num = egc[sc].num) then continue;
      if abs(coss(egc[sc-1],egc[sc],eg[i]) - min) < 0.0001 then begin
        if dist(egc[sc],eg[i]) < dist(egc[sc+1],egc[sc]) then egc[sc+1] := eg[i];
      end else
      if coss(egc[sc-1],egc[sc],eg[i]) < min then begin
        min := coss(egc[sc-1],egc[sc],eg[i]);
        egc[sc+1] := eg[i];
      end;
    end;
    inc(sc);
  end;
  for i := 1 to n do begin
    pl := pl + (egc[i].x-egc[i+1].x)*(egc[i].y+egc[i+1].y);
  end;
  if abs(pl) < 0.001 then begin
    writeln('0');
    close(input);
    close(output);
    halt;
  end;
  fl := false;
  for i := 1 to m do begin
    if inside(egc,sc-1,d[i]) then begin
      inc(scd);
      dc[scd] := d[i];
    end;
  end;
  if scd = 0 then begin
    writeln(sc-1);
    for i := 1 to sc-1 do write(egc[i].num,' ');
  end else begin
  for p := 1 to sc-1 do begin
    for i := 1 to sc-1 do begin
      for j := i+2 to sc-1 do begin
        fl := false;
        scc := j-i+1;
        for k := i to j do begin
          cura[k-i+1] := egc[k];
        end;
        cura[scc+1] := cura[1];
        for k := 1 to scd do begin
          if inside(cura,scc,dc[k]) then begin
            fl := true;
            break;
          end;
        end;
        if fl then continue
        else begin
          dd := calcs(cura,scc);
          if dd > max then begin
            sca := scc;
            ans := cura;
            max := dd;
          end;
        end;
      end;
    end;
    bf := egc[1];
    for j := 1 to n-1 do begin
      egc[j] := egc[j+1];
    end;
    egc[n] := bf;
  end;
    if max > eps then begin
      writeln(sca);
      for i := 1 to sca do begin
        write(ans[i].num,' ');
      end;
    end else writeln(0);
  end;
  close(input);
  close(output);
end.
