#include <stdio.h>

FILE*fi,*fo;

struct TAction {
  short d;
  long l;
};
struct TEdge {
  short d;
  TEdge*z,*y;
};
class TPainter {
  private:
    long m,n,c[3];
    TAction*d;
    TEdge*a,*p;
    void procedge(void);
  public:
    TPainter(void);
    ~TPainter();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void process(void);
};

TPainter g;

int main(void) {
  fi=fopen("rhombs.in","rt");
  g.scan(fi);
  fclose(fi);
  g.process();
  fo=fopen("rhombs.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TPainter::procedge(void) {
  TEdge*r;
  short e=(6+p->z->d-p->d)%6;
  if ((e==1)||(e==2)) {
    switch (p->d) {
      case 0: if (e==1) c[1]++; else c[2]++; break;
      case 1: if (e==1) c[0]++; else c[1]++; break;
      case 2: if (e==1) c[2]++; else c[0]++; break;
      case 3: if (e==1) c[1]++; else c[2]++; break;
      case 4: if (e==1) c[0]++; else c[1]++; break;
      case 5: if (e==1) c[2]++; else c[0]++; break;
    }
    r=p->z->z;
    p->z->y=p->y; p->y->z=p->z;
    p->z->z=p; p->y=p->z;
    p->z=r; r->y=p;
  } else if (e==3) {
    r=p->z->z; p=p->y;
    if (p->z!=r) {
      p->z=r; r->y=p;
    } else p=0;
  } else {
    p=p->z;
  }
}
void TPainter::process(void) {
  long i,j,l;
  for (l=0,i=0; i<m; i++) for (j=0; j<d[i].l; j++,l++) {
    a[l].d=d[i].d;
    a[l].z=&a[(l+1)%n]; a[l].y=&a[(l+n-1)%n];
  }
  c[0]=c[1]=c[2]=0;
  p=&a[0];
  while (p) procedge();
}

TPainter::TPainter(void) {
  d=0;
  a=0;
}
TPainter::~TPainter() {
  Delete();
}
void TPainter::Delete(void) {
  if (d) delete[]d;
  if (a) delete[]a;
}
void TPainter::scan(FILE*f) {
  Delete();
  long i;
  fscanf(f,"%ld",&m);
  d=new TAction[m];
  n=0;
  for (i=0; i<m; i++) {
    fscanf(f,"%hd%ld",&d[i].d,&d[i].l); d[i].d--;
    n+=d[i].l;
  }
  a=new TEdge[n];
}
void TPainter::print(FILE*f) {
  fprintf(f,"%ld %ld %ld",c[0],c[1],c[2]);
}

