{$I-,Q-,R-,S-,V-,X-}
Const
 inf='birds.in';
 ouf='birds.out';
 max=110;
type
 point=record x,y:longint; end;
 trace=array [1..max] of byte;
var
 n,m,i,j,k,ntr,ntrmax:longint;
 o,d:array [1..max] of point;
 g,ot:array [1..max,1..max,1..max] of boolean;
 mm:array [1..max] of extended;
 p:array [1..max] of byte;
 tr,trmax:trace;
 emax:boolean;
 smax:extended;
function inside(a,b,c,d:point):boolean;
var
 t:longint;
 em,ep:boolean;
begin
 em:=false;
 ep:=false;
 t:=(a.x-d.x)*(b.y-d.y)-(a.y-d.y)*(b.x-d.x);
 if t>0 then ep:=true
 else if t<0 then em:=true;
 t:=(b.x-d.x)*(c.y-d.y)-(b.y-d.y)*(c.x-d.x);
 if t>0 then ep:=true
 else if t<0 then em:=true;
 t:=(c.x-d.x)*(a.y-d.y)-(c.y-d.y)*(a.x-d.x);
 if t>0 then ep:=true
 else if t<0 then em:=true;
 if (not ep) or (not em) then inside:=true
 else inside:=false;
end;
function good(a,b,c:longint):boolean;
var
 i:longint;
 e:boolean;
 aa,bb,cc:point;
begin
 if ot[a,b,c] then good:=g[a,b,c]
 else
  begin
   aa:=o[a];
   bb:=o[b];
   cc:=o[c];
   e:=true;
   for i:=1 to m do if inside(aa,bb,cc,d[i]) then
    begin
     e:=false;
     break;
    end;
   ot[a,b,c]:=true;
   g[a,b,c]:=e;
   ot[a,c,b]:=true;
   g[a,c,b]:=e;
   ot[b,a,c]:=true;
   g[b,a,c]:=e;
   ot[b,c,a]:=true;
   g[b,c,a]:=e;
   ot[c,a,b]:=true;
   g[c,a,b]:=e;
   ot[c,b,a]:=true;
   g[c,b,a]:=e;
   good:=e;
  end;
end;
function angle(x,y:longint):extended;
var t:extended;
begin
 if x=0 then
  begin
   if y<>0 then angle:=pi/2
   else angle:=-pi/2;
  end
 else
  begin
   t:=arctan(y/x);
   angle:=t;
  end;
end;
procedure swapb(var a,b:byte);
var t:byte;
begin
 t:=a;
 a:=b;
 b:=t;
end;
procedure heapsort(n:longint);
var
 l,i:longint;
  procedure down(i:longint);
  var t:longint;
  begin
   repeat
    t:=i;
    if (2*i<=l) and (mm[p[t]]<mm[p[2*i]]) then t:=2*i;
    if (2*i+1<=l) and (mm[p[t]]<mm[p[2*i+1]]) then t:=2*i+1;
    swapb(p[i],p[t]);
    if t=i then break
    else i:=t;
   until false;
  end;
begin
 l:=n;
 for i:=n div 2 downto 1 do down(i);
 for i:=1 to n-1 do
  begin
   swapb(p[1],p[l]);
   dec(l);
   down(1);
  end;
end;
procedure refresh(ntr:longint);
var
 trt:trace;
 i,ntrt,xmin,ymin,cur:longint;
 s:extended;
begin
 if ntr>2 then
  begin
   xmin:=o[tr[1]].x;
   ymin:=o[tr[1]].y;
   for i:=2 to ntr do if (xmin>o[tr[i]].x) or ((xmin=o[tr[i]].x) and (ymin>o[tr[i]].y)) then
    begin
     xmin:=o[tr[i]].x;
     ymin:=o[tr[i]].y;
    end;
   for i:=1 to ntr do mm[i]:=angle(o[tr[i]].x-xmin,o[tr[i]].y-ymin);
   for i:=1 to ntr do p[i]:=i;
   heapsort(ntr);
   inc(ntr);
   p[ntr]:=p[1];
   ntrt:=3;
   trt[1]:=tr[p[1]];
   trt[2]:=tr[p[2]];
   trt[3]:=tr[p[3]];
   cur:=4;
   while cur<=ntr do
    begin
     while (o[trt[ntrt]].x-o[trt[ntrt-1]].x)*(o[tr[p[cur]]].y-o[trt[ntrt]].y)-
      (o[trt[ntrt]].y-o[trt[ntrt-1]].y)*(o[tr[p[cur]]].x-o[trt[ntrt]].x)<=0 do
       begin
        dec(ntrt);
        if ntrt<2 then exit;
       end;
     inc(ntrt);
     trt[ntrt]:=tr[p[cur]];
     inc(cur);
    end;
   s:=0;
   for i:=1 to ntrt-2 do
    s:=s+abs((o[trt[i]].x-o[trt[1]].x)*(o[trt[i+1]].y-o[trt[1]].y)-
             (o[trt[i]].y-o[trt[1]].y)*(o[trt[i+1]].x-o[trt[1]].x));
   s:=s/2;
   if (not emax) or (s>smax) then
    begin
     emax:=true;
     smax:=s;
     trmax:=trt;
     ntrmax:=ntrt-1;
    end;
  end;
end;
procedure find(ntr,minn:longint);
var
 i,j,k:longint;
 er:boolean;
begin
 for i:=minn to n do
  begin
   er:=false;
   for j:=1 to ntr-1 do
    begin
     for k:=j+1 to ntr do if not good(j,k,i) then
      begin
       er:=true;
       break;
      end;
     if er then break;
    end;
   if not er then
    begin
     tr[ntr+1]:=i;
     find(ntr+1,i+1);
    end;
  end;
 refresh(ntr);
end;
begin
 assign(input,inf);
 reset(input);
 assign(output,ouf);
 rewrite(output);
 readln(n);
 for i:=1 to n do read(o[i].x,o[i].y);
 readln(m);
 for i:=1 to m do read(d[i].x,d[i].y);
 emax:=false;
 ntrmax:=0;
 smax:=0;
 for i:=1 to n-2 do for j:=i+1 to n-1 do for k:=j+1 to n do if good(i,j,k) then
  begin
   ntr:=3;
   tr[1]:=i;
   tr[2]:=j;
   tr[3]:=k;
   find(ntr,k+1);
  end;
 writeln(ntrmax);
 for i:=1 to ntrmax do write(trmax[i],' ');
 close(input);
 close(output);
end.
