program Cows;

const
  MAXN = 1000; {1000}

var
  n : longint;
  m : array [1..MAXN,1..MAXN] of longint;
  ans, x, y : longint;

procedure Load(infile, outfile : string);
var
  i, a, b, c : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  if n>MAXN then
  begin
    writeln('1 2');
    close(input);
    close(output);
    halt(0);
  end;
  fillchar(m,sizeof(m),255);
  for i:=1 to n-1 do
  begin
    read(a,b,c);
    m[a,b] := c;
    m[b,a] := c;
  end;
end;

procedure Solve;
var
  i, j, k, temp, temp2 : longint;
begin
  for j:=1 to n do
    for i:=1 to n do
      if m[i,j]<>-1 then
        for k:=1 to n do
          if (m[j,k]<>-1) and ((m[i,k]=-1) or (m[i,k]>m[i,j]+m[j,k])) then
            m[i,k] := m[i,j] + m[j,k];
  ans := -1;
  for i:=1 to n do
    m[i,i] := 0;
  for i:=1 to n do
    for j:=i+1 to n do
    begin
      temp := 0;
      for k:=1 to n do
      begin
        if m[i,k]>m[j,k] then
          temp2 := m[j,k]
        else
          temp2 := m[i,k];
        if temp2>temp then
          temp := temp2;
      end;
      if (ans=-1) or (ans>temp) then
      begin
        ans := temp;
        x := i;
        y := j;
      end;
    end;
end;

procedure Save;
begin
  writeln(x,' ',y);
  close(input);
  close(output);
end;

begin
  Load('cows.in','cows.out');
  Solve;
  Save;
end.