{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 16384,0,655360}

Const INPUTFILE='cows.in';
      OUTPUTFILE='cows.out';

Const MaxN=50;
Const INF=842150450;

Procedure QSort(L,R:Longint);forward;
Function Min(a,b:Longint):Longint;forward;
Function Cmp(i,j:Longint):Shortint;forward;
Procedure PrepareAll;forward;

var a:Array[1..MaxN,1..3] of Longint;
    b:Array[1..MaxN+1] of Longint;

    d:Array[1..MaxN,1..MaxN] of Longint;
    Nums:Array[1..MaxN] of Longint;
    f:Array[1..MaxN] of Boolean;

    Base:Longint;
    Size:Longint;
    N,M:Longint;
    i,j:Longint;
    t:Longint;
    u,v:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N-1 do
begin
  Read(a[i,1],a[i,2],a[i,3]);
  a[i+N-1,1]:=a[i,2];
  a[i+N-1,2]:=a[i,1];
  a[i+N-1,3]:=a[i,3];
end;
Close(Input);

FillChar(d,SizeOf(d),50);
end;

Procedure FWrite;
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Write(u,' ',v);
Close(Output);

Halt;
end;

Function Min(a,b:Longint):Longint;
begin
if a<b then
  Min:=a
else
  Min:=b;
end;

Function Cmp(i,j:Longint):Shortint;
var k:Byte;
    Ans:Shortint;
begin
Ans:=0;
for k:=1 to 3 do
  if a[i,k]<a[j,k] then
  begin
    Ans:=-1;
    Break;
  end
  else if a[i,k]>a[j,k] then
  begin
    Ans:=1;
    Break;
  end;
Cmp:=Ans;
end;

Procedure QSort(L,R:Longint);
var i,j,x,k:Longint;
begin
i:=L;
j:=R;
a[M+1]:=a[(i+j) div 2];
x:=M+1;
Repeat
  While Cmp(i,x)=-1 Do Inc(i);
  While Cmp(j,x)=1 Do
    Dec(j);
  if i<=j then
  begin
    for k:=1 to 3 do
    begin
      t:=a[i,k];
      a[i,k]:=a[j,k];
      a[j,k]:=t;
    end;
    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if j>L then QSort(L,j);
end;


Procedure PrepareAll;
begin
M:=2*(N-1);
QSort(1,M);
for i:=1 to 3 do
  a[M+1,i]:=0;
i:=1;
b[1]:=1;
for j:=1 to M do
begin
  b[j+1]:=b[j];
  While a[i,1]=j Do
  begin
    Inc(b[j+1]);
    Inc(i);
  end;
end;

u:=0;
v:=0;
end;

Procedure Rec(Cur:Integer);
var i:Integer;
begin
f[Cur]:=True;
for i:=b[Cur] to b[Cur+1]-1 do
  if f[a[i,2]]=False then
  begin
    d[Base,a[i,2]]:=d[Base,Cur]+a[i,3];
    Rec(a[i,2]);
  end;
end;

Procedure Solve;
var g,h:Longint;
    tmp:Array[1..MaxN] of Longint;
    CurMin:Longint;
begin
PrepareAll;
for i:=1 to N do
begin
  Base:=i;
  FillChar(f,SizeOf(f),False);
  d[i,i]:=0;
  Rec(i);
end;


CurMin:=INF;
for i:=1 to N do
for j:=i+1 to N do
begin
  for g:=1 to N do
    tmp[g]:=Min(d[i,g],d[j,g]);
  h:=1;
  for g:=2 to N do
    if tmp[h]<tmp[g] then h:=g;
  if CurMin>tmp[h] then
  begin
    u:=i;
    v:=j;
    CurMin:=tmp[h];
  end;
end;

FWrite;
end;

begin
FRead;
Solve;
end.
