{$I-,S-,Q-,R-}
const max=100000;
var numcol,m,colcount,centre,count,size,n,out1,out2:longint;
    a,b,w:array[1..max]of longint;

    ok:array[1..max]of boolean;
    hv,hw:array[1..max]of longint;
    nta,pra,ntb,prb:array[0..max]of longint;
    col,wv,deg,fst:array[0..max]of longint;

    q:array[1..max]of longint;
    now,all:longint;

procedure init;
var i:longint;
begin
  assign(input,'cows.in');
  reset(input);
  read(n);
  for i:=1 to n-1 do
    read(a[i],b[i],w[i]);
  close(input);
end;

procedure FindGraf;
var i:longint;
begin
  fillchar(fst,sizeof(fst),0);
  fillchar(nta,sizeof(nta),0);
  fillchar(ntb,sizeof(ntb),0);
  fillchar(pra,sizeof(pra),0);
  fillchar(prb,sizeof(prb),0);
  fillchar(deg,sizeof(deg),0);
  for i:=1 to m do
    begin
      inc(deg[a[i]]);
      inc(deg[b[i]]);
      pra[fst[a[i]]]:=i;
      nta[i]:=fst[a[i]];
      fst[a[i]]:=i;
      prb[fst[b[i]]]:=i;
      ntb[i]:=fst[b[i]];
      fst[b[i]]:=i;
    end;
end;

procedure swap(i,j:longint);
var k:longint;
begin
  k:=hv[i];
  hv[i]:=hv[j];
  hv[j]:=k;
  k:=hw[i];
  hw[i]:=hw[j];
  hw[j]:=k;
end;

procedure add(av,aw:longint);
var i:longint;
begin
  inc(size);
  hv[size]:=av;
  hw[size]:=aw;
  i:=size;
  while (i>1)and(hw[i div 2]>hw[i]) do
    begin
      swap(i,i div 2);
      i:=i div 2;
    end;
end;

procedure heapify(i:longint);
var m:longint;
begin
  m:=i;
  if 2*i<=size then
    if hw[2*i]<hw[m] then
      m:=2*i;
  if 2*i+1<=size then
    if hw[2*i+1]<hw[m] then
      m:=2*i+1;
  if m<>i then
    begin
      swap(m,i);
      heapify(m);
    end;
end;

procedure extract(var av,aw:longint);
begin
  av:=hv[1];
  aw:=hw[1];
  hv[1]:=hv[size];
  hw[1]:=hw[size];
  dec(size);
  heapify(1);
end;

procedure FindCentre;
var n1,n2,i,av,aw,v:longint;
begin
  size:=0;
  fillchar(hv,sizeof(hv),0);
  fillchar(hw,sizeof(hw),0);
  fillchar(wv,sizeof(wv),0);
  fillchar(ok,sizeof(ok),true);
  count:=0;
  for i:=1 to n do
    if col[i]=numcol then
      begin
        inc(count);
        if deg[i]=1 then
          add(i,w[fst[i]]);
      end;
  while count>2 do
    begin
      extract(av,aw);
      ok[av]:=false;
      dec(count);
      if a[fst[av]]=av then
        v:=b[fst[av]]
      else
        v:=a[fst[av]];
      if aw>wv[v] then
        wv[v]:=aw;
      if v=a[fst[av]] then
        begin
          if fst[v]=fst[av] then
            fst[v]:=nta[fst[v]];
          nta[pra[fst[av]]]:=nta[fst[av]];
          pra[nta[fst[av]]]:=pra[fst[av]];
        end
      else
        begin
          if fst[v]=fst[av] then
            fst[v]:=ntb[fst[v]];
          ntb[prb[fst[av]]]:=ntb[fst[av]];
          prb[ntb[fst[av]]]:=prb[fst[av]];
        end;
      dec(deg[v]);
      if deg[v]=1 then
        add(v,wv[v]+w[fst[v]]);
    end;
  n1:=0;
  for i:=1 to n do
    if (ok[i])and(col[i]=numcol) then
      begin
        if n1=0 then
          n1:=i
        else
          n2:=i;
      end;
  if wv[n1]<wv[n2] then
    centre:=n2
  else
    centre:=n1;
end;

procedure bfs(num:longint);
var i,j:longint;
begin
  all:=1;
  q[all]:=num;
  now:=0;
  col[num]:=colcount;
  while now<all do
    begin
      inc(now);
      i:=q[now];
      j:=fst[i];
      while j>0 do
        if i=a[j] then
          begin
            if col[b[j]]=0 then
              begin
                col[b[j]]:=colcount;
                inc(all);
                q[all]:=b[j];
              end;
            j:=nta[j];
          end
        else
          begin
            if col[a[j]]=0 then
              begin
                col[a[j]]:=colcount;
                inc(all);
                q[all]:=a[j];
              end;
            j:=ntb[j];
          end;
    end;
end;

procedure run;
var i,maxi,maxw:longint;
begin
  m:=n-1;
  FindGraf;
  fillchar(col,sizeof(col),0);
  numcol:=0;
  FindCentre;
  FindGraf;
  maxw:=-1;
  i:=fst[centre];
  while i>0 do
    begin
      if w[i]>maxw then
        begin
          maxw:=w[i];
          maxi:=i;
        end;
      if a[i]=centre then
        i:=nta[i]
      else
        i:=ntb[i];
    end;
  a[maxi]:=a[n-1];
  b[maxi]:=b[n-1];
  w[maxi]:=w[n-1];
  m:=n-2;
  FindGraf;
  fillchar(col,sizeof(col),0);
  colcount:=0;
  for i:=1 to n do
    if col[i]=0 then
      begin
        inc(colcount);
        bfs(i);
      end;
  numcol:=1;
  FindCentre;
  out1:=centre;
  FindGraf;
  numcol:=2;
  FindCentre;
  out2:=centre;
end;

procedure done;
begin
  assign(output,'cows.out');
  rewrite(output);
  write(out1,' ',out2);
  close(output);
end;

begin
  init;
  run;
  done;
end.
