{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 20000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'palindr.in';
 coutfile= 'palindr.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 d :array [1..nmax,0..nmax shr 3] of byte;
 n :int; ans :int; answer :real;
 s :array [1..10*nmax] of char;
 symb :array ['a'..'z'] of int;

procedure init;
begin
 fillchar (s,sizeof(s),0);
 fillchar (symb,sizeof(symb),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 n := 0;
 while not seekeof do
  begin
   inc(n);
   read (s[n]);
   inc(symb[s[n]]);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (answer:0:0);
 close (output);
end;

procedure putbit (var v :byte; pos :byte);
begin
 v := v or (1 shl pos);
end;

function bit (v :byte; pos :byte):byte;
begin
 bit := v and (1 shl pos);
end;

procedure solve;
var i,j :int;
    u,v :int;
    t :int; c :char;
begin
 t := 0;
 for c := 'a' to 'z' do
  if symb[c] > 0 then inc(t);
 if t = 1 then
  begin
   answer := 1.0*(n-1)*n/2;
   exit;
  end;
 for i := 1 to n do
  fillchar (d[i],n shr 3 + 1,0);
 for i := 1 to n do
  putbit (d[i][i shr 3],i and 7);
 for i := 2 to n do
  putbit (d[i][(i-1) shr 3],(i-1) and 7);
 for i := 1 to n do
  for j := 1 to n-i do
   begin
    u := j;
    v := j + i;
    if s[u] = s[v] then
     if bit(d[u+1][(v-1) shr 3],(v-1) and 7) > 0 then
      begin
       putbit (d[u][v shr 3],v and 7);
       inc(ans);
      end;
   end;
 answer := 1.0*ans;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.