{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'nice.in'; outfile = 'nice.out'; max = 1005;
var a,b,c: array [1..max,1..max] of byte;
    ans: array [1..max*max,1..2] of integer;
    n,m,ans_num: longint;
    ok: boolean;

procedure init;
var i,j: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,m);
     for i:=1 to n do
         for j:=1 to m do read(a[i,j]);
     for i:=1 to n do
         for j:=1 to m do read(b[i,j]);
     close(input);
end;

function can(x,y: integer): boolean;
begin
     can:=false;
     if (x >= 2)and(y >= 2) then if (c[x-1,y-1]+c[x-1,y]+c[x,y-1]+(1-c[x,y])) mod 4 = 0 then exit;
     if (x <= n-1)and(y >= 2) then if (c[x+1,y-1]+c[x+1,y]+c[x,y+1]+(1-c[x,y])) mod 4 = 0 then exit;
     if (x >= 2)and(y <= m-1) then if (c[x-1,y+1]+c[x,y+1]+c[x-1,y]+(1-c[x,y])) mod 4 = 0 then exit;
     if (x <= n-1)and(y <= m-1) then if (c[x+1,y+1]+c[x+1,y]+c[x,y+1]+(1-c[x,y])) mod 4 = 0 then exit;
     can:=true;
end;

procedure do_it(x,y: integer);
begin
     c[x,y]:=1-c[x,y]; inc(ans_num); ans[ans_num,1]:=x; ans[ans_num,2]:=y;
end;

function evrGB: boolean;
var i,j: longint;
    g: boolean;
begin
     ans_num:=0; c:=a; evrGB:=false;
     for i:=1 to n do begin
         g:=false;
         for j:=1 to m do
             if a[i,j] <> b[i,j] then
                if can(i,j) then do_it(i,j)
                   else begin g:=true; break; end;
         if g then begin
            for j:=1 to m do c[i,j]:=a[i,j];
            for j:=m downto 1 do
                if a[i,j] <> b[i,j] then
                   if can(i,j) then do_it(i,j)
                      else exit
         end;
     end;
     evrGB:=true;
end;

function evrGE: boolean;
var i,j: longint;
    g: boolean;
begin
     ans_num:=0; c:=a; evrGE:=false;
     for i:=n downto 1 do begin
         g:=false;
         for j:=1 to m do
             if a[i,j] <> b[i,j] then
                if can(i,j) then do_it(i,j)
                   else begin g:=true; break; end;
         if g then begin
            for j:=1 to m do c[i,j]:=a[i,j];
            for j:=m downto 1 do
                if a[i,j] <> b[i,j] then
                   if can(i,j) then do_it(i,j)
                      else exit
         end;
     end;
     evrGE:=true;
end;

function evrVB: boolean;
var i,j: longint;
    g: boolean;
begin
     ans_num:=0; c:=a; evrVB:=false;
     for i:=1 to n do begin
         g:=false;
         for j:=1 to m do
             if a[j,i] <> b[j,i] then
                if can(j,i) then do_it(j,i)
                   else begin g:=true; break; end;
         if g then begin
            for j:=1 to m do c[j,i]:=a[j,i];
            for j:=m downto 1 do
                if a[j,i] <> b[j,i] then
                   if can(j,i) then do_it(j,i)
                      else exit
         end;
     end;
     evrVB:=true;
end;

function evrVE: boolean;
var i,j: longint;
    g: boolean;
begin
     ans_num:=0; c:=a; evrVE:=false;
     for i:=n downto 1 do begin
         g:=false;
         for j:=1 to m do
             if a[j,i] <> b[j,i] then
                if can(j,i) then do_it(j,i)
                   else begin g:=true; break; end;
         if g then begin
            for j:=1 to m do c[j,i]:=a[j,i];
            for j:=m downto 1 do
                if a[j,i] <> b[j,i] then
                   if can(j,i) then do_it(j,i)
                      else exit
         end;
     end;
     evrVE:=true;
end;

procedure solve;
begin
     ok:=true;
     if evrGB then exit;
     if evrGE then exit;
     if evrVB then exit;
     if evrVE then exit;
     ok:=false;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     if ok then begin
        writeln(ans_num);
        for i:=1 to ans_num do
            writeln(ans[i,1],' ',ans[i,2]);
     end
        else write(-1);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
