{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}
Const maxn = 2010;

Type Edge = Record
             a, b: Integer;
            End;

Var i, j, m, n, x, y, g: Integer;
    c: array[1..maxn] of Record
                          x, y: Integer;
                         End;
    p: array[1..maxn] of Integer;
    r: array[1..maxn * maxn] of Edge;
    a: array[1..maxn, 1..maxn] of Edge;

Procedure Poisk(x, k: Integer);
 Var i: Integer;
 Begin
  p[x] := k;
  For i := 1 to n do
   If (p[i] = 0) and (a[x, i].a > 0) Then Poisk(i, k);
 End;

Function Len(i, j: Integer): Integer;
 Begin
  Len := Trunc(Sqrt(Sqr(Longint(c[i].x - c[j].x)) + Sqr(Longint(c[i].y - c[j].y))));
 End;

Function LenEdge(r: Edge): Integer;
 Begin
  LenEdge := Len(a[r.a, r.b].a, a[r.a, r.b].b);
 End;

Procedure Swap(var a, b:Edge);
 Var c: Edge;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure Hoar(left, right: Integer);
 Var i, j, c: Integer;
 Begin
  i := left;
  j := right;
  c := LenEdge(r[Random(j - i + 1) + i]);
  While i < j do
   Begin
    While LenEdge(r[i]) < c do Inc(i);
    While LenEdge(r[j]) > c do Dec(j);
    If i <= j Then
     Begin
      Inc(i);
      Dec(j);
      Swap(r[i], r[j]);
     End;
   End;
  If j > left + 1 Then Hoar(left, j - 1);
  If i < right - 1 Then Hoar(i + 1, right);
 End;

Procedure Prima;
 Var k, kol: Integer;
 Begin
  k := 0;
  For i := 1 to g-1 do
   For j := i+1 to g do
    Begin
     Inc(k);
     r[k].a := i;
     r[k].b := j;
    End;
  Hoar(1, k);
  FillChar(p, SizeOf(p), 0);
  p[1] := 1;
  kol := 0;
  For i := 1 to g - 1 do
   For j := 1 to k do
    If ((p[r[j].a] = 0) and (p[r[j].b] = 1)) or
       ((p[r[j].a] = 1) and (p[r[j].b] = 0)) Then
     Begin
      Inc(kol);
      p[r[j].a] := 1;
      p[r[j].b] := 1;
     End;
  FillChar(p, SizeOf(p), 0);
  p[1] := 1;
  Writeln(kol);
  For i := 1 to g - 1 do
   For j := 1 to k do
    If ((p[r[j].a] = 0) and (p[r[j].b] = 1)) or
       ((p[r[j].a] = 1) and (p[r[j].b] = 0)) Then
     Begin
      Writeln(a[r[j].a, r[j].b].a, ' ', a[r[j].a, r[j].b].b);
      p[r[j].a] := 1;
      p[r[j].b] := 1;
     End;
 End;

Begin
 Randomize;
 Assign(input, 'road.in');
 Assign(output, 'road.out');
 Reset(input);
 Rewrite(output);
 Read(n, m);
 For i := 1 to n do
  Begin
   Read(x, y);
   c[i].x := x;
   c[i].y := y;
  End;
 For i := 1 to m do
  Begin
   Read(x, y);
   a[x, y].a := 1;
   a[x, y].b := 1;
  End;
 For i := 1 to n do
  If p[i] = 0 Then
   Begin
    Inc(g);
    Poisk(i, g);
   End;
 For i := 1 to m do
  a[x, y].a := 0;
 For i := 1 to n do
  For j := 1 to n do
  Begin
   x := Len(i, j);
   If (a[p[i], p[j]].a = 0) or (Len(a[p[i], p[j]].a, a[p[i], p[j]].b) > x) Then
    Begin
     a[p[i], p[j]].a := i;
     a[p[i], p[j]].b := j;
    End;
  End;
 Prima;
 Close(input);
 Close(output);
End.