{$N+}
const
  inp='road.in';
  out='road.out';
  maxn=2500;

type
  point=array[1..2]of integer;

var
  n,m,i,j,k,nc,col,nans:longint;
  d:array[1..maxn,1..maxn]of byte;
  a,ans:array[1..maxn*maxn div 2 +1]of point;
  b:array[1..maxn,1..2]of integer;
  c:array[1..maxn]of integer;

procedure init;
begin
  assign(input,inp);
  reset(input);

    read(n,m);
    for i:=1 to n do
      read(b[i,1],b[i,2]);
    for k:=1 to m do begin
      read(a[k,1],a[k,2]);
      d[a[k,1],a[k,2]]:=1;
      d[a[k,2],a[k,1]]:=1;
    end;

  close(input);
end;

procedure done;
begin
  assign(output,out);
  rewrite(output);

    writeln(nans);
    for i:=1 to nans do
      writeln(ans[i,1],' ',ans[i,2]);

  close(output);
end;

procedure rec(v,col:integer);
var
  i:integer;
begin
  c[v]:=col;
  for i:=1 to n do
    if (d[v,i]=1)and(c[i]=0)then
      rec(i,col);
end;

function len(i:integer):extended;
begin
  len:=sqrt(sqr(b[a[i,1],1]-b[a[i,2],1]+1.0-1.0)+sqr(b[a[i,1],2]-b[a[i,2],2]+1.0-1.0));
end;

procedure swap(i,j:longint);
var
  k:point;
begin
  k:=a[i];
  a[i]:=a[j];
  a[j]:=k;
end;

procedure sort(l,r:longint);
var
  i,j,x:longint;
begin
  i:=l;
  j:=r;
  x:=(l+r) div 2;
  repeat
    while len(i)<len(x) do
      inc(i);
    while len(j)>len(x) do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then sort(i,r);
  if l<j then sort(l,j);
end;

procedure solve;
begin
  for i:=1 to n do
    if c[i]=0 then begin
      inc(nc);
      rec(i,nc);
    end;

  m:=0;
  for i:=1 to n-1 do
    for j:=i+1 to n do begin
      inc(m);
      a[m,1]:=i;
      a[m,2]:=j;
    end;

  sort(1,m);

  for i:=1 to m do
    if c[a[i,1]]<>c[a[i,2]] then begin
      col:=c[a[i,1]];
      for j:=1 to n do
        if c[j]=col then
          c[j]:=c[a[i,2]];
      inc(nans);
      ans[nans]:=a[i];
    end;
end;

begin
  init;
  solve;
  done;
end.
