program Tree_Centers;

const
  MAXN = 1500; {1500}

type
  plist = ^tlist;
  tlist = record
    data : integer;
    next : plist;
  end;

var
  n, max, min : integer;
  l : array [1..MAXN] of plist;
  d, f : array [1..MAXN] of integer;

procedure Load(infile, outfile : string);
var
  i, a, b : integer;
  p : plist;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  for i:=1 to n do
    l[i] := nil;
  for i:=1 to n-1 do
  begin
    read(a,b);
    new(p);
    p^.data := b;
    p^.next := l[a];
    l[a] := p;
    new(p);
    p^.data := a;
    p^.next := l[b];
    l[b] := p;
  end;
end;

procedure bfs(a : integer);
var
  ql, qr, c : integer;
  p : plist;
  q : array [1..MAXN] of integer;
begin
  max := 0;
  fillchar(d,sizeof(d),255);
  d[a] := 0;
  ql := 1;
  qr := 1;
  q[1] := a;
  while qr>=ql do
  begin
    c := q[ql];
    if max<d[c] then
      max := d[c];
    inc(ql);
    p := l[c];
    while p<>nil do
    begin
      if d[p^.data]=-1 then
      begin
        d[p^.data] := d[c] + 1;
        inc(qr);
        q[qr] := p^.data;
      end;
      p := p^.next;
    end;
  end;
end;

procedure Solve;
var
  i : integer;
begin
  min := n+1;
  for i:=1 to n do
  begin
    bfs(i);
    f[i] := max;
    if min>max then
      min := max;
  end;
end;

procedure Save;
var
  i, k : integer;
begin
  k := 0;
  for i:=1 to n do
    if f[i]=min then
      inc(k);
  writeln(k);
  for i:=1 to n do
    if f[i]=min then
      write(i,' ');
  writeln;
  close(input);
  close(output);
end;

begin
  Load('tree.in','tree.out');
  Solve;
  Save;
end.