program Postman;

const
  MAXN = 1000; {1000}
  MAXM = 1000000; {1000000}

var
  g : array [1..MAXN,1..MAXN] of longint;
  s, f : array [1..MAXN] of longint;
  st : array [1..MAXM] of integer;
  n, m, odd1, odd2, sts : longint;

procedure Load(infile, outfile : string);
var
  i, j, mi, t : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  fillchar(g,sizeof(g),0);
  fillchar(s,sizeof(s),0);
  odd1 := 0;
  odd2 := 0;
  m := 0;
  for i:=1 to n do
  begin
    read(mi);
    inc(m,mi);
    for j:=1 to mi do
    begin
      read(t);
      inc(g[i,t]);
      inc(s[i]);
      read(t);
    end;
  end;
  for i:=1 to n do
    if s[i] mod 2<>0 then
    begin
      if odd1=0 then
        odd1 := i
      else
        odd2 := i;
    end;
end;

procedure Euler;
var
  c : longint;
begin
  while sts>0 do
  begin
    c := st[sts];
    while (f[c]<=n) and (g[c,f[c]]=0) do
      inc(f[c]);
    if f[c]>n then
    begin
      if (sts>1) or (odd1=0) then
        write(c,' ');
      dec(sts);
    end
    else
    begin
      inc(sts);
      st[sts] := f[c];
      dec(g[c,f[c]]);
      dec(g[f[c],c]);
    end;
  end;
end;

procedure Solve;
var
  i : longint;
begin
  for i:=1 to n do
    f[i] := 1;
  writeln(m div 2);
  if odd1=0 then
  begin
    sts := 1;
    st[1] := 1;
    Euler;
  end
  else
  begin
    sts := 2;
    st[1] := odd1;
    st[2] := odd2;
    Euler;
  end;
end;

procedure Save;
begin
  close(input);
  close(output);
end;

begin
  Load('post.in','post.out');
  Solve;
  Save;
end.