{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

Const INPUTFILE='game.in';
      OUTPUTFILE='game.out';

Const MaxN=100000;
      MaxM=MaxN*3;
Const INF=2139062143;

Type Real=Double;

var Stack:Array[1..MaxN] of Longint;
    d:Array[0..MaxN] of Longint;
    Prev:Array[0..MaxN] of Longint;

    Ans:Array[1..MaxN] of Longint;
    N:Longint;
    x,y:Longint;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N,x,y);
Close(Input);

FillChar(d,SizeOf(d),127);
end;

Procedure FWrite(Answer:Longint);
var i,j:Longint;
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);

if Answer>0 then
begin
  j:=y;
  for i:=1 to Answer do
  begin
    Ans[Answer+1-i]:=j;
    j:=Prev[j];
  end;
  Write(j,' ');
  for i:=1 to Answer do
    Write(Ans[i],' ');
end;
Close(Output);

Halt;
end;

Function Turn(Number:Longint;Typ:Byte):Longint;
var t:Comp;
    i:Byte;
begin
  t:=Number;
  for i:=2 to Typ Do
    t:=t*Number;
  t:=t+1;
  t:=t-Int(t/N)*N;
  Turn:=Round(t);
end;

Procedure Solve;
var g,h,k:Longint;
    Cur:Longint;
    Last:Longint;

    tmp:Array[1..3] of Longint;
begin
Stack[1]:=x;
Prev[x]:=-1;
d[x]:=0;
Cur:=1;
Last:=1;

Repeat
  if Stack[Cur]=y then FWrite(d[Stack[Cur]]);
  for i:=1 to 3 do
    tmp[i]:=Turn(Stack[Cur],i);
  for i:=1 to 3 do
    if d[tmp[i]]>d[Stack[Cur]]+1 then
    begin
      Inc(Last);
      Stack[Last]:=tmp[i];
      d[tmp[i]]:=d[Stack[Cur]]+1;
      Prev[tmp[i]]:=Stack[Cur];
    end;
  Inc(Cur);
Until Cur>Last;

FWrite(-1);
end;

begin
FRead;
Solve;
end.
