{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

Const INPUTFILE='tree.in';
      OUTPUTFILE='tree.out';

Const MaxN=1500;
      MaxM=2*(MaxN-1);
      INF=842150450;
Type Real=Double;

var a:Array[1..MaxN,1..MaxN] of Longint;
    b:Array[1..MaxM,1..2] of Integer;
    c:Array[1..MaxN+1] of Integer;

    S:Array[1..MaxN] of Integer;
    Maxs,Nums:Array[1..MaxN] of Longint;
    N,M:Longint;
    i,j,k:Longint;

Procedure FRead;
begin
FillChar(a,SizeOf(a),50);
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N-1 do
begin
  Read(b[i,1],b[i,2]);
  b[N-1+i,1]:=b[i,2];
  b[N-1+i,2]:=b[i,1];
end;
Close(Input);
M:=2*(N-1);

for j:=1 to M do
for i:=1 to M-j do
  if b[i,1]>b[i+1,1] then
  begin
    b[i,1]:=b[i,1] XOR b[i+1,1];
    b[i+1,1]:=b[i,1] XOR b[i+1,1];
    b[i,1]:=b[i,1] XOR b[i+1,1];

    b[i,2]:=b[i,2] XOR b[i+1,2];
    b[i+1,2]:=b[i,2] XOR b[i+1,2];
    b[i,2]:=b[i,2] XOR b[i+1,2];
  end;

j:=1;
c[1]:=1;
for i:=1 to N do
begin
  While b[j,1]=i Do Inc(j);
  c[i+1]:=j;
end;

end;

Procedure FWrite(Answer:Longint);
var i,j,k:Longint;
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
i:=1;
j:=2;
While Maxs[Nums[j]]=Maxs[Nums[i]] Do Inc(j);
Dec(j);
Writeln(j);
for i:=1 to j do
  Write(Nums[i],' ');
Close(Output);

Halt;
end;

Procedure Solve;
var g,h,k:Longint;
    Cur,Last:Integer;
begin
for k:=1 to N do
begin
  Last:=1;
  Cur:=1;
  S[Cur]:=k;
  a[k,k]:=0;

  Repeat
    for j:=c[S[Cur]] to c[S[Cur]+1]-1 do
      if a[k,b[j,2]]>a[k,b[j,1]]+1 then
      begin
        Inc(Last);
        S[Last]:=b[j,2];
        a[k,b[j,2]]:=a[k,b[j,1]]+1;
      end;
    Inc(Cur);
  Until Cur>Last;

{  for i:=1 to N do
    if a[i,k]<a[k,i] then
      a[k,i]:=a[i,k]
    else
      a[i,k]:=a[k,i];}
end;

for i:=1 to N do
begin
  Maxs[i]:=a[i,1];
  for j:=2 to N do
    if Maxs[i]<a[i,j] then Maxs[i]:=a[i,j];
end;

for i:=1 to N do
  Nums[i]:=i;

for j:=1 to N do
for i:=1 to N-j do
  if Maxs[Nums[i]]>Maxs[Nums[i+1]] then
  begin
    Nums[i]:=Nums[i] XOR Nums[i+1];
    Nums[i+1]:=Nums[i] XOR Nums[i+1];
    Nums[i]:=Nums[i] XOR Nums[i+1];
  end;
FWrite(1);
end;

begin
FRead;
Solve;
end.
