{$D-,L-,Q-,R-,S-,I-,N+}
Program pr_c;
const
  inpfile='graph.in';
  outfile='graph.out';
  inf=MaxLongInt div 3;
  nm=45;
var
  a : array [1..nm,1..nm] of LongInt;
  n,m : LongInt;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
end;
{}
Procedure Out;
begin
  close(output);
  halt;
end;
{}
Procedure Init;
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  for i:=1 to nm do
    for j:=1 to nm do a[i,j]:=inf;
  for i:=1 to nm do a[i,i]:=0;
end;
{}
Procedure Count(v1,v2,d : LongInt);
var
  i,j,bak : LongInt;
begin
  for i:=1 to n do
    for j:=1 to n do begin
      bak:=a[i,v1]+d+a[v2,j];
      if bak<a[i,j] then a[i,j]:=bak;
    end;
end;
{}
Procedure Solve;
var
  i,c,v1,v2,d : LongInt;
begin
  for i:=1 to m do begin
    read(c,v1,v2);
    if c=1 then begin
      read(d); Count(v1,v2,d);
    end else begin
      if a[v1,v2]=inf then writeln(-1)
                      else writeln(a[v1,v2]);
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.