program Postman;
{$M 4000000,2000000}

type pEd = ^Ed;
     Ed = record
       num: cardinal;
       next: pEd;
     end;

var f: text;
    i, n, odd, tem: word;
    num, eg, j, tmp, roads: cardinal;
    eds: array [1..1000] of pEd;
    road: array [1..100000, 1..2] of word;
    tt: pEd;

procedure Euler (v: word);
begin
  while (eds [v] <> nil) do
  begin
    tmp := eds [v] ^ . num;
    eds [v] := eds [v] ^ . next;
    if (road [tmp, 2] > 0) then
    begin
      road [tmp, 2] := 0;
      Euler (road [tmp, 1] - v);
    end;
  end;
  write (f, v, ' ');
end;

begin
  assign (f, 'post.in');
  reset (f);
  readln (f, n);
  odd := 1;
  num := 0;
  roads := 0;
  for i := 1 to 1000 do eds [i] := nil;
  for i := 1 to n do
  begin
    read (f, eg);
    inc (num, eg);
    if (eg and 1 > 0) then odd := i;
    for j := 1 to eg do
    begin
      read (f, tem);
      read (f, tmp);
      if (tem > i) then
      begin
        inc (roads);
        road [roads, 1] := i + tem;
        road [roads, 2] := 1;
        tt := eds [i];
        new (eds [i]);
        eds [i] ^ . num := roads;
        eds [i] ^ . next := tt;
        tt := eds [tem];
        new (eds [tem]);
        eds [tem] ^ . num := roads;
        eds [tem] ^ . next := tt;
      end;
    end;
  end;
  close (f);
  assign (f, 'post.out');
  rewrite (f);
  writeln (f, num shr 1);
  Euler (odd);
  writeln (f, '');
  close (f);
end.
