program HardCore;

const
  MAXN = 300; {300}

var
  n, size : integer;
  s, c : array [1..MAXN*2] of char;
  a : array [1..MAXN,1..MAXN] of integer;
  x, y : array [1..MAXN*2] of integer;

procedure Load(infile, outfile : string);
var
  i : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  readln(n);
  for i:=1 to n do
    read(s[i]);
end;

procedure Solve;
var
  l, r, i, j, t : integer;
begin
  for i:=1 to n do
    for l:=1 to n-i+1 do
    begin
      r := i+l-1;
      if r<=l then
        a[l,r] := 0
      else
        if s[l]=s[l+1] then
          a[l,r] := a[l+1,r]
        else
        begin
          a[l,r] := 1 + a[l+1,r];
          for j:=l+1 to r do
            if s[j]=s[l] then
            begin
              t := 1 + a[l+1,j-1] + a[j,r];
              if a[l,r]>t then
                a[l,r] := t;
            end;
        end;
    end;
end;

procedure find(l, r : integer);
var
  i : integer;
begin
  if l>=r then
    exit;
  if s[l]=s[l+1] then
    find(l+1,r)
  else
    if a[l,r]=1 + a[l+1,r] then
    begin
      inc(size);
      x[size] := l+1;
      y[size] := r;
      c[size] := s[l+1];
      find(l+1,r);
    end
    else
    begin
      for i:=l+1 to r do
        if (s[i]=s[l]) and (a[l,r]=1 + a[l+1,i-1] + a[i,r]) then
          break;
      inc(size);
      x[size] := l+1;
      y[size] := i-1;
      c[size] := s[l+1];
      find(l+1,i-1);
      find(i,r);
    end;
end;

procedure Save;
var
  i : integer;
begin
  size := 1;
  x[1] := 1;
  y[1] := n;
  c[1] := s[1];
  find(1,n);
  writeln(size);
  for i:=1 to size do
    writeln(x[i],' ',y[i],' ',c[i]);
  close(input);
  close(output);
end;

begin
  Load('paint.in','paint.out');
  Solve;
  Save;
end.