{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

Const INPUTFILE='paint.in';
      OUTPUTFILE='paint.out';

Const MaxN=300;
Type Real=Double;

var a,b,c:Array[1..MaxN] of Byte;
    Cur:Array[1..MaxN] of Byte;
    N,M:Longint;
    i,j:Longint;
    Ans:Array[1..MaxN,1..3] of Integer;
    Num:Longint;

Procedure FRead;
var ch:Char;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Readln(M);
for i:=1 to M do
begin
  Read(ch);
  b[i]:=Ord(ch)-Ord('A')+1;
end;
Close(Input);
b[M+1]:=0;

N:=1;
c[N]:=1;
for i:=2 to M do
  if b[i-1]<>b[i] then
  begin
    Inc(N);
    c[N]:=i;
  end;
c[N+1]:=M+1;
for i:=1 to N do
  a[i]:=b[c[i]];

FillChar(Cur,SizeOf(Cur),0);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);
for i:=1 to Answer do
  Writeln(c[Ans[i,1]],' ',c[Ans[i,2]+1]-1,' ',Chr(Ans[i,3]+Ord('A')-1));
Close(Output);

Halt;
end;

Procedure Paint(L,R:Integer);
var i,j,k:Integer;
begin
if L<=R then
begin
  While (a[L]=Cur[L]) AND (L<N-1) Do Inc(L);
  While (a[R]=Cur[R]) AND (R>1) Do Dec(R);
end;

if L<=R then
begin

  if a[L]=a[R] then
  begin
    Inc(Num);
    Ans[Num,1]:=L;
    Ans[Num,2]:=R;
    Ans[Num,3]:=a[L];
    for i:=L to R do
      Cur[i]:=a[L];

    j:=1;
    for i:=L to R do
      if a[i]<>a[L] then j:=0;
    if j=0 then Paint(L+1,R-1);
  end
  else
  begin
    j:=0;
    k:=0;
    for i:=L to R do
    begin
      if a[i]=a[L] then Inc(j);
      if a[i]=a[R] then Inc(k);
    end;

    if j>=k then
    begin
      i:=R;
      Repeat Dec(i) Until a[i]=a[L];
      Inc(Num);
      Ans[Num,1]:=L;
      Ans[Num,2]:=i;
      Ans[Num,3]:=a[L];
      for j:=L to i do
        Cur[j]:=a[L];
      Paint(L+1,i-1);
      Paint(i+1,R);
    end
    else
    begin
      i:=L;
      Repeat Inc(i) Until a[i]=a[R];
      Inc(Num);
      Ans[Num,1]:=i;
      Ans[Num,2]:=R;
      Ans[Num,3]:=a[R];
      for j:=i to R do
        Cur[j]:=a[R];
      Paint(L,i-1);
      Paint(i+1,R);

    end;
  end;
end;
end;

Procedure Solve;
var g,h:Longint;
begin
Num:=0;
Paint(1,N);
FWrite(Num);
end;

begin
FRead;
Solve;
end.
