{$N+}
Const
 inf='convexh.in';
 ouf='convexh.out';
 max=2000;
type
 tpi=record an:extended; np:longint; end;
 tp=record x,y:longint; end;
 tpe=record x,y:extended; end;
var
 n,i,j,kol,tkol,kk:longint;
 p1,p2:array [1..max] of tp;
 pl:array [1..2*max+1] of tpe;
 epl:array [1..2*max+1] of boolean;
 s,xd,yd:extended;
 an:array [1..2*max+1] of tpi;
 tr:array [1..2*max+1] of longint;
 pp:tpe;
procedure per(n1,n2:longint;var pp:tpe);
var
 ax,cx,kx,ay,cy,ky,d,d1,t:extended;
 pb1,pb2,pe1,pe2:tp;
begin
 pb1:=p1[n1];
 pe1:=p2[n1];
 pb2:=p1[n2];
 pe2:=p2[n2];
 ax:=pe1.x-pb1.x;
 cx:=pe2.x-pb2.x;
 kx:=pb2.x-pb1.x;
 ay:=pe1.y-pb1.y;
 cy:=pe2.y-pb2.y;
 ky:=pb2.y-pb1.y;
 d:=-ax*cy+ay*cx;
 d1:=-kx*cy+ky*cx;
 t:=d1/d;
 pp.x:=t*ax+pb1.x;
 pp.y:=t*ay+pb1.y;
end;
procedure relax(nl:longint;pp:tpe);
var
 r1,r2,r:extended;
 pp1,pp2:tpe;
begin
 pp1:=pl[2*nl-1];
 pp2:=pl[2*nl];
 if epl[2*nl-1] then
  begin
   if epl[2*nl] then
    begin
     r:=sqrt(sqr(pp1.x-pp2.x)+sqr(pp1.y-pp2.y));
     r1:=sqrt(sqr(pp1.x-pp.x)+sqr(pp1.y-pp.y));
     r2:=sqrt(sqr(pp.x-pp2.x)+sqr(pp.y-pp2.y));
     if (r<r1) or (r<r2) then
      begin
       if r1>r2 then pl[2*nl]:=pp
       else pl[2*nl-1]:=pp;
      end;
    end
   else
    begin
     epl[2*nl]:=true;
     pl[2*nl]:=pp;
    end;
  end
 else
  begin
   epl[2*nl-1]:=true;
   pl[2*nl-1]:=pp;
  end;
end;
function angle(i:longint):extended;
var t:extended;
begin
 if pl[i].y-yd=0 then
  begin
   if pl[i].x-xd<>0 then angle:=pi/2
   else angle:=0;
  end
 else
  begin
   t:=arctan((pl[i].x-xd)/(pl[i].y-yd));
   if pl[i].x-xd<0 then t:=t+pi;
   angle:=t;
  end;
end;
function srav(a,b:tpi):boolean;
begin
 srav:=a.an<b.an;
end;
procedure qsort(l,r:longint);
var
 i,j,t:longint;
 x,y:tpi;
begin
 i:=l;
 j:=r;
 t:=random(r-l);
 x:=an[l+t];
 repeat
  while srav(an[i],x) do inc(i);
  while srav(x,an[j]) do dec(j);
  if not (i>j) then
    begin
     y:=an[i];
     an[i]:=an[j];
     an[j]:=y;
     inc(i);
     j:=j-1;
    end;
 until i>j;
 if l<j then qsort(l,j);
 if i<r then qsort(i,r);
end;
function findans(i:longint):longint;
var
 pp1,pp2,pp3:tpe;
 j:longint;
 e:boolean;
begin
 inc(tkol);
 tr[tkol]:=an[i].np;
 if i=2*n+1 then
  begin
   kol:=tkol;
   findans:=0;
  end
 else
  begin
   j:=i+1;
   pp1:=pl[tr[tkol-1]];
   pp2:=pl[tr[tkol]];
   pp3:=pl[an[j].np];
   while (pp3.x=pp2.x) and (pp3.y=pp2.y) do
    begin
     inc(j);
     pp3:=pl[an[j].np];
    end;
   while (pp2.x-pp1.x)*(pp3.y-pp2.y)-(pp3.x-pp2.x)*(pp2.y-pp1.y)>=0 do
    begin
     j:=findans(j);
     if j=0 then break
     else pp3:=pl[an[j].np]
    end;
   findans:=j;
  end;
 dec(tkol);
end;
function ss(n1,n2:longint):extended;
var t:extended;
begin
 t:=pl[n1].x*pl[n2].y-pl[n1].y*pl[n2].x;
 ss:=t;
end;
begin
 assign(input,inf);
 reset(input);
 assign(output,ouf);
 rewrite(output);
 readln(n);
 fillchar(epl,sizeof(epl),false);
 for i:=1 to n do readln(p1[i].x,p1[i].y,p2[i].x,p2[i].y);
 for i:=1 to n-1 do for j:=i+1 to n do
  begin
   per(i,j,pp);
   relax(i,pp);
   relax(j,pp);
  end;
 xd:=pl[1].x;
 yd:=pl[1].y;
 kk:=1;
 for i:=2 to 2*n do if pl[i].y<yd then
  begin
   xd:=pl[1].x;
   yd:=pl[1].y;
   kk:=i;
  end;
 for i:=1 to 2*n do an[i].np:=i;
 for i:=1 to 2*n do an[i].an:=angle(i);
 qsort(1,2*n);
 an[2*n+1].an:=an[1].an;
 an[2*n+1].np:=an[1].np;
 s:=0;
 kol:=0;
 tkol:=1;
 tr[1]:=an[1].np;
 if findans(2)=0 then
  begin
   for i:=1 to kol do s:=s+ss(tr[i],tr[(i mod kol)+1]);
   s:=abs(s)/2;
  end;
 writeln(s:0:0);
 close(output);
 close(input);
end.