const MaxN = 305;

type Tstep = record
       b,e: integer;
       ch: char;
     end;

var n,len: integer;
    d: array[1..MaxN] of char;
    ls: array[1..MaxN+1] of integer;
    a,p,tmp: array[1..MaxN] of integer;
    b: array[1..MaxN,1..MaxN] of byte;
    steps: array[1..MaxN] of Tstep;
    sn: integer;

function Min(a,b: integer):integer;
begin
  if a<b then Min:=a else Min:=b;
end;

procedure Solve;
var i,j: integer;
begin
  For i:=1 to n do
    p[i]:=1;
  For i:=1 to n-1 do begin
    a[i]:=2;
    b[1,i]:=1;
  end;
  For i:=2 to n-1 do begin
    For j:=1 to n-i do begin
      tmp[j]:=min(a[j],a[j+1])+1;
      if (d[j]=d[j+i]) and (tmp[j]>p[j+1]+1) then begin
       tmp[j]:=p[j+1]+1;
       b[i,j]:=3;
      end else begin
        if a[j]<a[j+1] then b[i,j]:=1 else b[i,j]:=2;
      end;
    end;
    move(a,p,sizeof(integer)*(n-i)+1);
    move(tmp,a,sizeof(integer)*(n-i));
  end;

  i:=n-1;
  j:=1;
  while i>0 do begin
    inc(sn);
    case b[i,j] of
1:  begin
      steps[sn].b:=ls[j+i];
      steps[sn].e:=ls[j+i+1]-1;
      steps[sn].ch:=d[j+i];
      dec(i);
    end;
2:  begin
      steps[sn].b:=ls[j];
      steps[sn].e:=ls[j+1]-1;
      steps[sn].ch:=d[j];
      inc(j);
      dec(i);
    end;
3:  begin
      steps[sn].b:=ls[j];
      steps[sn].e:=ls[j+i+1]-1;
      steps[sn].ch:=d[j];
      inc(j);
      dec(i,2);
    end;
    end;
  end;
  inc(sn);
  steps[sn].b:=ls[j];
  steps[sn].e:=ls[j+1]-1;
  steps[sn].ch:=d[j];


end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'paint.out');
  Rewrite(f);
  WriteLn(f,sn);
  For i:=1 to sn do
    with steps[i] do
      WriteLn(f,b,' ',e,' ',ch);
  Close(f);
end;

procedure Load;
var f: text;
    i,s,t: integer;
    ch: char;
begin
  Assign(f,'paint.in');
  Reset(f);
  ReadLn(f,len);
  Read(f,d[1]); n:=1;
  ls[n]:=1;
  For i:=2 to len do begin
    Read(f,ch);
    if ch<>d[n] then begin
      inc(n); d[n]:=ch;
    end;
    inc(ls[n]);
  end;
  Close(f);
  s:=0; t:=0;
  For i:=1 to n+1 do begin
    t:=ls[i];
    ls[i]:=s+1;
    s:=s+t;
  end;

end;


Begin
  Load;
  Solve;
  Save;
End.
