#include <stdio.h>
#include <stdlib.h>

#define NN 310
#define MANY 1000000

struct PP {
  int a;
  PP *nx;
  PP *pr;
};

FILE *fi, *fo;
int n,m;
PP *g[NN];
int p[NN];
PP *mp[NN][NN];
PP *g1[NN];
int p1[NN];
PP *mp1[NN][NN];
int tt[NN][NN];
int ss;
int pwn[NN];
int pwm[NN];
int mxn, mxm;
bool used[NN];
bool used1[NN];
int pwn0[NN];
int inp[NN][NN];

void Add(int x, int y)
{
  PP *t;
  t=new PP;
  t->a=y;
  t->nx=g[x];
  t->nx->pr=t;
  t->pr=NULL;
  g[x]=t;
  mp[x][y]=t;
  
  t=new PP;
  t->a=x;
  t->nx=g1[y];
  t->nx->pr=t;
  t->pr=NULL;
  g1[y]=t;
  mp1[x][y]=t;
}

void Del(int x, int y,int tm)
{
  PP *t;
  pwn[x]--;
  pwm[y]--;
  t=mp[x][y];
  if(t->pr==NULL)
    g[x]=t->nx ;
  else
    t->pr->nx=t->nx;
  if(t->nx!=NULL)
    t->nx->pr=t->pr;
  mp[x][y]=NULL;
  delete(t);
  
  t=mp1[x][y];
  if(t->pr==NULL)
    g1[y]=t->nx ;
  else
    t->pr->nx=t->nx;
  if(t->nx!=NULL)
    t->nx->pr=t->pr;
  mp1[x][y]=NULL;
  tt[x][y]=tm;
  delete(t);
}

bool dfs(int v)
{
  PP *t;
  used[v]=true;
  for(t=g[v];t!=NULL;t=t->nx)
  {
    if(p[t->a]<0)
    {
      p[t->a]=v;
      p1[v]=t->a;
      return true;
    }
    else
    {
      if(!used[p[t->a]])
      {
        if(dfs(p[t->a]))
        {
          p[t->a]=v;
          p1[v]=t->a;
          return true;
        }
      }
    }
  }
  return false;
}

bool dfs1(int v)
{
  PP *t;
  used1[v]=true;
  for(t=g1[v];t!=NULL;t=t->nx)
  {
    if(p1[t->a]<0)
    {
      p1[t->a]=v;
      p[v]=t->a;
      return true;
    }
    else
    {
      if(!used1[p1[t->a]])
      {
        if(pwm[p1[t->a]]<mxm)
        {
          p[p1[t->a]]=-1;
          p[v]=t->a;
          p1[t->a]=v;
          return true;
        }
        else
        {
          if(dfs1(p1[t->a]))
          {
            p1[t->a]=v;
            p[v]=t->a;
            return true;
          }
        }
      }
    }
  }
  return false;
}

int main()
{
  int i,j;
  int x,y;
  PP *t;
  fi=fopen("move.in","rt");
  fo=fopen("move.out","wt");

  fscanf(fi,"%i%i",&n,&m);
  for(i=0;i<n;i++)
  {
    g[i]=NULL;
    pwn[i]=0;
    for(j=0;j<m;j++)
    {
      mp[i][j]=NULL;
      tt[i][j]=-1;
    }
  }
  for(j=0;j<m;j++)
    pwm[j]=0;

  for(i=0;i<n;i++)
  {
    fscanf(fi,"%i",&ss);
    for(j=0;j<ss;j++)
    {
      fscanf(fi,"%i",&x);
      inp[i][j]=x-1;
      Add(i,--x);
      pwn[i]++;
      pwm[x]++;
    }
    pwn0[i]=ss;
  }

  ss=0;
  while(true)
  {
    mxn=-1;
    mxm=-1;
    for(j=0;j<m;j++)
    {
      p[j]=-1;
      if(pwm[j]>mxm)
        mxm=pwm[j];
    }
    for(i=0;i<n;i++)
    {
      p1[i]=-1;
      if(pwn[i]>mxn)
        mxn=pwn[i];
    }
    if(mxn<=0)
      break;
    if(mxm<=0)
      break;

    if(mxn>=mxm)
    {
      for(i=0;i<n;i++)
      {
        if((pwn[i]==mxn)&&(p1[i]<0))
        {
          for(t=g[i];t!=NULL;t=t->nx)
          {
            if(p[t->a]<0)
            {
              p[t->a]=i;
              p1[i]=t->a;
              break;
            }
          }
          if(p1[i]<0)
          {
            for(j=0;j<n;j++)
              used[j]=false;
            dfs(i);
          }
        }
      }
    }

    if(mxm>=mxn)
    {
      for(i=0;i<m;i++)
      {
        if((pwm[i]==mxm)&&(p[i]<0))
        {
          for(t=g1[i];t!=NULL;t=t->nx)
          {
            if(p1[t->a]<0)
            {
              p1[t->a]=i;
              p[i]=t->a;
              break;
            }
          }
          if(p[i]<0)
          {
            for(j=0;j<n;j++)
              used1[j]=false;
            dfs1(i);
          }
        }
      }
    }

    for(i=0;i<n;i++)
    {
      if(p1[i]<0)
      {
        for(t=g[i];t!=NULL;t=t->nx)
        {
          if(p[t->a]<0)
          {
            p[t->a]=i;
            p1[i]=t->a;
            break;
          }
        }
      }
    }

    for(i=0;i<n;i++)
      if(p1[i]>=0)
        Del(i,p1[i],ss);
    ss++;
  }

  for(i=0;i<n;i++)
  {
    for(j=0;j<pwn0[i];j++)
      if(tt[i][inp[i][j]]>=0)
        fprintf(fo,"%i ",tt[i][inp[i][j]]);
    fprintf(fo,"\n");
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
