const MaxN = 301;

type Twire = record
       d,time: integer;
       del,used: boolean;
     end;
     Tdev = record
       el,en: longint;
     end;

var n,m: integer;
    wn,count,time: longint;
    ws: array[1..MaxN*MaxN] of Twire;
    devs: array[1..MaxN] of Tdev;
    dp,hp,hpe: array[1..MaxN] of integer;
    mark: array[1..MaxN] of longint;
    _true: Longint;

function dfs(v: integer):boolean;
var i: longint;
begin
  mark[v]:=_true;
  For i:=devs[v].el to devs[v].el+devs[v].en-1 do
    if not (ws[i].del or ws[i].used) then
      if hp[ws[i].d]=0 then begin
        ws[i].used:=true;
        hp[ws[i].d]:=v;
        hpe[ws[i].d]:=i;
        dp[v]:=ws[i].d;
        dfs:=true;
        break;
      end else begin
        if mark[hp[ws[i].d]]<>_true then
          if dfs(hp[ws[i].d]) then begin
            dp[v]:=ws[i].d;
            ws[i].used:=true;
            ws[hpe[ws[i].d]].used:=false;
            hpe[ws[i].d]:=i;
            hp[ws[i].d]:=v;
            dfs:=true;
            break;
          end;
      end;
  dfs:=false;
end;

procedure pairs;
var flag: boolean;
    i: integer;
begin
  fillchar(dp,sizeof(dp),0);
  fillchar(hp,sizeof(hp),0);
  fillchar(hpe,sizeof(hpe),0);
  flag:=true;
  while flag do begin
    flag:=false;
    inc(_true);
    For i:=1 to n do
      if (dp[i]=0) and (mark[i]<>_true) then
        if dfs(i) then begin
          flag:=true;
          break;
        end;
  end;

end;

procedure Solve;
var i: longint;
begin
  time:=0;
  while count<wn do begin
    pairs;
    For i:=1 to wn do
      if (ws[i].used) and (not ws[i].del) then begin
        ws[i].del:=true;
        ws[i].time:=time;
        inc(count);
      end;
    inc(time);
  end;
end;

procedure Save;
var f: text;
    i,j: longint;
begin
  Assign(f,'move.out');
  Rewrite(f);
  For i:=1 to n do begin
    For j:=devs[i].el to devs[i].el+devs[i].en-1 do
      Write(f,ws[j].time,' ');
    WriteLn(f);
  end;
  Close(f);
end;

procedure Load;
var f: text;
    i,j,k: integer;
begin
  Assign(f,'move.in');
  Reset(f);
  Read(f,n,m);
  For i:=1 to n do begin
    Read(f,k);
    devs[i].en:=k;
    devs[i].el:=wn+1;
    For j:=1 to k do begin
      inc(wn);
      Read(f,ws[wn].d);
    end;
  end;
  Close(f);
end;


Begin
  Load;
  Solve;
  Save;
End.
