{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'parking.in'; outfile = 'parking.out'; max = 100005;
type ev = record tp,t,a,c: longint; end;
var s: array [1..max*2] of ev;
    p: array [1..max] of longint;
    ans: array [1..max] of longint;
    n,m: longint;

procedure init;
var i,t1,t2,qc: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,m);
     fillchar(s,sizeOf(s),0);
     for i:=1 to m do begin
         read(t1,t2,qc);
         s[i].tp:=1; s[i].t:=t1; s[i].a:=i; s[i].c:=qc;
         s[i+m].tp:=0; s[i+m].t:=t2; s[i+m].a:=i; s[i+m].c:=qc;
     end;
     close(input);
end;

procedure swap(v1,v2: longint);
var ww: ev;
begin
     ww:=s[v1]; s[v1]:=s[v2]; s[v2]:=ww;
end;

procedure sort(l,t: longint);
var i,j,x: longint;
begin
     i:=l; j:=t; x:=s[(l+t) div 2].t;
     repeat
           while s[i].t < x do inc(i);
           while s[j].t > x do dec(j);
           if i <= j then begin
              swap(i,j); inc(i); dec(j);
           end;
     until i > j;
     if i < t then sort(i,t);
     if j > l then sort(l,j);
end;

procedure solve;
var i,j: longint;
begin
     sort(1,2*m);
     fillchar(p,SizeOf(p),0);
     for i:=1 to 2*m do begin
         if s[i].tp = 1 then begin
            j:=s[i].c; while p[j] <> 0 do j:=j mod n+1;
            p[j]:=1; ans[s[i].a]:=j;
         end
            else p[ans[s[i].a]]:=0;
     end;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     for i:=1 to m do
         writeln(ans[i]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.