#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 21000

struct POINT {
   int x,y,i;
};

int _stklen = 4000000;

FILE *fi, *fo;
int n;
POINT p[NN];
int res[NN];
int s_res;
int res1[NN];
int s_res1;
int s1[NN];
int s2[NN];
int x1[NN];
int x2[NN];
int s_x1;
int s_x2;

int cmp(POINT a, POINT b)
{
  if(a.x>b.x) return 1;
  if(a.x<b.x) return -1;
  if(a.y>b.y) return 1;
  if(a.y<b.y) return -1;
  return 0;
}

void sift_p(int p, int q,POINT *a)
{
  int i,j;
  POINT x;
  i=p;
  x=a[i];
  j=2*i+1;
  if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
  if(j<q) if(cmp(x,a[j])>0) j=q+1;
  while(j<q)
  {
    a[i]=a[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
    if(j<q) if(cmp(x,a[j])>0) j=q+1;
  }
  a[i]=x;
}

void Sort_p(int n, POINT *a)
{
  int i,j;
  POINT x;
  j=n;
  for(i=n/2+1;i>=0;i--)
    sift_p(i,j,a);
  i=0;
  for(j=n;j>1;j--)
  {
    x=a[0];
    a[0]=a[j-1];
    a[j-1]=x;
    sift_p(i,j-1,a);
  }
}

void sift_i(int p, int q,int *a)
{
  int i,j;
  int x;
  i=p;
  x=a[i];
  j=2*i+1;
  if(j<q-1) if(a[j+1]>a[j]) j++;
  if(j<q) if(x>a[j]) j=q+1;
  while(j<q)
  {
    a[i]=a[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(a[j+1]>a[j]) j++;
    if(j<q) if(x>a[j]) j=q+1;
  }
  a[i]=x;
}

void Sort_i(int n, int *a)
{
  int i,j;
  int x;
  j=n;
  for(i=n/2+1;i>=0;i--)
    sift_i(i,j,a);
  i=0;
  for(j=n;j>1;j--)
  {
    x=a[0];
    a[0]=a[j-1];
    a[j-1]=x;
    sift_i(i,j-1,a);
  }
}

int bsearch(int c,int *a,int s_a)
{
  int b,e;
  int t;
  b=0;
  e=s_a-1;
  if(a[b]>=c)
    return b;
  if(a[e]<c)
    return b;
  while((e-b)>1)
  {
    t=(b+e)/2;
    if(a[t]>=c)
      e=t;
    else
      b=t;
  }
  return e;
}

void solv()
{
  int xx,yy;
  int i,j;
  for(i=0;i<s_x1;i++)
    s1[i]=0;
  for(i=0;i<s_x2;i++)
    s2[i]=0;
  for(i=0;i<n;i++)
  {
    xx=bsearch(p[i].x,x1,s_x1);
    yy=bsearch(p[i].y,x2,s_x2);
    if(abs(s1[xx])>abs(s2[yy]))
      if(s1[xx]>0)
        res[p[i].i]=1;
      else
        res[p[i].i]=0;
    else
      if(s2[yy]>0)
        res[p[i].i]=1;
      else
        res[p[i].i]=0;
    if(res[p[i].i])
    {
      s1[xx]--;
      s2[yy]--;
    }
    else
    {
      s1[xx]++;
      s2[yy]++;
    }
  }
  s_res=0;
  for(i=0;i<s_x1;i++)
    if(s1[i]>s_res)
      s_res=s1[i];
  for(i=0;i<s_x2;i++)
    if(s2[i]>s_res)
      s_res=s2[i];
}

int main()
{
  int i,j;
  POINT tmp;
  fi=fopen("mayors.in","rt");
  fo=fopen("mayors.out","wt");

  fscanf(fi,"%i",&n);
  for(i=0;i<n;i++)
  {
    fscanf(fi,"%i%i",&p[i].x,&p[i].y);
    p[i].i=i;
    x1[i]=p[i].x;
    x2[i]=p[i].y;
    s1[i]=0;
    s2[i]=0;
  }
  Sort_i(n,x1);
  Sort_i(n,x2);
  i=1;
  j=1;
  while(i<n)
  {
    if(x1[i-1]!=x1[i])
    {
      x1[j]=x1[i];
      j++;
    }
    i++;
  }
  s_x1=j;
  i=1;
  j=1;
  while(i<n)
  {
    if(x2[i-1]!=x2[i])
    {
      x2[j]=x2[i];
      j++;
    }
    i++;
  }
  s_x2=j;

  solv();
  for(i=0;i<n;i++)
    res1[i]=res[i];
  s_res1=s_res;
  Sort_p(n,p);
  solv();
  if(s_res<s_res1)
  {
    s_res1=s_res;
    for(i=0;i<n;i++)
      res1[i]=res[i];
  }
  for(i=1;i<n;i+=2)
  {
    tmp=p[i-1];
    p[i-1]=p[i];
    p[i]=tmp;
  }
  solv();
  if(s_res<s_res1)
  {
    s_res1=s_res;
    for(i=0;i<n;i++)
      res1[i]=res[i];
  }
  for(i=0;i<n/2;i++)
  {
    tmp=p[i+n/2];
    p[i+n/2]=p[i];
    p[i]=tmp;
  }
  solv();
  
  if(s_res>s_res1)
    for(i=0;i<n;i++)
      res[i]=res1[i];

  for(i=0;i<n;i++)
    fprintf(fo,"%i\n",res[i]);

  fclose(fi);
  fclose(fo);
  return 0;
}
