program zz;

const
  maxn = 100000;
  inf = 2000000000;
type
  avt = record
    st,fin,pl,num: longint;
  end;
var
  i,j,k,n,m: longint;
  a: array[1..maxn] of avt;
  ans : array[1..maxn] of longint;
  hep: array[1..4*maxn] of longint;
function min(a,b: longint): longint;
begin
  if a>b then min := b else min := a;
end;
procedure swap(var a,b: avt);
var buf: avt;
begin
  buf := a;
  a := b;
  b := buf;
end;
procedure pushdown(st,fin: longint);
var i,j: longint;
begin
  i := st;
  j := 2*st;
  while j <= fin do begin
    if j <> fin then if a[j].st < a[j+1].st then inc(j);
    if a[i].st < a[j].st then begin
      swap(a[i],a[j]);
      i := j;
      j := 2*i;
    end else break;
  end;
end;
procedure inst(num,pl: longint);
var i,mx: longint;
begin
  i := 2*n+pl-1;
  hep[i] := num;
  while i <> 1 do begin
    if i mod 2 = 0 then begin
      if min(hep[i],hep[i+1]) > hep[i div 2] then begin
        hep[i div 2] := min(hep[i],hep[i+1]);
        i := i div 2;
      end else break;
    end else begin
      if min(hep[i],hep[i-1]) > hep[i div 2] then begin
        hep[i div 2] := min(hep[i],hep[i-1]);
        i := i div 2;
      end else break;
    end;
  end;
  i := 3*n+pl-1;
  if num < hep[i] then exit;
  hep[i] := num;
  while i <> 1 do begin
    if i mod 2 = 0 then begin
      if min(hep[i],hep[i+1]) > hep[i div 2] then begin
        hep[i div 2] := min(hep[i],hep[i+1]);
        i := i div 2;
      end else break;
    end else begin
      if min(hep[i],hep[i-1]) > hep[i div 2] then begin
        hep[i div 2] := min(hep[i],hep[i-1]);
        i := i div 2;
      end else break;
    end;
  end;
end;
function ask(lf,w: longint): longint;
var i,j: longint;
begin
  i := lf+2*n-1;
  while (w < hep[i]) do begin
    i := (i+1) div 2;
  end;
  while i < 2*n do begin
    if (w > hep[i*2]) then i := i*2 else i := i*2+1;
  end;
  if i >= 3*n then ask := i-3*n+1 else ask := i-2*n+1;
end;
procedure sort(n: longint);
var i: longint;
begin
  for i := n div 2 downto 2 do pushdown(i,n);
  for i := n downto 2 do begin
    pushdown(1,i);
    swap(a[1],a[i]);
  end;
end;
begin
  assign(input,'parking.in'); reset(input);
  assign(output,'parking.out'); rewrite(output);
  read(n,m);
  for i := 1 to m do begin
    read(a[i].st,a[i].fin,a[i].pl);
    a[i].num := i;
  end;
  sort(m);
  inst(a[1].fin,a[1].pl);
  ans[a[1].num] := a[1].pl;
  for i := 2 to m do begin
    k := ask(a[i].pl,a[i].st);
    ans[a[i].num] := k;
    inst(a[i].fin,k);
  end;
  for i := 1 to m do writeln(ans[i]);
  close(input);
  close(output);
end.