program zzzz;

const
  maxn = 20002;
type
  point = record
    x,y,num: longint;
  end;
  v = array[1..maxn] of longint;
var
  a: array[1..maxn] of point;
  numx,numy,col: array[1..maxn] of longint;
  x,y: v;
  xx,yy,nx,ny,i,j,k,n,m: longint;
procedure swap2(var a,b: point);
var buf: point;
begin
  buf := a;
  a := b;
  b := buf;
end;
procedure swap(var a,b: longint);
var buf: longint;
begin
  buf := a;
  a := b;
  b := buf;
end;
function more(p1,p2: point): boolean;
var i,j: longint;
begin
  if p1.x = p2.x then more := p1.y > p2.y else more := p1.x > p2.x;
end;
procedure pushdown2(st,fin: longint);
var i,j: longint;
begin
  i := st;
  j := 2*st;
  while j <= fin do begin
    if j <> fin then if more(a[j+1],a[j]) then inc(j);
    if more(a[j],a[i]) then begin
      swap2(a[i],a[j]);
      i := j;
      j := 2*i;
    end else break;
  end;
end;

procedure pushdown(var a: v; st,fin: longint);
var i,j: longint;
begin
  i := st;
  j := 2*st;
  while j <= fin do begin
    if j <> fin then if a[j+1] > a[j] then inc(j);
    if a[i] < a[j] then begin
      swap(a[i],a[j]);
      i := j;
      j := 2*i;
    end else break;
  end;
end;
procedure sort(var a: v; n: longint);
var i,j: longint;
begin
  for i := n div 2 downto 2 do pushdown(a,i,n);
  for i := n downto 2 do begin
    pushdown(a,1,i);
    swap(a[1],a[i]);
  end;
end;
function search(a: v; n,el: longint): longint;
var l,r,h: longint;
begin
  l := 1;
  r := n;
  while r-l > 1 do begin
    h := (l+r) div 2;
    if a[h] = el then begin
      search := h;
      exit;
    end;
    if a[h] > el then begin
      r := h;
    end else l := h;
  end;
  if a[l] = el then search := l else search := r;
end;
procedure sort2(n: longint);
var i,j: longint;
begin
  for i := n div 2 downto 2 do pushdown2(i,n);
  for i := n downto 2 do begin
    pushdown2(1,i);
    swap2(a[1],a[i]);
  end;
end;
begin
  assign(input,'mayors.in'); reset(input);
  assign(output,'mayors.out'); rewrite(output);
  read(n);
  for i := 1 to n do begin
    read(a[i].x,a[i].y);
    x[i] := a[i].x; y[i] := a[i].y;
    a[i].num := i;
  end;
  sort(x,n); sort(y,n); sort2(n);
  for i := 1 to n do begin
    if x[i] <> x[nx+1] then begin
      inc(nx); x[nx] := x[i];
    end;
    if y[i] = y[ny+1] then begin
      inc(ny); y[ny] := y[i];
    end;
  end;
  for i := 1 to n do begin
    xx := search(x,nx,a[i].x);
    yy := search(y,ny,a[i].y);
    if numx[xx] >= 1 then begin
      if numy[yy] <= 0 then begin
        if abs(numy[yy]) > numx[xx] then begin
          inc(numx[xx]);
          inc(numy[yy]);
          col[a[i].num] := 0;
        end else begin
          dec(numx[xx]);
          dec(numy[yy]);
          col[a[i].num] := 1;
        end;
      end else begin
        dec(numx[xx]);
        dec(numy[yy]);
        col[a[i].num] := 1;
      end;
    end else begin
      if numy[yy] >= 0 then begin
        if abs(numy[yy]) > abs(numx[xx]) then begin
          dec(numx[xx]);
          dec(numy[yy]);
          col[a[i].num] := 1;
        end else begin
          inc(numx[xx]);
          inc(numy[yy]);
          col[a[i].num] := 0;
        end;
      end else begin
        inc(numx[xx]);
        inc(numy[yy]);
        col[a[i].num] := 0;
      end;
    end;
  end;
  for i := 1 to n do writeln(col[i]);
  close(input);
  close(output);
end.
