const
  inf = 'mayors.in'; ouf = 'mayors.out';
  mx = 21000;
  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
var
  ys, p, x, y, yn: array[1..mx] of longint;
  pt: array[1..mx] of shortint;
  smy: array[1..mx] of longint;
  n, hs: longint;
  procedure heapify(k: longint);
  var
    lg, j: longint;
  begin
    lg := k; j := lg shl 1;
    if (j <= hs) and ((x[j] > x[lg])
      or (x[j] = x[lg]) and (y[j] > y[lg])) then lg := j;
    inc(j);
    if (j <= hs) and ((x[j] > x[lg])
      or (x[j] = x[lg]) and (y[j] > y[lg])) then lg := j;
    if (lg <> k) then
    begin
      swap(x[k], x[lg]); swap(y[k], y[lg]); swap(p[k], p[lg]);
      heapify(lg);
    end;
  end;
var
  i, j: longint;
  procedure heapsort;
  begin
    j := hs;
    for i := j shr 1 downto 1 do heapify(i);
    for i := 1 to j - 1 do
    begin
      swap(x[1], x[hs]); swap(y[1], y[hs]); swap(p[1], p[hs]);
      dec(hs); heapify(1);
    end;
  end;
  procedure heapifyn(k: longint);
  var
    lg, j: longint;
  begin
    lg := k; j := lg shl 1;
    if (j <= hs) and (yn[j] > yn[lg]) then lg := j;
    inc(j);
    if (j <= hs) and (yn[j] > yn[lg]) then lg := j;
    if (lg <> k) then
    begin
      swap(yn[k], yn[lg]); heapifyn(lg);
    end;
  end;
  procedure heapsortn;
  begin
    j := hs;
    for i := j shr 1 downto 1 do heapifyn(i);
    for i := 1 to j - 1 do
    begin
      swap(yn[1], yn[hs]);
      dec(hs); heapifyn(1);
    end;
  end;
var
  dx, qy, k, l, r, m: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf); rewrite(output);
  readln(input,n);
  for i := 1 to n do
  begin
    readln(input, x[i], y[i]); p[i] := i;
  end; hs := n;
  heapsort;
  yn := y; hs := n;
  heapsortn;
  i := 1; ys[1] := y[1]; qy := 1;
  for i := 2 to n do
    if (yn[i] <> ys[qy]) then
    begin
      inc(qy); ys[qy] := yn[i];
    end;
  fillchar(smy, sizeof(smy), 0);
  fillchar(pt, sizeof(pt), 0); i := 1;
  while (i <= n) do
  begin
    j := i + 1; dx := 0;
    while (x[j-1] = x[j]) and (j <= n) do inc(j); dec(j);
    for k := i to j do
    begin
      l := 1; r := qy + 1;
      while r - l > 1 do
      begin
        m := (l + r) shr 1;
        if (y[k] >= ys[m]) then l := m else r := m;
      end;
      if (ys[l] < y[k]) then inc(l);
      if (smy[l] >= 0) and (dx >= 0) then
      begin
        pt[p[k]] := -1; dec(smy[l]); dec(dx);
      end else
        if (smy[l] <= 0) and (dx <= 0) then
        begin
          pt[p[k]] := 1; inc(smy[l]); inc(dx);
        end else
          if (abs(smy[l]) > abs(dx)) then
          begin
            if (smy[l] > 0) then
            begin
               pt[p[k]] := -1; dec(smy[l]); dec(dx);
            end else
            begin
               pt[p[k]] := 1; inc(smy[l]); inc(dx);
            end;
          end else
           if (abs(smy[l]) < abs(dx)) then
           begin
            if (dx > 0) then
            begin
               pt[p[k]] := -1; dec(smy[l]); dec(dx);
            end else
            begin
               pt[p[k]] := 1; inc(smy[l]); inc(dx);
            end;
           end else
           begin
               pt[p[k]] := 1; inc(smy[l]); inc(dx);
           end;
    end;
    i := j + 1;
  end;
  for i := 1 to n do
    if (pt[i] = -1) then
      writeln(output, 1)
    else writeln(output, 0);
  close(input); close(output);
end.
