{$I-,R-,S-,Q-}
const max=100000;
var stz,size,m,n:longint;
    ht,hn,hc:array[1..2*max]of longint;
    {time,number+100000(out),stoianka}

    num:array[1..max]of longint;

    r:array[1..2*131072-1]of longint;


procedure swap(i,j:longint);
var k:longint;
begin
  k:=ht[i];
  ht[i]:=ht[j];
  ht[j]:=k;
  k:=hn[i];
  hn[i]:=hn[j];
  hn[j]:=k;
  k:=hc[i];
  hc[i]:=hc[j];
  hc[j]:=k;
end;

procedure heapify(i:longint);
var m:longint;
begin
  m:=i;
  if 2*i<size then
    if ht[2*i]<ht[m] then
      m:=2*i;
  if 2*i+1<size then
    if ht[2*i+1]<ht[m] then
      m:=2*i+1;
  if m<>i then
    begin
      swap(m,i);
      heapify(m);
    end;
end;

procedure add(at,an,ac:longint);
var i,j:longint;
begin
  inc(size);
  ht[size]:=at;
  hn[size]:=an;
  hc[size]:=ac;
  i:=size;
  while (i>1)and(ht[i div 2]>ht[i]) do
    begin
      swap(i,i div 2);
      i:=i div 2;
    end;
end;

procedure extract(var at,an,ac:longint);
begin
  at:=ht[1];
  an:=hn[1];
  ac:=hc[1];
  ht[1]:=ht[size];
  hn[1]:=hn[size];
  hc[1]:=hc[size];
  dec(size);
  heapify(1);
end;

procedure correct(i,x:longint);
var j:longint;
begin
  r[i]:=x;
  j:=i div 2;
  while j>=1 do
    begin
      if r[2*j]<r[2*j+1] then
        r[j]:=r[2*j]
      else
        r[j]:=r[2*j+1];
      j:=j div 2;
    end;
end;

function rmq(i,j:longint):longint;
var k:longint;

procedure relax(x:longint);
begin
  if (k=-1)or(r[x]<r[k]) then
    k:=x;
end;

begin
  k:=-1;
  while i<=j do
    begin
      relax(i);
      i:=(i+1)div 2;
      relax(j);
      j:=(j-1)div 2;
    end;
  rmq:=r[k];
end;

procedure init;
var i,a,b,c:longint;
begin
  assign(input,'parking.in');
  reset(input);
  size:=0;
  read(n,m);
  for i:=1 to m do
    begin
      read(a,b,c);
      add(a,i,c);
      add(b,i+max,0);
    end;
  close(input);
end;

procedure run;
var i,j:longint;
    at,an,ac:longint;
begin
  stz:=1;
  while stz<n do
    stz:=stz*2;
  for i:=1 to n do
    r[i+stz-1]:=i;
  for i:=n+1 to stz do
    r[stz-1+i]:=n+1;
  for i:=stz-1 downto 1 do
    if r[2*i]<r[2*i+1] then
      r[i]:=r[2*i]
    else
      r[i]:=r[2*i+1];

  for i:=1 to 2*m do
    begin
      extract(at,an,ac);
      if an>max then
        correct(num[an-max]+stz-1,num[an-max])
      else
        begin
          num[an]:=rmq(stz-1+ac,stz-1+n);
          if num[an]>n then
            num[an]:=rmq(stz-1+1,stz-1+ac-1);
          correct(stz-1+num[an],n+1);
        end;
    end;
end;

procedure done;
var i:longint;
begin
  assign(output,'parking.out');
  rewrite(output);
  for i:=1 to n do
    writeln(num[i]);
  close(output);
end;

begin
  init;
  run;
  done;
end.