program NemnogoyaroslavetsParkingLot;

var f: text;
    oo, ones, step, pl, de, i, j, n, m, t, aut, fre, nmf, dva: cardinal;
    time, ev, who, where: array [1..200000] of cardinal;
    inn: array [1..200000] of boolean;
    men: array [1..100000, 1..3] of cardinal;
    free: array [0..200000, 0..18] of cardinal;

procedure siftup (a: word);
begin
  if (a > 1) and (time [a shr 1] < time [a]) then
  begin
    t := time [a shr 1];
    time [a shr 1] := time [a];
    time [a] := t;
    t := ev [a shr 1];
    ev [a shr 1] := ev [a];
    ev [a] := t;
    siftup (a shr 1);
  end;
end;

procedure sdown (a: word);
begin
  if (a shl 1 + 2 <= i) and (time [a] < time [a shl 1 + 1]) and
     (time [a shl 1] < time [a shl 1 + 1]) then
  begin
    t := time [a shl 1 + 1];
    time [a shl 1 + 1] := time [a];
    time [a] := t;
    t := ev [a shl 1 + 1];
    ev [a shl 1 + 1] := ev [a];
    ev [a] := t;
    sdown (a shl 1 + 1);
  end
  else if (a shl 1 + 1 <= i) and (time [a] < time [a shl 1]) then
  begin
    t := time [a shl 1];
    time [a shl 1] := time [a];
    time [a] := t;
    t := ev [a shl 1];
    ev [a shl 1] := ev [a];
    ev [a] := t;
    sdown (a shl 1);
  end;
end;

begin
  assign (f, 'parking.in');
  reset (f);
  read (f, n);
  readln (f, m);
  step := 0;
  while (1 shl step < n) do inc (step);
  for j := 0 to step do
  begin
    for i := 0 to 1 shl (step - j) do
    begin
      free [i shl j, j] := 1 shl j;
    end;
  end;
  ones := 1 shl step;
  oo := ones * 2 - 1;
  for i := 1 to 2*m do
  begin
    ev [i] := i;
    inn [i] := ((i and 1) = 1);
  end;
  for i := 1 to m do
  begin
    read (f, men [i, 1], men [i, 2]);
    readln (f, men [i, 3]);
    who [i shl 1 - 1] := i;
    who [i shl 1] := i;
    where [i shl 1 - 1] := men [i, 3];
    time [i shl 1 - 1] := men [i, 1];
    time [i shl 1] := men [i, 2];
  end;
  for i := 2 to 2*m do
  begin
    siftup (i);
  end;
  for i := 2*m downto 2 do
  begin
    t := time [1];
    time [1] := time [i];
    time [i] := t;
    t := ev [1];
    ev [1] := ev [i];
    ev [i] := t;
    sdown (1);
  end;
  for i := 1 to 2*m do
  begin
    if inn [ev [i]] then
    begin
      pl := where [ev [i]] - 1;
      de := 0;
      while (free [pl, 0] = 0) do
      begin
        if (free [pl, de] = 0) then
        begin
          if (pl and (1 shl de) > 0) then
          begin
            inc (pl, 1 shl de);
            inc (de);
          end
          else
          begin
            inc (pl, 1 shl de);
          end;
        end
        else
        begin
          dec (de);
        end;
      end;
      if (pl >= n) then
      begin
        dec (pl, n);
      end;
      men [who [ev [i]], 3] := pl;
      aut := pl;
      for j := 0 to step do
      begin
        dec (free [pl, j]);
        pl := pl and (oo - 1 shl j);
      end;
      pl := aut + n;
      if (pl <= ones) then
      begin
        for j := 0 to step do
        begin
          dec (free [pl, j]);
          pl := pl and (oo - 1 shl j);
        end;
      end;
    end
    else
    begin
      pl := men [who [ev [i]], 3];
      for j := 0 to step do
      begin
        inc (free [pl, j]);
        pl := pl and (oo - 1 shl j);
      end;
      pl := men [who [ev [i]], 3] + n;
      if (pl <= ones) then
      begin
        for j := 0 to step do
        begin
          inc (free [pl, j]);
          pl := pl and (oo - 1 shl j);
        end;
      end;
    end;
  end;
  assign (f, 'parking.out');
  rewrite (f);
  for i := 1 to m do
  begin
    writeln (f, men [i, 3] + 1);
  end;
  close (f);
end.
