type tp1=record x,y1,y2:longint end;
     tp2=record y,x1,x2:longint end;
var pr:array[1..200000] of tp1;
    n,l1,l2,el1,el2:longint;
    dr:array[1..200000] of tp2;
    otv:int64;
procedure init;
var nx,ny,lx,ly:longint;
    a,b,c,d,i:longint;
begin
  assign(input,'poly.in');
  reset(input);
  readln(n);
  readln(lx,ly);
  l1:=0;
  l2:=0;
  for i:=2 to n do
    begin
      readln(nx,ny);
      a:=nx-lx;
      b:=ny-ly;
      if (a>0) and (b>0) then
        begin
          inc(l2);
          dr[l2].y:=ly-lx;
          dr[l2].x1:=lx+ly;
          dr[l2].x2:=lx+ly+2*(nx-lx);
        end;
      if (a<0) and (b<0) then
        begin
          inc(l2);
          dr[l2].y:=ly-lx;
          dr[l2].x2:=lx+ly;
          dr[l2].x1:=lx+ly+2*(nx-lx);
        end;
      if (a>0) and (b<0) then
        begin
          inc(l1);
          pr[l1].x:=lx+ly;
          pr[l1].y2:=-lx+ly;
          pr[l1].y1:=-lx+ly-2*(ly-ny);
        end;
      if (a<0) and (b>0) then
        begin
          inc(l1);
          pr[l1].x:=ly+lx;
          pr[l1].y1:=-lx+ly;
          pr[l1].y2:=-lx+ly-2*(ly-ny);
        end;
      lx:=nx;
      ly:=ny;
    end;
  close(input);
end;
procedure heapify1(k:longint);
var ms:longint;
    tmp:tp1;
begin
  ms:=k;
  if (pr[2*k].x>pr[ms].x) and (2*k<=el1) then
    ms:=2*k;
  if (pr[2*k+1].x>pr[ms].x) and (2*k+1<=el1) then
    ms:=2*k+1;
  if ms<>k then
    begin
      tmp:=pr[ms];
      pr[ms]:=pr[k];
      pr[k]:=tmp;
      heapify1(ms);
    end;
end;
procedure heapify2(k:longint);
var ms:longint;
    tmp:tp2;
begin
  ms:=k;
  if (dr[2*k].x1>dr[ms].x1) and (2*k<=el2) then
    ms:=2*k;
  if (dr[2*k+1].x1>dr[ms].x1) and (2*k+1<=el2) then
    ms:=2*k+1;
  if ms<>k then
    begin
      tmp:=dr[ms];
      dr[ms]:=dr[k];
      dr[k]:=tmp;
      heapify2(ms);
    end;
end;
procedure done;
begin
  assign(output,'poly.out');
  rewrite(output);
  writeln(otv);
  close(output);
  halt(0);
end;
procedure run;
var tmp1:tp1;
    tmp2:tp2;
    i,ls,j,lt:longint;
begin
  el1:=l1;
  el2:=l2;
  for i:=el1 div 2+el1 mod 2 downto 1 do
    heapify1(i);
  for i:=el2 div 2+el2 mod 2 downto 1 do
    heapify2(i);
  for i:=l1 downto 2 do
    begin
      tmp1:=pr[1];
      pr[1]:=pr[el1];
      pr[el1]:=tmp1;
      dec(el1);
      heapify1(1);
    end;
  for i:=l2 downto 2 do
    begin
      tmp2:=dr[1];
      dr[1]:=dr[el2];
      dr[el2]:=tmp2;
      dec(el2);
      heapify2(1);
    end;
  lt:=1;
  otv:=0;
  for i:=1 to l2 do
    begin
      ls:=lt;
      for j:=ls to l1 do
        begin
          if i<l2 then
            if pr[j].x<=dr[i+1].x1 then
              lt:=j;
          if pr[j].x>dr[i].x2 then
            break;
          if (pr[j].y1<dr[i].y) and (dr[i].y<pr[j].y2) then
            inc(otv);
        end;
    end;
end;
begin
  init;
  run;
  done;
end.
