program Left_Grammatics;

const
  MAXM = 21; {102}

var
  m : integer;
  isp : array [1..MAXM,1..MAXM,'@'..'['] of boolean;
  prev,mat : array [1..MAXN] of integer;
  bad : boolean;
  v : array ['A'..'Z'] of integer;
  v1,v3 : array [1..MAXM] of boolean;
  v2 : array [1..MAXM,1..MAXM] of boolean;
  term : char;

function vv(a : char) : integer;
begin
  if v[a]=0 then
  begin
    inc(m);
    v[a] := m;
  end;
  vv := v[a];
end;

procedure Load(infile, outfile : string);
var
  n, i, t, tt : integer;
  s : string;
  c1 : char;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  readln(n,c1,term);
  m := 1;
  fillchar(isp,sizeof(isp),0);
  fillchar(v,sizeof(v),0);
  for i:=1 to n do
  begin
    readln(s);
    while pos(' ',s)<>0 do
      delete(s,pos(' ',s),1);
    delete(s,2,2);
    t := vv(s[1]);
    delete(s,1,1);
    if (s<>'') and (s[1] in ['A'..'Z']) then
    begin
      tt := vv(s[1]);
      delete(s,1,1);
    end
    else
      tt := 1;
    if s='' then
    begin
      isp[tt,t,'@'] := true;
      isp[tt,t,'['] := true;
    end
    else
    begin
      while s<>'' do
        if length(s)>1 then
        begin
          inc(m);
          isp[tt,m,upcase(s[1])] := true;
          isp[tt,m,'['] := true;
          delete(s,1,1);
          tt := m;
        end
        else
        begin
          isp[tt,t,upcase(s[1])] := true;
          isp[tt,t,'['] := true;
          delete(s,1,1);
        end;
    end;
  end;
end;

procedure DFS(a : integer);
var
  i : integer;
begin
  v1[a] := true;
  for i:=1 to m do
    if isp[a,i,'['] and not v1[i] then
      dfs(i);
end;

procedure DFS2(a : integer);
var
  i : integer;
begin
  v3[a] := true;
  for i:=1 to m do
    if isp[i,a,'['] and not v3[i] then
      dfs2(i);
end;

procedure Solve;
var
  i, j, k : integer;
begin
  bad := false;
  fillchar(v1,sizeof(v1),0);
  fillchar(v3,sizeof(v3),0);
  dfs(1);
  dfs2(vv(term));
  for i:=1 to m do
    for j:=1 to m do
      v2[i,j] := isp[i,j,'['];
  for j:=1 to m do
    for i:=1 to m do
      for k:=1 to m do
        v2[i,k] := v2[i,k] or (v2[i,j] and v2[j,k]);
  for i:=1 to m do
    if v1[i] and v3[i] and v2[i,i] then
      bad := true;
  if bad or not v1[vv(term)] then
    exit;
  fillchar(mat,sizeof(mat),0);
  mat[1] := 1;
end;

procedure Save;
begin
  if bad then
    writeln('infinity')
  else
    if not vv1[vv(term)] then
      writeln(0);
  close(input);
  close(output);
end;

begin
  Load('left.in','left.out');
  Solve;
  Save;
end.