program zzz;

const
  maxr = 1000;
var
  i,j,k,n,sc,m: longint;
  sym,nxt: array[1..maxr] of char;
  size: array[1..maxr] of longint;
  rule : array[1..maxr,1..maxr] of char;
  g: array['A'..'Z','A'..'Z'] of boolean;
  isfin,is,vis: array['A'..'Z'] of boolean;
  fst,ch: char;
  por: array[1..26] of char;
procedure dfs(v: longint);
var i: longint;
begin
  if vis[chr(v)] then exit;
  vis[chr(v)] := true;
  for i := ord('A') to ord('Z') do begin
    if g[chr(i),chr(v)] then begin
      dfs(i);
    end;
  end;
end;
procedure cycle(v: longint);
var i: longint;
begin
  if is[chr(v)] then begin
    if not isfin['A'] then begin
      writeln('0');
      close(input);
      close(output);
      halt;
    end else begin
      writeln('infinity');
      close(input);
      close(output);
      halt;
    end;
  end;
  if vis[chr(v)] then exit;
  is[chr(v)] := true;
  for i := ord('A') to ord('Z') do begin
    if g[chr(v),chr(i)] then dfs(i);
  end;
  is[chr(v)] := false;
end;
{procedure tryput(ch: char; len: longint; w: array of char);
var i : longint;
    cur : nodep;
begin
  cur := fst;
  while cur^.nxt <> nil do begin
    if len = cur^.len then begin
      for i := 1 to len do if w[i] <> w[j] then break;
      if w[i] = w[j] then if ch = cur^.ch then exit;
    end;
    cur := cur^.nxt;
  end;
  new(cur^.nxt);
  cur := cur^.nxt;
  cur^.nxt := nil;
  cur^.w := w;
  cur^.len := len;
  cur^.ch := ch;
end;}
procedure readrule(i: longint);
var ch : char;
    j: longint;
begin
  ch := ' ';
  while not (ch in ['A'..'Z']) do read(ch);
  sym[i] := ch;
  while not (ch = '>') do read(ch);
  ch := ' ';
  while not seekeoln do begin
    read(ch);
    if ch in ['A'..'Z'] then begin
      nxt[i] := ch;
    end else begin
      inc(size[i]);
      rule[i,size[i]] := ch;
    end;
  end;
  if nxt[i] in ['A'..'Z'] then begin
    g[sym[i],nxt[i]] := true;
  end;
  readln;
end;
begin
  assign(input,'left.in'); reset(input);
  assign(output,'left.out'); rewrite(output);
  read(n);
  ch := ' ';
  while not (ch in ['A'..'Z']) do read(ch);
  readln;
  fst := ch;
  for i := 1 to n do readrule(i);
  for i := 1 to n do begin
    if not (nxt[i] in ['A'..'Z']) then dfs(ord(sym[i]));
  end;
  if not vis[fst] then writeln('0') else writeln('infinity');
  close(input);
  close(output);
  halt;
  fillchar(vis,sizeof(vis),false);
  close(input);
  close(output);
end.
