{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'merge.in'; outfile = 'merge.out'; max = 205;
var g: array [1..max,1..max] of longint;
    s: array [1..max,1..max] of longint;
    nnew: array [1..max] of longint;
    yk,sv: array [1..max] of longint;
    ans: array [1..max,1..2] of longint;
    ans_num: longint;
    n,m: longint;
    all_sv: boolean;

procedure init;
var i,p,q: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,m);
     fillchar(g,sizEoF(g),0);
     fillchar(nnew,Sizeof(nnew),0);
     for i:=1 to m do begin
         read(p,q); g[p,q]:=1;
     end;
     close(input);
end;

procedure bfs(v: longint);
var w: array [1..max] of byte;
    og: array [1..max] of longint;
    yk1,yk2,i: longint;
begin
     fillchar(og,sizEoF(og),0);
     fillchar(w,SizEoF(w),0);
     w[v]:=1; og[1]:=v; yk1:=1; yk2:=0;
     while yk1 > yk2 do begin
           inc(yk2);
           for i:=1 to n do
               if (nnew[i] = 0)and(w[i] = 0)and(g[og[yk2],i] = 1) then begin
                  inc(yk1); og[yk1]:=i; w[i]:=1;
               end;
     end;
     yk[v]:=yk1; sv[v]:=1;
     for i:=1 to n do if nnew[i] = 0 then begin
         if (w[i] = 0) then begin
            sv[v]:=0; s[v,i]:=0;
         end
            else s[v,i]:=1;
     end;
end;

procedure check_sv(var v1,v2: longint);
var i,j,k,h: longint;
begin
     all_sv:=false;
     for i:=1 to n do
         if (nnew[i] = 0)and(sv[i] = 0) then bfs(i);
     for i:=1 to n do
         if (nnew[i] = 0)and(sv[i] = 0) then break;
     if (nnew[i] = 0)and(sv[i] = 0) then begin
        for j:=1 to n do
            if (nnew[j] = 0)and(s[i,j] = 0) then break;
        for k:=1 to n do if k <> i then
            if (nnew[k] = 0)and(s[i,k] = 1) then begin
               for h:=1 to n do if h <> i then
                   if (nnew[h] = 0)and(s[j,h] = 1)and(s[k,h] = 0) then break;
            if (nnew[h] = 0)and(s[j,h] = 1)and(s[k,h] = 0) then
               begin v1:=k; v2:=j; exit; end;
            end;
        for k:=1 to n do
            if (nnew[k] = 0)and(s[i,k] = 1) then begin
               v1:=k; v2:=j; exit; end;
     end;
     all_sv:=true;
end;

procedure merge(v1,v2: longint);
var p1,p2,i: longint;
begin
     if v1 > v2 then begin p1:=v2; p2:=v1; end
        else begin p1:=v1; p2:=v2; end;
     for i:=1 to n do
         if (nnew[i] = 0)and(g[i,p2] = 1) then begin
            g[i,p2]:=0; g[i,p1]:=1;
         end;
     for i:=1 to n do
         if (nnew[i] = 0)and(g[p2,i] = 1) then begin
            g[p2,i]:=0; g[p1,i]:=1;
         end;
     nnew[p2]:=1;
end;

procedure solve;
var v1,v2: longint;
begin
     ans_num:=0;
     check_sv(v1,v2);
     while not all_sv do begin
           inc(ans_num);
           ans[ans_num,1]:=v1;
           ans[ans_num,2]:=v2;
           merge(v1,v2);
           check_sv(v1,v2);
     end;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     writeln(ans_num);
     for i:=1 to ans_num do
         writeln(ans[i,1],' ',ans[i,2]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.