{$D-,L-,Q-,R-,S-,I-}
Program pr_b;
const
  inpfile='merge.in';
  outfile='merge.out';
  inf=MaxLongInt div 3;
  nm=205;
type
  Rebr=record
    x,y : LongInt;
  end;
var
  a : array [1..nm,1..nm] of Boolean;
  inpv,outv : array [1..nm] of LongInt;
  r : array [1..nm] of Rebr;
  res,n,m,nul : LongInt;
{}
Procedure Inp;
var
  i,x,y : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
  for i:=1 to m do begin
    read(x,y); a[x,y]:=true;
    inc(inpv[y]); inc(outv[x]);
  end;
  nul:=n*n-n-m;
end;
{}
Procedure Out;
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  for i:=1 to res do
    writeln(r[i].x,' ',r[i].y);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(inpv,sizeof(inpv),0);
  fillchar(outv,sizeof(outv),0);
end;
{}
Procedure Glue(x,y : LongInt);
var
  i,j : LongInt;
begin
  for i:=1 to n do
    for j:=1 to n do
      if not a[i,j] then
        if a[i,x] and a[y,j] then begin
          a[i,j]:=true;
          dec(nul);
        end;
end;
{}
Procedure Solve;
var
  i,j,k,max,x,y : LongInt;
begin
  for i:=1 to n do a[i,i]:=true;
  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        if not a[i,j] then
          if a[i,k] and a[k,j] then begin
            a[i,j]:=true;
            dec(nul);
          end;
  while nul>0 do begin
    max:=-inf;
    for i:=1 to n do
      for j:=1 to n do
        if inpv[i]-outv[i]+outv[j]-inpv[j]>max then begin
          x:=i; y:=j; max:=inpv[i]-outv[i]+outv[j]-inpv[j];
        end;
    inpv[x]:=inpv[x]+inpv[y]; inpv[y]:=inpv[x];
    outv[x]:=outv[x]+outv[y]; outv[y]:=outv[x];
    inc(res); r[res].x:=x; r[res].y:=y; Glue(x,y);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
