#include "game.h"
#include <stdio.h>

#define NN 55
#define MM 1000000

int _stklen = 4194304;

FILE *fi, *fo;
int n;
int a[MM];
int b[NN][NN];
int sb[NN];
int p[NN];
int ssb;
int f[NN][NN];

int GetNumber(int *b, int k)
{
  int b1[NN];
  int i,j;
  int x;
  int n;
  int ii,jj;
  n=0;
  for(i=0;i<k;i++)
  {
    b1[i]=b[i];
    n+=b[i];
  }

  for(i=0;i<k;i++)
  {
    for(j=i+1;j<k;j++)
    {
      if(b[j]<b[i])
      {
        x=b[j];
        b[j]=b[i];
        b[i]=x;
      }
    }
  }
  x=0;
  for(i=0;i<n;i++)
    x+=f[i][i];
  ii=n;
  for(i=0;i<k;i++)
  {
    ii-=b[k-1-i];
    jj=b[k-i-1];
    x+=f[ii][jj];
  }
  for(i=0;i<k;i++)
    b[i]=b1[i];
  return x;
}

void del(int *b, int j,int k)
{
  int i;
  for(i=j;j<k-1;j++)
    b[j]=b[j+1];
}

void ins(int *b, int x, int k)
{
  int i,j;
  for(i=0;(i<k)&&(b[i]<x);i++) ;
  for(j=k-1;j>=i;j--)
    b[j+1]=b[j];
  b[i]=x;
}

void fine(int *b, int *k)
{
  int i,j;
  j=0;
  for(i=0;i<*k;i++)
  {
    if(b[i]==0)
      j++;
    else
      b[i-j]=b[i];
  }
  *k-=j;
}

int dfs(int *b,int k)
{
  int i,j,m;
  int x,y;
  int *b1;
  int kk;
  int yy,xx;
  if(k<=0)
    return 1;
  x=GetNumber(b,k);
  xx=0;
  if(a[x]>0)
    return a[x];
  a[x]=2;
  b1=new int[k+1];
  for(j=0;j<k;j++)
  {
    if(b[j]>1)
    {
      y=b[j];
      for(m=0;m<(y-2)/2+1;m++)
      {
        for(i=0;i<k;i++)
          b1[i]=b[i];
        del(b1,j,k);
        ins(b1,m,k-1);
        ins(b1,y-2-m,k);
        kk=k+1;
        fine(b1,&kk);
        yy=dfs(b1,kk);
        if(yy==2)
        {
          a[x]=1;
          return 1;
        }
        else
        {
          xx++;
        }
      }
    }
  }
  if(xx==0)
    a[x]=1;
  delete(b1);
  return a[x];
}

void div(int x, int y, int *aa, int *bb)
{
  int i,j;
  int r;
  int t1,t2;
  r=p[x];
  i=0;
  while(b[r][i]!=x) i++;
  t1=i;
  i++;
  sb[ssb]=0;
  j=0;
  while(b[r][i+j]!=y)
  {
    b[ssb][j]=b[r][i+j];
    p[b[ssb][j]]=ssb;
    sb[ssb]++;
    j++;
  }
  t2=i+j;
  for(i=t2+1;i<sb[r];i++)
    b[r][t1+i-t2-1]=b[r][i];
  sb[r]-=t2-t1+1;

  if((sb[r]==0)&&(sb[ssb]==0))
    ssb--;
  if(ssb>0)
    if(sb[r]==0)
    {
      for(i=0;i<sb[ssb];i++)
        b[r][i]=b[ssb][i];
      ssb--;
    }
  if(ssb>0)
    if(sb[ssb]==0)
      ssb--;
  
  ssb++;
  *aa=r;
  *bb=ssb-1;
}

int main()
{
  int i,j,m;
  int x1,y1,x2,y2;
  int cur;
  int aa,bb;
  int xx;
  int b1[NN];
  int y;
  int kk;
  
  n=Init();

  for(i=0;i<NN;i++)
    f[i][0]=0;
  for(i=0;i<NN;i++)
    f[0][i]=1;
  for(i=1;i<NN;i++)
    for(j=1;j<NN;j++)
      if(i>=j)
        f[i][j]=f[i][j-1]+f[i-j][j];
      else
        f[i][j]=f[i][j-1];

  for(i=0;i<n;i++)
  {
    b[0][i]=i+1;
    p[i]=0;
  }
  ssb=1;
  sb[0]=n;
  for(i=0;i<MM;i++)
    a[i]=0;

  dfs(sb,ssb);

  while(true)
  {
    xx=GetNumber(sb,ssb);
    if(a[xx]==2)
    {
      for(i=0;i<ssb;i++)
      {
        if(sb[i]>=2)
        {
          x1=b[i][0];
          y1=b[i][1];
          i=ssb+1;
        }
      }
      div(x1,y1,&aa,&bb);
      Move(x1,y1,&x2,&y2);
      div(x2,y2,&aa,&bb);
    }
    else
    {
      for(j=0;j<ssb;j++)
      {
        if(sb[j]>1)
        {
          y=sb[j];
          for(m=0;m<(y-2)/2+1;m++)
          {
            for(i=0;i<ssb;i++)
              b1[i]=sb[i];
            del(b1,j,ssb);
            ins(b1,m,ssb-1);
            ins(b1,y-2-m,ssb);
            kk=ssb+1;
            fine(b1,&kk);
            if(dfs(b1,kk)==2)
            {
              x1=b[j][0];
              y1=b[j][m+1];
              m=y+10;
              j=ssb+1;
            }
          }
        }
      }
      div(x1,y1,&aa,&bb);
      Move(x1,y1,&x2,&y2);
      div(x2,y2,&aa,&bb);
    }
  }

  return 0;
}
