{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R+,Q+,S+,I+,N+}


program template;
uses game;
const
 nmax = 50;
 maxpos = 250000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = '';
 coutfile= '';
 {$endif}
type
 int = longint;
 real = extended;
 tpos = array [-1..nmax shr 1] of int;
 ppos = ^tpos;
var
 m :int;
 n :integer;
 r :tpos;
 ps :array [1..maxpos] of ppos;
 used :array [1..maxpos] of boolean;
 state :array [1..maxpos] of boolean;
 b :array [1..nmax] of int;
 colors :int;

procedure init_;
begin
 randseed := 24235;
 fillchar (r,sizeof(r),0);
 fillchar (used,sizeof(used),0);
 m := 0;
end;

procedure readdata;
var i,j :int;
begin
{ assign (input,cinfile);
 reset (input);
 readln (n);
 close (input);}
 n := init;
end;

procedure rec (num :int; max :int);
var i :int;
begin
 if (num = 1) or (num < 0) then
  exit;
 if num = 0 then
  begin
   inc(m);
   new (ps[m]);
   ps[m]^ := r;
   exit;
  end;
 for i := 2 to max do
  begin
   inc(r[0]);
   r[r[0]] := i;
   rec (num-i,i);
   r[r[0]] := 0;
   dec(r[0]);
  end;
end;

procedure swap (var a,b :ppos);
var tmp :ppos;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

function less (var a,b :tpos):boolean;
var i :int;
begin
 if not (a[-1] = b[-1]) then
  less := a[-1] < b[-1]
 else
  if not (a[0] = b[0]) then
   less := a[0] < b[0]
  else
   begin
    i := a[0];
    while (i > 1) and (a[i] = b[i]) do
     dec(i);
    less := a[i] < b[i];
   end;
end;

function q (var a,b :tpos):boolean;
var i :int;
begin
 q := false;
 if not (a[-1] = b[-1]) or not (a[0] = b[0]) then
  exit;
 for i := 1 to a[0] do
  if not (a[i] = b[i]) then
   exit;
 q := true;
end;

procedure sort (l,r :int);
var i,j :int;
    x :tpos;
begin
 i := l;
 j := r;
 x := ps[l + random(r-l+1)]^;
 repeat
  while less (ps[i]^,x) do
   inc(i);
  while less (x,ps[j]^) do
   dec(j);
  if i <= j then
   begin
    swap (ps[i],ps[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if l < j then
  sort (l,j);
end;

function search (var x :tpos):int;
var l,r :int;
    mid :int;
begin
 l := 1;
 r := m;
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   if less (ps[mid]^,x) then
    l := mid
   else
    r := mid;
  end;
 if q (ps[l]^,x) then
  search := l
 else
  if q (ps[r]^,x) then
   search := r
  else
   search := 0;
end;


function makemove (var p :tpos; num :int; cnt :int; var res :tpos;
   var vv :boolean):boolean;
var i,j,k :int;
begin
 fillchar (res,sizeof(res),0);
 for i := 1 to num-1 do
  res[i] := p[i];
 k := num-1;
 if cnt > 1 then
  begin
   inc(k);
   res[k] := cnt;
  end;
 if p[num] - cnt - 2 > 1 then
  begin
   inc(k);
   res[k] := p[num] - cnt - 2;
  end;
 for i := num+1 to p[0] do
  begin
   inc(k);
   res[k] := p[i];
  end;
 for i := 1 to k-1 do
  for j := i+1 to k do
   if res[i] < res[j] then
    begin
     res[i] := res[i] xor res[j];
     res[j] := res[i] xor res[j];
     res[i] := res[i] xor res[j];
    end;
 res[0] := k;
 for i := 1 to k do
  inc(res[-1],res[i]);
 makemove := true;
 if res[-1] < 2 then
  begin
   vv := false;
   makemove := false;
  end;
end;

function dfs (v :int):boolean;
var i,j :int;
    pst :tpos;
    res :boolean;
begin
 if v = 0 then
  begin
   writeln ('jopa');
   exit;
  end;
 if used[v] then
  begin
   dfs := state[v];
   exit;
  end;
 used[v] := true;
 res := true;
 for i := 1 to ps[v]^[0] do
  for j := 0 to ps[v]^[i]-2 do
   if makemove (ps[v]^,i,j,pst,res) then
    begin
     res := false;
     if not dfs (search(pst)) then
      begin
       state[v] := true;
       dfs := true;
       exit;
      end;
    end;
 state[v] := res;
 dfs := res;
end;

procedure solve;
var i,j :int;
    u,v :int;
    tmp :int;
    res,founded :boolean;
    np :tpos;
    d :array [0..nmax] of int;
    lo,hi :integer;
begin
 for i := 2 to n do
  begin
   r[-1] := i;
   rec(i,i);
  end;
 sort (1,m);
 r[-1] := n;
 r[0] := 1;
 r[1] := n;
 dfs (search(r));
 lo := search(r);
 fillchar (b,sizeof(b),0);
 for i := 1 to n do
  b[i] := 1;
 colors := 1;
 while true do
  begin
   res := false;
   for i := 1 to r[0] do
    begin
     for j := 0 to r[i] - 2 do
      if makemove (r,i,j,np,founded) then
       begin
        tmp := search(np);
     {   writeln (tmp);}
        if not dfs(tmp) then
         begin
          res := true;
          u := i;
          v := j;
          break;
         end;
       end;
     if res then
      break;
    end;
   {$ifdef debug}
   writeln (res);
   {$endif}
   if not res then
    begin
     u := 1;
     v := 0;
    end;
 
     fillchar (d,sizeof(d),0);
     for i := 1 to n do
      inc(d[b[i]]);
     lo := 0;
     hi := 0;
     inc(colors);
     for i := 1 to n do
      if d[i] = r[u] then
       begin
        founded := false;
        for j := 1 to n do
         if b[j] = i then
          begin
           if not founded then
            begin
             founded := true;
             b[j] := 0;
             lo := j;
             continue;
            end;
           if v = 0 then
            begin
             b[j] := 0;
             hi := j;
             break;
            end;
          b[j] := colors;
          dec(v);
         end;
        break;
       end;
    move (lo,hi,lo,hi);
    r := np;
    u := b[lo];
    v := 0;
    for j := lo+1 to hi-1 do
     if b[j] = u then
      inc(v);
    b[lo] := 0;
    b[hi] := 0;
    inc(colors);
    tmp := 2;
    for j := 1 to n do
     if b[j] = u then
      inc(tmp);

    for j := lo+1 to hi-1 do
     if b[j] = u then
      b[j] := colors;

    for i := 1 to r[0] do
     if r[i] = tmp then
      begin
       makemove (r,i,v,np,founded);
       r := np;
       break;
      end;
  end;
end;

begin
 init_;
 readdata;
 solve;
end.
