{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}
Const maxn = 105;
      osn = 10000;

Type TLong = array[0..100] of Longint;

Var i, j, n: Integer;
    c, m2, m4: TLong;
    a, b: array[0..maxn] of TLong;

Procedure Init;
 Begin
  a[0, 0] := 1;
  a[0, 1] := 1;
  b[0, 0] := 1;
  b[0, 1] := 1;
  a[1, 0] := 1;
  a[1, 1] := 3;
  b[1, 0] := 1;
  b[1, 1] := 2;
  m2[0] := 1;
  m2[1] := 2;
  m4[0] := 1;
  m4[1] := 4;
 End;

Procedure AddLong(var a: TLong; b: TLong);
 Var i, ost: Integer;
 Begin
  ost := 0;
  If b[0] > a[0] Then a[0] := b[0];
  For i := 1 to a[0] do
   Begin
    Inc(a[i], b[i] + ost);
    ost := 1;
    If a[i] >= osn Then Dec(a[i], osn)
                   Else ost := 0;
   End;
  If ost > 0 Then
   Begin
    Inc(a[0]);
    a[a[0]] := ost;
   End;
 End;

Procedure MulLong(a, b: TLong; var c: TLong);
 Var i, j: Integer;
     ost: Longint;
     d: TLong;
 Begin
  FillChar(c, SizeOf(c), 0);
  For i := 1 to b[0] do
   Begin
    ost := 0;
    FillChar(d, SizeOf(d), 0);
    For j := 1 to a[0] do
     Begin
      d[i + j - 1] := a[j] * b[i] + ost;
      ost := d[i + j - 1] div osn;
      d[i + j - 1] := d[i + j - 1] mod osn;
     End;
    d[0] := i + j - 1;
    If ost > 0 Then
     Begin
      Inc(d[0]);
      d[d[0]] := ost;
     End;
    AddLong(c, d);
   End;
 End;

Procedure WriteLong(a: TLong);
 Var i: Integer;
 Begin
  Write(a[a[0]]);
  For i := a[0] - 1 downto 1 do
   Begin
    If a[i] < 1000 Then Write('0');
    If a[i] < 100 Then Write('0');
    If a[i] < 10 Then Write('0');
    Write(a[i]);
   End;
 End;

Begin
 Assign(input, 'brackets.in');
 Assign(output, 'brackets.out');
 Reset(input);
 Rewrite(output);
 Read(n);
 Init;
 For i := 2 to n do
  Begin
   For j := 1 to i - 1 do
    Begin
     MulLong(b[j - 1], b[i - j - 1], c);
     AddLong(a[i], c);
     MulLong(b[j - 1], a[i - j - 1], c);
     MulLong(c, m2, c);
     AddLong(a[i], c);
     MulLong(a[j - 1], b[i - j - 1], c);
     MulLong(c, m2, c);
     AddLong(a[i], c);
     MulLong(a[j - 1], a[i - j - 1], c);
     MulLong(c, m4, c);
     AddLong(a[i], c);
    End;
   MulLong(a[i - 1], m2, c);
   AddLong(a[i], c);
   AddLong(a[i], b[i - 1]);
   For j := 1 to i - 1 do
    Begin
     MulLong(b[j - 1], b[i - j - 1], c);
     MulLong(c, m4, c);
     AddLong(b[i], c);
    End;
   MulLong(b[i - 1], m2, c);
   AddLong(b[i], c);
  End;
 WriteLong(a[n]);
 Close(input);
 Close(output);
End.