#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include "game.h"

#define MM 4952198
#define ML 4952198ll

int _stklen = 4194304;
TFence a;
int n,k,w;
int g[MM];

FILE *fi, *fo;

int GetNumber(TFence a)
{
  long long res;
  long long pww;
  long long s;
  int i;
  pww=3;
  res=0;
  for(i=0;i<n;i++)
  {
    s=a[i];
    s*=pww;
    s%=ML;
    res+=s;
    res%=ML;
    pww*=3ll;
    pww%=ML;
  }
  return (int) res;
}

int dfs(TFence a)
{
  int x;
  int i,j;
  int f;
  bool flg;
  TFence b;
  x=GetNumber(a);
  if(g[x]>0)
    return g[x];
  g[x]=2;
  for(i=0;i<n;i++)
  {
    flg=false;
    for(j=i+1;j<n;j++)
    {
      if(a[j]!=a[i])
        flg=true;
      if(flg&&(a[i]==a[j])&&(j-i<w))
      {
        for(k=0;k<n;k++)
          if((k<i)||(k>j))
            b[k]=a[k];
          else
            b[k]=a[i];
        f=dfs(b);
        if(f==2)
        {
          g[x]=1;
          return 1;
        }
      }
    }
  }
  return g[x];
}

int main()
{
  int i,j,k;
  int x1,y1,x2,y2;
  int cur;
  TFence b;
  int f;
  bool flg;

  for(i=0;i<MM;i++)
    g[i]=-1;
  
  Init(&n,&k,&w,a);

  dfs(a);
  while(true)
  {
    cur=GetNumber(a);
    if(g[cur]==2)
    {
      for(i=0;i<n;i++)
      {
        flg=false;
        for(j=i+1;j<n;j++)
        {
          if(a[i]!=a[j])
            flg=true;
          if(flg&&(a[i]==a[j])&&(j-i<w))
          {
            x1=i;
            y1=j;
            i=n+1;
            j=n+1;
          }
        }
      }
    }
    else
    {
      for(i=0;i<n;i++)
      {
        flg=false;
        for(j=i+1;j<n;j++)
        {
          if(a[i]!=a[j])
            flg=true;
          if(flg&&(a[i]==a[j])&&(j-i<w))
          {
            for(k=0;k<n;k++)
              if((k<i)||(k>j))
                b[k]=a[k];
              else
                b[k]=a[i];
            f=dfs(b);
            if(f==2)
            {
              x1=i;
              y1=j;
              i=n+1;
              j=n+1;
            }
          }
        }
      }
    }
    for(k=x1+1;k<y1;k++)
      a[k]=a[x1];
    Move(x1,y1,&x2,&y2);
    for(k=x2+1;k<y2;k++)
      a[k]=a[x2];
  }
  
  return 0;
}


