{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 500000,0,655360}
Uses Game;

Const MaxN=80;
      CHash=15432571;
      MaxP=CHash;
Type Real=Double;
     TMyFence=Array[1..MaxN] of Integer;
var b:TFence;
    a:TMyFence;
    Wins:Array[1..MaxP] of Byte;
    N,K,W:Integer;
    i,j:Longint;


Function LargeNum(var P:TMyFence):Longint;
var i,j,t:Longint;
begin
t:=0;
j:=1;
for i:=1 to N do
begin
  Inc(t,P[i]*j);
  j:=j*K;
end;
LargeNum:=t;
end;

Function BadHash(var P:TMyFence):Longint;
var i,j:Longint;
    t:int64;
begin
t:=1;
for i:=1 to N do
begin
  t:=t*p[i] mod CHash;
  t:=(t+p[i]) mod CHash;
end;

for i:=1 to N do
  t:=t*t mod CHash;
BadHash:=t;
end;

Function Pos2Num(var P:TMyFence):Longint;
var i,j,t:Longint;
begin
Pos2Num:=BadHash(P);
end;

Function FWins(var P:TMyFence):Byte;
var Num:Longint;
    i,j,l,g:Longint;
    tp:TMyFence;
begin
Num:=Pos2Num(P);
if Wins[Num]=0 then
begin
  Wins[Num]:=1;
  for i:=1 to N do
  begin
    if Wins[Num]=2 then Break;
    for j:=i+1 to i+W-1 do
      if P[i]=P[j] then
      begin
        tp:=P;
        g:=0;
        for l:=i to j do
          if P[l]<>P[i] then g:=1;
        if g=1 then
        begin
          for l:=i to j do
            tp[l]:=tp[i];
          if FWins(tp)=1 then Wins[Num]:=2;
        end;
      end;
  end;
end;
FWins:=Wins[Num]
end;


Procedure MakeTurn(var u,v:Integer);
var i,j,l,g:Longint;
    Num:Longint;
    mu,mv:Integer;
    tp:TMyFence;
begin
mu:=0;
mv:=0;
if FWins(a)=2 then
begin
  for i:=1 to N do
  begin
    if mu>0 then Break;
    for j:=i+1 to i+W-1 do
      if a[i]=a[j] then
      begin
        tp:=a;
        g:=0;
        for l:=i to j do
          if a[l]<>a[i] then g:=1;
        if g=1 then
        begin
          for l:=i to j do
            tp[l]:=tp[i];
          Num:=Pos2Num(tp);
          if Wins[Num]=1 then
          begin
            mu:=i;
            mv:=j;
          end;
        end;
      end;
  end;

end
else
begin
  for i:=1 to N do
  begin
    if mu>0 then Break;
    for j:=i+1 to i+W-1 do
    if a[i]=a[j] then
    begin
      g:=0;
      for l:=i to j do
        if a[l]<>a[i] then g:=1;
      if g=1 then
      begin
        mu:=i;
        mv:=j;
      end;
    end;
  end;
end;
u:=mu;
v:=mv;
end;

Procedure Solve;
var g,h:Longint;
    v1,u1,v2,u2:Integer;
begin
FillChar(Wins,SizeOf(Wins),0);
Repeat
  MakeTurn(u1,v1);
  for i:=u1 to v1 do
    a[i]:=a[u1];
  Dec(u1);
  Dec(v1);
  Move(u1,v1,u2,v2);
  Inc(u2);
  Inc(v2);

  if u2>v2 then
  begin
    g:=u2;
    u2:=v2;
    v2:=g;
  end;

  for i:=u2 to v2 do
    a[i]:=a[u2];
Until 1=0;
end;

begin
Init(N,K,W,B);
if W>N then W:=N;
for i:=1 to N do
  a[i]:=b[i-1];
Solve;
end.
