uses game;
type
	longint=integer;	
     mas=array[1..1000] of record S:Tfence; Way:array[0..1000] of integer; Prior:boolean;end;
var a:TFence;
    b:mas;
    n,k,w,cnt:integer;

Function prov(const q:Tfence; w,e:longint):boolean;
var i:longint;
    bo:boolean;
begin
     bo:=false;
     for i:=w+1 to e-1 do if q[i]<>q[w] then
     begin
          bo:=true;
          break
     end;
     prov:=bo;
end;

Function is(const a,b:TFence):boolean;
var i:longint;
begin
     is:=false;
     for i:=0 to n-1 do if a[i]<>b[i] then exit;
     is:=true;
end;

Function sostisgood(const q:TFence; const w,e:longint; var t:longint; var c:TFence):boolean;
var i:longint;
begin
     fillchar(C,sizeof(c),0);
     for i:=0 to w do c[i]:=q[i];
     for i:=w to e do c[i]:=q[w];
     for i:=e to n-1 do c[i]:=q[i];
     for i:=1 to cnt do
     begin
          if is(b[i].S,c) then
          begin
               sostisgood:=false;
               t:=i;
               exit;
          end;
     end;
     sostisgood:=true;
end;

procedure looksost(const q:Tfence; const Count:longint);
var i,j,t:longint;
    oo:TFence;
begin
     for i:=0 to n-2 do
     begin
          for j:=i+1 to n-1 do
          begin
               if (q[i]=q[j])and(j-i+1<=w)and(prov(q,i,j)) then
               begin
                    if sostisgood(q,i,j,T,oo) then
                    begin
                         inc(cnt);
                         b[cnt].s:=oo;
                         inc(b[count].way[0]);
                         b[count].way[b[count].way[0]]:=cnt;
                    end else
                    begin
                         inc(b[count].way[0]);
                         b[count].way[b[count].way[0]]:=t;
                    end;
               end;
          end;
     end;
end;

Function doprior(const q:longint):boolean;
var i:longint;
    bo:boolean;
begin
     bo:=false;
     for i:=1 to b[q].way[0] do
     begin
          if not(doprior(b[q].way[i])) then bo:=true;
     end;
     b[q].prior:=bo;
     doprior:=bo;
end;

procedure solve;
var i:longint;
begin
     cnt:=1;
     b[1].S:=a;
     i:=1;
     while i<=cnt do
     begin
          looksost(b[i].s,i);
          inc(i);
     end;
     doprior(1);
end;

Function lookfalse(const q:longint):longint;
var i:longint;
begin
     for i:=1 to b[q].way[0] do
     begin
          if b[b[q].way[i]].prior=false then
          begin
               lookfalse:=b[q].way[i];
               exit;
          end;
     end;
     lookfalse:=b[q].way[1];
end;

procedure lookmove(const q,t:longint; var v1,v2:longint);
var i:longint;
    bo:boolean;
begin
     bo:=false;
     i:=0;
     while b[q].s[i]=b[t].s[i] do inc(i);
     v1:=i-1;
     while b[t].s[i]=b[q].s[v1]do inc(i);
     v2:=i-1;
end;

Function itis(const a,b:TFence; const v3,v4:longint):boolean;
var i,t1,t2:longint;
begin
     i:=0;
     while a[i]=b[i] do inc(i);
     t1:=i-1;
     while b[i]=b[t1] do inc(i);
     t2:=i-1;
     if (t1=v3)and(t2=v4)then itis:=true else itis:=false;
end;

procedure lookhimmove(const t:longint; var q:longint; const v3,v4:longint);
var i:longint;
begin
     for i:=1 to b[t].way[0] do
     begin
          if itis(b[t].s,b[b[t].way[i]].s,v3,v4) then
          begin
               q:=b[t].way[i];
               exit;
          end;
     end;
end;

procedure swap(var a,b:longint);
var t:longint;
begin
     t:=a;
     a:=b;
     b:=t;
end;

procedure play;
var i,t,v1,v2,v3,v4:integer;
begin
     i:=1;
     while true do
     begin
          t:=lookfalse(i);
          lookmove(i,t,v1,v2);
          move(v1,v2,v3,v4);
          if v3>v4 then swap(v3,v4);
          lookhimmove(t,i,v3,v4);
     end;
end;

begin
     init(n,k,w,a);
     solve;
     play
end.
