{$R-,Q-,S-,I-}

{.$define debug}

program template;
const
 h = 110;
 mmax = 5;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'nice.in';
 coutfile = 'nice.out';
 {$endif}
type
 int = longint;
 tmatrix = array [0..(1 shl mmax)-1,0..(1 shl mmax)-1] of int;
 tlong = array [0..h] of integer;
var
 ans :int;
 m,p :int;
 n :tlong;
 k :int;
 gr :tmatrix;

procedure init;
begin
 ans := 0;
 fillchar (n,sizeof(n),0);
 fillchar (gr,sizeof(gr),0);
end;

procedure readdata;
var i,j :int;
    t :array [1..h] of byte;
    c :char;
begin
 fillchar (t,sizeof(t),0);
 assign (input,cinfile);
 reset (input);
 repeat
  read (c);
  if not (c = ' ') then
   begin
    inc (n[0]);
    t[n[0]] := ord(c) - ord('0');
   end;
 until c = ' ';
 read (m,p);
 for i := 1 to n[0] do
  n[i] := t[n[0]-i+1];
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

function good (u,v :int):boolean;
var i :int;
    q :array [1..2,1..mmax] of byte;

begin
 good := false;

 fillchar (q,sizeof(q),0);
 for i := 1 to m do
  if u and (1 shl (i-1)) > 0  then
   q[1,i] := 1;
 for i := 1 to m do
  if v and (1 shl (i-1)) > 0 then
   q[2,i] := 1;

 for i := 1 to m-1 do
  if (q[1,i] = q[2,i]) and (q[1,i+1] = q[2,i+1]) and
     (q[1,i] = q[1,i+1]) then
      exit;

 good := true;
end;

procedure makematrix;
var i,j :int;
begin
 for i := 0 to (1 shl m)-1 do
  for j := 0 to (1 shl m)-1 do
   if good (i,j) then
    gr[i,j] := 1;
end;

procedure mult (a,b :tmatrix; var c :tmatrix);
var i,j,u :int;
begin
 fillchar (c,sizeof(c),0);
 for i := 0 to k do
  for j := 0 to k do
   begin
    for u := 0 to k do
     c[i,j] := c[i,j] + a[i,u]*b[u,j];
    c[i,j] := c[i,j] mod p;
   end;
end;

function even :boolean;
begin
 even := n[1] and 1 = 0;
end;

procedure decr;
var x :int;
begin
 x := 1;
 dec (n[x]);
 while n[x] < 0 do
  begin
   n[x] := n[x] + 10;
   dec (n[x+1]);
   inc (x);
  end;
 while (n[0] > 1) and (n[n[0]] = 0) do
  dec (n[0]);
end;

procedure div2;
var res :tlong;
    ost :int;
    i,j :int;
    t :int;
begin
 ost := 0;
 fillchar (res,sizeof(res),0);
 res[0] := n[0];
 for i := n[0] downto 1 do
  begin
   t := (n[i] + 10*ost);
   res[i] := t div 2;
   ost := t mod 2;
  end;
 while (res[0] > 1) and (res[res[0]] = 0) do
  dec (res[0]);
 move (res,n,sizeof(res));
end;

procedure solve;
var i,j :int;
    c,b :tmatrix;
begin
 k := (1 shl m)-1;
 makematrix;
 c := gr;
 fillchar (b,sizeof(b),0);
 for i := 0 to (1 shl m)-1 do
  b[i,i] := 1;
 decr;
 while not ((n[0] = 1) and (n[1] = 0)) do
  begin
   if even then
    begin
     div2;
     mult (c,c,c);
    end
   else
    begin
     decr;
     mult (b,c,b);
    end;
  end;
 ans := 0;
 for i := 0 to k do
  for j := 0 to k do
   ans := (ans + b[i,j]) mod p;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.