const infile = '2queens.in'; outfile = '2queens.out';
type pt = record x,y: longint; end;
var p1,p2,k: pt;
    ansX,ansY,ansN,ans: longint;

procedure init;
begin
     assign(input,infile);
     reset(input);
     read(p1.x,p1.y,p2.x,p2.y,k.x,k.y);
     close(input);
end;

function b(r: pt; t: pt): boolean;
begin
     b:=(r.x = t.x)or(r.y = t.y)or(r.x-r.y = t.x-t.y)or(r.x+r.y = t.x+t.y);
end;

function check(t1,t2: pt): byte;
var tmp: pt;
    y: longint;
begin
     check:=0; y:=0;
     if not (b(k,t1) or b(k,t2)) then inc(y);
     tmp.x:=k.x+1; tmp.y:=k.y;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     tmp.x:=k.x-1; tmp.y:=k.y;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     tmp.x:=k.x; tmp.y:=k.y+1;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     tmp.x:=k.x; tmp.y:=k.y-1;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     tmp.x:=k.x+1; tmp.y:=k.y+1;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     tmp.x:=k.x+1; tmp.y:=k.y-1;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     tmp.x:=k.x-1; tmp.y:=k.y+1;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     tmp.x:=k.x-1; tmp.y:=k.y+1;
     if not (b(tmp,t1) or b(tmp,t2)) then inc(y);
     check:=y;
end;

procedure solve_easy;
var c: pt;
begin
     c.x:=k.x; c.y:=k.y+1;
     if b(c,p1) and b(c,p2) then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1) then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;

     c.x:=k.x; c.y:=k.y-1;
     if b(c,p1) and b(c,p2)then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1)then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;

     c.x:=k.x+1; c.y:=k.y;
     if b(c,p1) and b(c,p2)then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1)then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;

     c.x:=k.x-1; c.y:=k.y;
     if b(c,p1) and b(c,p2)then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1)then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;

     c.x:=k.x-1; c.y:=k.y+1;
     if b(c,p1) and b(c,p2)then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1)then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;

     c.x:=k.x+1; c.y:=k.y+1;
     if b(c,p1) and b(c,p2)then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1)then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;

     c.x:=k.x-1; c.y:=k.y-1;
     if b(c,p1) and b(c,p2)then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1)then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;


     c.x:=k.x+1; c.y:=k.y-1;
     if b(c,p1) and b(c,p2)then
        if check(p2,c) = 0 then begin
           ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit; end;
     if b(c,p2) and b(c,p1)then
        if check(p1,c) = 0 then begin
           ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit; end;

end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     writeln(ans);
     write(ansN,' ',ansX,' ',ansY);
     close(output);
end;

procedure solve;
var i,j,minX,minY,min,minN: longint;
    c: pt;
begin
     ans:=-1;
     solve_easy;
     if ans > 0 then exit;
     for i:=2 to 20 do begin
         for j:=-i to i do begin
             c.x:=k.x-i; c.y:=j+k.y;
             if (check(c,p1) = 0)and b(c,p2) then begin
                ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p2) = 0)and b(c,p1) then begin
                ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p1) < min)and b(c,p2) then begin
                min:=check(c,p1); minN:=2; minX:=c.x; minY:=c.y;
             end;
             if (check(c,p2) < min)and b(c,p1) then begin
                min:=check(c,p2); minN:=1; minX:=c.x; minY:=c.y;
             end;
         end;
         for j:=-i to i do begin
             c.x:=k.x+i; c.y:=j+k.y;
             if (check(c,p1) = 0)and b(c,p2) then begin
                ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p2) = 0)and b(c,p1) then begin
                ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p1) < min)and b(c,p2) then begin
                min:=check(c,p1); minN:=2; minX:=c.x; minY:=c.y;
             end;
             if (check(c,p2) < min)and b(c,p1) then begin
                min:=check(c,p2); minN:=1; minX:=c.x; minY:=c.y;
             end;
         end;
         for j:=-i to i do begin
             c.x:=k.x-i; c.y:=j-k.y;
             if (check(c,p1) = 0)and b(c,p2) then begin
                ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p2) = 0)and b(c,p1) then begin
                ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p1) < min)and b(c,p2) then begin
                min:=check(c,p1); minN:=2; minX:=c.x; minY:=c.y;
             end;
             if (check(c,p2) < min)and b(c,p1) then begin
                min:=check(c,p2); minN:=1; minX:=c.x; minY:=c.y;
             end;
         end;
         for j:=-i to i do begin
             c.x:=k.x+i; c.y:=j-k.y;
             if (check(c,p1) = 0)and b(c,p2) then begin
                ans:=1; ansN:=2; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p2) = 0)and b(c,p1) then begin
                ans:=1; ansN:=1; ansX:=c.x; ansY:=c.y; exit;
             end;
             if (check(c,p1) < min)and b(c,p2) then begin
                min:=check(c,p1); minN:=2; minX:=c.x; minY:=c.y;
             end;
             if (check(c,p2) < min)and b(c,p1) then begin
                min:=check(c,p2); minN:=1; minX:=c.x; minY:=c.y;
             end;
         end;
     end;
     ans:=min+1; ansN:=minN; ansX:=minX; ansY:=minY;
end;

begin
     init;
     solve;
     done;
end.