  {$I-,Q-,R-,S-}
type
  tChain=record
    A,C:Longint;
  end;

var
  A,Color:array[1..250000]of Longint;
  Chain:array[1..250005]of tChain;
  N,L,Up,Down:Longint;

procedure OpenFiles;
begin
  assign(input,'color.in');
  assign(output,'color.out');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

procedure Solve;
var
  I,K1,K2,X:Longint;

begin
  read(N);
  for I:=1 to N do
    read(A[I]);
  fillchar(Color,SizeOf(Color),0);
  L:=1;
  Up:=250001;
  Down:=250002;
  Chain[Up].C:=1;
  Chain[Up].A:=A[1];
  Color[1]:=1;
  for I:=2 to N do
  begin
    K1:=Up;
    K2:=Down;
    X:=(Up+Down)div 2;
    while abs(K1-K2)>1 do
    begin
      if Chain[X].A>=A[I] then
        K2:=X
      else
        K1:=X;
      X:=(K1+K2)div 2;
    end;
    if Chain[K1].A<A[I] then
    begin
      Chain[K1].A:=A[I];
      Color[I]:=Chain[K1].C;
    end
    else
    begin
      dec(Up);
      inc(L);
      Color[I]:=L;
      Chain[Up].C:=L;
      Chain[Up].A:=A[I];
    end;
  end;
  writeln(L);
  for I:=1 to N do
    write(Color[I],' ');
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
