{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_b;
const
  inpfile='print.in';
  outfile='print.out';
  nm=5005;
type
  Sposob=record
    k : Integer;
    p : Integer;
    c : Char;
    d : Integer;
  end;
var
  a : array [1..nm] of Char;
  b : array [1..nm] of Sposob;
  n : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  i:=0;
  repeat
    inc(i);
    read(a[i]);
  until ord(a[i])<32;
  n:=i-1;
end;
{}
Procedure Print(i : Integer);
begin
  if b[i].p=0 then
  begin
    writeln('Letter(''',b[i].c,''');');
    exit;
  end;
  Print(b[i].p);
  if b[i].c=#31 then
   writeln('Repeat(',i-b[i].p,');')
  else writeln('Letter(''',b[i].c,''');');
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(b[n].k+1);
  Print(n);
  writeln('End.');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
end;
{}
Function Ravn(x1,y1,x2,y2 : LongInt) : Boolean;
var
  i : LongInt;
  ok : Boolean;
begin
  ok:=true;
  for i:=0 to y1-x1 do
  if a[x1+i]<>a[x2+i] then
  begin
    ok:=false;
    break;
  end;
  Ravn:=ok;
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  kn,point : LongInt;
begin
  for i:=1 to n do b[i].k:=MaxInt;

  b[1].p:=0; b[1].c:=a[1];
  b[1].k:=1;

  for k:=2 to n do
  begin
    {}
    point:=k-1;
    if b[k].k>b[point].k+1 then
    begin
      b[k].k:=b[point].k+1;
      b[k].p:=point;
      b[k].c:=a[k];
    end;
    {}
    for i:=1 to k div 2 do
    begin
      j:=2*i;
      kn:=0;
      while Ravn(k-i+1,k,k-j+1,k-j+i) do
      begin
	inc(kn);
	j:=j+i;
	if j>=k+1 then break;
      end;
      point:=k-i*kn;
      if b[k].k>=b[point].k+1 then
      begin
	b[k].k:=b[point].k+1;
	b[k].p:=point;
	b[k].c:=#31;
	b[k].d:=kn;
      end;
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
