#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

#define nN 1024
#define nM 100

class TNum {
  private:
    short int*a;
    int l,z;
  public:
    TNum(int);
    ~TNum();
    void read(void);
    void write(void);
    void set(short int);
    void add(short int);
    void mul(short int);
    int zero(void);
    void equ(TNum*);
    void add(TNum*);
    void sub(TNum*);
    int cmp(TNum*);
    short int cutout(void);
};

TNum*a,*b;
int z;

int main(void) {
  a=new TNum(nN);
  fi=fopen("square.in","rt");
  a->read();
  fclose(fi);
  b=new TNum(nN);
  TNum*c=new TNum(nN),*d=new TNum(nN),*e=new TNum(nN);
  short int f,g;
  b->set(0); c->set(0);
  while ((f=a->cutout())>=0) {
    c->mul(100); c->add(f);
    d->equ(b); d->mul(20);
    for (g=0; g<=9; g++) {
      e->equ(d);
      e->add(g); e->mul(g);
      if (c->cmp(e)<0) break;
    } g--;
    b->mul(10); b->add(g);
    d->add(g); d->mul(g);
    c->sub(d);
  }
  z=c->zero();
  delete c; delete d; delete e;
  fo=fopen("square.out","wt");
  if (z) b->write();
  else fprintf(fo,"-1");
  fclose(fo);
  delete b;
  delete a;
  return(0);
}


TNum::TNum(int Z) {
  z=Z;
  a=new short int[Z];
}
TNum::~TNum() {
  delete[]a;
}
void TNum::read(void) {
  memset(a,0,z*sizeof(short int));
  char*s=new char[(z+2)<<1];
  fscanf(fi,"%s",s);
  int i;
  for (i=strlen(s)-2,l=0; (i>=0)&&(l<z); i-=2,l++)
    a[l]=((short int)s[i]-'0')*10+((short int)s[i+1]-'0');
  if (i>=-1) a[l++]=((short int)s[0]-'0');
  delete[]s;
}
void TNum::write(void) {
  int i;
  if (l) {
    fprintf(fo,"%hd",a[l-1]);
    for (i=l-2; i>=0; i--) fprintf(fo,"%hd%hd",a[i]/10,a[i]%10);
  } else fprintf(fo,"0");
}
void TNum::set(short int x) {
  memset(a,0,z*sizeof(short int));
  if (x) {
    a[0]=x;
    l=1;
  } else l=0;
}
void TNum::add(short int x) {
  int i;
  for (i=0; (x)&&(i<z); i++) {
    x+=a[i];
    a[i]=x%nM;
    x/=nM;
    while (a[i]<0) { a[i]+=nM; x--; }
  }
  if (l<i) l=i;
  for (; l>0; l--) if (a[l-1]) break;
}
void TNum::mul(short int x) {
  int i;
  short int y=0;
  for (i=0; ((i<l)||(y))&&(i<z); i++) {
    y+=a[i]*x;
    a[i]=y%nM;
    y/=nM;
  }
  for (l=i; l>0; l--) if (a[l-1]) break;
}
int TNum::zero(void) {
  for (; l>0; l--) if (a[l-1]) break;
  return(!l);
}
void TNum::equ(TNum*m) {
  memmove(a,m->a,z*sizeof(short int));
  l=m->l;
}
void TNum::add(TNum*m) {
  int i;
  short int y=0;
  for (i=0; ((i<l)||(i<m->l)||(y))&&(i<z); i++) {
    y+=a[i]+m->a[i];
    a[i]=y%nM;
    y/=nM;
  }
  for (l=i; l>0; l--) if (a[l-1]) break;
}
void TNum::sub(TNum*m) {
  int i;
  short int y=0;
  for (i=0; ((i<l)||(i<m->l)||(y))&&(i<z); i++) {
    y+=a[i]-m->a[i];
    a[i]=y%nM;
    y/=nM;
    while (a[i]<0) { a[i]+=nM; y--; }
  }
  for (l=i; l>0; l--) if (a[l-1]) break;
}
int TNum::cmp(TNum*m) {
  int i;
  for (i=((l>=m->l)?l:m->l)-1; i>=0; i--) {
    if (a[i]<m->a[i]) return(-1);
    if (a[i]>m->a[i]) return(+1);
  }
  return(0);
}
short int TNum::cutout(void) {
  if (l>0) {
    l--;
    return(a[l]);
  } else return(-1);
}

