{Filimonov Vladislav}
Const
  InFileName='segment.in';
  OutFileName='segment.out';
  Eps=1;
  MaxN=25;
  Digit=12;

Var
  Fail:Text;
  X1,Y1,X2,Y2,X3,Y3,X4,Y4:Int64;
  Ans:Array[1..MaxN,1..4] Of Int64;

Procedure Get;
  Begin
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(Fail,X1,Y1,X2,Y2,X3,Y3,X4,Y4);
    Close(Fail);
  End;


Procedure Save;
Var
  I,J:Integer;
  G:Boolean;
  Begin
    For I:=1 To Digit Do Begin
      For J:=1 To 4 Do Ans[I,J]:=Abs(Ans[I,J]);
    End;

    Assign(Fail,OutFileName);
    ReWrite(Fail);
    G:=False;
    For I:=Digit DownTo 2 Do Begin
      If Ans[I,1]<>0 Then G:=True;
      If I=Digit-3 Then G:=True;
      If G=True Then Write(Fail,Ans[I,1]);
      If I=Digit-3 Then Write(Fail,'.');
    End;
    Write(Fail,' ');
    G:=False;
    For I:=Digit DownTo 2 Do Begin
      If Ans[I,1]<>0 Then G:=True;
      If I=Digit-3 Then G:=True;
      If G=True Then Write(Fail,Ans[I,2]);
      If I=Digit-3 Then Write(Fail,'.');
    End;
    Close(Fail);
    Halt;
  End;



Procedure Save1;
Var
  I,J:Integer;
  G:Boolean;
  Begin
    For I:=1 To Digit Do Begin
      For J:=1 To 4 Do Ans[I,J]:=Abs(Ans[I,J]);
    End;
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    G:=False;
    For I:=Digit DownTo 2 Do Begin
      If Ans[I,1]<>0 Then G:=True;
      If I=Digit-3 Then G:=True;
      If G=True Then Write(Fail,Ans[I,1]);
      If I=Digit-3 Then Write(Fail,'.');
    End;
    Write(Fail,' ');
    G:=False;
    For I:=Digit DownTo 2 Do Begin
      If Ans[I,1]<>0 Then G:=True;
      If I=Digit-3 Then G:=True;
      If G=True Then Write(Fail,Ans[I,2]);
      If I=Digit-3 Then Write(Fail,'.');
    End;
    Write(Fail,' ');
    G:=False;
    For I:=Digit DownTo 2 Do Begin
      If Ans[I,3]<>0 Then G:=True;
      If I=Digit-3 Then G:=True;
      If G=True Then Write(Fail,Ans[I,3]);
      If I=Digit-3 Then Write(Fail,'.');
    End;
    Write(Fail,' ');
    G:=False;
    For I:=Digit DownTo 2 Do Begin
      If Ans[I,4]<>0 Then G:=True;
      If I=Digit-3 Then G:=True;
      If G=True Then Write(Fail,Ans[I,4]);
      If I=Digit-3 Then Write(Fail,'.');
    End;
    Write(Fail,' ');

    Close(Fail);
    Halt;
  End;


Procedure Solve;
Var
  I:Integer;
  St10:Int64;
  T1,T2:Int64;
  DT1,DT2,D:Int64;
  X,Y:Int64;
  S:String;
  Code:Integer;
  P:Int64;
  Kol:Integer;

  XX1,XX2,XX3,XX4:Int64;
  Begin
    Kol:=1;
    X1:=X1;
    X2:=X2;
    X3:=X3;
    X4:=X4;
    Y1:=Y1;
    Y2:=Y2;
    Y3:=Y3;
    Y4:=Y4;

    If X1>X2 Then Begin
      P:=X1;
      X1:=X2;
      X2:=P;
      P:=Y1;
      Y1:=Y2;
      Y2:=P;
    End;
    If X3>X4 Then Begin
      P:=X3;
      X3:=X4;
      X4:=P;
      P:=Y3;
      Y3:=Y4;
      Y4:=P;
    End;



    D:=(X2-X1)*(Y3-Y4)-(Y2-Y1)*(X3-X4);
    DT1:=(X3-X1)*(Y3-Y4)-(Y3-Y1)*(X3-X4);
    DT2:=(X2-X1)*(Y1-Y3)-(Y2-Y1)*(X1-X3);


    If (Abs(D)<Eps) Then Begin
       X1:=X1*100000000;
       X2:=X2*100000000;
       X3:=X3*100000000;
       X4:=X4*100000000;
       Y1:=Y1*100000000;
       Y2:=Y2*100000000;
       Y3:=Y3*100000000;
       Y4:=Y4*100000000;
       XX1:=X1;
       XX2:=X2;
       XX3:=X3;
       XX4:=X4;


     If (Abs(DT1)>Eps) Or (Abs(DT2)>Eps) Then Begin
        Assign(Fail,OutFileName);
        ReWrite(Fail);
        WriteLn(Fail,'Empty');
        Close(Fail);
        Halt;
      End;
      If (X4<X1) Or (X3>X2) Then Begin
        Assign(Fail,OutFileName);
        ReWrite(Fail);
        WriteLn(Fail,'Empty');
        Close(Fail);
        Halt;
      End;
      FillChar(Ans,SizeOf(Ans),0);
      If X3<=X1 Then Begin
        If X4>=X2 Then Begin
          St10:=10;
          For I:=1 To Digit Do Begin
            Ans[I,1]:=X1 Mod St10;
            Ans[I,2]:=Y1 Mod St10;
            X1:=X1 Div St10;
            Y1:=Y1 Div St10;
            Ans[I,3]:=X2 Mod St10;
            Ans[I,4]:=Y2 Mod St10;
            X2:=X2 Div St10;
            Y2:=Y2 Div St10;
          End;
          If XX1<>XX2 Then Kol:=2;
        End Else Begin
          St10:=10;
          For I:=1 To Digit Do Begin
            Ans[I,1]:=X1 Mod St10;
            Ans[I,2]:=Y1 Mod St10;
            X1:=X1 Div St10;
            Y1:=Y1 Div St10;
            Ans[I,3]:=X4 Mod St10;
            Ans[I,4]:=Y4 Mod St10;
            X4:=X4 Div St10;
            Y4:=Y4 Div St10;
          End;
          If XX1<>XX4 Then Kol:=2;
        End;
      End Else Begin
        If X4>=X2 Then Begin
          St10:=10;
          For I:=1 To Digit Do Begin
            Ans[I,1]:=X3 Mod St10;
            Ans[I,2]:=Y3 Mod St10;
            X3:=X3 Div St10;
            Y3:=Y3 Div St10;
            Ans[I,3]:=X2 Mod St10;
            Ans[I,4]:=Y2 Mod St10;
            X2:=X2 Div St10;
            Y2:=Y2 Div St10;
          End;
          If XX3<>XX2 Then Kol:=2;
        End Else Begin
          St10:=10;
          For I:=1 To Digit Do Begin
            Ans[I,1]:=X3 Mod St10;
            Ans[I,2]:=Y3 Mod St10;
            X3:=X3 Div St10;
            Y3:=Y3 Div St10;
            Ans[I,3]:=X4 Mod St10;
            Ans[I,4]:=Y4 Mod St10;
            X4:=X4 Div St10;
            Y4:=Y4 Div St10;
          End;
          If XX3<>XX4 Then Kol:=2;
        End;
      End;
      If Kol=1 Then Save Else Save1;
    End;

    T1:=DT1*100000000 Div D;
    T2:=DT2*100000000 Div D;

    If T1<0 Then Begin
    End;
    X:=X1+(X2-X1)*T1;
    Y:=Y1+(Y2-Y1)*T1;
    FillChar(Ans,SizeOf(Ans),0);
    St10:=10;
    For I:=1 To Digit Do Begin
      Ans[I,1]:=X Mod St10;
      Ans[I,2]:=Y Mod St10;
      X:=X Div St10;
      Y:=Y Div St10;
    End;
  End;


Begin
  Get;
  Solve;
  Save;
End.

