{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const infile = 'circles.in'; outfile = 'circles.out'; eps = 0.000001;
type tcircle = record a,b,r: extended; end;
     pt = record x,y: extended; end;
var q1,q2: tcircle;
    p1,p2: pt;
    ans: longint;

procedure init;
begin
     assign(input,infile);
     reset(input);
     read(q1.a,q1.b,q1.r);
     read(q2.a,q2.b,q2.r);
     close(input);
end;

procedure solve;
var d,p,k: extended;
begin
     if abs(q1.a-q2.a) < eps then begin
        if abs(q1.b-q2.b) < eps then begin
           if abs(q1.r-q2.r) < eps then ans:=-1 else ans:=0;
           exit;
        end;
        p1.y:=(q1.r*q1.r-q2.r*q2.r+q2.b*q2.b-q1.b*q1.b)/(2*(q2.b-q1.b));
        p2.y:=p1.y;
        d:=q1.r*q1.r-(p1.y-q1.b)*(p1.y-q1.b);
        if (d > eps) then begin
           ans:=2;
           p1.x:=q1.a+sqrt(d);
           p2.x:=q1.a-sqrt(d);
        end
           else if (abs(d) < eps) then begin
           ans:=1; p1.x:=q1.a;
        end
           else ans:=0;
     end
        else begin
        p:=(q1.r*q1.r-q2.r*q2.r+q2.b*q2.b+q2.a*q2.a-q1.a*q1.a-q1.b*q1.b)/(2*(q2.a-q1.a));
        k:=(q1.b-q2.b)/(q2.a-q1.a);
        d:=(p*k-q1.a*k-q1.b); d:=d*(p*k-q1.a*k-q1.b);
        d:=d-(k*k+1)*(p*p+q1.a*q1.a+q1.b*q1.b-2*p*q1.a-q1.r*q1.r);
        if d < -eps then begin ans:=0; exit; end;
        if abs(d) < eps then begin
           ans:=1;
           p1.y:=-(p*k-q1.a*k-q1.b)/(k*k+1);
           p1.x:=p1.y*k+p;
           exit;
        end;
        ans:=2;
        p1.y:=(-sqrt(d)-(p*k-q1.a*k-q1.b))/(k*k+1);;
        p2.y:=(sqrt(d)-(p*k-q1.a*k-q1.b))/(k*k+1);;
        p1.x:=p+k*p1.y;
        p2.x:=p+k*p2.y;
     end;
end;

procedure done;
var nul: extended;
begin
     assign(output,outfile);
     rewrite(output);
     if abs(p1.x) < eps then p1.x:=0;  if abs(p1.y) < eps then p1.y:=0;
     if abs(p2.x) < eps then p2.x:=0;  if abs(p2.y) < eps then p2.y:=0;
     if ans = 2 then begin
        writeln(ans);
        writeln(p1.x:0:6,' ',p1.y:0:6);
        write(p2.x:0:6,' ',p2.y:0:6);
     end
        else begin
             if ans = 1 then begin writeln(ans); write(p1.x:0:6,' ',p1.y:0:6); end
                else begin write(ans); end
        end;
     close(output);
end;

begin
     init;
     solve;
     done;
end.