{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_a;
const
  inpfile='segment.in';
  outfile='segment.out';
  eps=1e-7;
type
  Coord=record
    x,y : Extended;
  end;
var
  q1,q2,w1,w2 : Coord;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  read(q1.x,q1.y,q2.x,q2.y,w1.x,w1.y,w2.x,w2.y);
end;
{}
Procedure Out(k,x1,y1,x2,y2 : Extended);
begin
  assign(output,outfile);
  rewrite(output);
  if k=1 then
  begin
    writeln(x1:0:6,' ',y1:0:6);
  end
  else
  if k=2 then
  begin
    writeln(x1:0:6,' ',y1:0:6,' ',x2:0:6,' ',y2:0:6);
  end;
  close(output);
  halt;
end;
{}

Procedure OutNo;
begin
  assign(output,outfile);
  rewrite(output);
  writeln('Empty');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
end;
{}
Function Sn(x : Extended) : Integer;
begin
  if abs(x)<eps then Sn:=0
  else if (x>eps) then Sn:=1
  else Sn:=-1;
end;
{}
Function Mezdu(a,b,c : Coord) : Boolean;
begin
  if (a.x<=b.x+eps) and (eps+a.x>=c.x) and (a.y<=b.y+eps) and (eps+a.y>=c.y)
  or (a.x+eps>=b.x) and (a.x<=c.x+eps) and (a.y<=b.y+eps) and (eps+a.y>=c.y)
  or (a.x+eps>=b.x) and (a.x<=c.x+eps) and (a.y+eps>=b.y) and (a.y<=c.y+eps)
  or (a.x<=b.x+eps) and (a.x+eps>=c.x) and (a.y+eps>=b.y) and (a.y<=c.y+eps)
  then Mezdu:=true else Mezdu:=false;
end;
{}
Procedure Solve;
var
  a1,b1,c1,a2,b2,c2 : Extended;
  r1,r2 : Extended;
  s1,s2,s3,s4 : Integer;
begin
  a1:=q1.y-q2.y;
  b1:=q2.x-q1.x;
  c1:=-(a1*q1.x+b1*q1.y);
  a2:=w1.y-w2.y;
  b2:=w2.x-w1.x;
  c2:=-(a2*w1.x+b2*w1.y);
  {}
  if (a1=0) and (b1=0) and (a2=0) and (b2=0) then
  begin
    if (abs(q1.x-w1.x)>eps) or (abs(q1.x-w1.x)>eps) then OutNo
    else Out(1,q1.x,q1.y,0,0);
  end;
  {}
  if (a1=0) and (b1=0) then
  begin
    if (abs(a2*q1.x+b2*q1.y+c2)<eps) and Mezdu(q1,w1,w2) then
    Out(1,q1.x,q1.y,0,0) else OutNo;
  end;
  if (a2=0) and (b2=0) then
  begin
    if (abs(a1*w1.x+b1*w1.y+c1)<eps) and Mezdu(w1,q1,q2) then
    Out(1,w1.x,w1.y,0,0) else OutNo;
  end;
  {}
  s1:=Sn((a1*w1.x+b1*w1.y+c1)/sqrt(sqr(a1)+sqr(b1)));
  s2:=Sn((a1*w2.x+b1*w2.y+c1)/sqrt(sqr(a1)+sqr(b1)));
  s3:=Sn((a2*q1.x+b2*q1.y+c2)/sqrt(sqr(a2)+sqr(b2)));
  s4:=Sn((a2*q2.x+b2*q2.y+c2)/sqrt(sqr(a2)+sqr(b2)));
  if (s1=1) and (s2=1) or (s1=-1) and (s2=-1) or
  (s3=1) and (s4=1) or (s3=-1) and (s4=-1) then OutNo;
  {}
  if (abs(s1)<eps) and (abs(s2)<eps) or (abs(s3)<eps) and (abs(s4)<eps) then
  begin
    if Mezdu(q1,w1,w2) and Mezdu(q2,w1,w2) then Out(2,q1.x,q1.y,q2.x,q2.y)
    else if Mezdu(w1,q1,q2) and Mezdu(w2,q1,q2) then Out(2,w1.x,w1.y,w2.x,w2.y)
    else if Mezdu(w1,q1,q2) and Mezdu(q2,w1,w2) then Out(2,w1.x,w1.y,q2.x,q2.y)
    else if Mezdu(w1,q1,q2) and Mezdu(q1,w1,w2) then Out(2,w1.x,w1.y,q1.x,q1.y)
    else if Mezdu(w2,q1,q2) and Mezdu(q2,w1,w2) then Out(2,w2.x,w2.y,q2.x,q2.y)
    else if Mezdu(w2,q1,q2) and Mezdu(q1,w1,w2) then Out(2,w2.x,w2.y,q1.x,q1.y)
    else OutNo;
  end
  else
  begin
    r2:=(c2*a1-c1*a2)/(a2*b1-a1*b2);
    r1:=(c2*b1-c1*b2)/(a1*b2-b1*a2);
    Out(1,r1,r2,0,0);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
End.
