{$N+}
const eps = 1e-7;
var a1, b1, c1, a2, b2, c2: extended;

var good: boolean;
procedure buildk(x0, y0, r, x, y: extended);
var xx, yy, xk, yk, a, b, x1, y1, t, d: extended;
begin
  if sqr(x - x0) + sqr(y - y0) + eps < r * r then
    begin
      good:=false;
      exit;
    end;

  d:=sqrt(sqr(x - x0) + sqr(y - y0));
  t:=sqrt(d * d - r * r);

  xx:=r * r / d;
  yy:=r * t / d;

  a:=x - x0;
  b:=y - y0;
  d:=sqrt(sqr(a) + sqr(b));
  a:=a / d;
  b:=b / d;

  x1:=x0 + xx * a;
  y1:=y0 + yy * b;

  xk:=x1 - b * yy;
  yk:=y1 + a * yy;

  a1:=y - yk;
  b1:=xk - x;
  c1:=-a1 * x - b1 * y;

  d:=sqrt(sqr(a1) + sqr(b1));
  a1:=a1 / d;
  b1:=b1 / d;
  c1:=c1 / d;

  xk:=x1 + b * yy;
  yk:=y1 - a * yy;

  a2:=y - yk;
  b2:=xk - x;
  c2:=-a2 * x - b2 * y;

  d:=sqrt(sqr(a2) + sqr(b2));
  a2:=a2 / d;
  b2:=b2 / d;
  c2:=c2 / d;

end;

var d, tmp, x1, y1, r1, x2, y2, r2: extended;
begin
  assign(input, 'tangent.in');
  assign(output, 'tangent.out');
  reset(input);
  rewrite(output);
  read(x1, y1, r1);
  read(x2, y2, r2);

  if (abs(x1 - x2) < eps) and (abs(y1 - y2) < eps) and (abs(r1 - r2) < eps) then
    begin
      writeln(-1);
      close(input);
      close(output);
      exit;
    end;

  d:=sqrt(sqr(x1 - x2) + sqr(y1 - y2));
  if (d + r2  + eps < r1) or (d + r1 + eps < r2) then
    begin
      writeln(0);
      close(input);
      close(output);
      exit;
    end;

  good:=true;
  if r1 + eps < r2 then
    begin
      tmp:=x1;
      x1:=x2;
      x2:=tmp;

      tmp:=y1;
      y1:=y2;
      y2:=tmp;

      tmp:=r1;
      r1:=r2;
      r2:=tmp;
    end;

  d:=sqrt(sqr(x1 - x2) + sqr(y1 - y2));
  if (d + eps < r1 + r2) then
    begin
      writeln(2);
      buildk(x1, y1, r1 - r2, x2, y2);
      c1:=c1 - r2;
      c2:=c2 + r2;
      writeln(a1: 0: 6, ' ', b1: 0: 6, ' ', c1: 0: 6);
      writeln(a2: 0: 6, ' ', b2: 0: 6, ' ', c2: 0: 6);
      close(input);
      close(output);
      exit;
    end;
  if (abs(d - r1 - r2) < eps) then
    begin
      writeln(3);
      buildk(x1, y1, r1 - r2, x2, y2);
      c1:=c1 - r2;
      c2:=c2 + r2;
      writeln(a1: 0: 6, ' ', b1: 0: 6, ' ', c1: 0: 6);
      writeln(a2: 0: 6, ' ', b2: 0: 6, ' ', c2: 0: 6);

      a1:=x2 - x1;
      b1:=y2 - y1;
      c1:=sqrt(sqr(a1) + sqr(b1));
      a1:=a1 / c1;
      b1:=b1 / c1;

      x1:=x1 + a1 * r1;
      y1:=y1 + b1 * r1;

      c1:=-a1 * x1 - b1 * y1;
      writeln(a1: 0: 6, ' ', b1: 0: 6, ' ', c1: 0: 6);
      close(input);
      close(output);
      exit;
    end;

  writeln(4);
  buildk(x1, y1, r1 - r2, x2, y2);
  c1:=c1 - r2;
  c2:=c2 + r2;
  writeln(a1: 0: 6, ' ', b1: 0: 6, ' ', c1: 0: 6);
  writeln(a2: 0: 6, ' ', b2: 0: 6, ' ', c2: 0: 6);

  buildk(x1, y1, r1 + r2, x2, y2);
  c1:=c1 - r2;
  c2:=c2 + r2;
  writeln(a1: 0: 6, ' ', b1: 0: 6, ' ', c1: 0: 6);
  writeln(a2: 0: 6, ' ', b2: 0: 6, ' ', c2: 0: 6);
  close(input);
  close(output);
end.