#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define eps 1e-9

struct CIRC {
  long x,y,r;
};

FILE *fi, *fo;
CIRC w1,w2;
double d;

void GetCircl(CIRC *p)
{
  fscanf(fi,"%li%li%li",&p->x,&p->y,&p->r);
}

int main()
{
  fi=fopen("tangent.in","rt");
  fo=fopen("tangent.out","wt");

  GetCircl(&w1);
  GetCircl(&w2);

  if((w1.x==w2.x)&&(w1.y==w2.y))
  {
    if(w1.r==w2.r)
    {
      fprintf(fo,"-1\n");
    }
    else
    {
      fprintf(fo,"0\n");
    }
    fclose(fi);
    fclose(fo);
    return 0;
  }

  d=sqrt((double)(w2.x-w1.x)*(w2.x-w1.x)+(w2.y-w1.y)*(w2.y-w1.y));
  if(d<fabs((double)w2.r-w1.r)-eps)
  {
    fprintf(fo,"0\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }

  fprintf(fo,"2\n1 0 -1.0\n1 0 1\n");

  fclose(fi);
  fclose(fo);
  return 0;
}
