{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_b;
const
  inpfile='chess.in';
  outfile='chess.out';
  nm=12;
  hm=15;
  qm=150;
type
  Coord=record
    x,y : Integer;
  end;
var
  a : array [1..hm,1..nm,1..nm] of Boolean;
  b : array [1..hm,1..nm] of Integer;
  d : array [1..hm] of Integer;
  n,q,c : LongInt;
  res : LongInt;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  read(n,q,c);
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
end;
{}
Procedure Zvezd(h,x0,y0 : LongInt);
var
  k  : LongInt;
begin
  a[h,x0,y0]:=true;
  k:=1; while x0+k<=n do begin a[h,x0+k,y0]:=true; inc(k); end;
  k:=1; while x0-k>0 do begin a[h,x0-k,y0]:=true; inc(k); end;
  k:=1; while y0+k<=n do begin a[h,x0,y0+k]:=true; inc(k); end;
  k:=1; while y0-k>0 do begin a[h,x0,y0-k]:=true; inc(k); end;
  k:=1; while (x0+k<=n) and (y0+k<=n) do begin a[h,x0+k,y0+k]:=true; inc(k); end;
  k:=1; while (x0-k>0) and (y0+k<=n) do begin a[h,x0-k,y0+k]:=true; inc(k); end;
  k:=1; while (x0+k<=n) and (y0-k>0) do begin a[h,x0+k,y0-k]:=true; inc(k); end;
  k:=1; while (x0-k>0) and (y0-k>0) do begin a[h,x0-k,y0-k]:=true; inc(k); end;
end;
{}
Procedure ZvezdC(h,x0,y0 : LongInt);
var
  k  : LongInt;
begin
  a[h,x0,y0]:=true;
  k:=1; while x0+k<=n do begin a[h,x0+k,y0]:=true; inc(k); end;
  k:=1; while x0-k>0 do begin a[h,x0-k,y0]:=true; inc(k); end;
  k:=1; while y0+k<=n do begin a[h,x0,y0+k]:=true; inc(k); end;
  k:=1; while y0-k>0 do begin a[h,x0,y0-k]:=true; inc(k); end;
end;
{}

{}
Procedure TryC(h,x0 : Integer);
var
  i,j,k : Integer;
begin
  {}
  if h=c+1 then
  begin
    inc(res);
    exit;
  end;
  {}
  for i:=x0 to n-c+h do
  begin
    for j:=1 to n do
    if not a[q+h,i,j] then
    begin
      a[q+h+1]:=a[q+h];
      ZvezdC(q+h+1,i,j);
      TryC(h+1,i+1);
    end;
  end;
end;

{}
Procedure TryQ(h,x0 : Integer);
var
  i,j,k : Integer;
begin
  {}
  if h=q+1 then
  begin
    TryC(1,1);
    exit;
  end;
  {}
  for i:=x0 to n-q+h do
  begin
    for j:=1 to n do
    if not a[h,i,j] then
    begin
      a[h+1]:=a[h];
      Zvezd(h+1,i,j);
      TryQ(h+1,i+1);
    end;
  end;
end;

{}
Procedure Solve;
var
  i,j : LongInt;
  n2 : LongInt;
begin
  res:=0; n2:=n*n;
  if q+c<=n then TryQ(1,1);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
