const MAXV=5001;
type
  vertex=record
    x,y:integer;
    st:integer;
    o:array[1..MAXV]of boolean;
  end;

var _f:text;
    N,i,j,k,l,vn:integer;
    xt1,yt1,xt2,yt2,vo:integer;
    v:array[1..MAXV]of vertex;
    colors:array[1..MAXV]of byte;

procedure add(x1,y1,x2,y2:integer);
var found:boolean;
begin
  found:=false;
  for i:=1 to vn do
    if (v[i].x=x1)and(v[i].y=y1)then begin found:=true; k:=i; break; end;
  if not found then
  begin
    inc(vn); k:=vn;
    v[k].x:=x1; v[k].y:=y1;
  end;
  found:=false;
  for i:=1 to vn do
  begin
    if (v[i].x=x2)and(v[i].y=y2)then begin found:=true; l:=i; break; end;
  end;
  if not found then
  begin
    inc(vn); l:=vn;
    v[l].x:=x2; v[l].y:=y2;
  end;
  inc(v[k].st); inc(v[l].st);
  v[k].o[l]:=true; v[l].o[k]:=true;
end;

procedure solve(c:integer);
var found:boolean;
    stmax,imax:integer;
begin
  stmax:=0; imax:=0;
  for i:=1 to vn do if (colors[i]=0)and(v[i].st>=stmax) then
  begin
    stmax:=v[i].st;
    imax:=i;
  end;
  colors[imax]:=c; inc(vo);
  for i:=1 to vn do
  begin
    if colors[i]<>0 then continue;
    found:=true;
    for j:=1 to vn do if (v[i].o[j])and(colors[j]=c) then found:=false;
    if found then
    begin
      colors[i]:=c;
      inc(vo);
      continue;
    end;
  end;
end;

begin
  assign(_f,'input.txt');
  reset(_f);
  read(_f,N);
  for i:=1 to MAXV do colors[i]:=0;
  for j:=1 to N do
  begin
    read(_f,xt1,yt1,xt2,yt2);
    add(xt1,yt1,xt2,yt2);
  end;
  close(_f);
  for xt1:=1 to 5 do
  begin
    if vo=vn then break;
    solve(xt1);
  end;
  assign(_f,'output.txt');
  rewrite(_f);
  for j:=1 to vn do
  begin
    writeln(_f,v[j].x,' ',v[j].y,' ',colors[j]);
  end;
  close(_f);
end.
