{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
Program pr_b;
const
  inpfile='input.txt';
  outfile='output.txt';
  nm=5005;
  sec=24*60*60;
type
  Rebr=record
    x,y : Integer;
  end;
  Coord=record
    x,y : Integer;
  end;
var
  a : array [1..nm] of Rebr;
  b : array [1..2*nm] of ShortInt;
  p : array [1..2*nm] of Coord;
  c : array [1..2*nm+1] of Integer;
  n,m : LongInt;
{}
Procedure Inp;
var
  i,j : LongInt;
  ok1,ok2 : Boolean;
  q,w : Coord;
  n1,n2 : Integer;
begin
  assign(input,inpfile);
  reset(input);
  read(n); m:=0;
  for i:=1 to n do
  begin
    read(q.x,q.y,w.x,w.y);
    ok1:=false; ok2:=false;
    for j:=1 to m do
    begin
      if (p[j].x=q.x) and (p[j].y=q.y) then begin ok1:=true; n1:=j; end;
      if (p[j].x=w.x) and (p[j].y=w.y) then begin ok2:=true; n2:=j; end;
    end;
    if not ok1 then begin inc(m); n1:=m; p[n1]:=q; end;
    if not ok2 then begin inc(m); n2:=m; p[n2]:=w; end;
    a[i].x:=n1; a[i].y:=n2;
    a[n+i].y:=n1; a[n+i].x:=n2;
  end;
  n:=n*2;
end;
{}
Procedure OutYes;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  for i:=1 to m do writeln(p[i].x,' ',p[i].y,' ',b[i]);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
end;
{}
Procedure Swap(var q,w : Rebr);
var
  bak : Rebr;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := a[(l+r) DIV 2].x;
  repeat
    while a[i].x < x do i := i + 1;
    while x < a[j].x do j := j - 1;
    if i <= j then
    begin
      Swap(a[i],a[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

{}
Procedure Plus(var q : ShortInt);
begin
  if q=5 then q:=1 else inc(q);
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  u : array [1..5] of Boolean;
  ok : Boolean;
begin
  for i:=1 to m do b[i]:=1;
  Sort(1,n); c[1]:=0;
  for i:=1 to n do c[a[i].x+1]:=i;

  repeat
    ok:=true;
    for i:=2 to m do
    begin
      fillchar(u,sizeof(u),0);
      for j:=c[i]+1 to c[i+1] do
        u[b[a[j].y]]:=true;
      if u[b[i]] then
      begin
        ok:=false;
        for j:=1 to 4 do
        begin
          Plus(b[i]);
          if not u[b[i]] then break;
        end;
      end;
    end;

  until ok;
  OutYes;
end;
{}
Begin
  Init;
  Inp;
  Solve;
End.
