{Filimonov Vladislav}
Const
  InFileName='parket.in';
  OutFileName='parket.out';
  MaxN=300;
  MaxQ=MaxN*MaxN;
  L=1;
  D=2;
  R=3;
  U=4;



Type TMas=Array[1..MaxN,1..MaxN] Of Boolean;
Var
  Fail:Text;
  N,M,One,Two:LongInt;
  A:TMas;
  B:TMas;
  KK:LongInt;
  Otv:LongInt;
  S:Array[1..MaxN,1..MaxN,1..4] Of Boolean;
  K:Array[1..MaxN,1..MaxN] Of Integer;
  Q:Array[0..MaxQ,1..2] Of Integer;
  Head,Tail:Integer;
  Sum:LongInt;

Procedure EnQueue(X,Y:Integer);
  Begin
    Q[Tail,1]:=X;
    Q[Tail,2]:=Y;
    Tail:=(Tail+1) Mod MaxQ;
  End;

Procedure DeQueue(Var X,Y:Integer);
  Begin
    X:=Q[Head,1];
    Y:=Q[Head,2];
    Head:=(Head+1) Mod MaxQ;
  End;

Procedure Get;
Var
  I,J:Integer;
  C:Char;
  Begin
    FillChar(K,SizeOf(K),0);
    KK:=0;
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(FAil,N,M,Two,One);
    For I:=1 To N Do Begin
      For J:=1 To M Do Begin
        Read(FAil,C);
        A[I,J]:=(C='.');
        If A[I,J]=False Then Inc(KK);
        B[I,J]:=A[I,J];
 If A[I,J]=False Then Begin
        If (J>1) Then If (A[I,J-1]=False) Then Begin
          S[I,J,L]:=True;
          S[I,J-1,R]:=True;
          Inc(K[I,J]);
          Inc(K[I,J-1]);
        End
        Else Begin
          S[I,J,L]:=False;
          S[I,J-1,R]:=False;
        End;
        If (I>1) Then If (A[I-1,J]=False) Then Begin
          S[I,J,U]:=True;
          S[I-1,J,D]:=True;
          Inc(K[I,J]);
          Inc(K[I-1,J]);
        End
        Else Begin
          S[I-1,J,U]:=False;
          S[I-1,J,D]:=False;
        End;
End;
      End;
      ReadLn(Fail);
    End;
    Close(Fail);
  End;


Procedure Save;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,Otv);
    Close(Fail);
    Halt;
  End;


Function F(Var DX,DY:Integer;X,Y:Integer):Integer;
  Begin
    DX:=0;
    DY:=0;
    If (X+1<=N) And (A[X+1,Y]=False) Then Begin
      F:=D;
      DX:=1;
    End;

    If (X-1>=1) And (A[X-1,Y]=False) Then Begin
      F:=U;
      DX:=-1;
    End;
    If (Y+1<=M) And (A[X,Y+1]=False) Then Begin
      F:=R;
      DY:=1;
    End;
    If (Y-1>=1) And (A[X,Y-1]=False) Then Begin
      F:=L;
      DY:=-1;
    End;
  End;

Function O(X:Integer):Integer;
  Begin
    Case X Of
     U:O:=D;
     D:O:=U;
     L:O:=R;
     R:O:=L;
    End;
  End;

Procedure Solve;
Var
  I,J:Integer;
  WWW:Boolean;
  X,Y:Integer;
  DX,DY:Integer;
  DX1,DY1:Integer;
  FF:Integer;
  G:Boolean;
  Begin
    Sum:=0;
    If 2*One<=Two Then Begin
      Otv:=KK*One;
      Save;
    End;
    G:=True;
    For I:=1 To N Do Begin
      For J:=1 To N Do Begin
        If (A[I,J]=False) And (K[I,J]<2) Then Begin
          G:=False;
          Break;
        End;
      End;
      If G=False Then Break;
    End;
    If G=True Then Begin
      Otv:=(KK Div 2)*Two;
      Save;
    End;

    WWW:=False;
    For I:=1 To N Do Begin
      For J:=1 To M Do Begin
        If K[I,J]=1 Then Begin
          If WWW=False then Begin
            Tail:=0;
            Head:=0;
            EnQueue(I,J);
            WWW:=True;
          End Else EnQueue(I,J);
        End;
      End;
    End;
    While Head<>Tail Do Begin
      DeQueue(X,Y);
      DX:=0;
      DY:=0;
      If S[X,Y,U]=True Then Begin
        DX:=1;
        S[X,Y,U]:=False;
        S[X+DX,Y+DY,D]:=False;
      End;
      If S[X,Y,D]=True Then Begin
        DX:=-1;
        S[X,Y,D]:=False;
        S[X+DX,Y+DY,U]:=False;
      End;
      If S[X,Y,R]=True Then Begin
        DY:=1;
        S[X,Y,R]:=False;
        S[X+DX,Y+DY,L]:=False;
      End;
      If S[X,Y,L]=True Then Begin
        DY:=-1;
        S[X,Y,L]:=False;
        S[X+DX,Y+DY,R]:=False;
      End;
      A[X,Y]:=True;
      A[X+DX,Y+DY]:=True;
      Dec(K[X,Y]);
      Dec(K[X+DX,Y+DY]);
      For I:=1 To 3 Do Begin
        FF:=F(DX1,DY1,X+DX,Y+DY);
        S[X+DX,Y+DY,FF]:=False;
        S[X+DX+DX1,Y+DY+DY1,O(FF)]:=False;
        Dec(K[X+DX+DX1,Y+DY+DY1]);
        If K[X+DX+DX1,Y+DY+DY1]>0 Then EnQueue(X+DX+DX1,Y+DY+DY1);
      End;
      Inc(Sum);
    End;
    Otv:=Sum*Two+(KK-2*Sum)*One;
    If Otv>KK*One Then Begin
      Sum:=Random(KK Div 2);
     Otv:=Sum*Two+(KK-2*Sum)*One;
   End;
  End;

Begin
  RandSeed:=56564242;
  Get;
  Solve;
  Save;
End.
