{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p22_14_f;

const
  max = 300;

type
  xy = record
    x, y : word;
  end;

var
  f : array[0..max + 1, 0..max + 1] of char;
  killed, step, indots, total, n, m, a, b, i, j, k, l : longint;
  dots : array[1..max*max] of xy;
  link : array[1..max*max, 1..4] of word;
  from : array[1..max*max] of word;
  free, ch, used : array[1..max*max] of boolean;

function adddot(x, y : longint) : longint;
begin
  inc(indots);
  dots[indots].x := x;
  dots[indots].y := y;
  adddot := indots;
end;

function find(x, y : longint) : longint;
var
  ps : longint;
begin
  for ps := 1 to indots do
    if (dots[ps].x = x) and (dots[ps].y = y) then begin
      find := ps;
      exit;
    end;
  find := adddot(x, y);
end;

procedure connect(x, y : longint);
var
  ps : longint;
begin
  for ps := 1 to 4 do
    if link[x, ps] = 0 then begin
      link[x, ps] := y;
      exit;
    end;
end;

procedure disconnect(x, y : longint);
var
  ps : longint;
begin
  for ps := 1 to 4 do
    if link[x, ps] = y then link[x, ps] := 0;
end;

function fnd(x, y : longint) : boolean;
var
  ps : longint;
begin
  for ps := 1 to indots do
    if (dots[ps].x = x) and (dots[ps].y = y) then begin
      fnd := true;
      exit;
    end;
  fnd := false;
end;

procedure rec(x, y : longint);
var
  pk, ps : longint;
begin
  f[x, y] := '!';
  if not fnd(x, y) then if step mod 2 = 0 then
    ch[adddot(x, y)] := true;
  inc(step);
  pk := indots;
  ps := find(x, y);
  if f[x + 1, y] = '!' then
    if step mod 2 = 0 then connect(ps, find(x + 1, y))
    else connect(find(x + 1, y), ps);
  if f[x - 1, y] = '!' then
    if step mod 2 = 0 then connect(ps, find(x - 1, y))
    else connect(find(x - 1, y), ps);
  if f[x, y + 1] = '!' then
    if step mod 2 = 0 then connect(ps, find(x, y + 1))
    else connect(find(x, y + 1), ps);
  if f[x, y - 1] = '!' then
    if step mod 2 = 0 then connect(ps, find(x, y - 1))
    else connect(find(x, y - 1), ps);
  if f[x + 1, y] = '*' then begin
    rec(x + 1, y);
  end;
  if f[x - 1, y] = '*' then begin
     rec(x - 1, y);
  end;
  if f[x, y + 1] = '*' then begin
    rec(x, y + 1);
  end;
  if f[x, y - 1] = '*' then begin
    rec(x, y - 1);
  end;
  dec(step);
{ f[x, y] := '.';}
end;


procedure buildup;
var
  innw, innxt, ps, pk, pj, num : longint;
  nw, nxt : array[1..max] of boolean;
  uf, ef : boolean;
begin
  for ps := 1 to indots do if not ch[ps] then begin
    fillchar(used, sizeof(used), false);
    fillchar(from, sizeof(from), 0);
    innw := 1;
    fillchar(nw, sizeof(nw), false);
    fillchar(nxt, sizeof(nxt), false);
    nw[ps] := true;
    ef := false;
    used[ps] := true;
    repeat
      uf := false;
      for pk := 1 to indots do if nw[pk] then begin
        if ef then break;
        for pj := 1 to 4 do if (link[pk, pj] <> 0) and (not used[link[pk, pj]]) then begin
          uf := true;
          used[link[pk, pj]] := true;
          nxt[link[pk, pj]] := true;
          from[link[pk, pj]] := pk;
          if (free[link[pk, pj]]) and (ch[link[pk, pj]]) then begin
            free[link[pk, pj]] := false;
            num := link[pk, pj];
            ef := true;
            break;
          end;
        end;
        nw := nxt;
      end;
      if not uf then begin
        num := 0;
        break;
      end;
      if ef then break;
    until false;
    if num = 0 then continue;
    free[num] := false;
    ps := num;
    repeat
      connect(ps, from[ps]);
      disconnect(from[ps], ps);
      ps := from[ps];
    until from[ps] = 0;
  end;
  pk := 0;
  for ps := 1 to indots do
    if not free[ps] then inc(pk);
  total := total + a * pk + (indots - 2 * pk) * b;
end;

{procedure kill(x, y : longint);
begin
  inc(killed);
  f[x, y] := '.';
  if f[x + 1, y] = '*' then kill(x + 1, y);
  if f[x - 1, y] = '*' then kill(x - 1, y);
  if f[x, y + 1] = '*' then kill(x, y + 1);
  if f[x, y - 1] = '*' then kill(x, y - 1);
end;}

begin
  assign(input, 'parket.in');
  reset(input);
  assign(output, 'parket.out');
  rewrite(output);
  readln(n, m, a, b);
  fillchar(f, sizeof(f), 0);
  for j := 1 to n do begin
    for i := 1 to m do read(f[i, j]);
    readln;
  end;
  total := 0;
  if b * 2 <= a then begin
    for i := 1 to m do
      for j := 1 to n do if f[i, j] = '*' then total := total + b;
    writeln(total);
    close(output);
    halt;
  end;
  for i := 1 to m do begin
    for j := 1 to n do begin
      if f[i, j] = '*' then begin
        fillchar(free, sizeof(free), true);
        fillchar(ch, sizeof(ch), false);
        step := 0;
        indots := 0;
        fillchar(link, sizeof(link), 0);
{        adddot(i, j);}
        rec(i, j);
        buildup;
{        killed := 0;
        kill(i, j);
        if killed mod 2 = 0 then total := total + (killed div 2) * a
        else total := total + (killed div 2) * a + b;                }
      end;
    end;
  end;
  writeln(total);
  close(output);
end.
