{Filimonov Vladislav}
Const
  InFileName='beauty.in';
  OutFileName='beauty.out';
  MaxN=100002;


Var
  Fail:Text;
  N:LongInt;
  S:Array[0..MaxN] Of LongInt;
  B:Array[0..MaxN] Of LongInt;
  A:Array[0..MaxN] Of LongInt;
  W:Array[0..MaxN] Of LongInt;
  Z:Array[0..MaxN] Of LongInt;
  Max:LongInt;

Procedure Get;
Var
  I:Integer;
  Begin
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(Fail,N);
    For I:=1 to N Do Begin
      ReadLn(Fail,S[I],B[I]);
      W[I]:=I;
    End;
    Close(Fail);
  End;


Procedure QSort(Left,Right:LongInt);
Var
  L,R:LongInt;
  Mid:LongInt;
  BMid:LongInt;
  P:LongInt;
  Begin
    L:=Left;
    R:=Right;
    Mid:=S[(L+R) Div 2];
    BMid:=B[(L+R) Div 2];
    Repeat
      While S[L]<Mid Do Inc(L);
      While (S[L]=Mid) And (B[L]<BMid) Do Inc(L);
      While S[R]>Mid Do Dec(R);
      While (S[R]=Mid) And (B[R]>BMid) Do Dec(R);
      If L<=R Then Begin
        P:=S[L];
        S[L]:=S[R];
        S[R]:=P;
        P:=B[L];
        B[L]:=B[R];
        B[R]:=P;
        P:=W[L];
        W[L]:=W[R];
        W[R]:=P;
        Inc(L);
        Dec(R);
      End;
    Until L>R;
    If L<Right Then QSort(L,Right);
    If R>Left Then QSort(Left,R);
  End;

Procedure Solve;
Var
  I:LongInt;
  L,R:LongInt;
  M:LongInt;
  Will:LongInt;
  Begin
    Max:=1;
    FillChar(A,SizeOf(A),0);
    FillChar(Z,SizeOf(Z),0);
    QSort(1,N);
    A[1]:=1;
    Z[1]:=1;
    For I:=2 To N Do Begin
      If B[A[1]]>=B[I] Then Continue;
{
      If B[A[Max]]<B[I] Then Begin
        A[Max]:=I;
        Continue;
      End;
}
      L:=1;
      R:=Max;

      While Abs(R-L)>1 Do Begin
        M:=(L+R) Div 2;
        If B[A[M]]>B[I] Then R:=M;
        If B[A[M]]<B[I] Then L:=M;
        If B[A[M]]=B[I] Then Begin
          If B[R]>B[I] Then R:=M Else L:=M;
        End;
      End;
      If B[A[R]]<B[I] Then Begin
        If S[A[R]]<S[I] Then Begin
          If A[R+1]=0 Then Begin
            A[R+1]:=I;
            If Z[I]<R+1 Then Z[I]:=R+1;
            Inc(Max);
          End Else If S[A[R+1]]<S[I] Then Begin
            A[R+1]:=I;
            If Z[I]<R+1 Then Z[I]:=R+1;
          End;
        End;
      End Else Begin
        If B[A[L]]<B[I] Then Begin
          If S[A[L]]<S[I] Then Begin
            If A[L+1]=0 Then Begin
              Inc(Max);
              A[L+1]:=I;
              If Z[I]<L+1 Then Z[I]:=L+1;
            End Else If S[A[L+1]]<S[I] Then Begin
              A[L+1]:=I;
              If Z[I]<L+1 Then Z[I]:=L+1;
            End;
          End;
        End;
      End;
      If (B[I]<B[A[R]]) And ((R=1) Or (S[I]<S[A[R-1]])) Then Begin
        A[R]:=I;
        If Z[I]<R Then Z[I]:=R;
      End;
      If (B[I]<B[A[L]]) And ((L=1) Or (S[I]<S[A[L-1]])) Then Begin
        A[L]:=I;
        If Z[I]<L Then Z[I]:=L;
      End;
      If Z[I]<1 Then Z[I]:=1;
    End;
  End;

Procedure Save;
Var
  I:LongInt;
  Cur:LongInt;
  Was,SWas:LongInt;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,Max);
    Cur:=A[Max];

    I:=Max;
    While I<>0 Do Begin
      Write(Fail,W[Cur],' ');
      Dec(I);
      Was:=B[Cur];
      Swas:=S[Cur];
      Dec(Cur);
      If I<>0 Then Begin
        While (Z[Cur]<I) Or (B[Cur]>=Was) Or (S[Cur]>=SWas) Do Dec(Cur);
      End;
    End;

    Close(Fail);
  End;

Begin
  Get;
  Solve;
  Save;
End.

