{Filimonov Vladislav}
Const
  InFileName='rooks.in';
  OutFileName='rooks.out';
  Eps=1E-10;


Var
  Fail:Text;
  N,M:LongInt;
  K:LongInt;

Procedure Get;
Var
  P:LongInt;
  Begin
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(FAil,N,M);
    Close(Fail);
    If N>M Then Begin
      P:=N;
      N:=M;
      M:=P;
    End;
  End;


Procedure Solve;
Var
  I:LongInt;
  F:Extended;
  L,R:LongInt;
  Mid:LongInt;
  Begin
    If N=1 Then Begin
      K:=1;
      Exit;
    End;
    L:=1;
    R:=N-1;
    While Abs(R-L)>1 Do Begin
      Mid:=(L+R) Div 2;
      F:=((Mid+1)/(N-Mid))/(M-Mid);
      If F+Eps<1 Then L:=Mid Else R:=Mid;
    End;
    F:=((R+1)/(N-R))/(M-R);
    If F<1 Then K:=R+1 Else K:=L+1;
  End;

Procedure Save;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,K);
    Close(Fail);
  End;

Begin
  Get;
  Solve;
  Save;
End.
