{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p22_14_a;

const
  maxc = 100;
  maxr = 1000;

type
  res = array[1..maxr] of boolean;

var
  link : array[1..maxc, 1..maxc, 1..maxr] of word;
  tl : array[1..maxc, 1..maxc] of word;
  top : array[1..maxc] of word;
  i, j, k, m, n, intop : longint;
  used : array[1..maxc] of boolean;
  flag : boolean;
  teq, l : longint;
  eq : array[1..maxr * 3, 1..2] of res;
  peq : array[1..maxr * 3, 1..maxr, 1..2] of word;
  inteq : array[1..maxr, 1..2] of word;

procedure rec(x : longint);
var
  ps : longint;
begin
  for ps := 1 to n do
    if (tl[x, ps] = 1) and (not used[ps]) then rec(ps);
  inc(intop);
  top[intop] := x;
  used[x] := true;
end;

function iseq(x : longint) : boolean;
var
  pj, pk, ps : longint;
  a1, a2, a3, a4 : res;
  pf : boolean;
begin
  a1 := eq[x, 1];
  a4 := eq[x, 2];
  for pj := 1 to teq - 1 do
  for ps := 1 to teq - 1 do begin
    for pk := 1 to m do begin
      if a1[pk] and a4[pk] then begin
        a1[pk] := false;
        a4[pk] := false;
      end;
    end;
    a2 := eq[ps, 1];
    pf := true;
    for pk := 1 to m do
      if a2[pk] and (not a1[pk]) then begin
        pf := false;
        break;
      end;
    if pf then begin
      a3 := eq[ps, 2];
      for pk := 1 to m do if a3[pk] then a1[pk] := true;
      for pk := 1 to m do if a2[pk] then a1[pk] := false;
    end;
    if not pf then begin
      a2 := eq[ps, 2];
      pf := true;
      for pk := 1 to m do
        if a2[pk] and (not a1[pk]) then begin
          pf := false;
          break;
        end;
      if pf then begin
        a3 := eq[ps, 1];
        for pk := 1 to m do if a3[pk] then a1[pk] := true;
        for pk := 1 to m do if a2[pk] then a1[pk] := false;
      end;
    end;
    pf := true;
    for pk := 1 to m do
      if a1[pk] or a4[pk] then begin
        pf := false;
        break;
      end;
    if pf then begin
      iseq := true;
      exit;
    end;
  end;
  iseq := false;
end;

begin
  assign(input, 'comm.in');
  reset(input);
  assign(output, 'comm.out');
  rewrite(output);
  read(n, m);
  fillchar(link, sizeof(link), 0);
  fillchar(tl, sizeof(tl), 0);
  for i := 1 to m do begin
    read(k, j);
    link[k, j, 1] := i;
    tl[k, j] := 1;
  end;
  fillchar(used, sizeof(used), false);
  intop := 0;
  teq := 0;
  for i := 1 to n do
    if not used[i] then rec(i);
  fillchar(eq, sizeof(eq), false);
  for i := 2 to n do begin
    for j := i - 1 downto 1 do begin
      flag := false;
      if tl[top[i], top[j]] <> 0 then flag := true;
      for k := i - 1 downto j + 1 do begin
        if (tl[top[i], top[k]] <> 0) and (tl[top[k], top[j]] <> 0) then begin
          if flag then begin
            inc(teq);
            inteq[teq, 1] := tl[top[i], top[j]];
            inteq[teq, 2] := tl[top[i], top[k]] + tl[top[k], top[j]];
            for l := 1 to m do begin
              eq[teq, 1, l] := false;
              eq[teq, 2, l] := false;
            end;
            for l := 1 to tl[top[i], top[j]] do
              eq[teq, 1, link[top[i], top[j], l]] := true;
            for l := 1 to tl[top[i], top[k]] do
              eq[teq, 2, link[top[i], top[k], l]] := true;
            for l := tl[top[i], top[k]] + 1 to tl[top[i], top[k]] + 1 + tl[top[k], top[j]] do
              eq[teq, 2, link[top[k], top[j], l - tl[top[i], top[k]]]] := true;

            for l := 1 to tl[top[i], top[j]] do
              peq[teq, l, 1] := link[top[i], top[j], l];
            for l := 1 to tl[top[i], top[k]] do
              peq[teq, l, 2] := link[top[i], top[k], l];
            for l := tl[top[i], top[k]] + 1 to tl[top[i], top[k]] + 1 + tl[top[k], top[j]] do
              peq[teq, l, 2] := link[top[k], top[j], l - tl[top[i], top[k]]];

            if iseq(teq) then dec(teq);
          end;
          if not flag then begin
            tl[top[i], top[j]] := tl[top[i], top[k]] + tl[top[k], top[j]];
            for l := 1 to tl[top[i], top[k]] do
              link[top[i], top[j], l] := link[top[i], top[k], l];
            for l := 1 to tl[top[k], top[j]] do
              link[top[i], top[j], l + tl[top[i], top[k]]] := link[top[k], top[j], l];
            flag := true;
          end;
        end;
      end;
    end;
  end;
  writeln(teq);
  for i := 1 to teq do begin
    for j := 1 to inteq[i, 1] do
      write(peq[i, j, 1], ' ');
    write('= ');
    for j := 1 to inteq[i, 2] do write(peq[i, j, 2], ' ');
    writeln;
  end;
  close(output);
end.
