{$I-,Q-,R-,S-}
const
  inputfile = 'comm.in';
  outputfile = 'comm.out';
  maxn = 111;
  maxm = 1111;

type
  int = longint;
  bool = boolean;

var
  n, m, k, i, j, bg, ed, count: int;
  a, nb: array[1..maxn, 1..maxn]of int;
  d: array[1..maxm, -2..3]of int;
  f, par: array[1..maxn]of int;
  used: array[1..maxn]of bool;

procedure dfs(v: int);
var
  i: int;
begin
  used[v] := true;
  for i := 1 to n do
    if(a[v, i] > 0)and(not used[i])then
      dfs(i);
  inc(k);
  f[k] := v;
end;

procedure getway(bg, ed: int);
var
  i: int;
  used: array[1..maxn]of bool;
begin
  inc(count);
  fillchar(used, sizeof(used), 0);
  i := ed;
  while(i > 0)do begin
    used[i] := true;
    i := par[i];
  end;

  i := bg;
  while(not used[i])do
    i := par[i];

  d[count, -2] := 1;
  d[count, 1] := i;
  d[count, 2] := bg;
  d[count, 3] := ed;
end;

procedure dfs2(v: int);
var
  i: int;
begin
  used[v] := true;
  for i := 1 to n do
    if(a[v, i] > 0)then
      if(not used[i])then begin
        par[i] := v;
        dfs2(i);
      end else
        getway(v, i);
  inc(k);
  f[k] := v;
end;

procedure rec(root, v: int);
begin
  if(v = root)then
    exit;
  rec(root, par[v]);
  write(nb[par[v], v], ' ');
end;


begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n, m);
  for i := 1 to m do begin
    read(bg, ed);
    inc(a[bg, ed]);
    if(a[bg, ed] > 1)then begin
      inc(count);
      d[count, 0] := 2;
      d[count, -1] := 1;
      d[count, 1] := nb[bg, ed];
      d[count, 2] := i;
    end else
      nb[bg, ed] := i;
  end;

  for i := 1 to n do
    if(not used[i])then
      dfs(i);

  for i := 1 to n div 2 do begin
    bg := f[i];
    f[i] := f[n - i + 1];
    f[n - i + 1] := bg;
  end;

  fillchar(used, sizeof(used), 0);
  for i := 1 to n do
    if(not used[f[i]])then
      dfs2(f[i]);

  writeln(count);
  for i := 1 to count do begin
    if(d[i, -2] = 0)then begin
      for j := 1 to d[i, -1] do
        write(d[i, j],' ');
      write('= ');
      for j := d[i, -1] + 1 to d[i, 0] do
        write(d[i, j],' ');
      writeln;
    end else begin
       rec(d[i, 1], d[i, 3]);
       write('= ');
       rec(d[i, 1], d[i, 2]);
       writeln(nb[d[i, 2], d[i, 3]]);
    end;
  end;
  close(output);
  close(input);
end.