{$I-,Q-,R-,S-}
const
  inputfile = 'math.in';
  outputfile = 'math.out';
  maxn = 311;

type
  int = longint;
  bool = boolean;
  pnode = ^tnode;
  tnode = record
    c, p: int;
    ch: char;
    next: pnode;
  end;

var
  n, i, j, k, p, c: int;
  ch: char;
  tmp, m, cur: real;
  g: array[1..maxn]of pnode;
  us, used, det, mark: array[1..maxn]of bool;
  min, max: array[1..maxn]of real;
  d: pnode;
  par: array[1..maxn]of int;

procedure readchar(var c: char);
begin
  read(c);
  while(not(c in ['*', '/']))do
    read(c);
end;

procedure add(var nd: pnode; ch: char; c, p: int);
var
  d: pnode;
begin
  new(d);
  d^.next := nd;
  d^.ch := ch;
  d^.p := p;
  d^.c := c;
  nd := d;
end;

procedure dfs2(v: int);
var
  d: pnode;
begin
  det[v] := false;
  mark[v] := true;
  d := g[v];
  while(d <> nil)do begin
    if(d^.ch = '*')then
      if(not mark[d^.p])then begin

        dfs2(d^.p);
      end;

    d := d^.next;
  end;
end;


procedure check(b, v: int);
var
  i: int;
begin
  fillchar(mark, sizeof(mark), 0);
  if(b = v)then begin
    dfs2(v);
    exit;
  end;
  i := b;
  while(i <> v)do begin
    det[i] := false;
    dfs2(i);
    i := par[i];
  end;
  det[i] := false;
  dfs2(i);
end;

procedure dfs(v: int);
var
  d: pnode;
  old: real;
begin
  us[v] := true;
  d := g[v];
  while(d <> nil)do begin
    if(not us[d^.p])then begin
      old := cur;
      if(d^.ch = '*')then
        cur := cur * d^.c
      else
        cur := cur / d^.c;
      par[d^.p] := v;
      dfs(d^.p);
      cur := old;
    end else begin
      old := cur;
      if(d^.ch = '*')then
        cur := cur * d^.c
      else
        cur := cur / d^.c;
      if(abs(cur) <> 1)then
        check(v, d^.p);
      cur := old;
    end;
    d := d^.next;
  end;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n);
  for i := 1 to n do begin
    read(k);
    for j := 1 to k do begin
      readchar(ch);
      read(c, p);
      add(g[i], ch, c, p);
    end;
  end;

  for i := 2 to n do begin
    min[i] := 1e50;
    max[i] := -1e50;
    det[i] := true;
  end;
  min[1] := 1.0;
  max[1] := 1.0;
  det[1] := true;


  while(true)do begin
    m := 1e50;
    k := -1;
    for i := 1 to n do
      if(not used[i])and(min[i] < m)then begin
        m := min[i];
        k := i;
      end;

    if(k = -1)then
      break;
    used[k] := true;
    d := g[k];
    while(d <> nil)do begin
      if(d^.ch = '/')then begin
        tmp := min[k] / d^.c;
        for j := 1 to 2 do begin
          if(tmp < min[d^.p])then
            min[d^.p] := tmp;
          if(tmp > max[d^.p])then
            max[d^.p] := tmp;
          tmp := max[k] / d^.c;
        end;
      end else begin
        tmp := min[k] * d^.c;
        for j := 1 to 2 do begin
          if(tmp < min[d^.p])then
            min[d^.p] := tmp;
          if(tmp > max[d^.p])then
            max[d^.p] := tmp;
          tmp := max[k] * d^.c;
        end;
      end;
      d := d^.next;
    end;
  end;

  for i := 1 to n do
    if(not us[i])then begin
      cur := 1;
      dfs(i);
    end;

  for i := 1 to n do
    if(used[i])then begin
      if(det[i])then
        writeln(max[i])
      else
        writeln('INF');
    end else
      writeln('NONE');

  close(output);
  close(input);
end.