program The_Great_Function;
{$N+}

const
  eps = 1e-9;

var
  n,a,b : extended;
  k : integer;
  q,qq,qqq : array [0 .. 10] of extended;
  xno : integer;
  xxx : array [1 .. 20] of extended;
  fd : array [1 .. 20] of extended;
  kk : integer;
  dot : extended;

function func(x : extended) : extended;
var
  i : integer;
  xx : extended;
begin
  xx := 0;
  for i:=k downto 0 do
  begin
    xx := xx + q[i];
    if i>0 then xx := xx*x;
  end;
  func := xx;
end;

function func2(x : extended) : extended;
var
  i : integer;
  xx : extended;
begin
  xx := 0;
  for i:=kk downto 0 do
  begin
    xx := xx + qq[i];
    if i>0 then xx := xx*x;
  end;
  func2 := xx;
end;

procedure divide(a : extended);
var
  i : integer;
  cur : extended;
begin
  cur := 0;
  qqq := qq;
  for i:=kk downto 1 do
  begin
    cur := cur + qqq[i];
    qq[i-1] := cur;
    cur := cur * a;
  end;
  dec(kk);
end;

function findmin : boolean;
var
  l,r,m : extended;
  t : longint;
  tt,ttt : extended;
begin
  l := a;
  findmin := false;
  tt := func2(l);
  for t:=0 to 10001 do
  begin    r := t/10000*b + (1-t/10000)*a;
    if tt*func2(r)<eps then
      break;
    if t=10001 then
      exit;
  end;
  ttt := func2(r);
  findmin := true;
  while (r-l>eps) do
  begin
    m := (l+r)/2;
    if (ttt>tt) then
      if func2(m) > 0 then r:=m else l:=m
    else
      if func2(m) > 0 then l:=m else r:=m;
  end;
  dot := (l+r)/2;
end;

procedure Inp;
var
  i,j : integer;
  temp : extended;
begin
  assign(input,'function.in'); reset(input);
  assign(output,'function.out'); rewrite(output);
  read(n,a,b,k);
  fillchar(q,sizeof(q),0);
  fillchar(qq,sizeof(qq),0);
  for i:=k downto 0 do
    read(q[i]);
  while (k>0) and (abs(q[k])<eps) do
    dec(k);
  xno := 0;
  for i:=0 to k-1 do
    qq[i] := q[i+1]*(i+1);
  kk := k-1;
  while true do
  begin
    if kk<=0 then break;
    if findmin then
    begin
      inc(xno);
      xxx[xno] := dot;
      divide(dot);
    end
    else
      break;
  end;
  for i:=1 to xno do
  for j:=1 to i-1 do
  if xxx[i]<xxx[j] then
  begin
    temp := xxx[i];
    xxx[i] := xxx[j];
    xxx[j] := temp;
  end;

  for i:=1 to xno do
    fd[i] := func(xxx[i]);
end;


function clips(a0,b0 : extended) : longint; forward;

function Run(A0,B0 : Extended) : longint;
var
  dimh,dimv : real;
  dh,dv : longint;
  tmp : longint;
  i : integer;
  xx : extended;
begin
  run := 0;
  dimh := b0-a0;
  dimv := func(a0);
  if func(b0)<dimv then dimv := func(b0);
  for i:=1 to xno do
    if (a0<eps+xxx[i]) and (-eps+xxx[i]<b0) then
      if fd[i] < dimv then dimv := fd[i];
  dh := trunc(1e-5 + dimh / n);
  dv := trunc(1e-5 + dimv / n);
  if (dh<=0) or (dv<=0) then exit;
  xx := dv*n;
  tmp := dh*dv;
  q[0] := q[0] - xx;
  run := tmp + clips(a0,b0);
  q[0] := q[0] + xx;
end;

function clips(a0,b0 : extended) : longint;
var
  b1,b2 : integer;
  i : integer;
  tmp : longint;
  up : boolean;
  b : array [1..15] of real;
  bs : integer;
  l,r,m : extended;
  lastup : extended;
begin
  tmp := 0;
  for b1:=1 to xno+1 do
    if (b1=xno+1) or (a0+eps<xxx[b1]) then
      break;
  for b2:=xno downto 0 do
    if (b2=0) or (b0-eps>xxx[b2]) then
      break;
  if b2<b1 then
  begin
    bs := 2;
    b[1] := a0;
    b[2] := b0;
  end
  else
  begin
    bs := 3 + b2-b1;
    b[1] := a0;
    for i:=1 to b2-b1+1 do
      b[i+1] := xxx[i+b1-1];
    b[bs] := b0;
  end;
  up := (func(a0)>n-eps);
  if up then lastup := a0 else lastup := 0;
  for i:=2 to bs do
  begin
    if up then
    begin
      if func(b[i])>n-eps then continue;
      l := b[i-1];
      r := b[i];
      while (r-l>eps) do
      begin
        m := (l+r)/2;
        if func(m)>eps+n then
          l := m
        else
          r := m;
      end;
      m := (l+r)/2;
      tmp := tmp + run(lastup,m);
      up := false;
    end
    else
    begin
      if func(b[i])<=n-eps then continue;
      l := b[i-1];
      r := b[i];
      while (r-l>eps) do
      begin
        m := (l+r)/2;
        if func(m)<n then
          l := m
        else
          r := m;
      end;
      m := (l+r)/2;
      up := true;
      lastup := m;
    end;
  end;
  if up then
  begin
    tmp := tmp + run(lastup,b[bs]);
  end;
  clips := tmp;
end;

procedure Outp(X : longint);
begin
  writeln(X);
  close(input); close(output);
end;

begin
  Inp;
  Outp(clips(a,b));
end.
