Uses Save;
{Filimonov Vladislav}
Const
  MaxK=100000;
Const Mon:Array[1..12] Of String=
(
'January',
'February',
'March',
'April',
'May',
'June',
'July',
'August',
'September',
'October',
'November',
'December'
);


Type TDate = Record
  M,D,HH,MM,SS:Integer;
End;

Var
  A:Array[1..MaxK] Of TDate;
  Num:Array[1..MaxK] Of LongInt;
  K:LongInt;
  N:LongInt;

Procedure MakeDate(Var S:String;NN:LongInt);
Var
  I:Integer;
  P:Integer;
  MM:String;
  Code:Integer;
  Begin
    P:=Pos(' ',S);
    Val(Copy(S,1,P-1),A[K+1].D,Code);
    Delete(S,1,P);
    While S[1]=' ' Do Delete(S,1,1);
    P:=Pos(' ',S);
    MM:=Copy(S,1,P-1);
    For I:=1 To 12 Do Begin
      If Mon[I]=MM Then Begin
        A[K+1].M:=I;
        Break;
      End;
    End;
    Delete(S,1,P);
    While S[1]=' ' Do Delete(S,1,1);
    Val(Copy(S,1,2),A[K+1].HH,Code);
    Val(Copy(S,4,2),A[K+1].MM,Code);
    Val(Copy(S,7,2),A[K+1].SS,Code);
    Num[K+1]:=NN;
    Inc(K);
  End;

Function More(I,J:LongInt):Boolean;
  Begin
    If A[I].M>A[J].M Then Begin
      More:=True;
      Exit;
    End;
    If A[I].M<A[J].M Then Begin
      More:=False;
      Exit;
    End;
    If A[I].D>A[J].D Then Begin
      More:=True;
      Exit;
    End;
    If A[I].D<A[J].D Then Begin
      More:=False;
      Exit;
    End;
    If A[I].HH>A[J].HH Then Begin
      More:=True;
      Exit;
    End;
    If A[I].HH<A[J].HH Then Begin
      More:=False;
      Exit;
    End;
    If A[I].MM>A[J].MM Then Begin
      More:=True;
      Exit;
    End;
    If A[I].MM<A[J].MM Then Begin
      More:=False;
      Exit;
    End;
    If A[I].SS>A[J].SS Then Begin
      More:=True;
      Exit;
    End;
    If A[I].SS<A[J].SS Then Begin
      More:=False;
      Exit;
    End;
  End;

Function Mid(L,R:LongInt):LongInt;
Var
  Mi:LongInt;
  Begin
    If R>L Then Begin
      Mid:=L+((R-L) Div 2);
    End Else Begin
      Mi:=L+((R+N-L) Div 2);
      If Mi>N Then Mid:=Mi Mod N Else Mid:=Mi;
    End;
  End;

Procedure Solve;
Var
  S:String;
  L,R,M:LongInt;
  Begin
    K:=0;
    N:=GetSlotNumber;
    If N=1 Then Begin
      LastGame(1);
      Exit;
    End;
    If N=2 Then Begin
      S:=LoadGame(1);
      MakeDate(S,1);
      S:=LoadGame(2);
      MakeDate(S,2);
      If More(1,2) Then LastGame(1) Else LastGame(2);
      Exit;
    End;
    If N=3 Then Begin
      S:=LoadGame(1);
      MakeDate(S,1);
      S:=LoadGame(2);
      MakeDate(S,2);
      S:=LoadGame(3);
      MakeDate(S,3);
      If More(1,2) Then Begin
        If More(1,3) Then LastGame(1) Else LastGame(3);
      End Else Begin
        If More(2,3) Then LastGame(2) Else LastGame(3);
      End;
      Exit;
    End;
    S:=LoadGame(1);
    MakeDate(S,1);
    S:=LoadGame((N+2) Div 2);
    MakeDate(S,(N+2) Div 2);
    If More(1,2) Then Begin
      L:=1;
      R:=2;
    End Else Begin
      L:=2;
      R:=1;
    End;
    While Abs((Num[L]-Num[R]) Mod (N-1))>1 Do Begin
      M:=Mid(Num[L],Num[R]);
      S:=LoadGame(M);
      MakeDate(S,M);
      If More(K,L) Then Begin
        L:=K;
      End Else R:=K;
    End;
    If More(L,R) Then LastGame(Num[L]) Else LastGame(Num[R]);
  End;

Begin
  Solve;
End.
