{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p23_14_a;

const
  stp = 0.01;
  eps = 0.0001;
  max = 12000;

var
  per : array[0..11] of extended;
  pr : array[0..max + 1] of extended;
  ks : array[0..10] of extended;
  step, total, a, b, n, x, y : extended;
  inper, inpr, i, j, k, l, m : longint;
  flag : boolean;

procedure findper(y : extended);
var
  ps : longint;
  add : extended;
begin
  inc(inper);
  per[inper] := a;
  for ps := 1 to inpr - 1 do begin
    if (pr[ps] <= y) and (pr[ps + 1] > y) then begin
      inc(inper);
      per[inper] := a + (ps * step) + ((pr[ps] - y) * step) / (pr[ps] - pr[ps + 1]);
    end;
    if (pr[ps] >= y) and (pr[ps + 1] < y) then begin
      inc(inper);
      add := ((pr[ps] - y) * step) / (pr[ps] - pr[ps + 1]);
      per[inper] := a + (ps * step) + add;
    end;
  end;
  inc(inper);
  per[inper] := b;
end;

function func(arg : extended) : extended;
var
  res, wrk : extended;
  ps : longint;
begin
  res := 0;
  wrk := 1;
  for ps := 0 to k do begin
    res := res + wrk * ks[ps];
    wrk := wrk * arg;
  end;
  func := res;
end;

function under(x, y : extended) : boolean;
var
  ps : longint;
  pw : extended;
begin
  pw := (x - a) / step;
  ps := trunc(pw);
  if y <= pr[ps] then under := true
  else under := false;
end;

begin
  assign(input, 'function.in');
  reset(input);
  assign(output, 'function.out');
  rewrite(output);
  read(n, a, b, k);
  for i := k downto 0 do read(ks[i]);
  x := a;
  inpr := -1;
  step := (b - a) / (1000 * (10 - k));
  repeat
    y := func(x);
    inc(inpr);
    pr[inpr] := y;
    x := x + step;
  until x > b;
  inc(inpr);
  pr[inpr] := func(b);
  j := 1;
  total := 0;

  repeat
    inper := 0;
    flag := false;
    findper(n * j);
    for i := 1 to inper - 1 do
      if under((per[i] + per[i + 1]) / 2, n * j) then begin
        x := per[i + 1] - per[i];
        if trunc(x / n + eps) >= 1 then flag := true;
        total := total + trunc(x / n + eps);
      end;
    j := j + 1;
  until not flag;
  j := - 1;
  repeat
    inper := 0;
    flag := false;
    findper(n * j);
    for i := 1 to inper - 1 do
      if not under((per[i] + per[i + 1]) / 2, n * j) then begin
        x := per[i + 1] - per[i];
        if trunc(x / n) >= 1 then flag := true;
        total := total + trunc(x / n);
      end;
    j := j - 1;
  until not flag;
  writeln(total:0:0);
  close(output);
end.
