uses save;

type ttime = record
       mn,d,h,m,s: integer;
     end;

const ms: array[1..12] of string = ('January','February','March','April','May',
                                    'June','July','August','September','October','November','December');

function GetMn(s: string):integer;
var i: integer;
begin
  GetMn:=0;
  For i:=1 to 12 do
    if ms[i]=s then begin
      GetMn:=i;
      break;
    end;
end;

procedure StrToTime(s: string;var res: ttime);
var i,j: integer;
begin
  i:=1;
  while not (s[i] in ['0'..'9']) do inc(i);
  j:=i;
  while (s[j] in ['0'..'9']) do inc(j);
  val(copy(s,i,j-i),res.d,i);

  i:=j;
  while not (s[i] in ['A'..'Z','a'..'z']) do inc(i);
  j:=i;
  while (s[j] in ['A'..'Z','a'..'z']) do inc(j);
  res.mn:=Getmn(copy(s,i,j-i));

  i:=j;
  while not (s[i] in ['0'..'9']) do inc(i);
  val(copy(s,i,2),res.h,j);
  val(copy(s,i+3,2),res.m,j);
  val(copy(s,i+6,2),res.s,j);
end;


function cmpdate(d1,d2:ttime):integer;
begin
  if d1.mn>d2.mn then cmpdate:=1 else
    if d1.mn<d2.mn then cmpdate:=-1 else
      if d1.d>d2.d then cmpdate:=1 else
        if d1.d<d2.d then cmpdate:=-1 else
          if d1.h>d2.h then cmpdate:=1 else
            if d1.h<d2.h then cmpdate:=-1 else
              if d1.m>d2.m then cmpdate:=1 else
                if d1.m<d2.m then cmpdate:=-1 else
                  if d1.s>d2.s then cmpdate:=1 else
                    if d1.s<d2.s then cmpdate:=-1 else
                      cmpdate:=0;
end;


var n: longint;
    tl,tr,tm: ttime;
    l,r,m: longint;

Begin
  n:=getslotnumber;
  if n=1 then LastGame(1);

  StrToTime(LoadGame(1),tl);
  StrToTime(LoadGame(n),tr);

  if cmpdate(tl,tr)=-1 then LastGame(n);
  l:=1; r:=n;
  while l<r do begin
    m:=(l+r) div 2;
    if m=l then break;
    StrToTime(LoadGame(m),tm);
    if cmpdate(tl,tm)=-1 then begin
      l:=m;
      tl:=tm;
    end else begin
      r:=m;
      tr:=tm;
    end;
  end;
  LastGame(l);

End.
