#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "save.h"

struct DDATA {
  int day;
  int month;
  int hh;
  int mm;
  int ss;
};

const char *month[] = {
"January",
"February",
"March",
"April",
"May",
"June",
"July",
"August",
"September",
"October",
"November",
"December"
};

long n;
long bb,cc,ee;

int cmp(char *s1, char *s2)
{
  DDATA d1,d2;
  char ss[20];
  int i;
  char *cc;
  sscanf(s1,"%i",&d1.day);
  while(!isalpha(*s1)) s1++;
  i=0;
  while(isalpha(*s1))
  {
    ss[i]=*s1;
    s1++;
    i++;
  }
  ss[i]='\0';
  for(i=0;i<12;i++)
  {
    if(strcmp(ss,month[i])==0) d1.month=i;
  }
  sscanf(s1,"%i:%i:%i",&d1.hh,&d1.mm,&d1.ss);
  
  sscanf(s2,"%i",&d2.day);
  while(!isalpha(*s2)) s2++;
  i=0;
  while(isalpha(*s2))
  {
    ss[i]=*s2;
    s2++;
    i++;
  }
  ss[i]='\0';
  for(i=0;i<12;i++)
  {
    if(strcmp(ss,month[i])==0) d2.month=i;
  }
  sscanf(s2,"%i:%i:%i",&d2.hh,&d2.mm,&d2.ss);

  if(d1.month>d2.month) return 1;
  if(d1.month<d2.month) return -1;
  if(d1.day>d2.day) return 1;
  if(d1.day<d2.day) return -1;
  if(d1.hh>d2.hh) return 1;
  if(d1.hh<d2.hh) return -1;
  if(d1.mm>d2.mm) return 1;
  if(d1.mm<d2.mm) return -1;
  if(d1.ss>d2.ss) return 1;
  if(d1.ss<d2.ss) return -1;
  return 0;
}

int main()
{
  char *sb,*se,*sc;
  n=GetSlotNumber();

  bb=1;
  ee=n;
  sb=LoadGame(bb);
  se=LoadGame(ee);
  if(cmp(sb,se)<0)
  {
    LastGame(ee);
  }
  else
  {
    while((ee-bb)>1)
    {
      cc=(ee+bb)/2;
      sc=LoadGame(cc);
      if(cmp(sb,sc)>0)
      {
        ee=cc;
        se=sc;
      }
      else
      {
        bb=cc;
        sb=sc;
      }
    }
    LastGame(bb);
  }
  

  return 0;
}
