{$I-,Q-,R-,S-}
const
  inputfile = 'function.in';
  outputfile = 'function.out';
  maxk = 11;
  eps = 1e-5;

type
  int = longint;
  bool = boolean;
  real = double;

var
  i, k, lf, rt, nb, minh, count: int;
  l, r, step, n: real;
  a: array[0..maxk]of real;
  c, f: array[-251000..251000]of int;

function funct(x: real): int;
var
  i: int;
  s, sl: real;
begin
  s := a[0];
  for i := 1 to k do begin
    if(abs(x) > eps)then
      sl := a[i] * exp(ln(abs(x)) * i)
    else
      sl := 0.0;
    if(odd(i)and(sl + eps < 0.0))then
      s := s - sl
    else
      s := s + sl;
  end;
  funct := round(s / step);
end;

function getmin(x: int): int;
var
  i, min: int;
begin
  min := f[x - nb + 1];
  for i := x - nb + 2 to x do
    if(min > f[i])then
      min := f[i];
  getmin := min;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n, l, r, k);
  for i := k downto 0 do
    read(a[i]);

  if(r - l <= 20)then
    step := 0.0005
  else
    step := 0.001;

  lf := round(l / step);
  rt := round(r / step);
  nb := round(n / step);
  for i := lf to rt do
    f[i] := funct(i * step);

  for i := lf + nb to rt do begin
    minh := getmin(i);
    if(minh <= 0)then
      minh := 0;
    count := c[i - nb] + minh div nb;
    if(count > c[i])then
      c[i] := count;
  end;

  writeln(c[rt]);
  close(output);
  close(input);
end.