program D_P_S;

const
  maxn = 1005; {1005}

var
  a,b : array [1..maxn] of integer;
  n,s : integer;
  nxt : array [1..maxn] of integer;
  ans : integer;

procedure Inp;
var
  i : integer;
begin
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  read(n,s);
  for i:=1 to n do
    read(a[i],b[i]);
end;

procedure swap(x,y : integer);
var t : integer;
begin
  t := a[x]; a[x] := a[y]; a[y] := t;
  t := b[x]; b[x] := b[y]; b[y] := t;
end;

procedure sort;
var
  i,j : integer;
begin
  for i:=1 to n do
    for j:=1 to i-1 do
    if a[i]<a[j] then
      swap(i,j);
  for i:=1 to n-1 do
    nxt[i] := i+1;
  nxt[n] := 0;
end;

procedure Run;
var
  i,j,k,l,ll : integer;
  t : integer;
begin
  ans := 0;
  sort;
  t := 1;
  for i:=0 to s do
  begin
    while (t>0) and (b[t]<i) do
      t := nxt[t];
    if t=0 then break;
    if a[t]>i then continue;
    k := t;
    j := t;
    ll := 0;
    while a[j]<=i do
    begin
      l := j;
      j := nxt[j];
      if j=0 then break;
      if b[j]<b[k] then begin k := j; ll:=l; end;
    end;
    inc(ans);
    if ll=0 then
       t := nxt[t]
    else
      nxt[ll] := nxt[k];
  end;
end;

procedure Outp;
begin
  writeln(ans);
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.