#include <stdio.h>

FILE*fi,*fo;

#define EPS ((long double)1e-1)

void sort(long*,long);

long n,m;
long double k;
long*a,*b,c;

long double count(long z) {
  long double l=0;
  long i,v,w,u;
  if (z<=b[m>>1]+a[n>>1]) {
    for (w=n,i=0; i<m; i++) {
      for (v=0; v<w; ) {
        u=(v+w)>>1;
        if (z<b[i]+a[u]) w=u; else v=u+1;
      }
      l+=(long double)v;
    }
  } else {
    for (v=0,i=m-1; i>=0; i--) {
      for (w=n; v<w; ) {
        u=(v+w)>>1;
        if (z<b[i]+a[u]) w=u; else v=u+1;
      }
      l+=(long double)v;
    }
  }
  return(l);
}

int main(void) {
  long i;
  fi=fopen("input.txt","rt");
  fscanf(fi,"%ld",&n);
  a=new long[n];
  for (i=0; i<n; i++) fscanf(fi,"%ld",&a[i]);
  fscanf(fi,"%ld",&m);
  b=new long[m];
  for (i=0; i<m; i++) fscanf(fi,"%ld",&b[i]);
  fscanf(fi,"%Lf",&k);
  fclose(fi);
  if (m>n) {
    i=m; m=n; n=i;
    long*z=a; a=b; b=z;
  } //N=(long double)n; M=(long double)m;
  sort(a,n); sort(b,m);
  long u,v,w; long double t;
  for (v=a[0]+b[0]-1,w=a[n-1]+b[m-1]+1; v<w; ) {
    u=(v+w)>>1; t=count(u);
    if (k-t<EPS) w=u; else v=u+1;
  }
  fo=fopen("output.txt","wt");
  fprintf(fo,"%ld",v);
  fclose(fo);
  delete[]a; delete[]b;
  return(0);
}



void sortsift(long*a,long v,long w) {
  long i,j; long z;
  i=v; j=(v<<1)+1;
  if ((j<w)&&(a[j]<a[j+1])) j++;
  z=a[i];
  while ((j<=w)&&(z<a[j])) {
    a[i]=a[j];
    i=j; j=(j<<1)+1;
    if ((j<w)&&(a[j]<a[j+1])) j++;
  }
  a[i]=z;
}
void sort(long*a,long n) {
  long i,j; long z;
  j=n-1; for (i=n>>1; i>=0; i--) sortsift(a,i,j);
  i=0; while (j>0) {
    z=a[i]; a[i]=a[j]; a[j]=z;
    j--;
    sortsift(a,i,j);
  }
}


