{.$define debug}
{$Q-,R-}

program template;
const
 h = 1010;
 smax = 10000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$endif}
type
 int = longint;
 totr = record
  u,v :int;
 end;
var
 n,s :int;
 ans :int;
 t :array [1..h] of totr;
 p :array [0..h] of int;
 f :array [0..smax] of boolean;
 min,max :int;

procedure init;
begin
 ans := 0;
 fillchar (t,sizeof(t),0);
 fillchar (p,sizeof(p),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,s);
 for i := 1 to n do
  readln (t[i].u,t[i].v);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

function rec (v :int):boolean;
var i :int;
begin
 rec := false;
 if f[v] then
  exit;
 f[v] := true;
 for i := 1 to n do
  if ((t[i].u <= v) and (t[i].v >= v)) and
    ((p[i] = -1) or rec(p[i])) then
     begin
      p[i] := v;
      rec := true;
      exit;
     end;
end;

procedure solve;
var i,j :int;
    unused :boolean;
begin
 for i := 1 to n do
  p[i] := -1;
 min := maxlongint;
 max := 0;
 for i := 1 to n do
  begin
   if t[i].u < min then
    min := t[i].u;
   if t[i].v > max  then
    max := t[i].v;
  end;
 for i := min to max do
  begin
   fillchar (f,sizeof(f),0);
   unused := rec (i);
  end;
 for i := 1 to n do
  if p[i] >= 0 then
   inc (ans);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.