const
    inf = 'input.txt'; ouf = 'output.txt';
    maxn = 1000;
     procedure swap(var a, b: word);
     var
       c: word;
     begin
       c := a; a := b; b := c;
     end;
var
   a, b: array[1..maxn] of word;
   m, bm: longint;
   procedure qsort(l, r: longint);
   var
      i, j: longint;
   begin
      m := b[(l + r) shr 1]; bm := a[(l + r) shr 1];
      i := l; j := r;
      repeat
         while (b[i] < m) or ((b[i] = m) and (a[i] < bm)) do inc(i);
         while (b[j] > m) or ((b[j] = m) and (a[j] > bm)) do dec(j);
         if (i <= j) then
         begin
            swap(a[i], a[j]); swap(b[i], b[j]);
            inc(i); dec(j);
         end;
      until i >= j;
      if (i < r) then qsort(i, r);
      if (j > l) then qsort(l, j);
   end;
var
   i, j, n, q, s: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n, s);
  for i := 1 to n do
    read(input, a[i], b[i]);
  qsort(1, n);
  j := 1; q := 0;
  for i := 0 to s do
  begin
    while (b[j] < i) and (j < n) do inc(j);
    if (a[j] <= i) and (b[j] >= i) then
    begin
      inc(q); inc(j);
    end;
  end;
  writeln(output, q);
  close(input); close(output);
end.