var
  a,b:array[1..100000]of longint;
  k,x,n,m:longint;
  c:array[1..100000]of longint;
  up,down,x1:comp;
  numup,numdown,numx:comp;

procedure openfiles;
begin
  assign(input,'input.txt');
  assign(output,'output.txt');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

procedure swap(var a,b:longint);
var
  tmp:longint;

begin
  tmp:=a;
  a:=b;
  b:=tmp;
end;

procedure qsorta(first,last:longint);
var
  up,down:longint;

begin
  up:=first;
  down:=last;
  k:=up+random(down-up);
  x:=a[k];
  repeat
    while (a[up]<x) do
      inc(up);
    while (a[down]>x) do
      dec(down);
    if up<=down then
    begin
      swap(a[up],a[down]);
      inc(up);
      dec(down);
    end;
  until up>down;
  if up<last then
    qsorta(up,last);
  if down>first then
    qsorta(first,down);
end;

procedure qsortb(first,last:longint);
var
  up,down:longint;

begin
  up:=first;
  down:=last;
  k:=up+random(down-up);
  x:=b[k];
  repeat
    while (b[up]<x) do
      inc(up);
    while (b[down]>x) do
      dec(down);
    if up<=down then
    begin
      swap(b[up],b[down]);
      inc(up);
      dec(down);
    end;
  until up>down;
  if up<last then
    qsortb(up,last);
  if down>first then
    qsortb(first,down);
end;

function calc(q:comp):comp;
var
  count:comp;
  x,y,k:longint;

begin
  x:=trunc((q-1)/n)+1;
  y:=trunc(q-(x-1)*n);
  k:=a[x]+b[y];
  count:=x;
  y:=y-1;
  while (x<=n)and(y>=1) do
  begin
    if a[x]+b[y]<=k then
      break;
    while a[x]+b[y]<=k do
      x:=x+1;
    count:=count+x;
    y:=y-1;
  end;
  calc:=count;
end;

procedure Solve;
var
  i,x,y,count:longint;
  k:comp;

begin
  read(n);
  for i:=1 to n do
    read(a[i]);
  qsorta(1,n);
  read(m);
  for i:=1 to m do
    read(b[i]);
  qsortb(1,m);
  read(k);
  up:=n;
  down:=m;
  down:=up*down;
  up:=1;
  numup:=calc(up);
  numdown:=calc(down);
  x1:=trunc((up+down)/2);
  numx:=calc(x1);
  while down-up>2 do
  begin
    if numx>k then
    begin
      down:=x1;
      numdown:=numx;
    end
    else
    begin
      up:=x1;
      numup:=numx;
    end;
    x1:=trunc((up+down)/2);
    numx:=calc(x1);
  end;
  if numdown=k then
    writeln(numdown:0:0)
  else
    writeln(numup:0:0);
end;

begin
  openfiles;
  Solve;
  closefiles;
end.
